!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 22

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(302)
  integer, parameter :: nGC_MI = 1
  integer, parameter :: nGC_14 = 2
  integer, parameter :: nGC_2615 = 3
  integer, parameter :: nGC_10 = 4
  integer, parameter :: nGC_3876 = 5
  integer, parameter :: nGC_3874 = 6
  integer, parameter :: nGC_2794 = 7
  integer, parameter :: nGC_2795 = 8
  integer, parameter :: nGC_2796 = 9
  integer, parameter :: nGC_2797 = 10
  integer, parameter :: nGC_2798 = 11
  integer, parameter :: nGC_4259 = 12
  integer, parameter :: nGC_4256 = 13
  integer, parameter :: nGC_2627 = 14
  integer, parameter :: nGC_MU = 15
  integer, parameter :: nGC_3687 = 16
  integer, parameter :: nGC_22 = 17
  integer, parameter :: nGC_3525 = 18
  integer, parameter :: nGC_3689 = 19
  integer, parameter :: nGC_3523 = 20
  integer, parameter :: nGC_12 = 21
  integer, parameter :: nGC_MC = 22
  integer, parameter :: nGC_MB = 23
  integer, parameter :: nGC_MD = 24
  integer, parameter :: nGC_3691 = 25
  integer, parameter :: nGC_13 = 26
  integer, parameter :: nGC_MS = 27
  integer, parameter :: nGC_2625 = 28
  integer, parameter :: nGC_2621 = 29
  integer, parameter :: nGC_2622 = 30
  integer, parameter :: nGC_2623 = 31
  integer, parameter :: nGC_1392 = 32
  integer, parameter :: nGC_26 = 33
  integer, parameter :: nGC_6955 = 34
  integer, parameter :: nGC_2619 = 35
  integer, parameter :: nGC_2618 = 36
  integer, parameter :: nGC_11 = 37
  integer, parameter :: nGC_2620 = 38
  integer, parameter :: nGC_2613 = 39
  integer, parameter :: nGC_2612 = 40
  integer, parameter :: nGC_2614 = 41
  integer, parameter :: nGC_2617 = 42
  integer, parameter :: nGC_2616 = 43
  integer, parameter :: nGC_1372 = 44
  integer, parameter :: nGC_2626 = 45
  integer, parameter :: nGC_1390 = 46
  integer, parameter :: nGC_1366 = 47
  integer, parameter :: nGC_2624 = 48
  integer, parameter :: nGC_3524 = 49
  integer, parameter :: nGC_3403 = 50
  integer, parameter :: nGC_3402 = 51
  integer, parameter :: nGC_3401 = 52
  integer, parameter :: nGC_3 = 53
  integer, parameter :: nGC_2 = 54
  integer, parameter :: nGC_1 = 55
  integer, parameter :: nGC_7 = 56
  integer, parameter :: nGC_6 = 57
  integer, parameter :: nGC_5 = 58
  integer, parameter :: nGC_4 = 59
  integer, parameter :: nGC_9 = 60
  integer, parameter :: nGC_8 = 61
  integer, parameter :: nGC_3404 = 62
  integer, parameter :: nGC_3526 = 63
  integer, parameter :: nGC_116 = 64
  integer, parameter :: nGC_1364 = 65
  integer, parameter :: nGC_2660 = 66
  integer, parameter :: nGC_2661 = 67
  integer, parameter :: nGC_2662 = 68
  integer, parameter :: nGC_2663 = 69
  integer, parameter :: nGC_2666 = 70
  integer, parameter :: nGC_2667 = 71
  integer, parameter :: nGC_2668 = 72
  integer, parameter :: nGC_2669 = 73
  integer, parameter :: nGC_2708 = 74
  integer, parameter :: nGC_2707 = 75
  integer, parameter :: nGC_2706 = 76
  integer, parameter :: nGC_2705 = 77
  integer, parameter :: nGC_2787 = 78
  integer, parameter :: nGC_2786 = 79
  integer, parameter :: nGC_2785 = 80
  integer, parameter :: nGC_2784 = 81
  integer, parameter :: nGC_2783 = 82
  integer, parameter :: nGC_2782 = 83
  integer, parameter :: nGC_2781 = 84
  integer, parameter :: nGC_2789 = 85
  integer, parameter :: nGC_2788 = 86
  integer, parameter :: nGC_3319 = 87
  integer, parameter :: nGC_6595 = 88
  integer, parameter :: nGC_2659 = 89
  integer, parameter :: nGC_2658 = 90
  integer, parameter :: nGC_2657 = 91
  integer, parameter :: nGC_3541 = 92
  integer, parameter :: nGC_3875 = 93
  integer, parameter :: nGC_2790 = 94
  integer, parameter :: nGC_2791 = 95
  integer, parameter :: nGC_2792 = 96
  integer, parameter :: nGC_1330 = 97
  integer, parameter :: nGC_1338 = 98
  integer, parameter :: nGC_3434 = 99
  integer, parameter :: nGC_3635 = 100
  integer, parameter :: nGC_3636 = 101
  integer, parameter :: nGC_1648 = 102
  integer, parameter :: nGC_3724 = 103
  integer, parameter :: nGC_4257 = 104
  integer, parameter :: nGC_1642 = 105
  integer, parameter :: nGC_372 = 106
  integer, parameter :: nGC_3332 = 107
  integer, parameter :: nGC_390 = 108
  integer, parameter :: nGC_2639 = 109
  integer, parameter :: nGC_3682 = 110
  integer, parameter :: nGC_2635 = 111
  integer, parameter :: nGC_2634 = 112
  integer, parameter :: nGC_2633 = 113
  integer, parameter :: nGC_3688 = 114
  integer, parameter :: nGC_2631 = 115
  integer, parameter :: nGC_1396 = 116
  integer, parameter :: nGC_7455 = 117
  integer, parameter :: nGC_7110 = 118
  integer, parameter :: nGC_7119 = 119
  integer, parameter :: nGC_3692 = 120
  integer, parameter :: nGC_2637 = 121
  integer, parameter :: nGC_3690 = 122
  integer, parameter :: nGC_2628 = 123
  integer, parameter :: nGC_2629 = 124
  integer, parameter :: nGC_2636 = 125
  integer, parameter :: nGC_3741 = 126
  integer, parameter :: nGC_3513 = 127
  integer, parameter :: nGC_7501 = 128
  integer, parameter :: nGC_3514 = 129
  integer, parameter :: nGC_3433 = 130
  integer, parameter :: nGC_2638 = 131
  integer, parameter :: nGC_2632 = 132
  integer, parameter :: nGC_7109 = 133
  integer, parameter :: nGC_2630 = 134
  integer, parameter :: nGC_2753 = 135
  integer, parameter :: nGC_3469 = 136
  integer, parameter :: nGC_2755 = 137
  integer, parameter :: nGC_3501 = 138
  integer, parameter :: nGC_3371 = 139
  integer, parameter :: nGC_3372 = 140
  integer, parameter :: nGC_3375 = 141
  integer, parameter :: nGC_3377 = 142
  integer, parameter :: nGC_1332 = 143
  integer, parameter :: nGC_2671 = 144
  integer, parameter :: nGC_2644 = 145
  integer, parameter :: nGC_2690 = 146
  integer, parameter :: nGC_2698 = 147
  integer, parameter :: nGC_4388 = 148
  integer, parameter :: nGC_3472 = 149
  integer, parameter :: nGC_3470 = 150
  integer, parameter :: nGC_3471 = 151
  integer, parameter :: nGC_2761 = 152
  integer, parameter :: nGC_4260 = 153
  integer, parameter :: nGC_2762 = 154
  integer, parameter :: nGC_3505 = 155
  integer, parameter :: nGC_3502 = 156
  integer, parameter :: nGC_2723 = 157
  integer, parameter :: nGC_4666 = 158
  integer, parameter :: nGC_1640 = 159
  integer, parameter :: nGC_4668 = 160
  integer, parameter :: nGC_2673 = 161
  integer, parameter :: nGC_2672 = 162
  integer, parameter :: nGC_2778 = 163
  integer, parameter :: nGC_2656 = 164
  integer, parameter :: nGC_2677 = 165
  integer, parameter :: nGC_2676 = 166
  integer, parameter :: nGC_2675 = 167
  integer, parameter :: nGC_2674 = 168
  integer, parameter :: nGC_2772 = 169
  integer, parameter :: nGC_2773 = 170
  integer, parameter :: nGC_2770 = 171
  integer, parameter :: nGC_2771 = 172
  integer, parameter :: nGC_2776 = 173
  integer, parameter :: nGC_2777 = 174
  integer, parameter :: nGC_2774 = 175
  integer, parameter :: nGC_2775 = 176
  integer, parameter :: nGC_4204 = 177
  integer, parameter :: nGC_3376 = 178
  integer, parameter :: nGC_7496 = 179
  integer, parameter :: nGC_2757 = 180
  integer, parameter :: nGC_3362 = 181
  integer, parameter :: nGC_3363 = 182
  integer, parameter :: nGC_2687 = 183
  integer, parameter :: nGC_2766 = 184
  integer, parameter :: nGC_7495 = 185
  integer, parameter :: nGC_3368 = 186
  integer, parameter :: nGC_2664 = 187
  integer, parameter :: nGC_2665 = 188
  integer, parameter :: nGC_2709 = 189
  integer, parameter :: nGC_2704 = 190
  integer, parameter :: nGC_3384 = 191
  integer, parameter :: nGC_2702 = 192
  integer, parameter :: nGC_2701 = 193
  integer, parameter :: nGC_2700 = 194
  integer, parameter :: nGC_2744 = 195
  integer, parameter :: nGC_2655 = 196
  integer, parameter :: nGC_2654 = 197
  integer, parameter :: nGC_2651 = 198
  integer, parameter :: nGC_2650 = 199
  integer, parameter :: nGC_2653 = 200
  integer, parameter :: nGC_2652 = 201
  integer, parameter :: nGC_3877 = 202
  integer, parameter :: nGC_2718 = 203
  integer, parameter :: nGC_2719 = 204
  integer, parameter :: nGC_2714 = 205
  integer, parameter :: nGC_2715 = 206
  integer, parameter :: nGC_2716 = 207
  integer, parameter :: nGC_2717 = 208
  integer, parameter :: nGC_2710 = 209
  integer, parameter :: nGC_2711 = 210
  integer, parameter :: nGC_2712 = 211
  integer, parameter :: nGC_2713 = 212
  integer, parameter :: nGC_8543 = 213
  integer, parameter :: nGC_8544 = 214
  integer, parameter :: nGC_3437 = 215
  integer, parameter :: nGC_2648 = 216
  integer, parameter :: nGC_2649 = 217
  integer, parameter :: nGC_2642 = 218
  integer, parameter :: nGC_2643 = 219
  integer, parameter :: nGC_2640 = 220
  integer, parameter :: nGC_2641 = 221
  integer, parameter :: nGC_2646 = 222
  integer, parameter :: nGC_2647 = 223
  integer, parameter :: nGC_3438 = 224
  integer, parameter :: nGC_2645 = 225
  integer, parameter :: nGC_2729 = 226
  integer, parameter :: nGC_2728 = 227
  integer, parameter :: nGC_7524 = 228
  integer, parameter :: nGC_2721 = 229
  integer, parameter :: nGC_2720 = 230
  integer, parameter :: nGC_2722 = 231
  integer, parameter :: nGC_2725 = 232
  integer, parameter :: nGC_2724 = 233
  integer, parameter :: nGC_2727 = 234
  integer, parameter :: nGC_2726 = 235
  integer, parameter :: nGC_2703 = 236
  integer, parameter :: nGC_3333 = 237
  integer, parameter :: nGC_2736 = 238
  integer, parameter :: nGC_2737 = 239
  integer, parameter :: nGC_2734 = 240
  integer, parameter :: nGC_2735 = 241
  integer, parameter :: nGC_2732 = 242
  integer, parameter :: nGC_2733 = 243
  integer, parameter :: nGC_2730 = 244
  integer, parameter :: nGC_2731 = 245
  integer, parameter :: nGC_2738 = 246
  integer, parameter :: nGC_2739 = 247
  integer, parameter :: nGC_7515 = 248
  integer, parameter :: nGC_7514 = 249
  integer, parameter :: nGC_2743 = 250
  integer, parameter :: nGC_2742 = 251
  integer, parameter :: nGC_2741 = 252
  integer, parameter :: nGC_2740 = 253
  integer, parameter :: nGC_2747 = 254
  integer, parameter :: nGC_2746 = 255
  integer, parameter :: nGC_2745 = 256
  integer, parameter :: nGC_8580 = 257
  integer, parameter :: nGC_2749 = 258
  integer, parameter :: nGC_2748 = 259
  integer, parameter :: nGC_3515 = 260
  integer, parameter :: nGC_3516 = 261
  integer, parameter :: nGC_2750 = 262
  integer, parameter :: nGC_2751 = 263
  integer, parameter :: nGC_2752 = 264
  integer, parameter :: nGC_7978 = 265
  integer, parameter :: nGC_2754 = 266
  integer, parameter :: nGC_2756 = 267
  integer, parameter :: nGC_2758 = 268
  integer, parameter :: nGC_2759 = 269
  integer, parameter :: nGC_2691 = 270
  integer, parameter :: nGC_2693 = 271
  integer, parameter :: nGC_2692 = 272
  integer, parameter :: nGC_2695 = 273
  integer, parameter :: nGC_2694 = 274
  integer, parameter :: nGC_2697 = 275
  integer, parameter :: nGC_2696 = 276
  integer, parameter :: nGC_2699 = 277
  integer, parameter :: nGC_7176 = 278
  integer, parameter :: nGC_3506 = 279
  integer, parameter :: nGC_2769 = 280
  integer, parameter :: nGC_2768 = 281
  integer, parameter :: nGC_2765 = 282
  integer, parameter :: nGC_2764 = 283
  integer, parameter :: nGC_2767 = 284
  integer, parameter :: nGC_2760 = 285
  integer, parameter :: nGC_2763 = 286
  integer, parameter :: nGC_2688 = 287
  integer, parameter :: nGC_2689 = 288
  integer, parameter :: nGC_2686 = 289
  integer, parameter :: nGC_2684 = 290
  integer, parameter :: nGC_2685 = 291
  integer, parameter :: nGC_2682 = 292
  integer, parameter :: nGC_2683 = 293
  integer, parameter :: nGC_2680 = 294
  integer, parameter :: nGC_2681 = 295
  integer, parameter :: nGC_7168 = 296
  integer, parameter :: nGC_7169 = 297
  integer, parameter :: nGC_2670 = 298
  integer, parameter :: nGC_2679 = 299
  integer, parameter :: nGC_2678 = 300
  integer, parameter :: nGC_8635 = 301
  integer, parameter :: nGC_5565 = 302
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
