!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl1()
    coupl(nGC_MI) = -cima
    coupl(nGC_14) = -3d0*cima*lam*vev/2d0
    coupl(nGC_2615) = -4d0*cima/vev**2d0
    coupl(nGC_10) = 4d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_2627) = -4d0*cima*gs**2d0/vev
    coupl(nGC_MU) = -cMU*cima
    coupl(nGC_22) = 4d0*cima/vev
    coupl(nGC_12) = 4d0*cggh*gs/vev
    coupl(nGC_MC) = -cMC*cima
    coupl(nGC_MB) = -cMB*cima
    coupl(nGC_MD) = -cMD*cima
    coupl(nGC_13) = -4d0*cggh*cima*gs**2d0/vev
    coupl(nGC_MS) = -cMS*cima
    coupl(nGC_2625) = 8d0*cima/vev**3d0
    coupl(nGC_2621) = 4d0*cima*gs**2d0/vev**2d0
    coupl(nGC_2622) = 2d0*cima*gs**2d0
    coupl(nGC_2623) = -16d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_1392) = 2d0*coupl(nGC_13)
    coupl(nGC_26) = cima*gs
    coupl(nGC_6955) = -coupl(nGC_12)
    coupl(nGC_2619) = -4d0*gs/vev**2d0
    coupl(nGC_2618) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_11) = 4d0*cggh*cima/vev
    coupl(nGC_2620) = 8d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_2613) = 4d0*cggh*gs/vev
    coupl(nGC_2612) = -gs
    coupl(nGC_2614) = 4d0*gs/vev
    coupl(nGC_2617) = 8d0*gs/vev**3d0
    coupl(nGC_2616) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_1372) = -2d0*coupl(nGC_10)
    coupl(nGC_2626) = -8d0*cggh*cima*gs**2d0/vev
    coupl(nGC_1390) = -coupl(nGC_13)
    coupl(nGC_1366) = 2d0*coupl(nGC_10)
    coupl(nGC_2624) = -8d0*cima*gs**2d0/vev**3d0
    coupl(nGC_3) = cima*gs**2d0
    coupl(nGC_2) = cima*gs
    coupl(nGC_1) = -gs
    coupl(nGC_7) = -8d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_6) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_5) = 8d0*cggh*cima/vev**3d0
    coupl(nGC_4) = -3d0*cima*lam/2d0
    coupl(nGC_9) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_8) = -4d0*cggh*cima/vev**2d0
    coupl(nGC_116) = -coupl(nGC_8)
    coupl(nGC_1364) = -coupl(nGC_10)
    coupl(nGC_6595) = -coupl(nGC_9)
    coupl(nGC_1330) = -coupl(nGC_7)
    coupl(nGC_1338) = -2d0*coupl(nGC_7)
    coupl(nGC_1648) = -2d0*coupl(nGC_3)
    coupl(nGC_1642) = 2d0*coupl(nGC_3)
    coupl(nGC_372) = -coupl(nGC_11)
    coupl(nGC_390) = -coupl(nGC_5)
    coupl(nGC_1396) = -2d0*coupl(nGC_13)
    coupl(nGC_1332) = 2d0*coupl(nGC_7)
    coupl(nGC_1640) = -coupl(nGC_3)
  end subroutine fill_couplings_mdl1
end module fill_couplings1
