!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_2792) = coupl(nGC_26)*dZgs_QCD2
    coupl(nGC_3434) = coupl(nGC_2)*dZsL_QCD2
    coupl(nGC_3635) = coupl(nGC_2782) + coupl(nGC_8)*dZg_QCD2
    coupl(nGC_3636) = -coupl(nGC_3635)
    coupl(nGC_3724) = coupl(nGC_2785) + 2d0*coupl(nGC_3)*dZg_QCD2
    coupl(nGC_4257) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_3332) = coupl(nGC_11)*dZg_QCD2 + coupl(nGC_2783)
    coupl(nGC_2639) = cima*coupl(nGC_2)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 -  &
                      cMD**2d0 - cMS**2d0 - cMU**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_3682) = coupl(nGC_2787) + 3d0*coupl(nGC_9)*dZg_QCD2/2d0
    coupl(nGC_2635) = -Nc*cima*coupl(nGC_1)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_2634) = cima*sq2**2d0*(3d0*Nc*coupl(nGC_1)**2d0 - 10d0*coupl(    &
                      nGC_2)**2d0)/(192d0*pi**2d0)
    coupl(nGC_2633) = cMS*cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_3688) = coupl(nGC_MC)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_2631) = cMU*cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_7455) = -coupl(nGC_3682)
    coupl(nGC_7110) = 2d0*coupl(nGC_3319)
    coupl(nGC_7119) = -2d0*coupl(nGC_3319)
    coupl(nGC_3692) = -coupl(nGC_3691)
    coupl(nGC_2637) = cima*sq2**2d0*(-3d0*Nc*coupl(nGC_1)**2d0 + 10d0*coupl(   &
                      nGC_2)**2d0)/(192d0*pi**2d0*Nc)
    coupl(nGC_3690) = coupl(nGC_2796) + coupl(nGC_3688)
    coupl(nGC_2628) = cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(64d0*pi&
                      **2d0*Nc)
    coupl(nGC_2629) = cMC*cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_2636) = cima*coupl(nGC_2)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0 +   &
                      cMD**2d0 + cMS**2d0 + cMU**2d0)/(16d0*pi**2d0)
    coupl(nGC_3741) = 2d0*coupl(nGC_13)*dZg_QCD2 + coupl(nGC_2791)
    coupl(nGC_3513) = coupl(nGC_2)*dZbR_QCD2
    coupl(nGC_7501) = -2d0*coupl(nGC_3724)
    coupl(nGC_3514) = coupl(nGC_2)*dZbL_QCD2
    coupl(nGC_3433) = coupl(nGC_2)*dZsR_QCD2
    coupl(nGC_2638) = cima*coupl(nGC_1)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_2632) = cMB*cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_7109) = -coupl(nGC_3319)
    coupl(nGC_2630) = cMD*cima*coupl(nGC_2)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_2753) = cima*coupl(nGC_1)**2d0*sq2**2d0*(-coupl(nGC_11)*coupl(   &
                      nGC_116) - coupl(nGC_372)*coupl(nGC_8))/(768d0*pi**2d0)
    coupl(nGC_3469) = coupl(nGC_2)*dZdL_QCD2
    coupl(nGC_2755) = -cima*coupl(nGC_1)**2d0*coupl(nGC_116)*coupl(nGC_372)*sq2&
                      **2d0/(384d0*pi**2d0)
    coupl(nGC_3501) = coupl(nGC_2)*dZuR_QCD2
    coupl(nGC_3371) = coupl(nGC_2)*dZcR_QCD2
    coupl(nGC_3372) = coupl(nGC_2)*dZcL_QCD2
    coupl(nGC_3375) = coupl(nGC_2)*dZg_QCD2/2d0 + coupl(nGC_2792)
    coupl(nGC_3377) = coupl(nGC_3372) + coupl(nGC_3375)
    coupl(nGC_2671) = Nc*coupl(nGC_1)**2d0*sq2**2d0*(-2d0*coupl(nGC_116) - 3d0*&
                      coupl(nGC_8))/(768d0*pi**2d0)
    coupl(nGC_2644) = cMB*coupl(nGC_2)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_11) +  &
                      8d0*Nc**2d0*coupl(nGC_372) - coupl(nGC_11) - 8d0*coupl(  &
                      nGC_372))/(128d0*pi**2d0*Nc)
    coupl(nGC_2690) = sq2**2d0*(-2d0*Nc*cima*coupl(nGC_1)**4d0*sq2**2d0 - 3d0* &
                      Nc*coupl(nGC_1)**2d0*coupl(nGC_1642) + 3d0*Nc*coupl(nGC_1&
                      )**2d0*coupl(nGC_1648) - 25d0*cima*coupl(nGC_2)**4d0*sq2 &
                      **2d0)/(384d0*pi**2d0)
    coupl(nGC_2698) = (-10d0*cima*coupl(nGC_1)**4d0*sq2**4d0 + 6d0*cima*coupl( &
                      nGC_1642)**2d0 + 18d0*coupl(nGC_1)**2d0*coupl(nGC_1642)* &
                      sq2**2d0 + 3d0*coupl(nGC_1)**2d0*coupl(nGC_1648)*sq2**2d0&
                      )/(192d0*pi**2d0)
    coupl(nGC_4388) = 3d0*coupl(nGC_1)*dZg_QCD2/2d0 + coupl(nGC_2784)
    coupl(nGC_3472) = coupl(nGC_3375) + coupl(nGC_3469)
    coupl(nGC_3470) = coupl(nGC_2)*dZdR_QCD2
    coupl(nGC_3471) = coupl(nGC_3375) + coupl(nGC_3470)
    coupl(nGC_2761) = cima*coupl(nGC_1)**2d0*coupl(nGC_11)*coupl(nGC_8)*sq2**  &
                      2d0/(384d0*pi**2d0)
    coupl(nGC_4260) = coupl(nGC_2798) + coupl(nGC_4257)
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
