!******************************************************************************!
!                                                                              !
!    derived_ctparameter.f90                                                   !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   derived_ctparameter.f90                        |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module derived_ctparameter
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_derived_ctparameter()
  dcggh_QCD4 = aS*dcgghfin_QCD2/(12d0*pi) + dZgs_QCD2*gs**2d0/(24d0*pi**2d0)
  dyup_QED1_QCD2 = sqrt(2d0)*sqrt(pi)*sqrt(aEW)*dMU_QCD2/(MW*sqrt((-MW**2d0 +  &
                   MZ**2d0)/MZ**2d0))
  dys_QED1_QCD2 = sqrt(2d0)*sqrt(pi)*sqrt(aEW)*dMS_QCD2/(MW*sqrt((-MW**2d0 + MZ&
                  **2d0)/MZ**2d0))
  dydo_QED1_QCD2 = sqrt(2d0)*sqrt(pi)*sqrt(aEW)*dMD_QCD2/(MW*sqrt((-MW**2d0 +  &
                   MZ**2d0)/MZ**2d0))
  dyb_QED1_QCD2 = sqrt(2d0)*sqrt(pi)*sqrt(aEW)*dMB_QCD2/(MW*sqrt((-MW**2d0 + MZ&
                  **2d0)/MZ**2d0))
  dyc_QED1_QCD2 = sqrt(2d0)*sqrt(pi)*sqrt(aEW)*dMC_QCD2/(MW*sqrt((-MW**2d0 + MZ&
                  **2d0)/MZ**2d0))
end subroutine set_derived_ctparameter
end module derived_ctparameter
