!******************************************************************************!
!                                                                              !
!    lcFaVF.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcFaVF.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcFaVF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopFaVF(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,      &
    riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(FaVF0)
!       GammaP(2,1,3)*c0
!       GammaM(2,1,3)*c1
        pl(:) = PL1(:) + PL2(:)
        x0 = pl(2)*w2(2)
        x1 = cima*w2(1)
        x2 = pl(2)*x1
        x3 = cima*w2(0)
        x4 = cima*w2(3)
        x5 = pl(1)*x3 + pl(1)*x4
        x7 = pl(1)*w2(2)
        x8 = pl(1)*x1
        x9 = pl(2)*x4
        x10 = pl(2)*x3
        x12 = -w2(2) + x1
        x14 = co(0)*m
        x15 = w2(0) - w2(3)
        x18 = pl(0)*w2(2)
        x19 = pl(0)*x1
        x20 = -pl(3)*x3
        x21 = pl(3)*x4
        x22 = pl(0)*x3
        x23 = pl(0)*x4
        x24 = pl(3)*w2(2) - pl(3)*x1
        x25 = w2(2) + x1
        x27 = w2(0) + w2(3)
        x33 = co(1)*m
        x45 = cima*w2(2)
        x46 = -w2(1) + x45
        x47 = w2(1) + x45
        do j = riMaxIn, 0, -1
          x6 = co(1)*wl(0,j)
          x11 = co(1)*wl(1,j)
          x13 = wl(3,j)*x12
          x16 = wl(2,j)*x15
          x17 = cima*x16
          x26 = wl(2,j)*x25
          x28 = wl(3,j)*x27
          x29 = cima*x28
          x30 = co(0)*wl(2,j)
          x31 = co(0)*wl(3,j)
          x32 = wl(1,j)*x12
          x34 = wl(0,j)*x27
          x35 = cima*x34
          x36 = wl(0,j)*x25
          x37 = wl(1,j)*x15
          x38 = cima*x37
          x39 = -co(1)*(x32 + x35)
          x40 = co(1)*(x36 + x38)
          x41 = -x40
          x42 = co(0)*(-x13 + x17)
          x43 = co(0)*(-x26 + x29)
          x44 = -x43
          wp(0,j) = -x11*(-x10 - x7 + x8 + x9) + x13*x14 - x14*x17 - x6*(-x0 - &
                    x2 + x5)
          wp(1,j) = -x11*(x22 - x23 + x24) + x14*x26 - x14*x29 - x6*(x18 + x19 &
                     + x20 - x21)
          wp(2,j) = x30*(x0 + x2 - x22 + x23) - x31*(x10 + x18 - x19 + x9) -   &
                    x32*x33 - x33*x35
          wp(3,j) = x30*(x20 + x21 + x7 + x8) - x31*(x24 + x5) - x33*x36 - x33*&
                    x38
          if(rankInc .lt. 1) cycle
          sp2(0,0) = x39
          sp2(0,1) = x41
          sp2(0,2) = -x42
          sp2(0,3) = x44
          sp2(1,0) = x41
          sp2(1,1) = x39
          sp2(1,2) = x43
          sp2(1,3) = x42
          sp2(2,0) = -co(1)*wl(0,j)*x46 + co(1)*x37
          sp2(2,1) = -co(1)*wl(1,j)*x47 - co(1)*x34
          sp2(2,2) = -co(0)*wl(2,j)*x46 - co(0)*x28
          sp2(2,3) = -co(0)*wl(3,j)*x47 + co(0)*x16
          sp2(3,0) = x39
          sp2(3,1) = x40
          sp2(3,2) = x42
          sp2(3,3) = x44
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + sp2(mu,:)
          end do 
        end do 
      end select 
    end subroutine loopFaVF
end module lcFaVF
