!******************************************************************************!
!                                                                              !
!    lcSSSVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSSSVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSSSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SSSVV0)
!       P(4,4)*P(5,5)*c0
!       c1*(P(4,4)*P(5,4) + P(4,5)*P(5,5))
!       P(4,5)*P(5,4)*c2
!       c3*(P(4,4)*P(5,2) + P(4,4)*P(5,3) + P(4,5)*P(5,2) + P(4,5)*P(5,3))
!       c4*(P(4,2)*P(5,4) + P(4,2)*P(5,5) + P(4,3)*P(5,4) + P(4,3)*P(5,5))
!       c5*(2*P(4,2)*P(5,2) + P(4,2)*P(5,3) + P(4,3)*P(5,2) + 2*P(4,3)*P(5,3))
!       c6*(Metric(4,5)*P(-1,4)**2 + Metric(4,5)*P(-1,5)**2)
!       Metric(4,5)*P(-1,4)*P(-1,5)*c7
!       Metric(4,5)*P(-1,2)*P(-1,3)*c8
!       c9*(Metric(4,5)*P(-1,2)**2 + Metric(4,5)*P(-1,3)**2)
!       c10*(Metric(4,5)*P(-1,2)*P(-1,4) + Metric(4,5)*P(-1,2)*P(-1,5) + Metric(4
!       ,5)*P(-1,3)*P(-1,4) + Metric(4,5)*P(-1,3)*P(-1,5))
        x0 = P1(1)*w4(1)
        x1 = co(1)*x0
        x2 = P1(2)*w4(2)
        x3 = co(1)*x2
        x4 = co(1)*w4(3)
        x5 = P1(3)*x4
        x6 = P2(0)*w4(0)
        x7 = co(4)*x6
        x8 = P2(1)*w4(1)
        x9 = co(1)*x8
        x10 = P2(2)*w4(2)
        x11 = co(1)*x10
        x12 = P2(3)*x4
        x13 = P3(0)*w4(0)
        x14 = co(4)*x13
        x15 = P3(1)*w4(1)
        x16 = co(1)*x15
        x17 = P3(2)*w4(2)
        x18 = co(1)*x17
        x19 = P3(3)*x4
        x20 = P4(0)*w4(0)
        x21 = co(0)*x20
        x22 = P4(1)*w4(1)
        x23 = co(1)*x22
        x24 = P4(2)*w4(2)
        x25 = co(1)*x24
        x26 = P4(3)*x4
        x27 = P1(0)*w4(0)
        x28 = co(1)*x27
        x29 = co(1)*x6
        x30 = co(4)*x8
        x31 = co(4)*x10
        x32 = P2(3)*w4(3)
        x33 = co(4)*x32
        x34 = co(1)*x13
        x35 = co(4)*x15
        x36 = co(4)*x17
        x37 = P3(3)*w4(3)
        x38 = co(4)*x37
        x39 = co(1)*x20
        x40 = co(0)*x22
        x41 = co(0)*x24
        x42 = P4(3)*w4(3)
        x43 = co(0)*x42
        x44 = x1 + x11 + x12 + x14 + x16 + x18 + x19 + x21 + x23 + x25 + x26 - &
              x28 - x29 + x3 - x30 - x31 - x33 - x34 - x35 - x36 - x38 - x39 - &
              x40 - x41 - x43 + x5 + x7 + x9
        x45 = P2(0)**2
        x46 = P3(0)**2
        x47 = P2(1)**2
        x48 = P2(2)**2
        x49 = P2(3)**2
        x50 = P3(1)**2
        x51 = P3(2)**2
        x52 = P3(3)**2
        x53 = P4(0)**2
        x54 = P4(1)**2
        x55 = P4(2)**2
        x56 = P4(3)**2
        x57 = 2*co(6)
        x58 = P1(0)*co(10)
        x59 = P4(0)*co(7)
        x60 = P2(1)*P3(1)
        x61 = P2(2)*P3(2)
        x62 = P2(3)*P3(3)
        x63 = P1(1)*co(10)
        x64 = P4(1)*co(7)
        x65 = P1(2)*co(10)
        x66 = P4(2)*co(7)
        x67 = P1(3)*co(10)
        x68 = P4(3)*co(7)
        x69 = P2(0)*P3(0)
        x70 = 2*P1(0)*co(6)
        x71 = 2*P4(0)*co(6)
        x72 = 2*co(10)
        x73 = 2*P1(1)*co(6)
        x74 = 2*P4(1)*co(6)
        x75 = 2*P1(2)*co(6)
        x76 = 2*P4(2)*co(6)
        x77 = 2*P1(3)*co(6)
        x78 = 2*P4(3)*co(6)
        x79 = co(5)*x13
        x80 = co(5)*x15
        x81 = co(5)*x17
        x82 = co(5)*x37
        x83 = co(5)*x8
        x84 = co(5)*x10
        x85 = co(5)*x32
        x86 = co(5)*x6
        x87 = P1(3)*w4(3)
        x88 = -x1
        x89 = -x3
        x90 = -x5
        x91 = -x9
        x92 = -x11
        x93 = -x12
        x94 = -x16
        x95 = -x18
        x96 = -x19
        x97 = -x21
        x98 = co(3)*x0 + co(3)*x10 - co(3)*x13 + co(3)*x15 + co(3)*x17 + co(3)*&
              x2 - co(3)*x27 + co(3)*x32 + co(3)*x37 - co(3)*x6 + co(3)*x8 + co&
              (3)*x87 - x14 - x23 - x25 - x26 + x28 + x29 + x30 + x31 + x33 +  &
              x34 + x35 + x36 + x38 + x39 + x40 + x41 + x43 - x7 + x88 + x89 + &
              x90 + x91 + x92 + x93 + x94 + x95 + x96 + x97
        x99 = co(2)*w4(1)
        x100 = co(2)*w4(0)
        do j = riMaxIn, 0, -1
          x101 = cima*w2(0)*w3(0)*wl(0,j)
          wp(:,j) = P1(:)*x101*x44 + P2(:)*(-x101*x79 + x101*x80 + x101*x81 +  &
                    x101*x82 + 2*x101*x83 + 2*x101*x84 + 2*x101*x85 - 2*x101*  &
                    x86 - x101*x98) + P3(:)*(-2*x101*x79 + 2*x101*x80 + 2*x101*&
                    x81 + 2*x101*x82 + x101*x83 + x101*x84 + x101*x85 - x101*  &
                    x86 - x101*x98) + P4(:)*(P1(0)*x100*x101 - P1(1)*x101*x99  &
                     + P2(0)*x100*x101 - P3(1)*x101*x99 - co(2)*x10*x101 + co(2&
                    )*x101*x13 - co(2)*x101*x17 - co(2)*x101*x2 + co(2)*x101*  &
                    x20 - co(2)*x101*x22 - co(2)*x101*x24 - co(2)*x101*x32 - co&
                    (2)*x101*x37 - co(2)*x101*x42 - co(2)*x101*x8 - co(2)*x101*&
                    x87 + 2*x101*x23 + 2*x101*x25 + 2*x101*x26 - x101*x28 -    &
                    x101*x29 - x101*x34 - 2*x101*x39 - x101*x40 - x101*x41 -   &
                    x101*x43 - x101*x88 - x101*x89 - x101*x90 - x101*x91 - x101&
                    *x92 - x101*x93 - x101*x94 - x101*x95 - x101*x96 - x101*x97&
                    ) + w4(:)*(-P1(0)**2*co(6)*x101 + P1(0)*x101*x59 + P1(1)**2&
                    *co(6)*x101 - P1(1)*x101*x64 + P1(1)*x101*x74 + P1(2)**2*co&
                    (6)*x101 - P1(2)*x101*x66 + P1(2)*x101*x76 + P1(3)**2*co(6 &
                    )*x101 - P1(3)*x101*x68 + P2(0)*x101*x58 + P2(0)*x101*x59  &
                     - P2(0)*x101*x70 - P2(0)*x101*x71 - P2(1)*x101*x63 - P2(1 &
                    )*x101*x64 + P2(1)*x101*x73 + P2(1)*x101*x74 - P2(2)*x101* &
                    x65 - P2(2)*x101*x66 + P2(2)*x101*x75 + P2(2)*x101*x76 - P2&
                    (3)*x101*x67 - P2(3)*x101*x68 + P2(3)*x101*x77 + P2(3)*x101&
                    *x78 + P3(0)*x101*x58 + P3(0)*x101*x59 - P3(0)*x101*x70 -  &
                    P3(0)*x101*x71 - P3(1)*x101*x63 - P3(1)*x101*x64 + P3(1)*  &
                    x101*x73 + P3(1)*x101*x74 - P3(2)*x101*x65 - P3(2)*x101*x66&
                     + P3(2)*x101*x75 + P3(2)*x101*x76 - P3(3)*x101*x67 - P3(3 &
                    )*x101*x68 + P3(3)*x101*x77 + P3(3)*x101*x78 - P4(0)*x101* &
                    x70 + P4(3)*x101*x77 + co(10)*x101*x45 + co(10)*x101*x46 - &
                    co(10)*x101*x47 - co(10)*x101*x48 - co(10)*x101*x49 - co(10&
                    )*x101*x50 - co(10)*x101*x51 - co(10)*x101*x52 - co(6)*x101&
                    *x45 - co(6)*x101*x46 + co(6)*x101*x47 + co(6)*x101*x48 +  &
                    co(6)*x101*x49 + co(6)*x101*x50 + co(6)*x101*x51 + co(6)*  &
                    x101*x52 + co(7)*x101*x53 - co(7)*x101*x54 - co(7)*x101*x55&
                     - co(7)*x101*x56 + co(8)*x101*x60 + co(8)*x101*x61 + co(8 &
                    )*x101*x62 - co(8)*x101*x69 - co(9)*x101*x45 - co(9)*x101* &
                    x46 + co(9)*x101*x47 + co(9)*x101*x48 + co(9)*x101*x49 + co&
                    (9)*x101*x50 + co(9)*x101*x51 + co(9)*x101*x52 - x101*x53* &
                    x57 + x101*x54*x57 + x101*x55*x57 + x101*x56*x57 + x101*x57&
                    *x60 + x101*x57*x61 + x101*x57*x62 - x101*x57*x69 - x101*  &
                    x60*x72 - x101*x61*x72 - x101*x62*x72 + x101*x69*x72)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x102 = co(1)*w4(mu)
            x103 = w4(mu)*(co(1) - co(3))
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) - P1(:)*x101*x102 - P2(:)*x101*x103 - P3 &
                          (:)*x101*x103 + P4(:)*(-co(1)*w4(mu)*x101 + co(2)*w4(&
                          mu)*x101) + gg(:,mu)*x101*x44 + w4(:)*(-P1(mu)*x101* &
                          x57 + P2(mu)*co(10)*x101 - P2(mu)*x101*x57 + P3(mu)* &
                          co(10)*x101 - P3(mu)*x101*x57 + P4(mu)*co(7)*x101 -  &
                          P4(mu)*x101*x57)
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(:,riOut) = wp(:,riOut) - co(6)*gg(nu,mu)*w4(:)*x101 - gg(:,nu &
                            )*x101*x102
            end do 
          end do 
        end do 
      end select 
    end subroutine loopSSSVV
end module lcSSSVV
