!******************************************************************************!
!                                                                              !
!    lcSSVSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSSVSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSSVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SSVSV0)
!       P(3,3)*P(5,5)*c0
!       c1*(P(3,3)*P(5,3) + P(3,5)*P(5,5))
!       P(3,5)*P(5,3)*c2
!       c3*(P(3,3)*P(5,2) + P(3,3)*P(5,4) + P(3,5)*P(5,2) + P(3,5)*P(5,4))
!       c4*(P(3,2)*P(5,2) + P(3,2)*P(5,4)/2 + P(3,4)*P(5,2)/2 + P(3,4)*P(5,4))
!       c5*(P(3,2)*P(5,3) + P(3,2)*P(5,5) + P(3,4)*P(5,3) + P(3,4)*P(5,5))
!       c6*(Metric(3,5)*P(-1,3)**2 + Metric(3,5)*P(-1,5)**2)
!       Metric(3,5)*P(-1,3)*P(-1,5)*c7
!       c8*(Metric(3,5)*P(-1,2)**2 + Metric(3,5)*P(-1,4)**2)
!       Metric(3,5)*P(-1,2)*P(-1,4)*c9
!       c10*(Metric(3,5)*P(-1,2)*P(-1,3) + Metric(3,5)*P(-1,2)*P(-1,5) + Metric(3
!       ,5)*P(-1,3)*P(-1,4) + Metric(3,5)*P(-1,4)*P(-1,5))
        x0 = co(1)*w3(1)
        x1 = P1(1)*x0
        x2 = co(1)*w3(2)
        x3 = P1(2)*x2
        x4 = co(1)*w3(3)
        x5 = P1(3)*x4
        x6 = P2(0)*w3(0)
        x7 = co(5)*x6
        x8 = P2(1)*x0
        x9 = P2(2)*x2
        x10 = P2(3)*w3(3)
        x11 = co(1)*x10
        x12 = P3(0)*w3(0)
        x13 = co(0)*x12
        x14 = P3(1)*x0
        x15 = P3(2)*x2
        x16 = P3(3)*x4
        x17 = P4(0)*w3(0)
        x18 = co(5)*x17
        x19 = P4(1)*x0
        x20 = P4(2)*x2
        x21 = P4(3)*w3(3)
        x22 = co(1)*x21
        x23 = co(1)*w3(0)
        x24 = P1(0)*x23
        x25 = co(1)*x6
        x26 = P2(1)*w3(1)
        x27 = co(5)*x26
        x28 = P2(2)*co(5)*w3(2)
        x29 = co(5)*x10
        x30 = P3(0)*x23
        x31 = P3(1)*co(0)*w3(1)
        x32 = P3(2)*co(0)*w3(2)
        x33 = P3(3)*co(0)*w3(3)
        x34 = co(1)*x17
        x35 = P4(1)*w3(1)
        x36 = co(5)*x35
        x37 = P4(2)*w3(2)
        x38 = co(5)*x37
        x39 = co(5)*x21
        x40 = x1 + x11 + x13 + x14 + x15 + x16 + x18 + x19 + x20 + x22 - x24 - &
              x25 - x27 - x28 - x29 + x3 - x30 - x31 - x32 - x33 - x34 - x36 - &
              x38 - x39 + x5 + x7 + x8 + x9
        x41 = P2(0)**2
        x42 = P4(0)**2
        x43 = P2(1)**2
        x44 = P2(2)**2
        x45 = P2(3)**2
        x46 = P4(1)**2
        x47 = P4(2)**2
        x48 = P4(3)**2
        x49 = P3(0)**2
        x50 = P3(1)**2
        x51 = P3(2)**2
        x52 = P3(3)**2
        x53 = 2*co(6)
        x54 = P1(0)*co(10)
        x55 = P3(0)*co(7)
        x56 = P2(1)*P4(1)
        x57 = P2(2)*P4(2)
        x58 = P2(3)*P4(3)
        x59 = P1(1)*co(10)
        x60 = P3(1)*co(7)
        x61 = P1(2)*co(10)
        x62 = P3(2)*co(7)
        x63 = P1(3)*co(10)
        x64 = P3(3)*co(7)
        x65 = P2(0)*P4(0)
        x66 = 2*P1(0)*co(6)
        x67 = 2*P3(0)*co(6)
        x68 = 2*co(10)
        x69 = 2*P1(1)*co(6)
        x70 = 2*P1(2)*co(6)
        x71 = 2*P4(2)*co(6)
        x72 = 2*P1(3)*co(6)
        x73 = 2*P3(1)*co(6)
        x74 = 2*P3(3)*co(6)
        x75 = co(2)*w3(1)
        x76 = co(2)*w3(2)
        x77 = co(2)*w3(3)
        x78 = P1(0)*w3(0)
        x79 = -2*x14
        x80 = -2*x15
        x81 = -2*x16
        x82 = 2*x30
        x83 = co(4)*x17
        x84 = co(4)*x35
        x85 = co(4)*w3(2)
        x86 = P4(2)*x85
        x87 = co(4)*x21
        x88 = co(4)*x26
        x89 = P2(2)*x85
        x90 = co(4)*x10
        x91 = co(4)*x6
        x92 = 2*co(3)
        x93 = 2*co(3)*w3(2)
        x94 = P1(1)*w3(1)*x92 + P1(2)*x93 + P1(3)*w3(3)*x92 + P2(2)*x93 - 2*x1 &
               + x10*x92 - 2*x11 - 2*x13 - x17*x92 - 2*x18 - 2*x19 - 2*x20 +   &
              x21*x92 - 2*x22 + 2*x24 + 2*x25 + x26*x92 + 2*x27 + 2*x28 + 2*x29&
               - 2*x3 + 2*x31 + 2*x32 + 2*x33 + 2*x34 + x35*x92 + 2*x36 + x37* &
              x92 + 2*x38 + 2*x39 - 2*x5 - x6*x92 - 2*x7 - x78*x92 + x79 - 2*x8&
               + x80 + x81 + x82 - 2*x9
        do j = riMaxIn, 0, -1
          x95 = cima*w2(0)*w4(0)*wl(0,j)
          wp(:,j) = P1(:)*x40*x95 + P2(:)*(-x83*x95/2 + x84*x95/2 + x86*x95/2  &
                     + x87*x95/2 + x88*x95 + x89*x95 + x90*x95 - x91*x95 - x94*&
                    x95/2) + P3(:)*(-P1(1)*x75*x95 - P1(2)*x76*x95 - P1(3)*x77*&
                    x95 - P2(1)*x75*x95 - P2(2)*x76*x95 - P3(1)*x75*x95 - P3(2 &
                    )*x76*x95 - P3(3)*x77*x95 - P4(1)*x75*x95 - co(2)*x10*x95  &
                     + co(2)*x12*x95 + co(2)*x17*x95 - co(2)*x21*x95 - co(2)*  &
                    x37*x95 + co(2)*x6*x95 + co(2)*x78*x95 + x1*x95 + x11*x95  &
                     + x13*x95 + x19*x95 + x20*x95 + x22*x95 - x24*x95 - x25*  &
                    x95 + x3*x95 - x31*x95 - x32*x95 - x33*x95 - x34*x95 + x5* &
                    x95 - x79*x95 + x8*x95 - x80*x95 - x81*x95 - x82*x95 + x9* &
                    x95) + P4(:)*(-x83*x95 + x84*x95 + x86*x95 + x87*x95 + x88*&
                    x95/2 + x89*x95/2 + x90*x95/2 - x91*x95/2 - x94*x95/2) + w3&
                    (:)*(-P1(0)**2*co(6)*x95 + P1(0)*x55*x95 + P1(1)**2*co(6)* &
                    x95 - P1(1)*x60*x95 + P1(2)**2*co(6)*x95 - P1(2)*x62*x95 + &
                    P1(2)*x71*x95 + P1(3)**2*co(6)*x95 - P1(3)*x64*x95 + P2(0)*&
                    x54*x95 + P2(0)*x55*x95 - P2(0)*x66*x95 - P2(0)*x67*x95 -  &
                    P2(1)*x59*x95 - P2(1)*x60*x95 + P2(1)*x69*x95 + P2(1)*x73* &
                    x95 + P2(2)*P3(2)*x53*x95 - P2(2)*x61*x95 - P2(2)*x62*x95  &
                     + P2(2)*x70*x95 - P2(3)*x63*x95 - P2(3)*x64*x95 + P2(3)*  &
                    x72*x95 + P2(3)*x74*x95 - P3(0)*x66*x95 + P3(1)*x69*x95 +  &
                    P3(2)*x70*x95 + P3(2)*x71*x95 + P3(3)*x72*x95 + P4(0)*x54* &
                    x95 + P4(0)*x55*x95 - P4(0)*x66*x95 - P4(0)*x67*x95 - P4(1 &
                    )*x59*x95 - P4(1)*x60*x95 + P4(1)*x69*x95 + P4(1)*x73*x95  &
                     - P4(2)*x61*x95 - P4(2)*x62*x95 - P4(3)*x63*x95 - P4(3)*  &
                    x64*x95 + P4(3)*x72*x95 + P4(3)*x74*x95 + co(10)*x41*x95 + &
                    co(10)*x42*x95 - co(10)*x43*x95 - co(10)*x44*x95 - co(10)* &
                    x45*x95 - co(10)*x46*x95 - co(10)*x47*x95 - co(10)*x48*x95 &
                     - co(6)*x41*x95 - co(6)*x42*x95 + co(6)*x43*x95 + co(6)*  &
                    x44*x95 + co(6)*x45*x95 + co(6)*x46*x95 + co(6)*x47*x95 +  &
                    co(6)*x48*x95 + co(7)*x49*x95 - co(7)*x50*x95 - co(7)*x51* &
                    x95 - co(7)*x52*x95 - co(8)*x41*x95 - co(8)*x42*x95 + co(8 &
                    )*x43*x95 + co(8)*x44*x95 + co(8)*x45*x95 + co(8)*x46*x95  &
                     + co(8)*x47*x95 + co(8)*x48*x95 + co(9)*x56*x95 + co(9)*  &
                    x57*x95 + co(9)*x58*x95 - co(9)*x65*x95 - x49*x53*x95 + x50&
                    *x53*x95 + x51*x53*x95 + x52*x53*x95 + x53*x56*x95 + x53*  &
                    x57*x95 + x53*x58*x95 - x53*x65*x95 - x56*x68*x95 - x57*x68&
                    *x95 - x58*x68*x95 + x65*x68*x95)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x96 = co(1)*w3(mu)
            x97 = w3(mu)*(co(1) - co(3))
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) - P1(:)*x95*x96 - P2(:)*x95*x97 + P3     &
                          (:)*(-co(1)*w3(mu)*x95 + co(2)*w3(mu)*x95) - P4(:)*  &
                          x95*x97 + gg(:,mu)*x40*x95 + w3(:)*(-P1(mu)*x53*x95  &
                           + P2(mu)*co(10)*x95 - P2(mu)*x53*x95 + P3(mu)*co(7)*&
                          x95 - P3(mu)*x53*x95 + P4(mu)*co(10)*x95 - P4(mu)*x53&
                          *x95)
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(:,riOut) = wp(:,riOut) - co(6)*gg(nu,mu)*w3(:)*x95 - gg(:,nu)*&
                            x95*x96
            end do 
          end do 
        end do 
      end select 
    end subroutine loopSSVSV
end module lcSSVSV
