!******************************************************************************!
!                                                                              !
!    lcSSVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSSVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SSVVS0)
!       P(3,4)*P(4,3)*c0
!       c1*(P(3,3)*P(4,2) + P(3,3)*P(4,5) + P(3,4)*P(4,2) + P(3,4)*P(4,5))
!       c2*(2*P(3,2)*P(4,2) + P(3,2)*P(4,5) + P(3,5)*P(4,2) + 2*P(3,5)*P(4,5))
!       c3*(P(3,2)*P(4,3) + P(3,2)*P(4,4) + P(3,5)*P(4,3) + P(3,5)*P(4,4))
!       P(3,3)*P(4,4)*c4
!       c5*(P(3,3)*P(4,3) + P(3,4)*P(4,4))
!       c6*(Metric(3,4)*P(-1,3)**2 + Metric(3,4)*P(-1,4)**2)
!       Metric(3,4)*P(-1,3)*P(-1,4)*c7
!       c8*(Metric(3,4)*P(-1,2)**2 + Metric(3,4)*P(-1,5)**2)
!       Metric(3,4)*P(-1,2)*P(-1,5)*c9
!       c10*(Metric(3,4)*P(-1,2)*P(-1,3) + Metric(3,4)*P(-1,2)*P(-1,4) + Metric(3
!       ,4)*P(-1,3)*P(-1,5) + Metric(3,4)*P(-1,4)*P(-1,5))
        x0 = P3(1)**2
        x1 = co(10)*w3(0)*w4(0)
        x2 = P3(2)**2
        x3 = P3(3)**2
        x4 = P4(1)**2
        x5 = P4(2)**2
        x6 = P4(3)**2
        x7 = P3(0)**2
        x8 = co(10)*w3(1)*w4(1)
        x9 = P4(0)**2
        x10 = co(10)*w3(2)*w4(2)
        x11 = co(10)*w3(3)*w4(3)
        x12 = w3(0)*w4(0)*x7
        x13 = w3(0)*w4(0)*x9
        x14 = w3(1)*w4(1)*x0
        x15 = w3(1)*w4(1)*x4
        x16 = w3(2)*w4(2)*x2
        x17 = w3(2)*w4(2)*x5
        x18 = co(5)*w3(3)*w4(3)
        x19 = co(6)*w3(1)*w4(1)
        x20 = w3(1)*w4(1)
        x21 = co(6)*x3
        x22 = co(6)*x5
        x23 = co(6)*w3(2)*w4(2)
        x24 = w3(2)*w4(2)
        x25 = co(6)*w3(3)*w4(3)
        x26 = P1(0)**2
        x27 = co(8)*w3(0)*w4(0)
        x28 = P1(1)**2
        x29 = co(8)*w3(1)*w4(1)
        x30 = P1(2)**2
        x31 = P1(3)**2
        x32 = co(8)*w3(2)*w4(2)
        x33 = co(8)*w3(3)*w4(3)
        x34 = P2(1)**2
        x35 = co(9)*w3(0)*w4(0)
        x36 = P2(2)**2
        x37 = w3(0)*w4(0)
        x38 = P2(3)**2
        x39 = co(9)*x38
        x40 = P2(0)**2
        x41 = co(9)*w3(1)*w4(1)
        x42 = co(9)*w3(2)*w4(2)
        x43 = co(9)*w3(3)*w4(3)
        x44 = co(1)*w3(3)*w4(3)
        x45 = co(3)*w3(0)*w4(0)
        x46 = co(3)*w3(3)*w4(3)
        x47 = co(6)*w3(0)*w4(0)
        x48 = w3(3)*w4(3)
        x49 = 2*co(8)*w3(0)*w4(0)
        x50 = 2*co(8)*w3(1)*w4(1)
        x51 = 2*co(8)*w3(2)*w4(2)
        x52 = 2*co(8)*w3(3)*w4(3)
        x53 = 2*co(2)*w3(0)*w4(0)
        x54 = 2*co(2)
        x55 = 2*co(2)*w3(1)*w4(1)
        x56 = 2*co(2)*w3(2)*w4(2)
        x57 = 2*co(2)*w3(3)*w4(3)
        x58 = 2*x36
        x59 = P1(0)*P2(0)
        x60 = P2(0)*co(9)*w3(3)*w4(3)
        x61 = P1(0)*co(10)*w3(1)*w4(1)
        x62 = P1(0)*P3(0)
        x63 = P3(1)*w3(1)
        x64 = P1(0)*co(1)*w4(0)
        x65 = P3(1)*w4(1)
        x66 = P1(0)*co(3)*w3(0)
        x67 = P3(2)*w3(2)
        x68 = P3(2)*w4(2)
        x69 = P3(3)*w3(3)
        x70 = P3(3)*w4(3)
        x71 = P1(0)*P4(0)
        x72 = P4(1)*w3(1)
        x73 = P4(1)*co(3)*w4(1)
        x74 = P1(0)*w3(0)
        x75 = P1(0)*w4(0)
        x76 = P4(2)*co(1)*w3(2)
        x77 = P4(2)*w4(2)
        x78 = P4(3)*w3(3)
        x79 = P4(3)*co(3)*w4(3)
        x80 = P2(1)*co(9)*w3(0)*w4(0)
        x81 = P1(1)*w3(1)
        x82 = P2(2)*co(2)*w4(2)
        x83 = P1(1)*co(2)*w4(1)
        x84 = P2(2)*w3(2)
        x85 = P2(3)*co(2)*w4(3)
        x86 = P2(3)*w3(3)
        x87 = P3(0)*w3(0)
        x88 = P1(1)*co(1)*w4(1)
        x89 = P3(0)*co(3)*w4(0)
        x90 = P1(1)*P3(1)
        x91 = P4(0)*w3(0)
        x92 = P4(0)*co(3)*w4(0)
        x93 = P1(1)*P4(1)
        x94 = P1(2)*w4(2)
        x95 = P2(1)*co(2)*w3(1)
        x96 = P1(2)*w3(2)
        x97 = P2(1)*co(2)*w4(1)
        x98 = P1(2)*P2(2)
        x99 = P2(3)*co(2)*w3(3)
        x100 = P1(2)*co(1)*w4(2)
        x101 = P1(2)*P3(2)
        x102 = P1(2)*P4(2)
        x103 = P1(3)*w4(3)
        x104 = P1(3)*w3(3)
        x105 = P2(2)*co(2)*w3(2)
        x106 = P1(3)*P2(3)
        x107 = P1(3)*co(1)*w4(3)
        x108 = P1(3)*P3(3)
        x109 = P4(0)*w4(0)
        x110 = P1(3)*co(3)*w3(3)
        x111 = P1(3)*P4(3)
        x112 = P2(0)*P3(0)
        x113 = P2(0)*P4(0)
        x114 = P4(2)*w3(2)
        x115 = P4(3)*w4(3)
        x116 = P2(2)*P3(2)
        x117 = P4(1)*w4(1)
        x118 = P2(2)*P4(2)
        x119 = P2(3)*P3(3)
        x120 = P2(3)*P4(3)
        x121 = P3(1)*co(1)*w4(1)
        x122 = P3(0)*co(1)*w4(0)
        x123 = P3(1)*co(3)*w4(1)
        x124 = P3(2)*co(1)*w4(2)
        x125 = P3(2)*co(3)*w4(2)
        x126 = P3(0)*P3(3)*w3(0)*w4(3)
        x127 = P3(0)*P4(0)*w3(0)*w4(0)
        x128 = P4(1)*co(1)*w4(1)
        x129 = P4(2)*co(1)*w4(2)
        x130 = P3(0)*P4(2)*w3(2)*w4(0)
        x131 = P4(2)*co(3)*w4(2)
        x132 = P4(3)*co(1)*w4(3)
        x133 = P3(2)*co(5)*w4(2)
        x134 = P3(1)*co(5)*w4(1)
        x135 = P3(3)*co(5)*w4(3)
        x136 = P4(0)*co(1)*w4(0)
        x137 = P4(0)*co(3)*w3(0)
        x138 = P3(1)*P4(1)*w3(1)*w4(1)
        x139 = P3(1)*P4(1)*co(7)
        x140 = P4(2)*co(0)*w3(2)
        x141 = P3(1)*P4(2)*w3(1)*w4(2)
        x142 = P4(3)*co(0)*w3(3)
        x143 = P4(3)*co(4)*w4(3)
        x144 = P3(2)*co(3)*w3(2)
        x145 = P4(1)*co(0)*w3(1)
        x146 = P3(2)*P4(1)*w3(2)*w4(1)
        x147 = P3(2)*P4(2)*w3(2)*w4(2)
        x148 = co(7)*w3(1)*w4(1)
        x149 = P3(2)*P4(2)
        x150 = co(7)*w3(3)*w4(3)
        x151 = P3(3)*co(1)*w4(3)
        x152 = P3(3)*co(4)*w3(3)
        x153 = P3(3)*P4(3)*w3(3)*w4(3)
        x154 = P3(3)*P4(3)
        x155 = co(7)*w3(2)*w4(2)
        x156 = P4(0)*P4(1)*w3(1)*w4(0)
        x157 = P4(2)*co(5)*w4(2)
        x158 = P4(2)*co(5)*w3(2)
        x159 = P4(3)*co(5)*w4(3)
        x160 = P4(3)*co(5)*w3(3)
        x161 = co(1)*w3(0)*w4(0)
        x162 = P2(0)*co(2)*w3(0)
        x163 = P1(1)*w4(1)
        x164 = P2(0)*co(2)*w4(0)
        x165 = P2(1)*co(9)*w3(1)*w4(1)
        x166 = P2(1)*co(9)*w3(2)*w4(2)
        x167 = P2(1)*co(9)*w3(3)*w4(3)
        x168 = co(1)*w3(1)*w4(1)
        x169 = co(3)*w3(1)*w4(1)
        x170 = P3(3)*co(3)*w4(3)
        x171 = P1(2)*P3(2)*w3(2)*w4(2)
        x172 = P1(2)*w3(2)*w4(2)
        x173 = P1(2)*P4(2)*w3(2)*w4(2)
        x174 = P3(0)*w4(0)
        x175 = P3(0)*co(5)*w4(0)
        x176 = P3(0)*P4(0)
        x177 = P3(0)*co(4)*w3(0)
        x178 = P3(3)*co(3)*w3(3)
        x179 = P4(0)*co(0)*w3(0)
        x180 = P4(0)*co(4)*w4(0)
        x181 = co(7)*w3(0)*w4(0)
        x182 = P4(0)*P4(1)*w3(0)*w4(1)
        x183 = 2*P1(1)*co(2)*w4(1)
        x184 = 2*P1(1)*co(2)*w3(1)
        x185 = 2*P1(0)*co(2)*w3(0)
        x186 = 2*P1(2)*co(2)*w3(2)
        x187 = 2*P1(3)*co(2)*w3(3)
        x188 = 2*P3(1)*co(2)*w3(1)
        x189 = 2*P3(2)*co(2)*w3(2)
        x190 = 2*P3(3)*co(2)*w3(3)
        x191 = 2*P4(1)*co(2)*w3(1)
        x192 = 2*P4(2)*co(2)*w4(2)
        x193 = 2*P4(2)*co(2)*w3(2)
        x194 = 2*P4(3)*co(2)*w3(3)
        x195 = P1(1)*P2(1)
        x196 = 2*P3(0)*co(2)*w3(0)
        x197 = 2*P4(0)*co(2)*w3(0)
        x198 = P2(1)*w4(1)
        x199 = 2*P2(0)*co(2)*w3(0)
        x200 = P2(0)*w4(0)
        x201 = 2*P2(1)*co(2)*w3(1)
        x202 = P2(2)*w4(2)
        x203 = 2*P2(2)*co(2)*w3(2)
        x204 = P2(0)*w3(0)
        x205 = 2*P2(3)*co(2)*w4(3)
        x206 = 2*P2(3)*co(2)*w3(3)
        x207 = P2(1)*P3(1)
        x208 = P2(1)*P4(1)
        x209 = 2*P3(0)*P4(0)
        x210 = 2*P3(1)*P4(1)
        x211 = 2*co(3)
        x212 = P3(1)*P4(1)
        x213 = 2*P3(2)*P4(2)
        x214 = 2*P3(3)*P4(3)
        x215 = P2(1)*w3(1)
        x216 = 4*co(2)*w3(0)*w4(0)
        x217 = 4*co(2)*w3(1)*w4(1)
        x218 = 4*co(2)
        x219 = 4*co(2)*w3(3)*w4(3)
        do j = riMaxIn, 0, -1
          x220 = cima*w2(0)*wl(0,j)
          wp(0,j) = P1(0)*x220*x60 - P1(1)*x165*x220 - P1(1)*x166*x220 - P1(1)*&
                    x167*x220 + P1(1)*x220*x80 + 2*P2(2)*co(2)*x172*x220 + P3(0&
                    )*x220*x61 - P3(1)*x165*x220 - P3(1)*x166*x220 - P3(1)*x167&
                    *x220 + P3(1)*x220*x80 + P4(0)*x220*x60 + P4(0)*x220*x61 - &
                    P4(1)*x165*x220 - P4(1)*x166*x220 - P4(1)*x167*x220 + P4(1 &
                    )*x220*x80 - P4(2)*co(1)*x172*x220 + co(0)*x127*x220 - co(0&
                    )*x130*x220 + co(0)*x138*x220 + co(0)*x147*x220 + co(0)*   &
                    x153*x220 - co(1)*x12*x220 + co(1)*x126*x220 - co(1)*x13*  &
                    x220 + co(1)*x130*x220 - co(1)*x14*x220 - 2*co(1)*x147*x220&
                     - co(1)*x15*x220 - co(1)*x16*x220 - co(1)*x17*x220 - co(1 &
                    )*x171*x220 - co(10)*x12*x220 - co(10)*x13*x220 + co(3)*   &
                    x126*x220 - co(3)*x14*x220 - co(3)*x141*x220 - co(3)*x15*  &
                    x220 + co(3)*x156*x220 - co(3)*x16*x220 - co(3)*x17*x220 - &
                    co(3)*x171*x220 - co(3)*x173*x220 + co(4)*x127*x220 + co(4 &
                    )*x138*x220 + co(4)*x141*x220 + co(4)*x146*x220 + co(4)*   &
                    x147*x220 + co(4)*x153*x220 + co(5)*x12*x220 + co(5)*x13*  &
                    x220 + co(5)*x14*x220 + co(5)*x15*x220 - co(5)*x156*x220 + &
                    co(5)*x16*x220 + co(5)*x17*x220 - co(5)*x182*x220 + co(6)* &
                    x12*x220 + co(6)*x13*x220 + co(6)*x14*x220 + co(6)*x15*x220&
                     + co(6)*x16*x220 + co(7)*x127*x220 + co(7)*x147*x220 + co(&
                    8)*x16*x220 + x0*x1*x220 - x0*x10*x220 - x0*x11*x220 + x0* &
                    x220*x23 + x0*x220*x25 - x0*x220*x27 + x0*x220*x29 + x0*   &
                    x220*x32 + x0*x220*x33 - x0*x220*x47 - x0*x220*x8 + x1*x101&
                    *x220 + x1*x102*x220 + x1*x108*x220 + x1*x111*x220 + x1*x2*&
                    x220 - x1*x209*x220 + x1*x210*x220 + x1*x213*x220 + x1*x214&
                    *x220 + x1*x220*x3 + x1*x220*x4 + x1*x220*x5 + x1*x220*x6  &
                     - x1*x220*x62 - x1*x220*x71 + x1*x220*x90 + x1*x220*x93 - &
                    x10*x101*x220 - x10*x102*x220 - x10*x108*x220 - x10*x111*  &
                    x220 - x10*x2*x220 + x10*x209*x220 - x10*x210*x220 - x10*  &
                    x213*x220 - x10*x214*x220 - x10*x220*x3 - x10*x220*x4 - x10&
                    *x220*x5 - x10*x220*x6 + x10*x220*x62 + x10*x220*x7 + x10* &
                    x220*x71 + x10*x220*x9 - x10*x220*x90 - x10*x220*x93 - x100&
                    *x220*x63 - x100*x220*x69 - x100*x220*x72 - x100*x220*x78  &
                     + x100*x220*x87 + x100*x220*x91 - x101*x11*x220 - x101*   &
                    x220*x49 + x101*x220*x50 + x101*x220*x51 + x101*x220*x52 - &
                    x101*x220*x8 - x102*x11*x220 - x102*x220*x49 + x102*x220*  &
                    x50 + x102*x220*x51 + x102*x220*x52 - x102*x220*x8 + x103* &
                    x105*x220 - x103*x162*x220 + x103*x184*x220 - x103*x185*   &
                    x220 + x103*x186*x220 + x103*x188*x220 + x103*x189*x220 +  &
                    x103*x191*x220 + x103*x193*x220 - x103*x196*x220 - x103*   &
                    x197*x220 + x103*x220*x95 - x104*x164*x220 + x104*x183*x220&
                     - x104*x220*x73 + x104*x220*x82 + x104*x220*x89 + x104*   &
                    x220*x97 - x105*x109*x220 + x105*x115*x220 + x105*x117*x220&
                     - x105*x174*x220 + x105*x220*x65 + x105*x220*x70 - x105*  &
                    x220*x75 + x106*x220*x35 - x106*x220*x41 - x106*x220*x42 - &
                    x106*x220*x43 - x106*x220*x49 + x106*x220*x50 + x106*x220* &
                    x51 + x106*x220*x52 + x106*x220*x57 - x107*x114*x220 - x107&
                    *x220*x63 - x107*x220*x67 - x107*x220*x72 + x107*x220*x87  &
                     + x107*x220*x91 - x108*x11*x220 + x108*x219*x220 - x108*  &
                    x220*x44 - x108*x220*x46 - x108*x220*x49 + x108*x220*x50 + &
                    x108*x220*x51 + x108*x220*x52 - x108*x220*x8 + x109*x110*  &
                    x220 + x109*x144*x220 - x109*x158*x220 - x109*x160*x220 -  &
                    x109*x184*x220 - x109*x186*x220 - x109*x187*x220 - x109*   &
                    x188*x220 - x109*x189*x220 - x109*x190*x220 - x109*x193*   &
                    x220 - x109*x194*x220 - x109*x220*x95 - x109*x220*x99 - x11&
                    *x111*x220 - x11*x2*x220 + x11*x209*x220 - x11*x210*x220 - &
                    x11*x213*x220 - x11*x214*x220 - x11*x220*x3 - x11*x220*x4  &
                     - x11*x220*x5 - x11*x220*x6 + x11*x220*x62 + x11*x220*x7  &
                     + x11*x220*x71 + x11*x220*x9 - x11*x220*x90 - x11*x220*x93&
                     - x110*x220*x65 - x110*x220*x68 - x110*x220*x77 + x111*   &
                    x219*x220 - x111*x220*x44 - x111*x220*x46 - x111*x220*x49  &
                     + x111*x220*x50 + x111*x220*x51 + x111*x220*x52 - x111*   &
                    x220*x8 - x112*x220*x35 + x112*x220*x41 + x112*x220*x42 +  &
                    x112*x220*x43 + x112*x220*x49 - x112*x220*x50 - x112*x220* &
                    x51 - x112*x220*x52 + x112*x220*x53 - x113*x220*x35 + x113*&
                    x220*x41 + x113*x220*x42 + x113*x220*x49 - x113*x220*x50 - &
                    x113*x220*x51 - x113*x220*x52 + x113*x220*x53 - x114*x121* &
                    x220 - x114*x123*x220 - x114*x128*x220 - x114*x132*x220 +  &
                    x114*x136*x220 - x114*x164*x220 - x114*x170*x220 + x114*   &
                    x183*x220 - x114*x220*x73 - x114*x220*x79 + x114*x220*x85  &
                     + x114*x220*x89 + x114*x220*x92 + x114*x220*x97 + x115*   &
                    x137*x220 + x115*x158*x220 - x115*x162*x220 - x115*x177*   &
                    x220 + x115*x184*x220 - x115*x185*x220 + x115*x186*x220 +  &
                    x115*x188*x220 + x115*x189*x220 + x115*x191*x220 + x115*   &
                    x193*x220 - x115*x196*x220 - x115*x197*x220 + x115*x220*x95&
                     + x116*x220*x35 - x116*x220*x41 - x116*x220*x42 - x116*   &
                    x220*x43 - x116*x220*x49 + x116*x220*x50 + x116*x220*x51 + &
                    x116*x220*x52 + x116*x220*x56 + x117*x152*x220 + x117*x158*&
                    x220 + x117*x160*x220 - x117*x162*x220 - x117*x177*x220 -  &
                    x117*x185*x220 + x117*x186*x220 + x117*x187*x220 + x117*   &
                    x190*x220 + x117*x193*x220 + x117*x194*x220 - x117*x196*   &
                    x220 + x117*x220*x99 + x118*x220*x35 - x118*x220*x41 - x118&
                    *x220*x42 - x118*x220*x43 - x118*x220*x49 + x118*x220*x50  &
                     + x118*x220*x51 + x118*x220*x52 + x118*x220*x56 + x119*   &
                    x220*x35 - x119*x220*x41 - x119*x220*x42 - x119*x220*x43 - &
                    x119*x220*x49 + x119*x220*x50 + x119*x220*x51 + x119*x220* &
                    x52 + x119*x220*x57 + x12*x220*x54 + x120*x220*x35 - x120* &
                    x220*x41 - x120*x220*x42 - x120*x220*x43 - x120*x220*x49 + &
                    x120*x220*x50 + x120*x220*x51 + x120*x220*x52 + x120*x220* &
                    x57 - x121*x220*x67 - x121*x220*x69 - x121*x220*x78 + x121*&
                    x220*x87 + x121*x220*x91 + x122*x220*x63 + x122*x220*x67 + &
                    x122*x220*x69 + x122*x220*x72 + x122*x220*x78 - x123*x220* &
                    x78 + x123*x220*x87 - x123*x220*x96 - x124*x220*x63 - x124*&
                    x220*x69 - x124*x220*x72 - x124*x220*x78 + x124*x220*x87 + &
                    x124*x220*x91 - x125*x220*x63 - x125*x220*x69 - x125*x220* &
                    x72 - x125*x220*x78 - x125*x220*x81 + x125*x220*x87 - x126*&
                    x220*x54 + x127*x218*x220 - x128*x220*x67 - x128*x220*x69  &
                     - x128*x220*x78 + x128*x220*x87 + x128*x220*x91 - x129*   &
                    x220*x63 - x129*x220*x69 - x129*x220*x72 - x129*x220*x78 + &
                    x129*x220*x87 + x129*x220*x91 + x13*x220*x54 - x130*x220*  &
                    x54 - x131*x220*x72 - x131*x220*x78 - x131*x220*x81 + x131*&
                    x220*x87 - x132*x220*x63 - x132*x220*x67 - x132*x220*x72 + &
                    x132*x220*x87 + x132*x220*x91 + x133*x220*x63 + x133*x220* &
                    x69 - x133*x220*x87 + x134*x220*x67 + x134*x220*x69 - x134*&
                    x220*x87 + x135*x220*x63 + x135*x220*x67 - x135*x220*x87 + &
                    x136*x220*x63 + x136*x220*x67 + x136*x220*x69 + x136*x220* &
                    x72 + x136*x220*x78 + x137*x220*x65 + x137*x220*x68 + x137*&
                    x220*x70 + x137*x220*x77 - x138*x211*x220 + x138*x218*x220 &
                     + x139*x20*x220 + x139*x220*x24 - x139*x220*x37 + x139*   &
                    x220*x48 + x14*x220*x54 + x140*x220*x65 + x140*x220*x70 +  &
                    x141*x220*x54 - x142*x174*x220 + x142*x220*x65 + x142*x220*&
                    x68 + x143*x220*x63 + x143*x220*x67 - x144*x220*x65 - x144*&
                    x220*x70 - x145*x174*x220 + x145*x220*x68 + x145*x220*x70  &
                     + x146*x220*x54 - x147*x211*x220 + x147*x218*x220 + x148* &
                    x149*x220 + x148*x154*x220 - x148*x176*x220 + x149*x150*   &
                    x220 - x149*x181*x220 - x149*x220*x49 + x149*x220*x50 +    &
                    x149*x220*x51 + x149*x220*x52 + x15*x220*x54 + x150*x154*  &
                    x220 - x150*x176*x220 - x151*x220*x63 - x151*x220*x67 -    &
                    x151*x220*x72 + x151*x220*x91 + x152*x220*x77 + x153*x218* &
                    x220 + x154*x155*x220 - x154*x181*x220 - x154*x220*x49 +   &
                    x154*x220*x50 + x154*x220*x51 + x154*x220*x52 - x155*x176* &
                    x220 - x156*x220*x54 + x157*x220*x72 + x157*x220*x78 - x157&
                    *x220*x91 + x159*x220*x72 - x159*x220*x91 + x16*x220*x54 - &
                    x161*x209*x220 - x161*x220*x62 - x161*x220*x71 - x162*x163*&
                    x220 - x162*x220*x65 - x162*x220*x68 - x162*x220*x70 - x162&
                    *x220*x77 - x162*x220*x94 + x163*x186*x220 - x163*x196*x220&
                     - x163*x220*x76 - x164*x220*x63 - x164*x220*x67 - x164*   &
                    x220*x69 - x164*x220*x72 - x164*x220*x78 - x164*x220*x81 - &
                    x164*x220*x96 - x168*x210*x220 - x168*x220*x90 - x168*x220*&
                    x93 - x169*x220*x90 - x169*x220*x93 + x17*x220*x54 - x170* &
                    x220*x63 - x170*x220*x72 - x170*x220*x81 - x170*x220*x96 + &
                    x171*x218*x220 + x173*x218*x220 - x174*x184*x220 - x174*   &
                    x186*x220 - x174*x187*x220 - x174*x188*x220 - x174*x189*   &
                    x220 - x174*x190*x220 - x174*x191*x220 - x174*x194*x220 -  &
                    x174*x220*x95 - x174*x220*x99 - x175*x220*x63 - x175*x220* &
                    x67 - x175*x220*x69 + x176*x220*x49 - x176*x220*x50 - x176*&
                    x220*x51 - x176*x220*x52 - x177*x220*x77 - x178*x220*x65 - &
                    x178*x220*x77 - x179*x220*x65 - x179*x220*x68 - x179*x220* &
                    x70 + x18*x220*x3 + x18*x220*x6 - x180*x220*x63 - x180*x220&
                    *x67 - x180*x220*x69 - x182*x220*x54 + x183*x220*x67 + x183&
                    *x220*x69 - x183*x220*x74 + x183*x220*x78 - x183*x220*x91  &
                     + x184*x220*x68 + x184*x220*x70 - x184*x220*x75 + x184*   &
                    x220*x77 + x184*x220*x94 - x185*x220*x65 - x185*x220*x68 - &
                    x185*x220*x70 - x185*x220*x94 + x186*x220*x65 + x186*x220* &
                    x70 - x186*x220*x75 + x187*x220*x65 + x187*x220*x68 - x187*&
                    x220*x75 + x187*x220*x77 + x187*x220*x94 + x188*x220*x68 + &
                    x188*x220*x70 - x188*x220*x75 + x188*x220*x94 + x189*x220* &
                    x65 + x189*x220*x70 - x189*x220*x75 + x19*x2*x220 + x19*   &
                    x220*x6 - x19*x220*x7 - x19*x220*x9 + x190*x220*x65 + x190*&
                    x220*x68 - x190*x220*x75 + x190*x220*x94 + x191*x220*x68 + &
                    x191*x220*x70 - x191*x220*x75 + x191*x220*x77 + x191*x220* &
                    x94 + x192*x220*x69 - x192*x220*x74 + x192*x220*x78 - x192*&
                    x220*x91 + x193*x220*x65 + x193*x220*x70 - x193*x220*x75 + &
                    x194*x220*x65 + x194*x220*x68 - x194*x220*x75 + x194*x220* &
                    x94 - x195*x220*x49 + x195*x220*x50 + x195*x220*x51 + x195*&
                    x220*x52 + x195*x220*x55 - x196*x220*x65 - x196*x220*x68 - &
                    x196*x220*x77 - x196*x220*x94 - x197*x220*x65 - x197*x220* &
                    x68 - x197*x220*x70 - x197*x220*x94 - x198*x199*x220 + x198&
                    *x203*x220 + x198*x206*x220 - x199*x202*x220 + x2*x220*x25 &
                     - x2*x220*x27 + x2*x220*x29 + x2*x220*x33 - x2*x220*x47 - &
                    x2*x220*x8 + x20*x21*x220 + x20*x22*x220 - x20*x220*x39 -  &
                    x200*x201*x220 - x200*x203*x220 - x200*x206*x220 + x201*   &
                    x202*x220 + x202*x206*x220 - x204*x205*x220 + x205*x215*   &
                    x220 + x205*x220*x84 - x207*x220*x49 + x207*x220*x50 + x207&
                    *x220*x51 + x207*x220*x52 + x207*x220*x55 - x208*x220*x49  &
                     + x208*x220*x50 + x208*x220*x51 + x208*x220*x52 + x208*   &
                    x220*x55 - x209*x220*x45 + x209*x220*x8 + x21*x220*x24 -   &
                    x21*x220*x37 - x210*x220*x8 - x212*x220*x49 + x212*x220*x50&
                     + x212*x220*x51 + x212*x220*x52 - x213*x220*x8 - x214*x220&
                    *x44 - x214*x220*x46 - x214*x220*x8 + x216*x220*x62 + x216*&
                    x220*x71 + x217*x220*x90 + x217*x220*x93 + x22*x220*x24 -  &
                    x22*x220*x37 + x220*x23*x4 + x220*x23*x6 - x220*x23*x7 -   &
                    x220*x23*x9 - x220*x24*x39 + x220*x25*x3 + x220*x25*x4 +   &
                    x220*x25*x5 + x220*x25*x6 - x220*x25*x7 - x220*x25*x9 +    &
                    x220*x26*x27 - x220*x26*x29 - x220*x26*x32 - x220*x26*x33  &
                     + x220*x26*x53 - x220*x27*x28 - x220*x27*x3 - x220*x27*x30&
                     - x220*x27*x31 - x220*x27*x4 - x220*x27*x5 - x220*x27*x6  &
                     + x220*x27*x7 + x220*x27*x9 + x220*x28*x29 + x220*x28*x32 &
                     + x220*x28*x33 + x220*x28*x55 + x220*x29*x3 + x220*x29*x30&
                     + x220*x29*x31 + x220*x29*x4 + x220*x29*x5 + x220*x29*x58 &
                     + x220*x29*x6 - x220*x29*x7 - x220*x29*x9 + x220*x3*x32 + &
                    x220*x3*x33 - x220*x3*x44 - x220*x3*x46 + x220*x3*x57 -    &
                    x220*x3*x8 + x220*x30*x32 + x220*x30*x33 + x220*x30*x56 +  &
                    x220*x31*x32 + x220*x31*x33 + x220*x31*x57 + x220*x32*x4 + &
                    x220*x32*x5 + x220*x32*x6 - x220*x32*x7 - x220*x32*x9 +    &
                    x220*x33*x4 + x220*x33*x5 + x220*x33*x58 + x220*x33*x6 -   &
                    x220*x33*x7 - x220*x33*x9 + x220*x34*x35 - x220*x34*x41 -  &
                    x220*x34*x42 - x220*x34*x43 - x220*x34*x49 + x220*x34*x50  &
                     + x220*x34*x51 + x220*x34*x52 + x220*x34*x55 + x220*x35*  &
                    x36 - x220*x35*x40 - x220*x35*x59 + x220*x35*x98 - x220*x36&
                    *x41 - x220*x36*x42 - x220*x36*x43 - x220*x36*x49 + x220*  &
                    x36*x51 + x220*x36*x56 + x220*x37*x39 - x220*x38*x49 + x220&
                    *x38*x50 + x220*x38*x51 + x220*x38*x52 + x220*x38*x57 -    &
                    x220*x39*x48 - x220*x4*x47 - x220*x4*x8 + x220*x40*x41 +   &
                    x220*x40*x42 + x220*x40*x43 + x220*x40*x49 - x220*x40*x50  &
                     - x220*x40*x51 - x220*x40*x52 + x220*x40*x53 + x220*x41*  &
                    x59 - x220*x41*x98 + x220*x42*x59 - x220*x42*x98 - x220*x43&
                    *x98 - x220*x44*x6 - x220*x45*x62 - x220*x45*x7 - x220*x45*&
                    x71 - x220*x45*x9 - x220*x46*x6 - x220*x47*x6 + x220*x49*  &
                    x59 + x220*x49*x62 + x220*x49*x71 - x220*x49*x90 - x220*x49&
                    *x93 - x220*x49*x98 - x220*x5*x8 - x220*x50*x59 - x220*x50*&
                    x62 - x220*x50*x71 + x220*x50*x90 + x220*x50*x93 + x220*x50&
                    *x98 - x220*x51*x59 - x220*x51*x62 - x220*x51*x71 + x220*  &
                    x51*x90 + x220*x51*x93 + x220*x51*x98 - x220*x52*x59 - x220&
                    *x52*x62 - x220*x52*x71 + x220*x52*x90 + x220*x52*x93 +    &
                    x220*x52*x98 + x220*x53*x59 + x220*x57*x6 - x220*x6*x8 +   &
                    x220*x63*x64 - x220*x63*x79 + x220*x63*x82 + x220*x63*x85  &
                     + x220*x63*x89 + x220*x63*x92 + x220*x64*x67 + x220*x64*  &
                    x69 + x220*x64*x72 + x220*x64*x78 + x220*x65*x66 + x220*x65&
                    *x99 + x220*x66*x68 + x220*x66*x70 + x220*x66*x77 - x220*  &
                    x67*x73 - x220*x67*x79 + x220*x67*x85 - x220*x67*x88 + x220&
                    *x67*x89 + x220*x67*x97 + x220*x68*x95 + x220*x68*x99 -    &
                    x220*x69*x73 + x220*x69*x82 - x220*x69*x88 + x220*x69*x89  &
                     + x220*x69*x92 + x220*x69*x97 + x220*x7*x8 - x220*x70*x76 &
                     + x220*x70*x95 - x220*x72*x79 + x220*x72*x82 + x220*x72*  &
                    x85 + x220*x72*x89 + x220*x73*x74 - x220*x73*x78 + x220*x73&
                    *x87 + x220*x73*x91 - x220*x73*x96 + x220*x74*x79 - x220*  &
                    x74*x82 - x220*x74*x85 - x220*x74*x97 + x220*x75*x76 - x220&
                    *x75*x95 - x220*x75*x99 + x220*x77*x95 + x220*x77*x99 +    &
                    x220*x78*x82 - x220*x78*x88 + x220*x78*x89 + x220*x78*x92  &
                     + x220*x78*x97 - x220*x79*x81 + x220*x79*x87 - x220*x79*  &
                    x96 + x220*x8*x9 - x220*x8*x90 - x220*x8*x93 + x220*x81*x82&
                     + x220*x81*x85 + x220*x81*x89 + x220*x81*x92 - x220*x82*  &
                    x87 - x220*x82*x91 + x220*x83*x84 + x220*x83*x86 - x220*x85&
                    *x87 - x220*x85*x91 + x220*x85*x96 + x220*x87*x88 - x220*  &
                    x87*x97 + x220*x88*x91 + x220*x89*x96 - x220*x91*x97 + x220&
                    *x92*x96 + x220*x94*x95 + x220*x94*x99 + x220*x96*x97
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x221 = co(2)*w4(mu)
            x222 = co(2)*w3(mu)
            x223 = co(1)*w3(1)*w4(mu)
            x224 = co(3)*w3(mu)*w4(1)
            x225 = co(1)*w3(2)*w4(mu)
            x226 = co(3)*w3(mu)*w4(2)
            x227 = co(1)*w3(3)*w4(mu)
            x228 = co(3)*w3(mu)*w4(3)
            x229 = co(1)*w3(0)*w4(mu)
            x230 = co(3)*w3(mu)*w4(0)
            x231 = 2*co(2)*w4(mu)
            x232 = 2*co(2)*w3(mu)
            x233 = 2*co(2)*w3(2)*w4(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - P1(2)*x220*x233 + P1(mu)*x220*x49 - P1(&
                          mu)*x220*x50 - P1(mu)*x220*x51 - P1(mu)*x220*x52 - P2&
                          (2)*co(2)*w3(2)*w4(mu)*x220 - P2(3)*w4(3)*x220*x222  &
                           - P2(mu)*x220*x35 + P2(mu)*x220*x41 + P2(mu)*x220*  &
                          x42 + P2(mu)*x220*x43 + P2(mu)*x220*x49 - P2(mu)*x220&
                          *x50 - P2(mu)*x220*x51 - P2(mu)*x220*x52 - P3(0)*x220&
                          *x229 - P3(0)*x220*x230 + P3(1)*x220*x223 + P3(1)*   &
                          x220*x224 + P3(2)*x220*x225 + P3(2)*x220*x226 - P3(2 &
                          )*x220*x233 + P3(3)*x220*x227 + P3(3)*x220*x228 - P3(&
                          mu)*x1*x220 + P3(mu)*x10*x220 + P3(mu)*x11*x220 + P3(&
                          mu)*x220*x49 - P3(mu)*x220*x50 - P3(mu)*x220*x51 - P3&
                          (mu)*x220*x52 + P3(mu)*x220*x8 - P4(0)*x220*x229 - P4&
                          (0)*x220*x230 + P4(1)*x220*x223 + P4(1)*x220*x224 +  &
                          P4(2)*x220*x225 + P4(2)*x220*x226 - P4(2)*x220*x233  &
                           + P4(3)*x220*x227 + P4(3)*x220*x228 - P4(mu)*x1*x220&
                           + P4(mu)*x10*x220 + P4(mu)*x11*x220 + P4(mu)*x220*  &
                          x49 - P4(mu)*x220*x50 - P4(mu)*x220*x51 - P4(mu)*x220&
                          *x52 + P4(mu)*x220*x8 - x103*x220*x232 - x104*x220*  &
                          x231 + x109*x220*x232 - x115*x220*x232 - x117*x220*  &
                          x232 - x163*x220*x232 + x174*x220*x232 - x198*x220*  &
                          x222 + x200*x220*x222 - x202*x220*x222 + x204*x220*  &
                          x221 - x215*x220*x221 - x220*x221*x86 - x220*x231*x63&
                           - x220*x231*x69 - x220*x231*x72 + x220*x231*x74 -   &
                          x220*x231*x78 - x220*x231*x81 + x220*x231*x87 + x220*&
                          x231*x91 - x220*x232*x65 - x220*x232*x68 - x220*x232*&
                          x70 + x220*x232*x75 - x220*x232*x77 - x220*x232*x94
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) + gg(nu,mu)*x220*x27 - gg(nu,mu)*x220* &
                            x29 - gg(nu,mu)*x220*x32 - gg(nu,mu)*x220*x33 + w4(&
                            nu)*x220*x232
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSSVVS
end module lcSSVVS
