!******************************************************************************!
!                                                                              !
!    lcSVSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVSSV0)
!       P(2,5)*P(5,2)*c0
!       c1*(P(2,2)*P(5,3) + P(2,2)*P(5,4) + P(2,5)*P(5,3) + P(2,5)*P(5,4))
!       c2*(2*P(2,3)*P(5,3) + P(2,3)*P(5,4) + P(2,4)*P(5,3) + 2*P(2,4)*P(5,4))
!       c3*(P(2,3)*P(5,2) + P(2,3)*P(5,5) + P(2,4)*P(5,2) + P(2,4)*P(5,5))
!       P(2,2)*P(5,5)*c4
!       c5*(P(2,2)*P(5,2) + P(2,5)*P(5,5))
!       Metric(2,5)*P(-1,2)*P(-1,5)*c6
!       c7*(Metric(2,5)*P(-1,3)**2 + Metric(2,5)*P(-1,4)**2)
!       Metric(2,5)*P(-1,3)*P(-1,4)*c8
!       c9*(Metric(2,5)*P(-1,2)*P(-1,3) + Metric(2,5)*P(-1,2)*P(-1,4) + Metric(2,
!       5)*P(-1,3)*P(-1,5) + Metric(2,5)*P(-1,4)*P(-1,5))
!       c10*(Metric(2,5)*P(-1,2)**2 + Metric(2,5)*P(-1,5)**2)
        x0 = P1(1)*w2(1)
        x1 = co(5)*x0
        x2 = P1(2)*w2(2)
        x3 = co(5)*x2
        x4 = co(5)*w2(3)
        x5 = P1(3)*x4
        x6 = P2(0)*w2(0)
        x7 = co(4)*x6
        x8 = P2(1)*w2(1)
        x9 = co(5)*x8
        x10 = P2(2)*w2(2)
        x11 = co(5)*x10
        x12 = P2(3)*x4
        x13 = P3(0)*w2(0)
        x14 = co(3)*x13
        x15 = P3(1)*w2(1)
        x16 = co(5)*x15
        x17 = P3(2)*w2(2)
        x18 = co(5)*x17
        x19 = P3(3)*x4
        x20 = P4(0)*w2(0)
        x21 = co(3)*x20
        x22 = P4(1)*w2(1)
        x23 = co(5)*x22
        x24 = P4(2)*w2(2)
        x25 = co(5)*x24
        x26 = P4(3)*x4
        x27 = P1(0)*w2(0)
        x28 = co(5)*x27
        x29 = -x28
        x30 = co(5)*x6
        x31 = -x30
        x32 = co(4)*x8
        x33 = -x32
        x34 = co(4)*x10
        x35 = -x34
        x36 = P2(3)*w2(3)
        x37 = co(4)*x36
        x38 = -x37
        x39 = co(5)*x13
        x40 = -x39
        x41 = -co(3)*x15
        x42 = -co(3)*x17
        x43 = P3(3)*w2(3)
        x44 = -co(3)*x43
        x45 = co(5)*x20
        x46 = -x45
        x47 = -co(3)*x22
        x48 = -co(3)*x24
        x49 = P4(3)*w2(3)
        x50 = -co(3)*x49
        x51 = x1 + x11 + x12 + x14 + x16 + x18 + x19 + x21 + x23 + x25 + x26 + &
              x29 + x3 + x31 + x33 + x35 + x38 + x40 + x41 + x42 + x44 + x46 + &
              x47 + x48 + x5 + x50 + x7 + x9
        x52 = co(2)*x22
        x53 = co(2)*x24
        x54 = co(2)*x49
        x55 = co(2)*x20
        x56 = co(2)*x13
        x57 = co(2)*x15
        x58 = co(2)*x17
        x59 = co(2)*x43
        x60 = P1(3)*w2(3)
        x61 = -co(1)*x0 + co(1)*x13 - co(1)*x15 - co(1)*x17 - co(1)*x2 + co(1)*&
              x20 - co(1)*x22 - co(1)*x24 + co(1)*x27 - co(1)*x43 - co(1)*x49  &
               - co(1)*x60 + x1 + x11 + x12 + x14 + x16 + x18 + x19 + x21 + x23&
               + x25 + x26 + x29 + x3 + x31 + x33 + x35 + x38 + x40 + x41 + x42&
               + x44 + x46 + x47 + x48 + x5 + x50 + x7 + x9
        x62 = P3(1)**2
        x63 = P3(2)**2
        x64 = P3(3)**2
        x65 = P4(1)**2
        x66 = P4(2)**2
        x67 = P4(3)**2
        x68 = P2(0)**2
        x69 = P3(0)**2
        x70 = P4(0)**2
        x71 = P2(1)**2
        x72 = P2(2)**2
        x73 = P2(3)**2
        x74 = 2*co(10)
        x75 = P2(0)*co(6)
        x76 = P1(0)*co(9)
        x77 = P3(1)*P4(1)
        x78 = P3(2)*P4(2)
        x79 = P3(3)*P4(3)
        x80 = P2(1)*co(6)
        x81 = P1(1)*co(9)
        x82 = P2(2)*co(6)
        x83 = P1(2)*co(9)
        x84 = P2(3)*co(6)
        x85 = P1(3)*co(9)
        x86 = P3(0)*P4(0)
        x87 = 2*P1(0)*co(10)
        x88 = 2*P2(0)*co(10)
        x89 = 2*co(9)
        x90 = 2*P3(1)*co(10)
        x91 = 2*P4(1)*co(10)
        x92 = 2*P2(2)*co(10)
        x93 = 2*P1(2)*co(10)
        x94 = 2*P2(3)*co(10)
        x95 = 2*P3(3)*co(10)
        x96 = co(0)*w2(1)
        x98 = -co(5)
        do j = riMaxIn, 0, -1
          x97 = cima*w3(0)*w4(0)*wl(0,j)
          wp(:,j) = P1(:)*x51*x97 + P2(:)*(-P1(1)*x96*x97 - P2(1)*x96*x97 - P3(&
                    1)*x96*x97 - P4(1)*x96*x97 - co(0)*x10*x97 + co(0)*x13*x97 &
                     - co(0)*x17*x97 - co(0)*x2*x97 + co(0)*x20*x97 - co(0)*x24&
                    *x97 + co(0)*x27*x97 - co(0)*x36*x97 - co(0)*x43*x97 - co(0&
                    )*x49*x97 + co(0)*x6*x97 - co(0)*x60*x97 + x1*x97 + 2*x11* &
                    x97 + 2*x12*x97 + x16*x97 + x18*x97 + x19*x97 + x23*x97 +  &
                    x25*x97 + x26*x97 - x28*x97 + x3*x97 - 2*x30*x97 - x32*x97 &
                     - x34*x97 - x37*x97 - x39*x97 - x45*x97 + x5*x97 + x7*x97 &
                     + 2*x9*x97) + P3(:)*(x52*x97 + x53*x97 + x54*x97 - x55*x97&
                     - 2*x56*x97 + 2*x57*x97 + 2*x58*x97 + 2*x59*x97 + x61*x97 &
                    ) + P4(:)*(2*x52*x97 + 2*x53*x97 + 2*x54*x97 - 2*x55*x97 - &
                    x56*x97 + x57*x97 + x58*x97 + x59*x97 + x61*x97) + w2(:)*(-&
                    P1(0)**2*co(10)*x97 + P1(0)*x75*x97 + P1(1)**2*co(10)*x97  &
                     + P1(1)*P2(1)*x74*x97 - P1(1)*x80*x97 + P1(1)*x90*x97 + P1&
                    (1)*x91*x97 + P1(2)**2*co(10)*x97 - P1(2)*x82*x97 + P1(2)* &
                    x92*x97 + P1(3)**2*co(10)*x97 + P1(3)*P4(3)*x74*x97 - P1(3 &
                    )*x84*x97 + P1(3)*x94*x97 + P1(3)*x95*x97 - P2(0)*x87*x97  &
                     + P2(1)*x90*x97 + P2(1)*x91*x97 + P2(3)*x95*x97 + P3(0)*  &
                    x75*x97 + P3(0)*x76*x97 - P3(0)*x87*x97 - P3(0)*x88*x97 -  &
                    P3(1)*x80*x97 - P3(1)*x81*x97 - P3(2)*x82*x97 - P3(2)*x83* &
                    x97 + P3(2)*x92*x97 + P3(2)*x93*x97 - P3(3)*x84*x97 - P3(3 &
                    )*x85*x97 + P4(0)*x75*x97 + P4(0)*x76*x97 - P4(0)*x87*x97  &
                     - P4(0)*x88*x97 - P4(1)*x80*x97 - P4(1)*x81*x97 - P4(2)*  &
                    x82*x97 - P4(2)*x83*x97 + P4(2)*x92*x97 + P4(2)*x93*x97 -  &
                    P4(3)*x84*x97 - P4(3)*x85*x97 + P4(3)*x94*x97 + co(10)*x62*&
                    x97 + co(10)*x63*x97 + co(10)*x64*x97 + co(10)*x65*x97 + co&
                    (10)*x66*x97 + co(10)*x67*x97 - co(10)*x69*x97 - co(10)*x70&
                    *x97 + co(6)*x68*x97 - co(6)*x71*x97 - co(6)*x72*x97 - co(6&
                    )*x73*x97 + co(7)*x62*x97 + co(7)*x63*x97 + co(7)*x64*x97  &
                     + co(7)*x65*x97 + co(7)*x66*x97 + co(7)*x67*x97 - co(7)*  &
                    x69*x97 - co(7)*x70*x97 + co(8)*x77*x97 + co(8)*x78*x97 +  &
                    co(8)*x79*x97 - co(8)*x86*x97 - co(9)*x62*x97 - co(9)*x63* &
                    x97 - co(9)*x64*x97 - co(9)*x65*x97 - co(9)*x66*x97 - co(9 &
                    )*x67*x97 + co(9)*x69*x97 + co(9)*x70*x97 - x68*x74*x97 +  &
                    x71*x74*x97 + x72*x74*x97 + x73*x74*x97 + x74*x77*x97 + x74&
                    *x78*x97 + x74*x79*x97 - x74*x86*x97 - x77*x89*x97 - x78*  &
                    x89*x97 - x79*x89*x97 + x86*x89*x97)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x99 = w2(mu)*(co(1) + x98)
            x100 = co(5)*w2(mu)
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) - P1(:)*x100*x97 + P2(:)*(co(0)*w2(mu)*  &
                          x97 + w2(mu)*x97*x98) + P3(:)*x97*x99 + P4(:)*x97*x99&
                           + gg(:,mu)*x51*x97 + w2(:)*(-P1(mu)*x74*x97 + P2(mu &
                          )*co(6)*x97 - P2(mu)*x74*x97 + P3(mu)*co(9)*x97 - P3(&
                          mu)*x74*x97 + P4(mu)*co(9)*x97 - P4(mu)*x74*x97)
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(:,riOut) = wp(:,riOut) - co(10)*gg(nu,mu)*w2(:)*x97 - gg(:,nu &
                            )*x100*x97
            end do 
          end do 
        end do 
      end select 
    end subroutine loopSVSSV
end module lcSVSSV
