!******************************************************************************!
!                                                                              !
!    lcSVSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVSVS0)
!       P(2,2)*P(4,4)*c0
!       c1*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,4)*P(4,2)*c2
!       c3*(P(2,2)*P(4,3) + P(2,2)*P(4,5) + P(2,4)*P(4,3) + P(2,4)*P(4,5))
!       c4*(2*P(2,3)*P(4,3) + P(2,3)*P(4,5) + P(2,5)*P(4,3) + 2*P(2,5)*P(4,5))
!       c5*(P(2,3)*P(4,2) + P(2,3)*P(4,4) + P(2,5)*P(4,2) + P(2,5)*P(4,4))
!       c6*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
!       Metric(2,4)*P(-1,2)*P(-1,4)*c7
!       c8*(Metric(2,4)*P(-1,3)**2 + Metric(2,4)*P(-1,5)**2)
!       Metric(2,4)*P(-1,3)*P(-1,5)*c9
!       c10*(Metric(2,4)*P(-1,2)*P(-1,3) + Metric(2,4)*P(-1,2)*P(-1,5) + Metric(2
!       ,4)*P(-1,3)*P(-1,4) + Metric(2,4)*P(-1,4)*P(-1,5))
        x0 = P2(0)**2
        x1 = w2(0)*w4(0)*x0
        x2 = P4(0)**2
        x3 = w2(0)*w4(0)*x2
        x4 = P2(1)**2
        x5 = w2(1)*w4(1)*x4
        x6 = P4(1)**2
        x7 = w2(1)*w4(1)*x6
        x8 = P2(2)**2
        x9 = w2(2)*w4(2)*x8
        x10 = P4(2)**2
        x11 = w2(2)*w4(2)*x10
        x12 = P2(3)**2
        x13 = w2(3)*w4(3)*x12
        x14 = P4(3)**2
        x15 = w2(3)*w4(3)*x14
        x16 = co(10)*w2(0)*w4(0)
        x17 = w2(1)*w4(1)*x0
        x18 = w2(1)*w4(1)
        x19 = co(10)*x2
        x20 = co(10)*w2(2)*w4(2)
        x21 = w2(2)*w4(2)
        x22 = co(10)*w2(3)*w4(3)
        x23 = w2(3)*w4(3)
        x24 = co(6)*w2(0)*w4(0)
        x25 = co(6)*w2(1)*w4(1)
        x26 = w2(1)*w4(1)*x8
        x27 = co(6)*x14
        x28 = co(6)*w2(2)*w4(2)
        x29 = co(6)*w2(3)*w4(3)
        x30 = w2(3)*w4(3)*x8
        x31 = w2(0)*w4(0)
        x32 = P1(0)**2
        x33 = co(8)*x32
        x34 = co(8)*w2(0)*w4(0)
        x35 = P1(1)**2
        x36 = co(8)*w2(1)*w4(1)
        x37 = P1(2)**2
        x38 = P1(3)**2
        x39 = co(8)*w2(2)*w4(2)
        x40 = co(8)*w2(3)*w4(3)
        x41 = P3(1)**2
        x42 = co(9)*w2(0)*w4(0)
        x43 = P3(2)**2
        x44 = P3(3)**2
        x45 = P3(0)**2
        x46 = co(9)*w2(1)*w4(1)
        x47 = co(9)*w2(2)*w4(2)
        x48 = co(9)*w2(3)*w4(3)
        x49 = co(10)*w2(1)*w4(1)
        x50 = 2*co(8)*w2(0)*w4(0)
        x51 = 2*x43
        x52 = 2*co(8)*w2(1)*w4(1)
        x53 = 2*co(8)*w2(2)*w4(2)
        x54 = 2*co(8)*w2(3)*w4(3)
        x55 = 2*co(4)*w2(0)*w4(0)
        x56 = 2*co(4)
        x57 = 2*co(4)*w2(1)*w4(1)
        x58 = 2*co(4)*w2(2)*w4(2)
        x59 = 2*co(4)*w2(3)*w4(3)
        x60 = P1(0)*P2(0)
        x61 = P2(1)*co(3)*w2(1)
        x62 = P1(0)*w4(0)
        x63 = P2(1)*co(5)*w4(1)
        x64 = P1(0)*w2(0)
        x65 = P2(2)*co(3)*w2(2)
        x66 = P2(2)*co(5)*w4(2)
        x67 = P2(3)*co(3)*w2(3)
        x68 = P2(3)*w4(3)
        x69 = P1(0)*co(5)*w2(0)
        x70 = P1(0)*P3(0)
        x71 = P1(0)*P4(0)
        x72 = P4(1)*co(3)*w2(1)
        x73 = P4(1)*co(5)*w4(1)
        x74 = P4(2)*co(3)*w2(2)
        x75 = P4(2)*co(5)*w4(2)
        x76 = P4(3)*co(3)*w2(3)
        x77 = P4(3)*w4(3)
        x78 = P1(1)*w4(1)
        x79 = P2(0)*co(3)*w2(0)
        x80 = P2(0)*w4(0)
        x81 = P1(1)*co(5)*w2(1)
        x82 = P1(1)*co(10)*w2(0)*w4(0)
        x83 = P3(1)*co(9)*w2(0)*w4(0)
        x84 = P3(2)*co(4)*w4(2)
        x85 = P1(1)*w2(1)
        x86 = P3(2)*co(4)*w2(2)
        x87 = P3(3)*co(4)*w4(3)
        x88 = P3(3)*co(4)*w2(3)
        x89 = P4(0)*co(3)*w2(0)
        x90 = P4(0)*w4(0)
        x91 = P1(2)*w4(2)
        x92 = P1(2)*w2(2)
        x93 = P2(0)*co(5)*w4(0)
        x94 = P1(2)*P2(2)
        x95 = P3(1)*co(4)*w2(1)
        x96 = P3(1)*co(4)*w4(1)
        x97 = P1(2)*P3(2)
        x98 = P4(0)*co(5)*w4(0)
        x99 = P1(2)*P4(2)
        x100 = P1(3)*w4(3)
        x101 = P1(3)*w2(3)
        x102 = P1(3)*P2(3)
        x103 = P1(3)*P3(3)
        x104 = P1(3)*P4(3)
        x105 = P2(1)*w4(1)
        x106 = P2(0)*w2(0)
        x107 = P2(1)*w2(1)
        x108 = P2(2)*w4(2)
        x109 = P2(2)*co(5)*w2(2)
        x110 = P2(0)*P2(3)*w2(3)*w4(0)
        x111 = P2(3)*co(5)*w4(3)
        x112 = P2(0)*P3(0)
        x113 = P2(0)*P4(0)*w2(0)*w4(0)
        x114 = P4(1)*w4(1)
        x115 = P4(1)*w2(1)
        x116 = P4(2)*w4(2)
        x117 = P2(0)*P4(2)*w2(2)*w4(0)
        x118 = P4(3)*co(3)*w4(3)
        x119 = P4(3)*co(5)*w4(3)
        x120 = P4(3)*w2(3)
        x121 = P2(2)*co(1)*w4(2)
        x122 = P2(2)*co(1)*w2(2)
        x123 = P2(3)*co(1)*w4(3)
        x124 = P2(3)*co(1)*w2(3)
        x125 = P4(0)*w2(0)
        x126 = P2(1)*P4(1)*w2(1)*w4(1)
        x127 = P4(1)*w2(1)*w4(1)
        x128 = P2(1)*P4(1)*co(7)
        x129 = P4(2)*co(0)*w4(2)
        x130 = P4(2)*co(2)*w2(2)
        x131 = P4(3)*co(0)*w4(3)
        x132 = P4(3)*co(2)*w2(3)
        x133 = P2(2)*w2(2)
        x134 = P2(2)*P3(2)
        x135 = P4(0)*co(3)*w4(0)
        x136 = P4(1)*co(0)*w4(1)
        x137 = P2(2)*P4(1)*w2(1)*w4(2)
        x138 = P2(2)*P4(2)*w2(2)*w4(2)
        x139 = P2(2)*P4(2)*co(7)
        x140 = P2(3)*w2(3)
        x141 = P2(3)*P3(3)
        x142 = P2(3)*P4(1)*w2(1)*w4(3)
        x143 = P2(3)*P4(3)*w2(3)*w4(3)
        x144 = P2(3)*P4(3)*co(7)
        x145 = P3(0)*P4(0)
        x146 = P4(2)*w2(2)
        x147 = P3(2)*P4(2)
        x148 = P3(3)*co(4)
        x149 = P4(2)*w2(3)*w4(2)
        x150 = P3(3)*P4(3)
        x151 = P4(1)*co(1)*w2(1)
        x152 = P4(1)*co(1)*w4(1)
        x153 = P4(3)*co(1)*w2(3)
        x154 = P4(2)*co(1)*w2(2)
        x155 = P4(2)*P4(3)*w2(3)*w4(2)
        x156 = P1(0)*P2(0)*w2(0)*w4(0)
        x157 = P2(0)*w2(0)*w4(0)
        x158 = P1(0)*P4(0)*w2(0)*w4(0)
        x159 = P1(1)*P2(1)
        x160 = P1(1)*P2(1)*w2(1)*w4(1)
        x161 = P1(1)*co(5)
        x162 = P2(2)*co(3)*w2(2)*w4(1)
        x163 = P3(0)*co(4)*w2(0)
        x164 = P3(0)*co(4)*w4(0)
        x165 = P1(1)*P3(1)
        x166 = P3(1)*co(9)*w2(2)*w4(2)
        x167 = P1(1)*P4(1)
        x168 = P1(1)*P4(1)*w2(1)*w4(1)
        x169 = co(3)*w2(2)*w4(2)
        x170 = co(5)*w2(2)*w4(2)
        x171 = co(3)*w2(3)*w4(3)
        x172 = P1(3)*P2(3)*w2(3)*w4(3)
        x173 = P1(3)*co(5)
        x174 = P4(3)*w2(3)*w4(3)
        x175 = P2(0)*P2(1)*w2(0)*w4(1)
        x176 = P2(0)*P2(1)*w2(1)*w4(0)
        x177 = P2(0)*P4(0)*co(7)
        x178 = P2(0)*P4(1)*w2(1)*w4(0)
        x179 = P2(1)*co(5)*w2(1)
        x180 = P2(1)*P3(1)
        x181 = P4(0)*co(0)*w4(0)
        x182 = P4(0)*co(2)*w2(0)
        x183 = P4(2)*co(5)*w2(2)
        x184 = P3(1)*P4(1)
        x185 = P4(0)*co(1)*w2(0)
        x186 = 2*P1(0)*co(4)*w2(0)
        x187 = 2*P1(0)*co(4)*w4(0)
        x188 = 2*P1(2)*co(4)*w4(2)
        x189 = 2*P1(2)*co(4)*w2(2)
        x190 = 2*P2(1)*co(4)*w2(1)
        x191 = 2*P2(2)*co(4)*w2(2)
        x192 = 2*P4(2)*co(4)*w2(2)
        x193 = 2*P2(0)*co(4)*w2(0)
        x194 = 2*P2(0)*co(4)*w4(0)
        x195 = 2*P1(1)*co(4)*w4(1)
        x196 = 2*P4(0)*co(4)*w4(0)
        x197 = 2*P1(3)*co(4)*w4(3)
        x198 = 2*P1(3)*co(4)*w2(3)
        x199 = 2*P2(0)*P4(0)
        x200 = 2*co(3)
        x201 = 2*co(5)
        x202 = P2(0)*P4(0)
        x203 = 2*P4(2)*co(4)*w4(2)
        x204 = 2*P2(1)*co(4)*w4(1)
        x205 = 2*P2(1)*P4(1)
        x206 = P2(1)*P4(1)
        x207 = 2*P2(2)*co(4)*w4(2)
        x208 = 2*P2(2)*P4(2)
        x209 = P2(2)*P4(2)
        x210 = 2*P2(3)*co(4)*w4(3)
        x211 = 2*P2(3)*P4(3)
        x212 = P2(3)*P4(3)
        x213 = 2*co(10)*w2(3)*w4(3)
        x214 = 2*P3(1)*w4(1)
        x215 = P3(1)*w2(1)
        x216 = 2*P3(0)*co(4)*w4(0)
        x217 = 2*P3(2)*w4(2)
        x218 = P3(2)*w2(2)
        x219 = 2*P3(3)
        x220 = 2*P4(1)*co(4)*w4(1)
        x221 = 2*P4(3)*co(4)*w4(3)
        x222 = 2*P3(0)*co(4)*w2(0)*w4(0)
        x223 = 2*P3(3)*co(4)*w2(3)*w4(3)
        x224 = 2*P3(3)*co(4)*w4(3)
        x225 = 4*co(4)
        x226 = 4*co(4)*w2(2)*w4(2)
        x234 = P3(0)*co(4)
        do j = riMaxIn, 0, -1
          x227 = cima*w3(0)*wl(0,j)
          wp(0,j) = -P1(0)*co(5)*x157*x227 + P1(0)*x222*x227 - P1(1)*x162*x227 &
                     - P1(1)*x166*x227 + P1(1)*x227*x83 + P1(3)*P4(2)*w2(3)*w4(&
                    2)*x227*x56 + P1(3)*P4(3)*w2(3)*w4(3)*x225*x227 + P1(3)*   &
                    x223*x227 + P2(1)*co(7)*x127*x227 - P2(1)*w2(1)*w4(1)*x161*&
                    x227 - P2(1)*x166*x227 + P2(1)*x227*x82 + P2(1)*x227*x83 + &
                    P2(3)*x223*x227 - P3(0)*co(4)*w2(0)*w4(3)*x219*x227 - P3(0 &
                    )*co(4)*w2(3)*w4(0)*x219*x227 + 2*P3(0)*co(4)*x157*x227 + 2&
                    *P3(1)*co(4)*x127*x227 + 2*P3(3)*co(4)*x174*x227 + P4(0)*  &
                    x222*x227 - P4(1)*x162*x227 - P4(1)*x166*x227 + P4(1)*x227*&
                    x82 + P4(1)*x227*x83 + co(0)*x113*x227 + co(0)*x126*x227 + &
                    co(0)*x138*x227 + co(0)*x143*x227 + co(1)*x1*x227 + co(1)* &
                    x11*x227 - co(1)*x110*x227 + co(1)*x13*x227 + co(1)*x15*   &
                    x227 + co(1)*x155*x227 - co(1)*x175*x227 - co(1)*x176*x227 &
                     + co(1)*x227*x3 + co(1)*x227*x5 + co(1)*x227*x7 + co(1)*  &
                    x227*x9 - co(10)*x11*x227 - co(10)*x13*x227 + co(10)*x17*  &
                    x227 - co(10)*x227*x26 - co(10)*x227*x30 - co(10)*x227*x5  &
                     - co(10)*x227*x7 - co(10)*x227*x9 + co(2)*x113*x227 - co(2&
                    )*x117*x227 + co(2)*x126*x227 + co(2)*x137*x227 + co(2)*   &
                    x138*x227 + co(2)*x142*x227 + co(2)*x143*x227 - co(2)*x178*&
                    x227 - co(3)*x1*x227 - co(3)*x11*x227 + co(3)*x110*x227 +  &
                    co(3)*x117*x227 - co(3)*x13*x227 - co(3)*x137*x227 - co(3)*&
                    x142*x227 - co(3)*x15*x227 - co(3)*x156*x227 - co(3)*x158* &
                    x227 - co(3)*x160*x227 - co(3)*x168*x227 - co(3)*x227*x3 - &
                    co(3)*x227*x5 - co(3)*x227*x7 - co(3)*x227*x9 + co(4)*w2(2 &
                    )*w4(2)*x227*x51 - co(5)*x1*x227 - co(5)*x11*x227 + co(5)* &
                    x110*x227 + co(5)*x117*x227 - co(5)*x13*x227 - co(5)*x137* &
                    x227 - co(5)*x142*x227 - co(5)*x15*x227 - co(5)*x155*x227  &
                     - co(5)*x158*x227 - co(5)*x172*x227 - co(5)*x227*x3 - co(5&
                    )*x227*x5 - co(5)*x227*x7 - co(5)*x227*x9 + co(6)*x1*x227  &
                     - co(6)*x17*x227 + co(6)*x227*x26 + co(6)*x227*x30 + co(6 &
                    )*x227*x7 + co(7)*x113*x227 + co(7)*x138*x227 + co(7)*x143*&
                    x227 - co(8)*x17*x227 + co(8)*x227*x26 + co(8)*x227*x30 +  &
                    co(8)*x227*x5 + co(8)*x227*x7 + co(8)*x227*x9 - x0*x16*x227&
                     + x0*x20*x227 + x0*x22*x227 - x0*x227*x28 - x0*x227*x29 + &
                    x0*x227*x34 - x0*x227*x39 - x0*x227*x40 + x1*x227*x56 + x10&
                    *x16*x227 - x10*x22*x227 - x10*x227*x24 + x10*x227*x25 +   &
                    x10*x227*x28 + x10*x227*x29 - x10*x227*x34 + x10*x227*x36  &
                     + x10*x227*x39 + x10*x227*x40 - x10*x227*x49 - x100*x163* &
                    x227 - x100*x186*x227 + x100*x189*x227 + x100*x190*x227 +  &
                    x100*x191*x227 + x100*x192*x227 - x100*x227*x61 - x100*x227&
                    *x65 - x100*x227*x72 - x100*x227*x74 + x100*x227*x79 + x100&
                    *x227*x86 + x100*x227*x89 + x100*x227*x95 - x101*x164*x227 &
                     - x101*x187*x227 + x101*x188*x227 - x101*x196*x227 + x101*&
                    x207*x227 - x101*x227*x63 - x101*x227*x66 - x101*x227*x73  &
                     + x101*x227*x84 + x101*x227*x93 + x101*x227*x96 + x101*   &
                    x227*x98 + x102*x16*x227 - x102*x171*x227 - x102*x20*x227  &
                     - x102*x22*x227 - x102*x227*x49 - x102*x227*x50 + x102*   &
                    x227*x52 + x102*x227*x53 + x102*x227*x54 + x103*x227*x42 - &
                    x103*x227*x46 - x103*x227*x47 - x103*x227*x48 - x103*x227* &
                    x50 + x103*x227*x52 + x103*x227*x53 + x103*x227*x54 + x104*&
                    x16*x227 - x104*x171*x227 - x104*x20*x227 - x104*x22*x227  &
                     - x104*x227*x49 - x104*x227*x50 + x104*x227*x52 + x104*   &
                    x227*x53 + x104*x227*x54 - x105*x109*x227 + x105*x122*x227 &
                     + x105*x124*x227 + x105*x130*x227 + x105*x132*x227 - x105*&
                    x163*x227 - x105*x182*x227 - x105*x186*x227 + x105*x189*   &
                    x227 + x105*x191*x227 + x105*x192*x227 + x105*x198*x227 -  &
                    x105*x227*x65 - x105*x227*x67 - x105*x227*x74 - x105*x227* &
                    x76 + x105*x227*x79 + x105*x227*x86 + x105*x227*x88 + x105*&
                    x227*x89 + x106*x111*x227 + x106*x118*x227 + x106*x119*x227&
                     - x106*x121*x227 - x106*x123*x227 - x106*x129*x227 - x106*&
                    x131*x227 - x106*x136*x227 - x106*x188*x227 - x106*x197*   &
                    x227 - x106*x203*x227 + x106*x227*x63 + x106*x227*x66 +    &
                    x106*x227*x73 + x106*x227*x75 - x106*x227*x84 - x106*x227* &
                    x87 - x106*x227*x96 + x107*x121*x227 + x107*x123*x227 +    &
                    x107*x129*x227 + x107*x131*x227 - x107*x164*x227 - x107*   &
                    x181*x227 - x107*x227*x66 - x107*x227*x75 + x107*x227*x84  &
                     + x107*x227*x87 + x107*x227*x93 + x107*x227*x98 + x108*   &
                    x124*x227 + x108*x132*x227 - x108*x163*x227 - x108*x182*   &
                    x227 - x108*x186*x227 + x108*x190*x227 - x108*x193*x227 -  &
                    x108*x227*x61 - x108*x227*x67 - x108*x227*x76 + x108*x227* &
                    x79 + x108*x227*x88 + x108*x227*x89 + x108*x227*x95 - x109*&
                    x114*x227 - x109*x227*x68 - x109*x227*x77 + x109*x227*x80  &
                     + x109*x227*x90 + x11*x227*x56 - x110*x227*x56 + x111*x125&
                    *x227 - x111*x227*x92 - x112*x227*x42 + x112*x227*x46 +    &
                    x112*x227*x47 + x112*x227*x48 + x112*x227*x50 - x112*x227* &
                    x52 - x112*x227*x53 - x112*x227*x54 - x113*x200*x227 - x113&
                    *x201*x227 + x113*x225*x227 + x114*x153*x227 - x114*x163*  &
                    x227 - x114*x186*x227 + x114*x189*x227 + x114*x191*x227 +  &
                    x114*x192*x227 - x114*x193*x227 + x114*x198*x227 - x114*   &
                    x227*x67 - x114*x227*x74 - x114*x227*x76 + x114*x227*x79 + &
                    x114*x227*x86 + x114*x227*x88 + x114*x227*x89 - x115*x118* &
                    x227 - x115*x119*x227 + x115*x135*x227 - x115*x164*x227 -  &
                    x115*x187*x227 + x115*x188*x227 - x115*x196*x227 + x115*   &
                    x197*x227 + x115*x203*x227 + x115*x221*x227 - x115*x227*x75&
                     + x115*x227*x84 + x115*x227*x87 + x115*x227*x93 + x115*   &
                    x227*x98 + x116*x151*x227 - x116*x163*x227 - x116*x185*x227&
                     - x116*x186*x227 + x116*x190*x227 - x116*x227*x61 - x116* &
                    x227*x67 - x116*x227*x72 - x116*x227*x76 + x116*x227*x79 + &
                    x116*x227*x89 + x116*x227*x95 - x117*x227*x56 + x118*x125* &
                    x227 - x118*x133*x227 - x118*x146*x227 + x119*x125*x227 -  &
                    x119*x227*x92 + x12*x16*x227 - x12*x20*x227 - x12*x227*x24 &
                     + x12*x227*x25 + x12*x227*x28 + x12*x227*x29 - x12*x227*  &
                    x34 + x12*x227*x36 + x12*x227*x39 + x12*x227*x40 - x12*x227&
                    *x49 - x120*x164*x227 - x120*x187*x227 + x120*x188*x227 -  &
                    x120*x194*x227 + x120*x195*x227 - x120*x196*x227 + x120*   &
                    x204*x227 + x120*x207*x227 + x120*x220*x227 - x120*x227*x63&
                     - x120*x227*x66 - x120*x227*x73 + x120*x227*x84 + x120*   &
                    x227*x93 + x120*x227*x96 + x120*x227*x98 + x122*x227*x68 - &
                    x122*x227*x80 - x125*x152*x227 - x125*x188*x227 - x125*x195&
                    *x227 - x125*x197*x227 - x125*x203*x227 - x125*x204*x227 - &
                    x125*x207*x227 - x125*x210*x227 - x125*x220*x227 - x125*   &
                    x221*x227 + x125*x227*x63 + x125*x227*x66 + x125*x227*x73  &
                     + x125*x227*x75 - x125*x227*x84 - x125*x227*x87 - x125*   &
                    x227*x96 - x126*x200*x227 - x126*x201*x227 + x126*x225*x227&
                     - x127*x161*x227 + x128*x21*x227 + x128*x227*x23 - x128*  &
                    x227*x31 + x129*x140*x227 + x13*x227*x56 + x130*x227*x68 + &
                    x131*x133*x227 - x132*x227*x80 + x133*x135*x227 + x133*x136&
                    *x227 - x133*x164*x227 - x133*x181*x227 + x133*x227*x87 +  &
                    x133*x227*x96 + x134*x227*x42 - x134*x227*x46 - x134*x227* &
                    x47 - x134*x227*x48 - x134*x227*x50 + x134*x227*x52 + x134*&
                    x227*x53 + x134*x227*x54 + x134*x227*x58 + x135*x140*x227  &
                     + x135*x146*x227 + x136*x140*x227 + x137*x227*x56 - x138* &
                    x200*x227 + x138*x225*x227 + x139*x18*x227 + x139*x227*x23 &
                     - x139*x227*x31 + x14*x16*x227 - x14*x20*x227 - x14*x22*  &
                    x227 - x14*x227*x34 + x14*x227*x36 + x14*x227*x39 + x14*   &
                    x227*x40 - x14*x227*x49 - x140*x164*x227 - x140*x181*x227  &
                     - x140*x187*x227 + x140*x188*x227 + x140*x195*x227 - x140*&
                    x196*x227 + x140*x203*x227 + x140*x204*x227 + x140*x207*   &
                    x227 + x140*x220*x227 - x140*x227*x63 - x140*x227*x66 -    &
                    x140*x227*x73 - x140*x227*x75 + x140*x227*x84 + x140*x227* &
                    x96 + x140*x227*x98 + x141*x227*x42 - x141*x227*x46 - x141*&
                    x227*x47 - x141*x227*x48 - x141*x227*x50 + x141*x227*x52 + &
                    x141*x227*x53 + x141*x227*x54 + x142*x227*x56 - x143*x200* &
                    x227 - x143*x201*x227 + x143*x225*x227 + x144*x18*x227 +   &
                    x144*x21*x227 - x144*x227*x31 - x145*x227*x42 + x145*x227* &
                    x46 + x145*x227*x47 + x145*x227*x48 + x145*x227*x50 - x145*&
                    x227*x52 - x145*x227*x53 - x145*x227*x54 + x146*x152*x227  &
                     - x146*x164*x227 - x146*x227*x63 - x146*x227*x73 + x146*  &
                    x227*x87 + x146*x227*x96 + x146*x227*x98 + x147*x227*x42 - &
                    x147*x227*x46 - x147*x227*x47 - x147*x227*x48 - x147*x227* &
                    x50 + x147*x227*x52 + x147*x227*x53 + x147*x227*x54 + x147*&
                    x227*x58 + x148*x149*x227 - x149*x173*x227 + x15*x227*x56  &
                     + x150*x227*x42 - x150*x227*x46 - x150*x227*x47 - x150*   &
                    x227*x48 - x150*x227*x50 + x150*x227*x52 + x150*x227*x53 + &
                    x150*x227*x54 + x151*x227*x77 - x151*x227*x90 - x153*x227* &
                    x90 + x154*x227*x77 - x154*x227*x90 + x155*x227*x56 + x156*&
                    x225*x227 + x158*x225*x227 - x159*x20*x227 - x159*x22*x227 &
                     - x159*x227*x49 - x159*x227*x50 + x159*x227*x52 + x159*   &
                    x227*x53 + x159*x227*x54 - x16*x199*x227 + x16*x205*x227 + &
                    x16*x208*x227 + x16*x211*x227 + x16*x227*x4 + x16*x227*x6  &
                     - x16*x227*x60 - x16*x227*x71 + x16*x227*x8 + x16*x227*x94&
                     + x16*x227*x99 + x160*x225*x227 - x163*x214*x227 - x163*  &
                    x217*x227 - x163*x227*x68 - x163*x227*x77 - x163*x227*x78  &
                     - x163*x227*x91 - x164*x227*x85 - x164*x227*x92 - x165*   &
                    x227*x46 - x165*x227*x48 - x165*x227*x50 + x165*x227*x52 + &
                    x165*x227*x53 + x165*x227*x54 + x165*x227*x57 - x167*x20*  &
                    x227 - x167*x22*x227 - x167*x227*x49 - x167*x227*x50 + x167&
                    *x227*x52 + x167*x227*x53 + x167*x227*x54 + x168*x225*x227 &
                     - x169*x227*x94 - x169*x227*x99 - x170*x208*x227 - x170*  &
                    x227*x94 - x170*x227*x99 + x172*x225*x227 - x173*x174*x227 &
                     - x175*x227*x56 - x176*x227*x56 - x177*x18*x227 - x177*x21&
                    *x227 - x177*x227*x23 - x178*x227*x56 - x179*x227*x68 -    &
                    x179*x227*x77 + x18*x19*x227 + x18*x227*x27 - x18*x227*x33 &
                     - x180*x227*x46 - x180*x227*x48 - x180*x227*x50 + x180*   &
                    x227*x52 + x180*x227*x53 + x180*x227*x54 + x180*x227*x57 - &
                    x182*x227*x68 - x183*x227*x68 - x183*x227*x77 - x184*x227* &
                    x46 - x184*x227*x48 - x184*x227*x50 + x184*x227*x52 + x184*&
                    x227*x53 + x184*x227*x54 - x185*x227*x77 - x186*x227*x68 - &
                    x186*x227*x77 - x186*x227*x78 - x187*x227*x85 - x188*x227* &
                    x64 + x188*x227*x85 - x189*x227*x62 + x189*x227*x68 + x189*&
                    x227*x77 + x189*x227*x78 - x189*x227*x80 - x189*x227*x90 + &
                    x19*x21*x227 + x19*x227*x23 - x19*x227*x31 - x190*x227*x62 &
                     + x190*x227*x68 + x190*x227*x77 - x190*x227*x90 + x190*   &
                    x227*x91 - x191*x227*x62 + x191*x227*x68 + x191*x227*x77 + &
                    x191*x227*x78 - x191*x227*x80 - x191*x227*x90 - x192*x227* &
                    x62 + x192*x227*x68 + x192*x227*x77 + x192*x227*x78 - x192*&
                    x227*x90 - x193*x227*x68 - x193*x227*x77 - x193*x227*x78 - &
                    x194*x227*x85 - x196*x227*x85 + x197*x227*x85 + x198*x227* &
                    x78 - x198*x227*x80 + x199*x20*x227 + x199*x227*x49 + x2*  &
                    x227*x24 - x2*x227*x25 - x2*x227*x28 - x2*x227*x29 + x2*   &
                    x227*x34 - x2*x227*x36 - x2*x227*x39 - x2*x227*x40 - x20*  &
                    x205*x227 - x20*x208*x227 - x20*x211*x227 - x20*x227*x4 -  &
                    x20*x227*x6 + x20*x227*x60 + x20*x227*x71 - x20*x227*x94 - &
                    x20*x227*x99 + x202*x213*x227 + x202*x227*x50 - x202*x227* &
                    x52 - x202*x227*x53 - x202*x227*x54 + x203*x227*x85 - x205*&
                    x22*x227 - x205*x227*x49 - x206*x227*x50 + x206*x227*x52 + &
                    x206*x227*x53 + x206*x227*x54 + x207*x227*x85 - x208*x22*  &
                    x227 - x208*x227*x49 - x209*x227*x50 + x209*x227*x52 + x209&
                    *x227*x53 + x209*x227*x54 + x21*x227*x27 - x21*x227*x33 +  &
                    x210*x227*x85 - x211*x227*x49 - x212*x213*x227 - x212*x227*&
                    x50 + x212*x227*x52 + x212*x227*x53 + x212*x227*x54 + x214*&
                    x227*x86 + x214*x227*x88 - x215*x216*x227 + x215*x224*x227 &
                     - x216*x218*x227 + x217*x227*x88 + x217*x227*x95 + x218*  &
                    x224*x227 - x22*x227*x4 - x22*x227*x6 + x22*x227*x60 + x22*&
                    x227*x71 - x22*x227*x94 - x22*x227*x99 + x221*x227*x85 +   &
                    x226*x227*x94 + x226*x227*x99 + x227*x23*x27 - x227*x23*x33&
                     - x227*x24*x4 - x227*x24*x6 - x227*x24*x8 + x227*x25*x4 - &
                    x227*x27*x31 + x227*x28*x4 + x227*x28*x6 + x227*x28*x8 +   &
                    x227*x29*x4 + x227*x29*x6 + x227*x3*x56 + x227*x31*x33 +   &
                    x227*x32*x55 - x227*x34*x35 - x227*x34*x37 - x227*x34*x38  &
                     - x227*x34*x4 - x227*x34*x51 - x227*x34*x6 - x227*x34*x8  &
                     + x227*x35*x36 + x227*x35*x39 + x227*x35*x40 + x227*x35*  &
                    x57 + x227*x36*x37 + x227*x36*x38 + x227*x36*x51 + x227*x37&
                    *x39 + x227*x37*x40 + x227*x37*x58 + x227*x38*x39 + x227*  &
                    x38*x40 + x227*x38*x59 + x227*x39*x4 + x227*x39*x51 + x227*&
                    x39*x6 + x227*x4*x40 + x227*x40*x51 + x227*x40*x6 + x227*  &
                    x41*x42 - x227*x41*x46 - x227*x41*x47 - x227*x41*x48 - x227&
                    *x41*x50 + x227*x41*x52 + x227*x41*x53 + x227*x41*x54 +    &
                    x227*x41*x57 + x227*x42*x43 + x227*x42*x44 - x227*x42*x45  &
                     - x227*x42*x70 + x227*x42*x97 - x227*x43*x46 - x227*x43*  &
                    x47 - x227*x43*x48 - x227*x44*x46 - x227*x44*x47 - x227*x44&
                    *x48 - x227*x44*x50 + x227*x44*x52 + x227*x44*x53 + x227*  &
                    x44*x54 + x227*x44*x59 + x227*x45*x46 + x227*x45*x47 + x227&
                    *x45*x48 + x227*x45*x50 - x227*x45*x52 - x227*x45*x53 -    &
                    x227*x45*x54 + x227*x45*x55 + x227*x46*x70 - x227*x46*x97  &
                     + x227*x47*x70 - x227*x47*x97 + x227*x48*x70 - x227*x48*  &
                    x97 + x227*x49*x60 + x227*x49*x71 - x227*x49*x94 - x227*x49&
                    *x99 + x227*x5*x56 + x227*x50*x60 + x227*x50*x70 + x227*x50&
                    *x71 - x227*x50*x94 - x227*x50*x97 - x227*x50*x99 - x227*  &
                    x52*x60 - x227*x52*x70 - x227*x52*x71 + x227*x52*x94 + x227&
                    *x52*x97 + x227*x52*x99 - x227*x53*x60 - x227*x53*x70 -    &
                    x227*x53*x71 + x227*x53*x94 + x227*x53*x97 + x227*x53*x99  &
                     - x227*x54*x60 - x227*x54*x70 - x227*x54*x71 + x227*x54*  &
                    x94 + x227*x54*x97 + x227*x54*x99 + x227*x56*x7 + x227*x56*&
                    x9 + x227*x58*x97 + x227*x61*x62 - x227*x61*x68 - x227*x61*&
                    x77 + x227*x61*x80 + x227*x61*x90 - x227*x61*x91 + x227*x62&
                    *x65 + x227*x62*x67 + x227*x62*x72 + x227*x62*x74 + x227*  &
                    x62*x76 - x227*x62*x86 - x227*x62*x88 - x227*x62*x95 + x227&
                    *x63*x64 - x227*x63*x92 + x227*x64*x66 + x227*x64*x73 +    &
                    x227*x64*x75 - x227*x64*x84 - x227*x64*x87 - x227*x64*x96  &
                     - x227*x65*x68 + x227*x65*x80 - x227*x66*x85 - x227*x67*  &
                    x78 - x227*x67*x91 + x227*x68*x69 - x227*x68*x74 + x227*x68&
                    *x79 - x227*x68*x81 + x227*x68*x86 + x227*x68*x89 + x227*  &
                    x68*x95 + x227*x69*x77 + x227*x72*x80 - x227*x72*x91 - x227&
                    *x73*x92 - x227*x74*x78 - x227*x75*x85 - x227*x76*x78 +    &
                    x227*x76*x80 + x227*x76*x90 - x227*x76*x91 - x227*x77*x81  &
                     + x227*x77*x86 + x227*x77*x95 + x227*x78*x79 + x227*x78*  &
                    x86 + x227*x78*x88 + x227*x78*x89 + x227*x79*x91 + x227*x80&
                    *x81 - x227*x80*x86 - x227*x80*x88 - x227*x80*x95 + x227*  &
                    x81*x90 + x227*x84*x85 + x227*x85*x87 - x227*x86*x90 + x227&
                    *x87*x92 - x227*x88*x90 + x227*x88*x91 + x227*x89*x91 -    &
                    x227*x90*x95 + x227*x91*x95 + x227*x92*x93 + x227*x92*x96  &
                     + x227*x92*x98
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x228 = co(3)*w2(1)*w4(mu)
            x229 = co(5)*w2(mu)*w4(1)
            x230 = co(3)*w2(2)*w4(mu)
            x231 = co(5)*w2(mu)*w4(2)
            x232 = co(3)*w2(3)*w4(mu)
            x233 = co(5)*w2(mu)*w4(3)
            x235 = co(3)*w2(0)*w4(mu)
            x236 = co(5)*w2(mu)*w4(0)
            x237 = co(4)*w4(mu)
            x238 = co(4)*w2(mu)
            x239 = 2*co(4)*w4(mu)
            x240 = 2*co(4)*w2(mu)
            x241 = 2*co(4)*w2(3)*w4(mu)
            x242 = 2*P2(mu)
            x243 = 2*co(4)*w2(0)*w4(mu)
            x244 = 2*co(4)*w2(mu)*w4(0)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + P1(0)*x227*x243 + P1(0)*x227*x244 - P1(&
                          3)*x227*x241 + P1(mu)*x227*x50 - P1(mu)*x227*x52 - P1&
                          (mu)*x227*x53 - P1(mu)*x227*x54 - P2(0)*x227*x235 -  &
                          P2(0)*x227*x236 + P2(0)*x227*x243 + P2(0)*x227*x244  &
                           + P2(1)*x227*x228 + P2(1)*x227*x229 + P2(2)*x227*   &
                          x230 + P2(2)*x227*x231 + P2(3)*x227*x232 + P2(3)*x227&
                          *x233 - P2(3)*x227*x241 - P2(mu)*x16*x227 + P2(mu)*  &
                          x20*x227 + P2(mu)*x22*x227 + P2(mu)*x227*x49 - P3(1)*&
                          w4(1)*x227*x238 - P3(2)*w4(2)*x227*x238 - P3(mu)*x227&
                          *x42 + P3(mu)*x227*x46 + P3(mu)*x227*x47 + P3(mu)*   &
                          x227*x48 + P3(mu)*x227*x50 - P3(mu)*x227*x52 - P3(mu &
                          )*x227*x53 - P3(mu)*x227*x54 - P4(0)*x227*x235 - P4(0&
                          )*x227*x236 + P4(0)*x227*x243 + P4(0)*x227*x244 + P4(&
                          1)*x227*x228 + P4(1)*x227*x229 + P4(2)*x227*x230 + P4&
                          (2)*x227*x231 + P4(3)*x227*x232 + P4(3)*x227*x233 -  &
                          P4(3)*x227*x241 - P4(mu)*x16*x227 + P4(mu)*x20*x227  &
                           + P4(mu)*x22*x227 + P4(mu)*x227*x49 + P4(mu)*x227*  &
                          x50 - P4(mu)*x227*x52 - P4(mu)*x227*x53 - P4(mu)*x227&
                          *x54 + w2(0)*w4(mu)*x227*x234 - w2(3)*w4(mu)*x148*   &
                          x227 + w2(mu)*w4(0)*x227*x234 - w2(mu)*x227*x87 -    &
                          x100*x227*x240 - x105*x227*x240 - x107*x227*x239 -   &
                          x108*x227*x240 - x114*x227*x240 - x115*x227*x239 -   &
                          x116*x227*x240 - x133*x227*x239 - x146*x227*x239 -   &
                          x215*x227*x237 - x218*x227*x237 - x227*x239*x85 -    &
                          x227*x239*x92 - x227*x240*x68 - x227*x240*x77 - x227*&
                          x240*x78 - x227*x240*x91 + x227*x242*x34 - x227*x242*&
                          x36 - x227*x242*x39 - x227*x242*x40
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) + gg(nu,mu)*x227*x34 - gg(nu,mu)*x227* &
                            x36 - gg(nu,mu)*x227*x39 - gg(nu,mu)*x227*x40 + w4(&
                            nu)*x227*x240
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVSVS
end module lcSVSVS
