!******************************************************************************!
!                                                                              !
!    lcSVVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVVSS0)
!       P(2,3)*P(3,2)*c0
!       c1*(P(2,2)*P(3,4) + P(2,2)*P(3,5) + P(2,3)*P(3,4) + P(2,3)*P(3,5))
!       c2*(P(2,4)*P(3,4) + P(2,4)*P(3,5)/2 + P(2,5)*P(3,4)/2 + P(2,5)*P(3,5))
!       c3*(P(2,4)*P(3,2) + P(2,4)*P(3,3) + P(2,5)*P(3,2) + P(2,5)*P(3,3))
!       P(2,2)*P(3,3)*c4
!       c5*(P(2,2)*P(3,2) + P(2,3)*P(3,3))
!       c6*(Metric(2,3)*P(-1,2)**2 + Metric(2,3)*P(-1,3)**2)
!       Metric(2,3)*P(-1,2)*P(-1,3)*c7
!       c8*(Metric(2,3)*P(-1,4)**2 + Metric(2,3)*P(-1,5)**2)
!       Metric(2,3)*P(-1,4)*P(-1,5)*c9
!       c10*(Metric(2,3)*P(-1,2)*P(-1,4) + Metric(2,3)*P(-1,2)*P(-1,5) + Metric(2
!       ,3)*P(-1,3)*P(-1,4) + Metric(2,3)*P(-1,3)*P(-1,5))
        x0 = P2(1)**2
        x1 = co(10)*w2(0)*w3(0)
        x2 = P2(2)**2
        x3 = P2(3)**2
        x4 = P3(1)**2
        x5 = P3(2)**2
        x6 = P3(3)**2
        x7 = P2(0)**2
        x8 = co(10)*w2(1)*w3(1)
        x9 = P3(0)**2
        x10 = co(10)*w2(2)*w3(2)
        x11 = co(10)*w2(3)*w3(3)
        x12 = P1(0)**2
        x13 = co(2)*w2(0)*w3(0)
        x14 = w2(0)*w3(0)*x9
        x15 = P4(0)**2
        x16 = w2(0)*w3(0)*x15
        x17 = P1(1)**2
        x18 = co(2)*w2(1)*w3(1)
        x19 = P4(1)**2
        x20 = P1(2)**2
        x21 = co(2)*w2(2)*w3(2)
        x22 = w2(2)*w3(2)*x2
        x23 = w2(2)*w3(2)*x5
        x24 = P4(2)**2
        x25 = P1(3)**2
        x26 = co(2)*w2(3)*w3(3)
        x27 = w2(3)*w3(3)*x6
        x28 = P4(3)**2
        x29 = w2(0)*w3(0)*x7
        x30 = w2(1)*w3(1)*x0
        x31 = w2(1)*w3(1)*x4
        x32 = w2(3)*w3(3)*x3
        x33 = co(6)*w2(0)*w3(0)
        x34 = co(6)*w2(1)*w3(1)
        x35 = w2(1)*w3(1)*x3
        x36 = co(6)*w2(2)*w3(2)
        x37 = co(6)*w2(3)*w3(3)
        x38 = co(8)*w2(0)*w3(0)
        x39 = co(8)*w2(1)*w3(1)
        x40 = co(8)*w2(2)*w3(2)
        x41 = w2(2)*w3(2)
        x42 = co(8)*x5
        x43 = co(8)*w2(3)*w3(3)
        x44 = w2(3)*w3(3)
        x45 = w2(0)*w3(0)
        x46 = co(9)*x19
        x47 = co(9)*x24
        x48 = co(9)*x28
        x49 = w2(1)*w3(1)
        x50 = co(9)*x15
        x51 = co(1)*w2(3)*w3(3)
        x52 = 2*co(8)*w2(0)*w3(0)
        x53 = 2*co(8)*w2(1)*w3(1)
        x54 = 2*co(8)*w2(2)*w3(2)
        x55 = 2*co(8)*w2(3)*w3(3)
        x56 = 2*co(8)
        x57 = P1(0)*P2(0)
        x58 = P1(0)*w3(0)
        x59 = P2(1)*co(1)*w2(1)
        x60 = P2(1)*co(3)*w3(1)
        x61 = P1(0)*w2(0)
        x62 = P2(2)*co(1)*w2(2)
        x63 = P2(2)*co(3)*w3(2)
        x64 = P2(3)*co(1)*w2(3)
        x65 = P2(3)*co(3)*w3(3)
        x66 = P1(0)*P3(0)
        x67 = P3(1)*co(1)*w2(1)
        x68 = P3(1)*co(3)*w3(1)
        x69 = P3(2)*co(1)*w2(2)
        x70 = P3(2)*co(3)*w3(2)
        x71 = P3(3)*co(1)*w2(3)
        x72 = P3(3)*co(3)*w3(3)
        x73 = P4(0)*co(2)*w2(0)*w3(0)
        x74 = P4(0)*co(9)*w2(1)*w3(1)
        x75 = P1(0)*P4(0)*co(9)
        x76 = P1(2)*w3(2)
        x77 = P1(1)*co(2)*w2(1)
        x78 = P1(2)*co(2)*w2(2)
        x79 = P1(1)*w3(1)
        x80 = P1(3)*w3(3)
        x81 = P1(3)*co(2)*w2(3)
        x82 = P2(0)*co(1)*w2(0)
        x83 = P2(0)*co(3)*w3(0)
        x84 = P1(1)*w2(1)
        x85 = P1(1)*P2(1)
        x86 = P2(2)*co(2)*w3(2)
        x87 = P2(2)*w2(2)
        x88 = P1(1)*co(2)*w3(1)
        x89 = P2(3)*co(2)*w3(3)
        x90 = P2(3)*co(2)*w2(3)
        x91 = P3(0)*co(1)*w2(0)
        x92 = P3(0)*co(3)*w3(0)
        x93 = P1(1)*P3(1)
        x94 = P3(2)*w3(2)
        x95 = P3(2)*co(2)*w2(2)
        x96 = P3(3)*w3(3)
        x97 = P3(3)*co(2)*w2(3)
        x98 = P4(1)*co(2)*w2(1)*w3(1)
        x99 = P1(1)*P4(1)*co(9)
        x100 = P1(2)*w2(2)
        x101 = P1(2)*P2(1)*w2(1)*w3(2)
        x102 = P2(1)*co(2)*w3(1)
        x103 = P1(2)*P2(2)
        x104 = P1(2)*P2(3)*w2(2)
        x105 = P3(1)*co(2)*w2(1)
        x106 = P3(1)*w3(1)
        x107 = P1(2)*P3(2)
        x108 = P4(2)*co(2)*w2(2)*w3(2)
        x109 = P1(2)*P4(2)*co(9)
        x110 = P1(3)*w2(3)
        x111 = P2(1)*co(2)*w2(1)
        x112 = P2(1)*w3(1)
        x113 = P1(3)*co(2)*w3(3)
        x114 = P1(3)*P2(3)
        x115 = P1(3)*P3(3)
        x116 = P4(3)*co(2)*w2(3)*w3(3)
        x117 = P1(3)*P4(3)*co(9)
        x118 = P2(1)*w2(1)
        x119 = P2(0)*co(1)*w3(0)
        x120 = P2(0)*w2(0)
        x121 = P2(2)*w3(2)
        x122 = P2(3)*w3(3)
        x123 = P2(3)*w2(3)
        x124 = P2(0)*P3(0)*w2(0)*w3(0)
        x125 = P3(1)*w2(1)
        x126 = P3(2)*w2(2)
        x127 = P3(3)*w2(3)
        x128 = P2(0)*P4(0)*w2(0)*w3(0)
        x129 = P2(0)*P4(0)*co(9)
        x130 = P2(1)*P2(2)*w2(1)*w3(2)
        x131 = P2(2)*co(5)*w2(2)
        x132 = P2(1)*co(5)*w2(1)
        x133 = P2(3)*co(5)*w2(3)
        x134 = P3(0)*w3(0)
        x135 = P3(0)*w2(0)
        x136 = P2(1)*P3(1)*w2(1)*w3(1)
        x137 = P2(1)*P3(1)*co(7)
        x138 = P2(1)*w2(3)*w3(3)
        x139 = P2(1)*co(0)*w3(1)
        x140 = P2(1)*P3(2)*w2(1)*w3(2)
        x141 = P3(3)*co(4)*w3(3)
        x142 = P2(1)*P4(1)*co(9)
        x143 = P2(2)*co(0)*w3(2)
        x144 = P2(2)*co(2)*w2(2)
        x145 = P2(2)*co(4)*w2(2)
        x146 = P3(2)*w2(2)*w3(2)
        x147 = P2(2)*P3(2)*w2(2)*w3(2)
        x148 = P3(2)*w2(1)*w3(1)
        x149 = P2(2)*P3(2)*co(7)
        x150 = P2(2)*P4(2)*co(9)
        x151 = P2(3)*co(0)*w3(3)
        x152 = P2(3)*co(4)*w2(3)
        x153 = P2(3)*P3(3)*w2(3)*w3(3)
        x154 = P2(3)*P3(3)*co(7)
        x155 = P2(3)*P4(3)*co(9)
        x156 = P3(0)*P4(0)*co(9)
        x157 = P3(2)*co(5)*w3(2)
        x158 = P3(1)*co(5)*w3(1)
        x159 = P3(3)*co(5)*w3(3)
        x160 = P3(1)*P4(1)*co(9)
        x161 = P4(2)*co(9)
        x162 = P3(3)*P4(3)*co(9)
        x163 = P4(2)*w3(2)
        x164 = P4(1)*co(2)*w2(1)
        x165 = P4(2)*co(2)*w2(2)
        x166 = P4(1)*w3(1)
        x167 = P4(3)*w3(3)
        x168 = P4(3)*co(2)*w2(3)
        x169 = P4(2)*w3(2)/2
        x170 = P4(2)*w2(2)/2
        x171 = P4(3)*w3(3)/2
        x172 = P4(3)*co(2)*w2(3)/2
        x173 = P4(1)*co(2)*w2(1)/2
        x174 = P4(1)*w3(1)/2
        x175 = P4(1)*w2(1)/2
        x176 = P4(2)/2
        x177 = P4(3)/2
        x178 = P4(2)*co(2)*w2(2)/2
        x179 = P1(0)*co(2)*w2(0)
        x180 = P1(0)*P2(0)*w2(0)*w3(0)
        x181 = P1(0)*P3(0)*w2(0)*w3(0)
        x182 = P2(0)*w3(0)
        x183 = co(1)*w2(1)*w3(1)
        x184 = co(3)*w2(1)*w3(1)
        x185 = P2(0)*co(2)*w2(0)
        x186 = P1(2)*P2(2)*w2(2)*w3(2)
        x187 = P3(0)*co(2)*w2(0)
        x188 = P1(2)*P3(2)*w2(2)*w3(2)
        x189 = P4(2)*co(9)*w2(3)*w3(3)
        x190 = P2(0)*co(2)*w2(3)*w3(0)
        x191 = co(3)*w2(3)*w3(3)
        x192 = P2(0)*co(5)*w2(0)
        x193 = P2(0)*P3(0)*co(7)
        x194 = P2(0)*co(0)*w3(0)
        x195 = P2(0)*P3(1)*w2(0)*w3(1)
        x196 = P2(1)*co(3)*w2(1)*w3(3)
        x197 = P4(1)*co(9)*w2(2)*w3(2)
        x198 = P4(1)*co(9)
        x199 = P4(3)*co(9)*w2(1)*w3(1)
        x200 = P3(0)*co(5)*w3(0)
        x201 = P4(0)*co(2)*w2(0)
        x202 = P4(0)*w3(0)
        x203 = P1(0)*P4(0)
        x204 = 2*P4(1)*co(8)*w2(0)*w3(0)
        x205 = P1(2)*P4(2)
        x206 = P1(3)*P4(3)
        x207 = 2*P3(0)*w2(0)
        x208 = 2*P2(0)*P3(0)*w2(0)*w3(0)
        x209 = P2(0)*P3(0)
        x210 = P2(0)*P4(0)
        x211 = 2*co(1)
        x212 = 2*P2(1)*P3(1)
        x213 = 2*co(3)
        x214 = P2(1)*P3(1)
        x215 = 2*P2(2)*P3(2)
        x216 = P2(2)*P3(2)
        x217 = 2*co(10)*w2(3)*w3(3)
        x218 = 2*P2(2)*co(8)*w2(0)*w3(0)
        x219 = 2*P2(3)*P3(3)
        x220 = P2(3)*P3(3)
        x221 = P2(3)*P4(3)
        x222 = P3(0)*P4(0)
        x223 = P3(2)*P4(2)
        x224 = P3(3)*P4(3)
        x225 = 2*co(2)*w2(1)*w3(1)
        x226 = 2*P4(1)*co(8)*w2(1)*w3(1)
        x227 = P1(1)*P4(1)
        x228 = 2*co(2)*w2(2)*w3(2)
        x229 = 2*P4(2)*co(8)*w2(3)*w3(3)
        x230 = 2*co(2)*w2(3)*w3(3)
        x231 = 2*P2(0)*P3(0)
        x232 = P2(1)*P4(1)
        x233 = P2(2)*P4(2)
        x234 = P3(1)*P4(1)
        x235 = P4(0)*w2(0)/2
        x236 = P4(0)*w3(0)/2
        x237 = P4(0)*co(2)*w2(0)/2
        x249 = P4(0)/2
        x257 = P4(1)/2
        do j = riMaxIn, 0, -1
          x238 = cima*w4(0)*wl(0,j)
          wp(0,j) = P1(0)*x238*x73 + P1(0)*x238*x74 - P1(1)*x204*x238 + P1(1)* &
                    x226*x238 + P1(1)*x238*x98 + P1(2)*x108*x238 - P1(2)*x189* &
                    x238 + P1(2)*x229*x238 + P1(3)*x116*x238 - P1(3)*x190*x238 &
                     - P2(0)*P4(0)*co(9)*w2(0)*w3(0)*x238 - P2(0)*co(4)*w2(0)* &
                    x238*x94 + 2*P2(0)*w3(0)*x179*x238 + P2(0)*x238*x74 + P2(1 &
                    )*co(2)*w2(1)*w3(2)*x176*x238 - P2(1)*x197*x238 - P2(1)*   &
                    x204*x238 + P2(1)*x226*x238 + P2(1)*x238*x98 + P2(2)*co(0)*&
                    x146*x238 + P2(2)*co(2)*w2(3)*w3(2)*x177*x238 + P2(2)*co(7 &
                    )*x148*x238 + P2(2)*x108*x238 + P2(2)*x229*x238 + P2(3)*   &
                    x116*x238 - P2(3)*x196*x238 - P2(3)*x199*x238 - P3(0)*co(4 &
                    )*w3(0)*x118*x238 + P3(0)*x238*x73 + P3(0)*x238*x74 + P3(1 &
                    )*co(7)*x138*x238 - P3(1)*w2(1)*w3(1)*x198*x238 - P3(1)*   &
                    x197*x238 - P3(1)*x204*x238 + P3(1)*x226*x238 + P3(1)*x238*&
                    x98 + P3(2)*w2(0)*w3(0)*x161*x238 + P3(2)*x108*x238 - P3(2 &
                    )*x189*x238 - P3(2)*x218*x238 + P3(2)*x229*x238 + P3(3)*   &
                    x116*x238 - P3(3)*x190*x238 - P3(3)*x196*x238 - P3(3)*x199*&
                    x238 - P4(2)*x218*x238 + co(0)*x124*x238 + co(0)*x136*x238 &
                     + co(0)*x153*x238 - co(1)*x101*x238 - co(1)*x130*x238 - co&
                    (1)*x14*x238 - co(1)*x140*x238 - co(1)*x181*x238 - co(1)*  &
                    x186*x238 - co(1)*x188*x238 - co(1)*x22*x238 - co(1)*x23*  &
                    x238 - co(1)*x238*x29 - co(1)*x238*x30 - co(1)*x238*x31 -  &
                    co(10)*x180*x238 - co(10)*x208*x238 - co(10)*x22*x238 - co(&
                    10)*x23*x238 - co(10)*x238*x30 - co(10)*x238*x35 + 2*co(2)*&
                    w2(0)*w3(0)*x238*x66 + co(2)*w3(3)*x104*x238 + co(2)*x101* &
                    x238 + co(2)*x128*x238 + co(2)*x130*x238 + co(2)*x14*x238  &
                     + co(2)*x140*x238 + co(2)*x16*x238 - co(2)*x195*x238 + co(&
                    2)*x208*x238 + co(2)*x22*x238 + co(2)*x23*x238 + co(2)*x238&
                    *x27 - co(3)*w3(3)*x104*x238 - co(3)*x130*x238 - co(3)*x14*&
                    x238 - co(3)*x140*x238 - co(3)*x181*x238 - co(3)*x186*x238 &
                     - co(3)*x188*x238 - co(3)*x22*x238 - co(3)*x23*x238 - co(3&
                    )*x238*x27 - co(3)*x238*x29 - co(3)*x238*x30 - co(3)*x238* &
                    x31 - co(3)*x238*x32 + co(4)*x124*x238 + co(4)*x136*x238 + &
                    co(4)*x140*x238 + co(4)*x147*x238 + co(4)*x153*x238 - co(4 &
                    )*x195*x238 + co(5)*x130*x238 + co(5)*x14*x238 + co(5)*x22*&
                    x238 + co(5)*x23*x238 + co(5)*x238*x27 + co(5)*x238*x29 +  &
                    co(5)*x238*x30 + co(5)*x238*x31 + co(5)*x238*x32 + co(6)*  &
                    x22*x238 + co(6)*x238*x35 + co(7)*x124*x238 + co(7)*x136*  &
                    x238 + co(7)*x147*x238 + co(8)*x22*x238 + co(8)*x238*x35 - &
                    co(9)*x16*x238 + x0*x1*x238 - x0*x10*x238 - x0*x11*x238 +  &
                    x0*x18*x238 - x0*x238*x33 + x0*x238*x34 + x0*x238*x36 + x0*&
                    x238*x37 - x0*x238*x38 + x0*x238*x39 + x0*x238*x40 + x0*   &
                    x238*x43 + x1*x103*x238 + x1*x107*x238 + x1*x114*x238 + x1*&
                    x115*x238 + x1*x2*x238 + x1*x212*x238 + x1*x215*x238 + x1* &
                    x219*x238 + x1*x238*x3 + x1*x238*x4 + x1*x238*x5 + x1*x238*&
                    x6 - x1*x238*x66 - x1*x238*x7 + x1*x238*x85 - x1*x238*x9 + &
                    x1*x238*x93 - x10*x103*x238 - x10*x107*x238 - x10*x114*x238&
                     - x10*x115*x238 - x10*x212*x238 - x10*x215*x238 - x10*x219&
                    *x238 + x10*x231*x238 - x10*x238*x3 - x10*x238*x4 + x10*   &
                    x238*x57 - x10*x238*x6 + x10*x238*x66 + x10*x238*x7 - x10* &
                    x238*x85 + x10*x238*x9 - x10*x238*x93 + x100*x102*x238 -   &
                    x100*x238*x60 - x100*x238*x68 - x100*x238*x72 + x100*x238* &
                    x83 + x100*x238*x92 - x102*x120*x238 + x102*x126*x238 -    &
                    x102*x135*x238 + x102*x170*x238 - x102*x235*x238 - x102*   &
                    x238*x61 + x102*x238*x87 - x103*x11*x238 + x103*x228*x238  &
                     - x103*x238*x52 + x103*x238*x53 + x103*x238*x54 + x103*   &
                    x238*x55 - x103*x238*x8 - x105*x134*x238 + x105*x169*x238  &
                     + x105*x171*x238 - x105*x182*x238 - x105*x236*x238 - x105*&
                    x238*x58 + x105*x238*x76 + x105*x238*x80 + x105*x238*x94 + &
                    x105*x238*x96 + x106*x144*x238 + x106*x145*x238 + x106*x152&
                    *x238 + x106*x172*x238 + x106*x178*x238 - x106*x179*x238 - &
                    x106*x187*x238 - x106*x237*x238 - x106*x238*x62 - x106*x238&
                    *x64 - x106*x238*x69 - x106*x238*x71 + x106*x238*x78 + x106&
                    *x238*x81 + x106*x238*x82 + x106*x238*x90 + x106*x238*x91  &
                     + x106*x238*x95 + x106*x238*x97 - x107*x11*x238 + x107*   &
                    x228*x238 - x107*x238*x52 + x107*x238*x53 + x107*x238*x54  &
                     + x107*x238*x55 - x107*x238*x8 - x109*x238*x41 + x109*x238&
                    *x45 - x109*x238*x49 - x11*x114*x238 - x11*x115*x238 - x11*&
                    x2*x238 - x11*x212*x238 - x11*x219*x238 - x11*x238*x3 - x11&
                    *x238*x4 - x11*x238*x5 + x11*x238*x57 - x11*x238*x6 + x11* &
                    x238*x66 + x11*x238*x7 - x11*x238*x85 + x11*x238*x9 - x11* &
                    x238*x93 - x110*x238*x60 - x110*x238*x63 - x110*x238*x68 - &
                    x110*x238*x70 + x110*x238*x83 + x110*x238*x86 + x110*x238* &
                    x92 - x111*x134*x238 + x111*x171*x238 - x111*x182*x238 -   &
                    x111*x236*x238 - x111*x238*x58 + x111*x238*x80 + x111*x238*&
                    x96 + x112*x131*x238 + x112*x133*x238 + x112*x172*x238 -   &
                    x112*x192*x238 - x112*x238*x62 - x112*x238*x64 - x112*x238*&
                    x69 - x112*x238*x71 + x112*x238*x81 + x112*x238*x82 + x112*&
                    x238*x90 + x112*x238*x91 + x112*x238*x97 - x113*x120*x238  &
                     + x113*x170*x238 + x113*x175*x238 - x113*x235*x238 + x113*&
                    x238*x87 - x114*x191*x238 + x114*x230*x238 - x114*x238*x51 &
                     - x114*x238*x52 + x114*x238*x53 + x114*x238*x54 + x114*   &
                    x238*x55 - x114*x238*x8 - x115*x191*x238 + x115*x230*x238  &
                     - x115*x238*x51 - x115*x238*x52 + x115*x238*x53 + x115*   &
                    x238*x54 + x115*x238*x55 - x115*x238*x8 - x117*x238*x41 -  &
                    x117*x238*x44 + x117*x238*x45 - x117*x238*x49 + x118*x119* &
                    x238 + x118*x141*x238 + x118*x238*x83 + x118*x238*x89 +    &
                    x118*x238*x92 + x119*x123*x238 + x119*x125*x238 + x119*x126&
                    *x238 + x119*x127*x238 - x119*x207*x238 - x119*x238*x61 +  &
                    x119*x238*x87 + x12*x13*x238 + x12*x238*x38 - x12*x238*x39 &
                     - x12*x238*x40 - x12*x238*x43 - x120*x141*x238 + x120*x238&
                    *x60 + x120*x238*x63 + x120*x238*x65 + x120*x238*x68 + x120&
                    *x238*x70 + x120*x238*x72 - x120*x238*x86 - x120*x238*x88  &
                     - x120*x238*x89 + x121*x133*x238 - x121*x192*x238 - x121* &
                    x238*x64 - x121*x238*x67 - x121*x238*x71 + x121*x238*x82 + &
                    x121*x238*x91 + x122*x131*x238 + x122*x132*x238 - x122*x192&
                    *x238 - x122*x238*x59 - x122*x238*x62 - x122*x238*x67 -    &
                    x122*x238*x69 + x122*x238*x82 + x122*x238*x91 - x123*x238* &
                    x60 - x123*x238*x63 - x123*x238*x68 - x123*x238*x70 + x123*&
                    x238*x83 + x123*x238*x86 + x123*x238*x92 + x124*x238*x56 + &
                    x125*x143*x238 + x125*x151*x238 + x125*x157*x238 + x125*   &
                    x159*x238 - x125*x194*x238 - x125*x200*x238 - x125*x238*x63&
                     - x125*x238*x65 - x125*x238*x70 - x125*x238*x72 + x125*   &
                    x238*x83 + x125*x238*x86 + x125*x238*x89 + x125*x238*x92 + &
                    x126*x139*x238 + x126*x151*x238 + x126*x158*x238 + x126*   &
                    x159*x238 - x126*x194*x238 - x126*x200*x238 - x126*x238*x60&
                     - x126*x238*x65 - x126*x238*x68 - x126*x238*x72 + x126*   &
                    x238*x83 + x126*x238*x89 + x126*x238*x92 + x127*x139*x238  &
                     + x127*x143*x238 + x127*x157*x238 + x127*x158*x238 - x127*&
                    x194*x238 - x127*x200*x238 - x127*x238*x60 - x127*x238*x63 &
                     - x127*x238*x68 - x127*x238*x70 + x127*x238*x83 + x127*   &
                    x238*x86 + x127*x238*x92 + x128*x238*x56 + x129*x238*x41 + &
                    x129*x238*x44 + x13*x238*x7 - x131*x182*x238 - x132*x182*  &
                    x238 - x133*x182*x238 - x134*x144*x238 - x134*x145*x238 -  &
                    x134*x152*x238 - x134*x172*x238 - x134*x173*x238 - x134*   &
                    x178*x238 + x134*x238*x59 + x134*x238*x62 + x134*x238*x64  &
                     + x134*x238*x67 + x134*x238*x69 + x134*x238*x71 - x134*   &
                    x238*x77 - x134*x238*x78 - x134*x238*x81 - x134*x238*x90 - &
                    x134*x238*x95 - x134*x238*x97 - x135*x139*x238 - x135*x143*&
                    x238 - x135*x151*x238 - x135*x157*x238 - x135*x158*x238 -  &
                    x135*x159*x238 + x135*x238*x60 + x135*x238*x63 + x135*x238*&
                    x65 + x135*x238*x68 + x135*x238*x70 + x135*x238*x72 - x135*&
                    x238*x86 - x135*x238*x88 - x135*x238*x89 - x136*x211*x238  &
                     - x136*x213*x238 + x137*x238*x41 - x137*x238*x45 - x138*  &
                    x198*x238 + x142*x238*x45 - x142*x238*x49 + x144*x171*x238 &
                     + x144*x174*x238 - x144*x182*x238 - x144*x236*x238 - x144*&
                    x238*x58 + x144*x238*x96 + x145*x238*x96 - x146*x161*x238  &
                     - x147*x211*x238 - x147*x213*x238 - x148*x161*x238 + x149*&
                    x238*x44 - x149*x238*x45 - x15*x238*x53 - x15*x238*x54 -   &
                    x15*x238*x55 - x150*x238*x41 - x150*x238*x44 + x150*x238*  &
                    x45 - x150*x238*x49 + x152*x238*x94 + x154*x238*x41 + x154*&
                    x238*x44 - x154*x238*x45 + x154*x238*x49 - x155*x238*x41 - &
                    x155*x238*x44 + x155*x238*x45 + x156*x238*x41 + x156*x238* &
                    x44 - x156*x238*x45 + x16*x238*x56 - x160*x238*x44 + x160* &
                    x238*x45 - x162*x238*x41 - x162*x238*x44 + x162*x238*x45 + &
                    x163*x164*x238 + x163*x168*x238 - x163*x201*x238 + x164*   &
                    x167*x238 - x164*x202*x238 + x165*x166*x238 + x165*x167*   &
                    x238 - x165*x202*x238 + x166*x168*x238 - x166*x201*x238 -  &
                    x167*x201*x238 - x168*x202*x238 - x169*x179*x238 - x169*   &
                    x185*x238 - x169*x187*x238 + x169*x238*x77 + x169*x238*x81 &
                     + x169*x238*x90 + x169*x238*x97 + x17*x18*x238 - x17*x238*&
                    x38 + x17*x238*x39 + x17*x238*x40 + x17*x238*x43 + x170*   &
                    x238*x88 + x170*x238*x89 - x171*x179*x238 - x171*x185*x238 &
                     - x171*x187*x238 + x171*x238*x77 + x171*x238*x78 + x171*  &
                    x238*x95 - x172*x238*x58 + x172*x238*x76 + x172*x238*x79 + &
                    x172*x238*x94 - x173*x182*x238 - x173*x238*x58 + x173*x238*&
                    x76 + x173*x238*x94 + x173*x238*x96 - x174*x179*x238 - x174&
                    *x185*x238 - x174*x187*x238 + x174*x238*x78 + x174*x238*x81&
                     + x174*x238*x90 + x174*x238*x95 + x174*x238*x97 + x175*   &
                    x238*x86 + x175*x238*x89 - x177*x190*x238 - x178*x182*x238 &
                     - x178*x238*x58 + x178*x238*x96 - x179*x238*x76 - x179*   &
                    x238*x79 - x179*x238*x80 - x179*x238*x94 - x179*x238*x96 + &
                    x18*x19*x238 + x18*x212*x238 + x18*x238*x4 + x180*x238*x56 &
                     - x182*x238*x77 - x182*x238*x78 - x182*x238*x90 - x182*   &
                    x238*x95 - x183*x238*x85 - x183*x238*x93 - x184*x238*x85 - &
                    x184*x238*x93 - x185*x238*x76 - x185*x238*x94 - x185*x238* &
                    x96 - x187*x238*x76 - x187*x238*x80 - x187*x238*x94 - x187*&
                    x238*x96 - x19*x238*x52 + x19*x238*x53 + x19*x238*x54 + x19&
                    *x238*x55 - x191*x219*x238 - x193*x238*x41 - x193*x238*x44 &
                     - x193*x238*x49 - x2*x238*x33 + x2*x238*x34 + x2*x238*x37 &
                     - x2*x238*x38 + x2*x238*x39 + x2*x238*x43 - x2*x238*x8 +  &
                    x20*x21*x238 - x20*x238*x38 + x20*x238*x39 + x20*x238*x40  &
                     + x20*x238*x43 + x203*x238*x52 - x203*x238*x53 - x203*x238&
                    *x54 - x203*x238*x55 - x205*x238*x52 + x205*x238*x53 + x205&
                    *x238*x54 - x206*x238*x52 + x206*x238*x53 + x206*x238*x54  &
                     + x206*x238*x55 - x207*x238*x83 + x209*x217*x238 - x209*  &
                    x238*x53 - x209*x238*x54 - x209*x238*x55 + x21*x238*x24 -  &
                    x210*x238*x53 - x210*x238*x54 - x210*x238*x55 - x212*x238* &
                    x8 - x214*x238*x52 + x214*x238*x53 + x214*x238*x54 + x214* &
                    x238*x55 - x215*x238*x8 - x216*x217*x238 + x216*x228*x238  &
                     + x216*x238*x53 + x216*x238*x54 + x216*x238*x55 + x219*   &
                    x238*x26 - x219*x238*x51 - x219*x238*x8 - x220*x238*x52 +  &
                    x220*x238*x53 + x220*x238*x54 + x220*x238*x55 - x221*x238* &
                    x52 + x221*x238*x53 + x221*x238*x54 + x221*x238*x55 + x222*&
                    x238*x52 - x222*x238*x53 - x222*x238*x54 - x222*x238*x55 - &
                    x223*x238*x52 + x223*x238*x53 + x223*x238*x54 - x224*x238* &
                    x52 + x224*x238*x53 + x224*x238*x54 + x224*x238*x55 + x225*&
                    x238*x85 + x225*x238*x93 + x227*x238*x54 + x227*x238*x55 + &
                    x231*x238*x8 + x232*x238*x54 + x232*x238*x55 + x233*x238*  &
                    x53 + x233*x238*x54 + x234*x238*x54 + x234*x238*x55 - x235*&
                    x238*x86 - x235*x238*x88 - x235*x238*x89 - x236*x238*x77 - &
                    x236*x238*x78 - x236*x238*x81 - x236*x238*x90 - x236*x238* &
                    x95 - x236*x238*x97 - x237*x238*x76 - x237*x238*x94 - x237*&
                    x238*x96 - x238*x24*x52 + x238*x24*x53 + x238*x24*x54 +    &
                    x238*x24*x55 + x238*x25*x26 - x238*x25*x38 + x238*x25*x39  &
                     + x238*x25*x40 + x238*x25*x43 + x238*x26*x28 + x238*x26*x3&
                     - x238*x28*x52 + x238*x28*x53 + x238*x28*x54 + x238*x28*  &
                    x55 - x238*x3*x33 + x238*x3*x36 + x238*x3*x37 - x238*x3*x38&
                     + x238*x3*x40 + x238*x3*x43 - x238*x3*x51 - x238*x33*x4 - &
                    x238*x33*x5 - x238*x33*x6 + x238*x33*x7 + x238*x33*x9 +    &
                    x238*x34*x4 + x238*x34*x5 + x238*x34*x6 - x238*x34*x7 -    &
                    x238*x34*x9 + x238*x36*x4 + x238*x36*x5 + x238*x36*x6 -    &
                    x238*x36*x7 - x238*x36*x9 + x238*x37*x4 + x238*x37*x5 +    &
                    x238*x37*x6 - x238*x37*x7 - x238*x37*x9 - x238*x38*x4 -    &
                    x238*x38*x6 + x238*x38*x7 + x238*x38*x9 + x238*x39*x4 +    &
                    x238*x39*x5 + x238*x39*x6 - x238*x39*x7 - x238*x39*x9 +    &
                    x238*x4*x40 + x238*x4*x43 - x238*x4*x8 + x238*x40*x6 - x238&
                    *x40*x7 - x238*x40*x9 + x238*x41*x42 - x238*x41*x46 - x238*&
                    x41*x47 - x238*x41*x48 + x238*x41*x50 + x238*x41*x75 - x238&
                    *x41*x99 + x238*x42*x44 - x238*x42*x45 + x238*x43*x6 - x238&
                    *x43*x7 - x238*x43*x9 - x238*x44*x46 - x238*x44*x47 - x238*&
                    x44*x48 + x238*x44*x50 + x238*x44*x75 - x238*x44*x99 + x238&
                    *x45*x46 + x238*x45*x47 + x238*x45*x48 - x238*x45*x75 +    &
                    x238*x45*x99 - x238*x46*x49 - x238*x47*x49 - x238*x48*x49  &
                     + x238*x49*x50 - x238*x49*x99 - x238*x5*x8 - x238*x51*x6  &
                     + x238*x52*x66 - x238*x52*x85 - x238*x52*x93 - x238*x53*  &
                    x57 - x238*x53*x66 + x238*x53*x85 + x238*x53*x93 - x238*x54&
                    *x57 - x238*x54*x66 + x238*x54*x85 + x238*x54*x93 - x238*  &
                    x55*x57 - x238*x55*x66 + x238*x55*x85 + x238*x55*x93 + x238&
                    *x57*x8 + x238*x58*x59 + x238*x58*x62 + x238*x58*x64 + x238&
                    *x58*x67 + x238*x58*x69 + x238*x58*x71 - x238*x58*x77 -    &
                    x238*x58*x78 - x238*x58*x81 - x238*x58*x90 - x238*x58*x95  &
                     - x238*x58*x97 - x238*x59*x80 - x238*x59*x96 - x238*x6*x8 &
                     + x238*x60*x61 - x238*x60*x87 + x238*x61*x63 + x238*x61*  &
                    x65 + x238*x61*x68 + x238*x61*x70 + x238*x61*x72 - x238*x61&
                    *x83 - x238*x61*x86 - x238*x61*x89 - x238*x62*x79 - x238*  &
                    x62*x80 - x238*x62*x96 - x238*x63*x84 - x238*x64*x76 - x238&
                    *x64*x79 - x238*x64*x94 - x238*x65*x84 - x238*x65*x87 +    &
                    x238*x66*x8 - x238*x67*x76 - x238*x67*x80 - x238*x67*x94 - &
                    x238*x67*x96 - x238*x68*x87 - x238*x69*x79 - x238*x69*x80  &
                     - x238*x69*x96 + x238*x7*x8 - x238*x70*x84 - x238*x71*x76 &
                     - x238*x71*x79 - x238*x71*x94 - x238*x72*x84 - x238*x72*  &
                    x87 + x238*x76*x77 + x238*x76*x81 + x238*x76*x82 + x238*x76&
                    *x90 + x238*x76*x91 + x238*x76*x97 + x238*x77*x80 + x238*  &
                    x77*x94 + x238*x77*x96 + x238*x78*x79 + x238*x78*x80 + x238&
                    *x78*x96 + x238*x79*x81 + x238*x79*x82 + x238*x79*x90 +    &
                    x238*x79*x91 + x238*x79*x95 + x238*x79*x97 - x238*x8*x85 + &
                    x238*x8*x9 - x238*x8*x93 + x238*x80*x82 + x238*x80*x91 +   &
                    x238*x80*x95 + x238*x81*x94 + x238*x82*x94 + x238*x82*x96  &
                     + x238*x83*x84 + x238*x83*x87 + x238*x84*x86 + x238*x84*  &
                    x89 + x238*x84*x92 + x238*x87*x88 + x238*x87*x89 + x238*x87&
                    *x92 + x238*x90*x94 + x238*x91*x94 + x238*x91*x96 + x238*  &
                    x94*x97 + x238*x95*x96
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x239 = co(2)*w2(0)*w3(mu)
            x240 = co(2)*w2(mu)*w3(0)
            x241 = co(2)*w2(mu)
            x242 = co(1)*w2(1)*w3(mu)
            x243 = co(3)*w2(mu)
            x244 = co(1)*w3(mu)
            x245 = co(3)*w2(mu)*w3(2)
            x246 = co(1)*w2(3)*w3(mu)
            x247 = co(3)*w2(mu)*w3(3)
            x248 = P4(mu)*co(9)
            x250 = co(2)*w2(1)*w3(mu)
            x251 = co(2)*w2(mu)*w3(1)
            x252 = co(2)*w3(mu)
            x253 = co(2)*w2(mu)*w3(2)
            x254 = co(2)*w2(3)*w3(mu)
            x255 = co(2)*w2(mu)*w3(3)
            x256 = co(1)*w2(0)*w3(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + P1(0)*x238*x239 + P1(0)*x238*x240 - P1(&
                          1)*x238*x250 - P1(1)*x238*x251 - P1(2)*x238*x253 - P1&
                          (3)*x238*x254 - P1(3)*x238*x255 + P1(mu)*x238*x52 -  &
                          P1(mu)*x238*x53 - P1(mu)*x238*x54 - P1(mu)*x238*x55  &
                           + P2(0)*x238*x239 - P2(0)*x238*x256 + P2(1)*x238*   &
                          x242 - P2(1)*x238*x250 + P2(2)*x238*x245 - P2(2)*x238&
                          *x253 + P2(3)*x238*x246 + P2(3)*x238*x247 - P2(3)*   &
                          x238*x254 - P2(3)*x238*x255 - P2(mu)*x1*x238 + P2(mu &
                          )*x10*x238 + P2(mu)*x11*x238 + P2(mu)*x238*x52 - P2( &
                          mu)*x238*x53 - P2(mu)*x238*x54 - P2(mu)*x238*x55 + P2&
                          (mu)*x238*x8 + P3(0)*x238*x239 + P3(0)*x238*x240 - P3&
                          (0)*x238*x256 + P3(1)*x238*x242 - P3(1)*x238*x250 -  &
                          P3(1)*x238*x251 + P3(2)*x238*x245 - P3(2)*x238*x253  &
                           + P3(3)*x238*x246 + P3(3)*x238*x247 - P3(3)*x238*   &
                          x254 - P3(3)*x238*x255 - P3(mu)*x1*x238 + P3(mu)*x10*&
                          x238 + P3(mu)*x11*x238 + P3(mu)*x238*x52 - P3(mu)*   &
                          x238*x53 - P3(mu)*x238*x54 - P3(mu)*x238*x55 + P3(mu &
                          )*x238*x8 + P4(mu)*x238*x52 - P4(mu)*x238*x53 - P4(mu&
                          )*x238*x54 - P4(mu)*x238*x55 - x100*x238*x252 + x106*&
                          x238*x243 - x112*x238*x241 + x112*x238*x243 + x126*  &
                          x238*x244 - x126*x238*x252 - x134*x238*x243 - x170*  &
                          x238*x252 - x176*x238*x253 - x177*x238*x254 - x177*  &
                          x238*x255 + x182*x238*x241 - x182*x238*x243 + x238*  &
                          x239*x249 + x238*x240*x249 + x238*x244*x87 + x238*   &
                          x248*x41 + x238*x248*x44 - x238*x248*x45 + x238*x248*&
                          x49 - x238*x250*x257 - x238*x251*x257 - x238*x252*x87
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) + gg(nu,mu)*x238*x38 - gg(nu,mu)*x238* &
                            x39 - gg(nu,mu)*x238*x40 - gg(nu,mu)*x238*x43 + w3(&
                            nu)*x238*x241
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVVSS
end module lcSVVSS
