!******************************************************************************!
!                                                                              !
!    lcVSSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVSSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSSSV0)
!       P(1,1)*P(5,5)*c0
!       c1*(P(1,1)*P(5,1) + P(1,5)*P(5,5))
!       P(1,5)*P(5,1)*c2
!       c3*(P(1,1)*P(5,3) + P(1,1)*P(5,4) + P(1,5)*P(5,3) + P(1,5)*P(5,4))
!       c4*(2*P(1,3)*P(5,3) + P(1,3)*P(5,4) + P(1,4)*P(5,3) + 2*P(1,4)*P(5,4))
!       c5*(P(1,3)*P(5,1) + P(1,3)*P(5,5) + P(1,4)*P(5,1) + P(1,4)*P(5,5))
!       c6*(Metric(1,5)*P(-1,1)**2 + Metric(1,5)*P(-1,5)**2)
!       Metric(1,5)*P(-1,1)*P(-1,5)*c7
!       c8*(Metric(1,5)*P(-1,3)**2 + Metric(1,5)*P(-1,4)**2)
!       Metric(1,5)*P(-1,3)*P(-1,4)*c9
!       c10*(Metric(1,5)*P(-1,1)*P(-1,3) + Metric(1,5)*P(-1,1)*P(-1,4) + Metric(1
!       ,5)*P(-1,3)*P(-1,5) + Metric(1,5)*P(-1,4)*P(-1,5))
        x63 = 2*co(1)
        x65 = P3(0)**2
        x66 = P4(0)**2
        x67 = P3(1)**2
        x68 = P3(2)**2
        x69 = P3(3)**2
        x70 = P4(1)**2
        x71 = P4(2)**2
        x72 = P4(3)**2
        x73 = P1(0)**2
        x74 = P1(1)**2
        x75 = P1(2)**2
        x76 = P1(3)**2
        x77 = P3(1)*P4(1)
        x78 = P3(2)*P4(2)
        x79 = P3(3)*P4(3)
        x80 = P3(0)*P4(0)
        x81 = cima*w2(0)*w3(0)*w4(0)
        do j = riMaxIn, 0, -1
          x0 = P1(0)*wl(0,j)
          x1 = co(0)*x0
          x2 = P1(1)*wl(1,j)
          x3 = co(1)*x2
          x4 = co(1)*wl(2,j)
          x5 = P1(2)*x4
          x6 = P1(3)*wl(3,j)
          x7 = co(1)*x6
          x8 = P2(1)*wl(1,j)
          x9 = co(1)*x8
          x10 = P2(2)*x4
          x11 = co(1)*wl(3,j)
          x12 = P2(3)*x11
          x13 = P3(0)*wl(0,j)
          x14 = co(5)*x13
          x15 = P3(1)*wl(1,j)
          x16 = co(1)*x15
          x17 = P3(2)*wl(2,j)
          x18 = co(1)*x17
          x19 = P3(3)*wl(3,j)
          x20 = co(1)*x19
          x21 = P4(0)*wl(0,j)
          x22 = co(5)*x21
          x23 = P4(1)*wl(1,j)
          x24 = co(1)*x23
          x25 = P4(2)*wl(2,j)
          x26 = co(1)*x25
          x27 = P4(3)*x11
          x28 = co(1)*wl(0,j)
          x29 = -P1(0)*x28
          x30 = co(0)*x2
          x31 = -x30
          x32 = P1(2)*wl(2,j)
          x33 = co(0)*x32
          x34 = -x33
          x35 = co(0)*x6
          x36 = -x35
          x37 = P2(0)*x28
          x38 = -x37
          x39 = P3(0)*x28
          x40 = -x39
          x41 = -co(5)*x15
          x42 = -co(5)*x17
          x43 = -co(5)*x19
          x44 = co(1)*x21
          x45 = -x44
          x46 = -co(5)*x23
          x47 = -co(5)*x25
          x48 = P4(3)*wl(3,j)
          x49 = -co(5)*x48
          x50 = co(4)*x23
          x51 = co(4)*x25
          x52 = co(4)*x48
          x53 = co(4)*x21
          x54 = co(4)*x13
          x55 = co(4)*x15
          x56 = co(4)*x17
          x57 = co(4)*x19
          x58 = co(3)*wl(3,j)
          x59 = P2(0)*co(3)*wl(0,j) - P2(2)*co(3)*wl(2,j) - P2(3)*x58 - P4(3)* &
                x58 + co(3)*x13 - co(3)*x15 - co(3)*x17 - co(3)*x19 + co(3)*x21&
                 - co(3)*x23 - co(3)*x25 - co(3)*x8 + x1 + x10 + x12 + x14 +   &
                x16 + x18 + x20 + x22 + x24 + x26 + x27 + x29 + x3 + x31 + x34 &
                 + x36 + x38 + x40 + x41 + x42 + x43 + x45 + x46 + x47 + x49 + &
                x5 + x7 + x9
          x60 = co(2)*wl(2,j)
          x61 = co(2)*wl(3,j)
          x62 = co(2)*wl(0,j)
          x64 = -P1(0)*x62 + P1(2)*x60 + P1(3)*x61 - P2(0)*x62 + P2(2)*x60 + P2&
                (3)*x61 - P3(0)*x62 - P4(0)*x62 + P4(3)*x61 + co(2)*x15 + co(2 &
                )*x17 + co(2)*x19 + co(2)*x2 + co(2)*x23 + co(2)*x25 + co(2)*x8&
                 + x0*x63 - x1 - x10 - x12 - x16 - x18 - x2*x63 - x20 - x24 -  &
                x26 - x27 + x30 - x32*x63 + x33 + x35 + x37 + x39 + x44 - x6*  &
                x63 - x9
          x0vec = co(10)*wl(:,j)
          x1vec = co(6)*wl(:,j)
          x2vec = wl(:,j)*x68
          x3vec = wl(:,j)*x69
          x4vec = wl(:,j)*x71
          x5vec = co(7)*wl(:,j)
          x6vec = co(8)*wl(:,j)
          x7vec = 2*co(6)*wl(:,j)
          x8vec = P1(0)*co(7)*wl(:,j)
          x9vec = P2(0)*co(10)*wl(:,j)
          x10vec = co(9)*wl(:,j)
          x11vec = P1(1)*co(7)*wl(:,j)
          x12vec = P1(2)*co(7)*wl(:,j)
          x13vec = P1(3)*co(7)*wl(:,j)
          x14vec = P2(1)*co(10)*wl(:,j)
          x15vec = P2(2)*co(10)*wl(:,j)
          x16vec = P2(3)*co(10)*wl(:,j)
          x17vec = 2*P2(0)*co(6)*wl(:,j)
          x18vec = 2*P1(0)*co(6)*wl(:,j)
          x19vec = 2*co(10)*wl(:,j)
          x20vec = 2*P1(1)*co(6)*wl(:,j)
          x21vec = 2*P2(2)*co(6)*wl(:,j)
          x22vec = 2*P3(2)*co(6)*wl(:,j)
          x23vec = 2*P1(3)*co(6)*wl(:,j)
          x24vec = 2*P2(1)*co(6)*wl(:,j)
          x25vec = 2*P2(3)*co(6)*wl(:,j)
          wp(:,j) = -P1(:)*x64*x81 + P2(:)*(x1*x81 + x10*x81 + x12*x81 + x14*  &
                    x81 + x16*x81 + x18*x81 + x20*x81 + x22*x81 + x24*x81 + x26&
                    *x81 + x27*x81 + x29*x81 + x3*x81 + x31*x81 + x34*x81 + x36&
                    *x81 + x38*x81 + x40*x81 + x41*x81 + x42*x81 + x43*x81 +   &
                    x45*x81 + x46*x81 + x47*x81 + x49*x81 + x5*x81 + x7*x81 +  &
                    x81*x9) + P3(:)*(x50*x81 + x51*x81 + x52*x81 - x53*x81 - 2*&
                    x54*x81 + 2*x55*x81 + 2*x56*x81 + 2*x57*x81 + x59*x81) + P4&
                    (:)*(2*x50*x81 + 2*x51*x81 + 2*x52*x81 - 2*x53*x81 - x54*  &
                    x81 + x55*x81 + x56*x81 + x57*x81 + x59*x81) + x0vec*(x65* &
                    x81 + x66*x81 - x67*x81 - x70*x81 - x72*x81) + x10vec*(x77*&
                    x81 + x78*x81 + x79*x81 - x80*x81) + x11vec*(-P2(1)*x81 -  &
                    P3(1)*x81 - P4(1)*x81) + x12vec*(-P2(2)*x81 - P3(2)*x81 -  &
                    P4(2)*x81) + x13vec*(-P2(3)*x81 - P3(3)*x81 - P4(3)*x81) + &
                    x14vec*(-P3(1)*x81 - P4(1)*x81) + x15vec*(-P3(2)*x81 - P4(2&
                    )*x81) + x16vec*(-P3(3)*x81 - P4(3)*x81) + x17vec*(-P1(0)* &
                    x81 - P3(0)*x81 - P4(0)*x81) + x18vec*(-P3(0)*x81 - P4(0)* &
                    x81) + x19vec*(-x77*x81 - x78*x81 - x79*x81 + x80*x81) +   &
                    x1vec*(-P2(0)**2*x81 + P2(1)**2*x81 + P2(2)**2*x81 + P2(3  &
                    )**2*x81 - x65*x81 - x66*x81 + x67*x81 + x70*x81 + x72*x81 &
                    ) + x20vec*(P2(1)*x81 + P3(1)*x81 + P4(1)*x81) + x21vec*(P1&
                    (2)*x81 + P4(2)*x81) + x22vec*(P1(2)*x81 + P2(2)*x81) +    &
                    x23vec*(P2(3)*x81 + P3(3)*x81 + P4(3)*x81) + x24vec*(P3(1)*&
                    x81 + P4(1)*x81) + x25vec*(P3(3)*x81 + P4(3)*x81) + x2vec  &
                    *(-co(10)*x81 + co(6)*x81) + x3vec*(-co(10)*x81 + co(6)*x81&
                    ) + x4vec*(-co(10)*x81 + co(6)*x81) + x5vec*(x73*x81 - x74*&
                    x81 - x75*x81 - x76*x81) + x6vec*(-x65*x81 - x66*x81 + x67*&
                    x81 + x68*x81 + x69*x81 + x70*x81 + x71*x81 + x72*x81) +   &
                    x7vec*(P1(2)*P4(2)*x81 - x73*x81 + x74*x81 + x75*x81 + x76*&
                    x81 + x77*x81 + x78*x81 + x79*x81 - x80*x81) + x8vec*(P2(0 &
                    )*x81 + P3(0)*x81 + P4(0)*x81) + x9vec*(P3(0)*x81 + P4(0)* &
                    x81)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x82 = wl(mu,j)*(co(0) + co(2) - x63)
            x83 = wl(mu,j)*(co(0) - co(1))
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + P1(:)*x81*x82 - 4*P1(mu)*x1vec*x81 + P2&
                          (:)*x81*x83 + P3(:)*x81*x83 + P4(:)*x81*x83 - gg(:,mu&
                          )*x64*x81 + x5vec*(2*P1(mu)*x81 + P2(mu)*x81 + P3(mu &
                          )*x81 + P4(mu)*x81) + x7vec*(-P2(mu)*x81 - P3(mu)*x81&
                           - P4(mu)*x81)
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(:,riOut) = wp(:,riOut) + gg(:,nu)*x81*x82 + gg(nu,mu)*x5vec*  &
                            x81 - gg(nu,mu)*x7vec*x81
            end do 
          end do 
        end do 
      end select 
    end subroutine loopVSSSV
end module lcVSSSV
