!******************************************************************************!
!                                                                              !
!    lcVSSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSSVS0)
!       P(1,4)*P(4,1)*c0
!       c1*(P(1,1)*P(4,3) + P(1,1)*P(4,5) + P(1,4)*P(4,3) + P(1,4)*P(4,5))
!       c2*(2*P(1,3)*P(4,3) + P(1,3)*P(4,5) + P(1,5)*P(4,3) + 2*P(1,5)*P(4,5))
!       c3*(P(1,3)*P(4,1) + P(1,3)*P(4,4) + P(1,5)*P(4,1) + P(1,5)*P(4,4))
!       P(1,1)*P(4,4)*c4
!       c5*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       Metric(1,4)*P(-1,1)*P(-1,4)*c6
!       c7*(Metric(1,4)*P(-1,3)**2 + Metric(1,4)*P(-1,5)**2)
!       Metric(1,4)*P(-1,3)*P(-1,5)*c8
!       c9*(Metric(1,4)*P(-1,1)*P(-1,3) + Metric(1,4)*P(-1,1)*P(-1,5) + Metric(1,
!       4)*P(-1,3)*P(-1,4) + Metric(1,4)*P(-1,4)*P(-1,5))
!       c10*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
        x0 = P1(0)**2
        x2 = P4(0)**2
        x4 = P1(1)**2
        x6 = P1(2)**2
        x8 = P1(3)**2
        x9 = P4(1)**2
        x11 = P4(2)**2
        x12 = P4(3)**2
        x21 = P2(0)**2
        x23 = P2(1)**2
        x24 = P2(2)**2
        x25 = P2(3)**2
        x28 = P3(1)**2
        x29 = co(8)*x28
        x31 = P3(2)**2
        x33 = P3(3)**2
        x36 = P3(0)**2
        x49 = 2*co(2)
        x56 = P1(0)*w4(0)
        x58 = P1(1)*w4(1)
        x61 = P1(0)*co(3)*w4(0)
        x64 = P1(2)*w4(2)
        x68 = P1(3)*w4(3)
        x70 = P1(0)*P2(0)
        x72 = P2(1)*co(1)*w4(1)
        x74 = P2(2)*w4(2)
        x76 = P2(3)*co(1)*w4(3)
        x80 = P1(0)*P3(0)
        x84 = P4(1)*w4(1)
        x87 = P4(2)*co(1)*w4(2)
        x89 = P4(2)*w4(2)
        x91 = P4(3)*w4(3)
        x96 = P1(3)*co(5)*w4(3)
        x97 = P2(0)*w4(0)
        x99 = P1(1)*P2(1)
        x102 = P3(2)*co(2)*w4(2)
        x104 = P3(3)*co(2)*w4(3)
        x105 = P4(0)*co(1)*w4(0)
        x107 = P4(0)*co(3)*w4(0)
        x111 = P1(1)*P4(1)
        x112 = P1(1)*P4(1)*co(6)
        x114 = P4(2)*co(4)*w4(2)
        x118 = P1(2)*P2(2)
        x120 = P3(1)*co(2)*w4(1)
        x123 = P1(2)*P3(2)
        x124 = P4(0)*w4(0)
        x128 = P1(2)*P4(2)*co(6)
        x130 = P1(3)*P2(3)
        x134 = P1(3)*co(0)*w4(3)
        x137 = P1(3)*P4(3)
        x138 = P1(3)*P4(3)*co(6)
        x139 = P2(0)*P3(0)
        x141 = P2(0)*P4(0)
        x142 = P2(1)*w4(1)
        x143 = P2(1)*P4(1)
        x144 = P2(2)*P3(2)
        x145 = P2(2)*P4(2)
        x146 = P2(3)*w4(3)
        x148 = P2(3)*P4(3)
        x149 = P3(0)*P4(0)
        x150 = P3(2)*P4(2)
        x151 = P4(1)*co(5)*w4(1)
        x152 = P4(2)*co(5)*w4(2)
        x153 = P4(3)*co(5)*w4(3)
        x157 = P1(0)*P4(0)
        x158 = P1(0)*P4(0)*co(6)
        x160 = P1(2)*co(3)*w4(2)
        x161 = P1(3)*co(3)*w4(3)
        x164 = P1(1)*co(3)*w4(1)
        x166 = P3(0)*co(2)*w4(0)
        x172 = P4(2)*co(3)*w4(2)
        x173 = P4(3)*co(3)*w4(3)
        x175 = P2(3)*co(1)
        x181 = P4(1)*co(3)*w4(1)
        x183 = P2(3)*P3(3)
        x185 = P3(1)*P4(1)*co(8)
        x186 = P3(3)*P4(3)
        x187 = P4(0)*co(5)*w4(0)
        x191 = 2*P1(0)*co(2)*w4(0)
        x192 = 2*P1(3)*co(2)*w4(3)
        x195 = 2*co(1)
        x196 = 2*P1(0)*P4(0)
        x198 = 2*P4(1)*co(2)*w4(1)
        x199 = 2*P4(3)*co(2)*w4(3)
        x201 = P1(1)*P3(1)
        x203 = 2*P1(1)*P4(1)
        x204 = 2*co(3)
        x206 = 2*P2(0)*co(2)*w4(0)
        x207 = P1(2)*P4(2)
        x208 = 2*P1(2)*P4(2)
        x209 = P1(3)*P3(3)
        x211 = 2*P1(3)*P4(3)
        x212 = 2*P4(2)*co(2)*w4(2)
        x213 = P2(1)*P3(1)
        x216 = 2*P3(0)*co(2)*w4(0)
        x218 = 2*P3(1)*co(2)*w4(1)
        x220 = 2*P3(2)*co(2)*w4(2)
        x222 = 2*P3(3)*co(2)*w4(3)
        x223 = P3(1)*P4(1)
        x226 = 2*P1(2)*co(2)*w4(2)
        x229 = 4*co(2)
        x231 = cima*w2(0)*w3(0)
        do j = riMaxIn, 0, -1
          x1 = w4(0)*wl(0,j)*x0
          x3 = co(10)*w4(0)*wl(0,j)
          x5 = w4(1)*wl(1,j)*x4
          x7 = co(10)*w4(1)*wl(1,j)
          x10 = w4(1)*wl(1,j)*x9
          x13 = co(10)*w4(2)*wl(2,j)
          x14 = w4(2)*wl(2,j)*x11
          x15 = co(10)*w4(3)*wl(3,j)
          x16 = w4(3)*wl(3,j)*x8
          x17 = w4(0)*wl(0,j)*x2
          x18 = w4(2)*wl(2,j)*x6
          x19 = w4(3)*wl(3,j)*x12
          x20 = co(7)*w4(0)*wl(0,j)
          x22 = co(7)*w4(1)*wl(1,j)
          x26 = co(7)*w4(2)*wl(2,j)
          x27 = co(7)*w4(3)*wl(3,j)
          x30 = w4(0)*wl(0,j)
          x32 = co(8)*x31
          x34 = co(8)*x33
          x35 = w4(1)*wl(1,j)
          x37 = co(8)*x36
          x38 = w4(2)*wl(2,j)
          x39 = w4(3)*wl(3,j)
          x40 = co(9)*w4(0)*wl(0,j)
          x41 = co(9)*w4(1)*wl(1,j)
          x42 = co(9)*w4(2)*wl(2,j)
          x43 = co(9)*w4(3)*wl(3,j)
          x44 = co(3)*w4(0)*wl(0,j)
          x45 = 2*co(7)*w4(0)*wl(0,j)
          x46 = 2*co(7)*w4(1)*wl(1,j)
          x47 = 2*co(7)*w4(2)*wl(2,j)
          x48 = 2*co(7)*w4(3)*wl(3,j)
          x50 = 2*co(2)*w4(0)*wl(0,j)
          x51 = 2*co(2)*w4(1)*wl(1,j)
          x52 = 2*co(2)*w4(2)*wl(2,j)
          x53 = 2*co(2)*w4(3)*wl(3,j)
          x54 = 2*x31
          x55 = 2*x33
          x57 = P1(1)*co(1)*wl(1,j)
          x59 = P1(0)*co(1)*wl(0,j)
          x60 = P1(1)*wl(1,j)
          x62 = P1(0)*co(3)*wl(0,j)
          x63 = P1(2)*co(1)*wl(2,j)
          x65 = P1(2)*co(3)*wl(2,j)
          x66 = P1(2)*co(3)*w4(2)*wl(0,j)
          x67 = P1(3)*co(1)*wl(3,j)
          x69 = P1(3)*wl(3,j)
          x71 = P1(0)*wl(0,j)
          x73 = P2(1)*wl(1,j)
          x75 = P2(2)*wl(2,j)
          x77 = P2(3)*wl(3,j)
          x78 = P3(0)*co(8)*w4(1)*wl(1,j)
          x79 = co(8)*w4(2)*wl(2,j)
          x81 = co(8)*w4(3)*wl(3,j)
          x82 = P1(0)*P4(0)*w4(0)*wl(0,j)
          x83 = P4(1)*co(1)*wl(1,j)
          x85 = P4(1)*co(3)*wl(1,j)
          x86 = P4(2)*co(1)*wl(2,j)
          x88 = P4(2)*wl(2,j)
          x90 = P4(3)*co(1)*wl(3,j)
          x92 = P4(3)*wl(3,j)
          x93 = P1(2)*co(5)*wl(2,j)
          x94 = P1(1)*co(5)*wl(1,j)
          x95 = P1(1)*P1(3)*w4(1)*wl(3,j)
          x98 = P2(0)*co(3)*wl(0,j)
          x100 = P3(1)*co(8)*w4(0)*wl(0,j)
          x101 = P3(2)*co(2)*wl(2,j)
          x103 = P3(3)*co(2)*wl(3,j)
          x106 = P4(0)*co(1)*wl(0,j)
          x108 = P4(0)*co(3)*wl(0,j)
          x109 = P1(1)*P4(1)*w4(1)*wl(1,j)
          x110 = co(6)*w4(1)*wl(1,j)
          x113 = P4(2)*co(0)*wl(2,j)
          x115 = P1(1)*P4(3)*w4(1)*wl(3,j)
          x116 = P1(1)*co(4)*wl(1,j)
          x117 = P1(3)*co(5)*wl(3,j)
          x119 = P1(2)*wl(2,j)
          x121 = P3(1)*co(2)*wl(1,j)
          x122 = co(8)*w4(0)*wl(0,j)
          x125 = P4(1)*co(0)*wl(1,j)
          x126 = P1(2)*co(4)*wl(2,j)
          x127 = P1(2)*P4(2)*w4(2)*wl(2,j)
          x129 = P4(3)*co(0)*wl(3,j)
          x131 = P3(3)*co(8)*w4(0)*wl(0,j)
          x132 = P1(3)*P4(0)*w4(0)*wl(3,j)
          x133 = P4(1)*wl(1,j)
          x135 = P1(3)*P4(1)*w4(1)*wl(3,j)
          x136 = P1(3)*P4(3)*w4(3)*wl(3,j)
          x140 = co(8)*w4(1)*wl(1,j)
          x147 = P4(0)*wl(0,j)
          x154 = P1(0)*co(5)*wl(0,j)
          x155 = co(1)*w4(0)*wl(0,j)
          x156 = P3(0)*co(8)*w4(0)*wl(0,j)
          x159 = P1(0)*co(4)*wl(0,j)
          x162 = co(1)*w4(1)*wl(1,j)
          x163 = co(3)*w4(1)*wl(1,j)
          x165 = P2(3)*co(3)*wl(3,j)
          x167 = P3(0)*co(2)*wl(0,j)
          x168 = P3(1)*co(8)*w4(1)*wl(1,j)
          x169 = P3(1)*co(8)*w4(2)*wl(2,j)
          x170 = P3(1)*co(8)*w4(3)*wl(3,j)
          x171 = P4(0)*co(0)*wl(0,j)
          x174 = P1(2)*P2(2)*w4(2)*wl(2,j)
          x176 = P1(3)*P2(3)*w4(3)*wl(3,j)
          x177 = P3(3)*co(8)*w4(1)*wl(1,j)
          x178 = P3(3)*co(8)*w4(2)*wl(2,j)
          x179 = P1(3)*P3(3)*w4(3)*wl(3,j)
          x180 = P2(0)*wl(0,j)
          x182 = P2(2)*P4(2)*w4(2)*wl(2,j)
          x184 = P2(3)*P4(3)*w4(3)*wl(3,j)
          x188 = 2*P1(1)*co(2)*wl(1,j)
          x189 = 2*P1(0)*co(2)*wl(0,j)
          x190 = 2*P1(2)*co(2)*wl(2,j)
          x193 = 2*P2(1)*co(2)*wl(1,j)
          x194 = 2*P2(3)*co(2)*wl(3,j)
          x197 = 2*P4(1)*co(2)*wl(1,j)
          x200 = 2*P2(0)*co(2)*wl(0,j)
          x202 = 2*P4(0)*co(2)*wl(0,j)
          x205 = 2*co(9)*w4(3)*wl(3,j)
          x210 = 2*P1(3)*P4(3)*w4(3)*wl(3,j)
          x214 = 2*P2(2)*co(2)*wl(2,j)
          x215 = P3(1)*wl(1,j)
          x217 = P3(0)*wl(0,j)
          x219 = P3(2)*wl(2,j)
          x221 = P3(3)*wl(3,j)
          x224 = 2*P4(2)*co(2)*wl(2,j)
          x225 = 2*P4(3)*co(2)*wl(3,j)
          x227 = 2*P1(3)*co(2)*wl(3,j)
          x228 = 4*co(2)*w4(0)*wl(0,j)
          x230 = 4*co(2)*w4(1)*wl(1,j)
          wp(0,j) = -P1(0)*x156*x231 + P1(0)*x231*x66 + P1(0)*x231*x78 + P1(1)*&
                    x100*x231 - P1(1)*x168*x231 - P1(1)*x169*x231 - P1(1)*x170*&
                    x231 - P1(3)*w4(3)*wl(3,j)*x175*x231 + P1(3)*x131*x231 - P1&
                    (3)*x177*x231 - P1(3)*x178*x231 + P2(0)*x231*x66 + P2(1)*  &
                    x100*x231 - P2(1)*x168*x231 - P2(1)*x169*x231 - P2(1)*x170*&
                    x231 + P2(3)*x131*x231 - P2(3)*x177*x231 - P2(3)*x178*x231 &
                     - P4(0)*x156*x231 + P4(0)*x231*x66 + P4(0)*x231*x78 + P4(1&
                    )*x100*x231 - P4(1)*x169*x231 - P4(3)*w4(3)*wl(3,j)*x175*  &
                    x231 + P4(3)*x131*x231 - P4(3)*x177*x231 + co(0)*x109*x231 &
                     + co(0)*x115*x231 + co(0)*x127*x231 + co(0)*x136*x231 + co&
                    (0)*x231*x82 - co(1)*x1*x231 - co(1)*x10*x231 - co(1)*x115*&
                    x231 - co(1)*x135*x231 - co(1)*x14*x231 - co(1)*x16*x231 - &
                    co(1)*x17*x231 - co(1)*x174*x231 - co(1)*x18*x231 - co(1)* &
                    x182*x231 - co(1)*x19*x231 - co(1)*x210*x231 - co(1)*x231* &
                    x5 - co(1)*x231*x95 + co(10)*x1*x231 + co(10)*x10*x231 + co&
                    (10)*x14*x231 + co(10)*x16*x231 + co(10)*x231*x5 - co(3)*  &
                    x10*x231 - co(3)*x115*x231 + co(3)*x132*x231 - co(3)*x135* &
                    x231 - co(3)*x14*x231 - co(3)*x16*x231 - co(3)*x174*x231 - &
                    co(3)*x176*x231 - co(3)*x18*x231 - co(3)*x182*x231 - co(3)*&
                    x184*x231 - co(3)*x19*x231 - co(3)*x210*x231 - co(3)*x231* &
                    x5 - co(3)*x231*x95 + co(4)*x109*x231 + co(4)*x127*x231 -  &
                    co(4)*x132*x231 + co(4)*x135*x231 + co(4)*x136*x231 + co(4 &
                    )*x231*x82 + co(5)*x1*x231 + co(5)*x10*x231 + co(5)*x14*   &
                    x231 + co(5)*x16*x231 + co(5)*x17*x231 + co(5)*x18*x231 +  &
                    co(5)*x19*x231 + co(5)*x231*x5 + co(5)*x231*x95 + co(6)*   &
                    x136*x231 + co(6)*x231*x82 + co(7)*x10*x231 + co(7)*x14*   &
                    x231 - co(8)*x179*x231 - co(9)*x1*x231 - co(9)*x10*x231 -  &
                    co(9)*x14*x231 - co(9)*x231*x5 - x0*x13*x231 - x0*x15*x231 &
                     + x0*x20*x231 - x0*x22*x231 - x0*x231*x26 - x0*x231*x27 + &
                    x0*x231*x41 + x0*x231*x42 + x0*x231*x43 - x0*x231*x44 - x0*&
                    x231*x7 + x1*x231*x49 + x10*x231*x49 - x101*x124*x231 +    &
                    x101*x142*x231 + x101*x146*x231 - x101*x231*x56 + x101*x231&
                    *x58 + x101*x231*x68 + x101*x231*x84 + x101*x231*x91 - x101&
                    *x231*x97 + x102*x133*x231 - x102*x147*x231 - x102*x180*   &
                    x231 + x102*x231*x60 + x102*x231*x69 - x102*x231*x71 + x102&
                    *x231*x73 + x102*x231*x77 + x102*x231*x92 - x103*x124*x231 &
                     + x103*x142*x231 - x103*x231*x56 + x103*x231*x58 + x103*  &
                    x231*x64 + x103*x231*x74 + x103*x231*x84 + x103*x231*x89 - &
                    x103*x231*x97 + x104*x119*x231 + x104*x133*x231 - x104*x147&
                    *x231 - x104*x180*x231 + x104*x231*x60 - x104*x231*x71 +   &
                    x104*x231*x73 + x104*x231*x75 + x104*x231*x88 + x105*x119* &
                    x231 + x105*x133*x231 + x105*x231*x60 + x105*x231*x69 +    &
                    x105*x231*x92 + x106*x142*x231 + x106*x231*x58 + x106*x231*&
                    x64 + x106*x231*x68 + x106*x231*x74 + x106*x231*x84 + x106*&
                    x231*x91 + x107*x231*x60 + x107*x231*x73 + x107*x231*x75 + &
                    x107*x231*x77 + x107*x231*x88 + x107*x231*x92 + x108*x231* &
                    x58 + x108*x231*x68 + x108*x231*x84 + x108*x231*x89 + x108*&
                    x231*x91 - x109*x204*x231 + x109*x229*x231 + x11*x15*x231  &
                     - x11*x20*x231 + x11*x22*x231 + x11*x231*x27 - x11*x231*x3&
                     + x11*x231*x40 - x11*x231*x41 - x11*x231*x43 + x11*x231*x7&
                     + x110*x111*x231 + x110*x137*x231 - x110*x157*x231 - x111*&
                    x205*x231 - x111*x231*x45 + x111*x231*x46 + x111*x231*x47  &
                     + x111*x231*x48 - x112*x231*x30 + x112*x231*x38 + x112*   &
                    x231*x39 - x113*x231*x56 + x113*x231*x58 + x113*x231*x68 + &
                    x114*x231*x60 + x114*x231*x69 + x115*x231*x49 - x116*x124* &
                    x231 + x116*x231*x91 - x117*x231*x56 + x117*x231*x64 + x118&
                    *x231*x40 - x118*x231*x41 - x118*x231*x42 - x118*x231*x43  &
                     - x118*x231*x45 + x118*x231*x46 + x118*x231*x47 + x118*   &
                    x231*x48 + x119*x120*x231 - x119*x161*x231 - x119*x166*x231&
                     - x119*x173*x231 + x119*x192*x231 + x119*x198*x231 + x119*&
                    x199*x231 - x119*x206*x231 - x119*x231*x76 + x12*x13*x231  &
                     + x12*x15*x231 - x12*x20*x231 + x12*x22*x231 + x12*x231*  &
                    x26 + x12*x231*x27 - x12*x231*x3 + x12*x231*x40 - x12*x231*&
                    x41 - x12*x231*x42 - x12*x231*x43 + x12*x231*x7 - x120*x147&
                    *x231 - x120*x180*x231 + x120*x231*x69 - x120*x231*x71 +   &
                    x120*x231*x75 + x120*x231*x77 + x120*x231*x88 + x120*x231* &
                    x92 - x121*x124*x231 + x121*x146*x231 - x121*x231*x56 +    &
                    x121*x231*x64 + x121*x231*x68 + x121*x231*x74 + x121*x231* &
                    x89 + x121*x231*x91 - x121*x231*x97 + x122*x123*x231 - x122&
                    *x139*x231 + x122*x144*x231 + x122*x150*x231 - x123*x140*  &
                    x231 - x123*x231*x45 + x123*x231*x46 + x123*x231*x47 + x123&
                    *x231*x48 + x123*x231*x52 - x123*x231*x79 - x123*x231*x81  &
                     - x124*x126*x231 - x124*x188*x231 - x124*x190*x231 - x124*&
                    x193*x231 - x124*x194*x231 - x124*x197*x231 - x124*x214*   &
                    x231 - x124*x224*x231 - x124*x225*x231 + x124*x231*x65 +   &
                    x124*x231*x85 + x124*x231*x86 - x125*x231*x56 + x125*x231* &
                    x64 + x126*x231*x84 + x126*x231*x91 - x127*x195*x231 - x127&
                    *x204*x231 + x127*x229*x231 - x128*x231*x30 + x128*x231*x35&
                     + x128*x231*x38 + x128*x231*x39 - x129*x231*x56 + x129*   &
                    x231*x64 - x13*x2*x231 + x13*x231*x4 + x13*x231*x6 + x13*  &
                    x231*x8 + x13*x231*x9 + x130*x231*x40 - x130*x231*x41 -    &
                    x130*x231*x42 - x130*x231*x43 - x130*x231*x45 + x130*x231* &
                    x46 + x130*x231*x47 + x130*x231*x48 - x132*x231*x49 + x133*&
                    x134*x231 + x133*x152*x231 + x133*x153*x231 - x133*x160*   &
                    x231 - x133*x161*x231 - x133*x166*x231 - x133*x173*x231 -  &
                    x133*x187*x231 + x133*x192*x231 + x133*x199*x231 - x133*   &
                    x206*x231 - x133*x231*x76 - x133*x231*x87 - x134*x147*x231 &
                     + x135*x231*x49 + x136*x229*x231 - x137*x205*x231 - x137* &
                    x231*x45 + x137*x231*x46 + x137*x231*x47 + x137*x231*x48 - &
                    x138*x231*x30 + x138*x231*x38 + x139*x140*x231 + x139*x231*&
                    x45 - x139*x231*x46 - x139*x231*x47 - x139*x231*x48 + x139*&
                    x231*x50 + x139*x231*x79 + x139*x231*x81 + x14*x231*x49 -  &
                    x140*x144*x231 - x140*x150*x231 - x141*x155*x231 + x141*   &
                    x228*x231 - x141*x231*x40 + x141*x231*x41 + x141*x231*x42  &
                     + x141*x231*x43 - x141*x231*x44 + x141*x231*x45 - x141*   &
                    x231*x46 - x141*x231*x47 - x141*x231*x48 - x142*x167*x231  &
                     - x142*x189*x231 + x142*x190*x231 + x142*x194*x231 - x142*&
                    x200*x231 - x142*x202*x231 + x142*x214*x231 + x142*x224*   &
                    x231 + x142*x225*x231 + x142*x227*x231 - x142*x231*x63 -   &
                    x142*x231*x86 - x143*x162*x231 - x143*x163*x231 + x143*x230&
                    *x231 + x143*x231*x40 - x143*x231*x41 - x143*x231*x42 -    &
                    x143*x231*x43 - x143*x231*x45 + x143*x231*x46 + x143*x231* &
                    x47 + x143*x231*x48 - x144*x231*x45 + x144*x231*x46 + x144*&
                    x231*x47 + x144*x231*x48 + x144*x231*x52 - x144*x231*x79 - &
                    x144*x231*x81 + x145*x231*x40 - x145*x231*x41 - x145*x231* &
                    x42 - x145*x231*x43 - x145*x231*x45 + x145*x231*x46 + x145*&
                    x231*x47 + x145*x231*x48 - x146*x167*x231 + x146*x188*x231 &
                     - x146*x189*x231 + x146*x190*x231 + x146*x193*x231 + x146*&
                    x197*x231 - x146*x200*x231 - x146*x202*x231 + x146*x214*   &
                    x231 + x146*x224*x231 - x147*x151*x231 - x147*x152*x231 -  &
                    x147*x153*x231 - x147*x192*x231 - x147*x198*x231 - x147*   &
                    x199*x231 + x147*x231*x76 + x147*x231*x87 + x148*x231*x40  &
                     - x148*x231*x41 - x148*x231*x42 - x148*x231*x43 - x148*   &
                    x231*x45 + x148*x231*x46 + x148*x231*x47 + x148*x231*x48 + &
                    x149*x231*x45 - x149*x231*x46 - x149*x231*x47 - x149*x231* &
                    x48 + x149*x231*x50 + x149*x231*x79 + x149*x231*x81 - x15* &
                    x2*x231 + x15*x231*x4 + x15*x231*x6 + x15*x231*x9 - x150*  &
                    x231*x45 + x150*x231*x46 + x150*x231*x47 + x150*x231*x48 + &
                    x150*x231*x52 - x150*x231*x79 - x150*x231*x81 + x151*x231* &
                    x88 + x151*x231*x92 + x152*x231*x92 + x153*x231*x88 - x154*&
                    x231*x58 - x154*x231*x64 - x155*x231*x70 + x157*x231*x45 - &
                    x157*x231*x46 - x157*x231*x47 - x157*x231*x48 - x158*x231* &
                    x38 - x158*x231*x39 - x159*x231*x84 - x159*x231*x89 - x159*&
                    x231*x91 + x16*x231*x49 - x160*x231*x60 - x160*x231*x69 -  &
                    x160*x231*x73 - x160*x231*x77 - x160*x231*x92 - x161*x231* &
                    x60 - x161*x231*x73 - x161*x231*x75 - x161*x231*x88 - x162*&
                    x203*x231 - x162*x231*x99 - x163*x231*x99 - x164*x231*x75  &
                     - x164*x231*x88 - x165*x231*x58 - x165*x231*x84 - x166*   &
                    x231*x60 - x166*x231*x69 - x166*x231*x73 - x166*x231*x75 - &
                    x166*x231*x77 - x166*x231*x88 - x166*x231*x92 - x167*x231* &
                    x58 - x167*x231*x64 - x167*x231*x68 - x167*x231*x74 - x167*&
                    x231*x84 - x167*x231*x89 - x167*x231*x91 + x17*x231*x49 -  &
                    x171*x231*x58 - x171*x231*x64 - x172*x231*x60 - x172*x231* &
                    x69 - x172*x231*x73 - x172*x231*x77 - x172*x231*x92 - x173*&
                    x231*x60 - x173*x231*x73 - x173*x231*x75 - x173*x231*x88 + &
                    x174*x229*x231 + x176*x229*x231 + x179*x231*x49 + x18*x231*&
                    x49 - x180*x192*x231 - x180*x198*x231 - x180*x199*x231 -   &
                    x180*x212*x231 - x181*x231*x75 - x181*x231*x88 - x181*x231*&
                    x92 + x182*x229*x231 - x183*x231*x45 + x183*x231*x46 + x183&
                    *x231*x47 + x183*x231*x48 + x183*x231*x53 - x183*x231*x81  &
                     + x184*x229*x231 - x185*x231*x35 - x185*x231*x39 - x186*  &
                    x231*x45 + x186*x231*x46 + x186*x231*x47 + x186*x231*x48 + &
                    x186*x231*x53 - x186*x231*x79 - x186*x231*x81 - x187*x231* &
                    x88 - x187*x231*x92 - x188*x231*x56 + x188*x231*x64 + x188*&
                    x231*x68 + x188*x231*x74 + x188*x231*x89 - x188*x231*x97 - &
                    x189*x231*x58 - x189*x231*x64 - x189*x231*x74 - x189*x231* &
                    x89 + x19*x231*x49 - x190*x231*x56 + x190*x231*x58 - x191* &
                    x231*x69 - x191*x231*x75 - x191*x231*x88 - x191*x231*x92 - &
                    x192*x231*x71 + x192*x231*x73 + x192*x231*x75 + x192*x231* &
                    x88 - x193*x231*x56 + x193*x231*x64 + x193*x231*x74 + x193*&
                    x231*x89 - x194*x231*x56 + x194*x231*x58 + x194*x231*x64 + &
                    x194*x231*x74 + x194*x231*x89 - x194*x231*x97 - x195*x231* &
                    x82 - x196*x231*x40 + x196*x231*x41 + x196*x231*x42 + x196*&
                    x231*x43 - x196*x231*x44 - x197*x231*x56 + x197*x231*x64 + &
                    x197*x231*x74 + x197*x231*x89 - x198*x231*x71 + x198*x231* &
                    x75 + x198*x231*x77 + x198*x231*x88 + x198*x231*x92 + x199*&
                    x231*x60 - x199*x231*x71 + x199*x231*x73 + x199*x231*x75 + &
                    x199*x231*x88 + x2*x20*x231 - x2*x22*x231 - x2*x231*x26 -  &
                    x2*x231*x27 + x2*x231*x3 - x2*x231*x40 + x2*x231*x41 + x2* &
                    x231*x42 + x2*x231*x43 - x2*x231*x44 - x2*x231*x7 + x20*x21&
                    *x231 - x20*x23*x231 - x20*x231*x24 - x20*x231*x25 - x20*  &
                    x231*x4 - x20*x231*x6 - x20*x231*x8 - x20*x231*x9 - x200*  &
                    x231*x58 - x200*x231*x64 - x200*x231*x74 - x201*x231*x45 + &
                    x201*x231*x46 + x201*x231*x47 + x201*x231*x48 + x201*x231* &
                    x51 - x202*x231*x58 - x202*x231*x64 - x202*x231*x74 - x202*&
                    x231*x89 + x203*x231*x40 - x203*x231*x41 - x203*x231*x42 - &
                    x205*x207*x231 - x206*x231*x69 - x206*x231*x73 - x206*x231*&
                    x75 - x206*x231*x88 - x206*x231*x92 - x207*x231*x45 + x207*&
                    x231*x46 + x207*x231*x47 + x207*x231*x48 + x208*x231*x40 - &
                    x208*x231*x41 - x208*x231*x42 - x209*x231*x45 + x209*x231* &
                    x46 + x209*x231*x47 + x209*x231*x48 - x21*x22*x231 - x21*  &
                    x231*x26 - x21*x231*x27 + x21*x231*x50 + x211*x231*x40 -   &
                    x211*x231*x41 - x211*x231*x42 + x212*x231*x69 + x212*x231* &
                    x92 - x213*x231*x45 + x213*x231*x46 + x213*x231*x47 + x213*&
                    x231*x48 + x213*x231*x51 + x214*x231*x58 - x215*x216*x231  &
                     + x215*x220*x231 + x215*x222*x231 - x216*x219*x231 - x216*&
                    x221*x231 - x217*x218*x231 - x217*x220*x231 - x217*x222*   &
                    x231 + x218*x219*x231 + x218*x221*x231 + x219*x222*x231 +  &
                    x22*x23*x231 + x22*x231*x24 + x22*x231*x25 + x22*x231*x4 + &
                    x22*x231*x54 + x22*x231*x55 + x22*x231*x6 + x22*x231*x8 +  &
                    x220*x221*x231 - x223*x231*x45 + x223*x231*x46 + x223*x231*&
                    x47 + x223*x231*x48 + x223*x231*x51 + x224*x231*x58 + x225*&
                    x231*x74 + x226*x231*x69 + x226*x231*x92 + x227*x231*x74 + &
                    x228*x231*x70 + x229*x231*x82 + x23*x231*x26 + x23*x231*x27&
                     + x23*x231*x51 + x230*x231*x99 + x231*x24*x26 + x231*x24* &
                    x27 + x231*x24*x52 + x231*x25*x26 + x231*x25*x27 + x231*x25&
                    *x53 + x231*x26*x4 + x231*x26*x54 + x231*x26*x55 + x231*x26&
                    *x6 + x231*x26*x8 + x231*x26*x9 + x231*x27*x4 + x231*x27*  &
                    x54 + x231*x27*x55 + x231*x27*x6 + x231*x27*x8 + x231*x27* &
                    x9 - x231*x28*x45 + x231*x28*x46 + x231*x28*x47 + x231*x28*&
                    x48 + x231*x28*x51 + x231*x29*x30 - x231*x29*x35 - x231*x29&
                    *x38 - x231*x29*x39 - x231*x3*x4 - x231*x3*x6 - x231*x3*x8 &
                     - x231*x3*x9 + x231*x30*x32 + x231*x30*x34 - x231*x30*x37 &
                     - x231*x31*x45 + x231*x31*x52 - x231*x32*x35 - x231*x32*  &
                    x38 - x231*x32*x39 - x231*x33*x45 + x231*x33*x53 - x231*x34&
                    *x35 - x231*x34*x38 - x231*x34*x39 + x231*x35*x37 + x231*  &
                    x36*x45 - x231*x36*x46 - x231*x36*x47 - x231*x36*x48 + x231&
                    *x36*x50 + x231*x37*x38 + x231*x37*x39 + x231*x4*x40 - x231&
                    *x4*x42 - x231*x4*x43 + x231*x40*x6 - x231*x40*x70 + x231* &
                    x40*x8 + x231*x40*x9 + x231*x40*x99 - x231*x41*x6 + x231*  &
                    x41*x70 - x231*x41*x8 - x231*x41*x99 - x231*x42*x6 + x231* &
                    x42*x70 - x231*x42*x8 - x231*x42*x9 - x231*x42*x99 - x231* &
                    x43*x6 + x231*x43*x70 - x231*x43*x8 - x231*x43*x9 - x231*  &
                    x43*x99 - x231*x44*x70 + x231*x45*x70 + x231*x45*x80 - x231&
                    *x45*x99 - x231*x46*x70 - x231*x46*x80 + x231*x46*x99 -    &
                    x231*x47*x70 - x231*x47*x80 + x231*x47*x99 - x231*x48*x70  &
                     - x231*x48*x80 + x231*x48*x99 + x231*x49*x5 + x231*x49*x95&
                     + x231*x50*x80 + x231*x56*x57 + x231*x56*x63 + x231*x56*  &
                    x65 + x231*x56*x67 + x231*x56*x83 + x231*x56*x85 + x231*x56&
                    *x86 + x231*x56*x90 - x231*x56*x93 - x231*x56*x94 - x231*  &
                    x57*x64 - x231*x57*x68 - x231*x57*x74 - x231*x57*x91 + x231&
                    *x57*x97 + x231*x58*x59 + x231*x58*x62 - x231*x58*x63 -    &
                    x231*x58*x65 - x231*x58*x86 + x231*x58*x93 + x231*x58*x98  &
                     + x231*x59*x64 + x231*x59*x68 + x231*x59*x74 + x231*x59*  &
                    x84 + x231*x59*x91 + x231*x6*x7 + x231*x60*x61 - x231*x60* &
                    x76 - x231*x60*x87 + x231*x60*x96 + x231*x61*x69 + x231*x61&
                    *x73 + x231*x61*x75 + x231*x61*x77 + x231*x61*x88 + x231*  &
                    x61*x92 + x231*x62*x68 + x231*x62*x84 + x231*x62*x89 + x231&
                    *x62*x91 - x231*x63*x68 - x231*x63*x84 - x231*x63*x91 +    &
                    x231*x63*x97 - x231*x64*x67 - x231*x64*x83 - x231*x64*x90  &
                     + x231*x64*x94 - x231*x65*x84 - x231*x67*x74 + x231*x67*  &
                    x97 - x231*x68*x83 - x231*x68*x86 + x231*x68*x93 + x231*x68&
                    *x98 - x231*x69*x72 - x231*x69*x87 + x231*x7*x8 + x231*x71*&
                    x72 + x231*x71*x76 + x231*x71*x87 - x231*x71*x96 - x231*x72&
                    *x92 - x231*x74*x83 - x231*x74*x90 - x231*x76*x88 + x231*  &
                    x79*x80 + x231*x80*x81 - x231*x83*x91 + x231*x83*x97 - x231&
                    *x84*x86 - x231*x84*x90 + x231*x84*x98 - x231*x85*x89 -    &
                    x231*x86*x91 + x231*x86*x97 - x231*x87*x92 + x231*x89*x98  &
                     + x231*x90*x97 + x231*x91*x98
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x232 = co(5)*wl(mu,j)
            x233 = co(5)*w4(mu)
            x234 = co(1)*wl(mu,j)
            x235 = co(1)*w4(mu)
            x236 = co(3)*wl(mu,j)
            x237 = co(3)*w4(mu)*wl(1,j)
            x238 = co(1)*w4(2)*wl(mu,j)
            x239 = co(3)*w4(mu)
            x240 = co(1)*w4(mu)*wl(3,j)
            x241 = co(1)*w4(3)*wl(mu,j)
            x242 = co(3)*w4(mu)*wl(3,j)
            x243 = co(2)*wl(mu,j)
            x244 = co(2)*w4(mu)
            x245 = P3(mu)*co(8)
            x246 = P4(0)*w4(mu)*wl(0,j)
            x247 = co(4)*wl(mu,j)
            x248 = P4(mu)*co(6)
            x249 = co(3)*w4(mu)*wl(0,j)
            x250 = co(0)*w4(mu)
            x251 = 2*co(2)*wl(mu,j)
            x252 = 2*co(2)*w4(mu)
            x253 = 2*P1(mu)
            x254 = 2*P4(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - P1(0)*x231*x249 + P1(1)*x231*x237 + P1(&
                          2)*x231*x238 + P1(3)*x231*x240 - P2(0)*x231*x249 + P2&
                          (1)*x231*x237 + P2(2)*x231*x238 + P2(3)*x231*x241 +  &
                          P2(3)*x231*x242 - P2(mu)*x231*x40 + P2(mu)*x231*x41  &
                           + P2(mu)*x231*x42 + P2(mu)*x231*x43 + P2(mu)*x231*  &
                          x45 - P2(mu)*x231*x46 - P2(mu)*x231*x47 - P2(mu)*x231&
                          *x48 + P3(0)*w4(0)*x231*x243 - P3(1)*w4(1)*x231*x243 &
                           - P3(2)*w4(2)*x231*x243 - P3(3)*w4(3)*x231*x243 + P3&
                          (mu)*x231*x45 - P3(mu)*x231*x46 - P3(mu)*x231*x47 -  &
                          P3(mu)*x231*x48 - P4(0)*co(3)*w4(mu)*wl(0,j)*x231 +  &
                          P4(2)*x231*x238 + P4(3)*x231*x240 + P4(3)*x231*x241  &
                           + P4(3)*x231*x242 + co(0)*x231*x246 - co(1)*x231*   &
                          x246 - x119*x231*x233 + x119*x231*x235 + x119*x231*  &
                          x239 - x119*x231*x252 - x124*x231*x234 - x124*x231*  &
                          x236 + x124*x231*x247 + x124*x231*x251 - x13*x231*   &
                          x253 + x133*x231*x235 + x133*x231*x239 - x133*x231*  &
                          x250 - x133*x231*x252 + x142*x231*x234 - x142*x231*  &
                          x251 - x146*x231*x251 - x15*x231*x253 + x180*x231*   &
                          x252 + x20*x231*x253 + x20*x231*x254 - x215*x231*x244&
                           + x217*x231*x244 - x219*x231*x244 - x22*x231*x253 - &
                          x22*x231*x254 - x221*x231*x244 + x231*x232*x56 - x231&
                          *x232*x58 - x231*x232*x64 - x231*x232*x68 - x231*x233&
                          *x60 - x231*x233*x69 + x231*x233*x71 - x231*x234*x56 &
                           + x231*x234*x58 + x231*x234*x68 + x231*x234*x84 -   &
                          x231*x234*x97 + x231*x235*x60 - x231*x235*x71 + x231*&
                          x235*x88 - x231*x236*x56 + x231*x236*x58 + x231*x236*&
                          x64 + x231*x236*x68 + x231*x236*x84 + x231*x236*x89  &
                           + x231*x236*x91 + x231*x239*x69 + x231*x239*x75 +   &
                          x231*x239*x88 - x231*x245*x30 + x231*x245*x35 + x231*&
                          x245*x38 + x231*x245*x39 + x231*x246*x49 - x231*x247*&
                          x84 - x231*x247*x89 - x231*x247*x91 + x231*x248*x30  &
                           - x231*x248*x35 - x231*x248*x38 - x231*x248*x39 -   &
                          x231*x250*x88 - x231*x250*x92 + x231*x251*x56 - x231*&
                          x251*x58 - x231*x251*x64 - x231*x251*x68 - x231*x251*&
                          x74 - x231*x251*x84 - x231*x251*x89 - x231*x251*x91  &
                           + x231*x251*x97 - x231*x252*x60 - x231*x252*x69 +   &
                          x231*x252*x71 - x231*x252*x73 - x231*x252*x75 - x231*&
                          x252*x77 - x231*x252*x88 - x231*x252*x92 - x231*x253*&
                          x26 - x231*x253*x27 + x231*x253*x3 - x231*x253*x40 + &
                          x231*x253*x41 + x231*x253*x42 + x231*x253*x43 - x231*&
                          x253*x7 - x231*x254*x26 - x231*x254*x27 - x231*x254* &
                          x40 + x231*x254*x41 + x231*x254*x42 + x231*x254*x43
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              x255 = w4(nu)*wl(mu,j)
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) - co(1)*x231*x255 - co(3)*x231*x255 +  &
                            co(5)*x231*x255 - gg(nu,mu)*x13*x231 - gg(nu,mu)*  &
                            x15*x231 + gg(nu,mu)*x20*x231 - gg(nu,mu)*x22*x231 &
                             - gg(nu,mu)*x231*x26 - gg(nu,mu)*x231*x27 + gg(nu,&
                            mu)*x231*x3 - gg(nu,mu)*x231*x40 + gg(nu,mu)*x231* &
                            x41 + gg(nu,mu)*x231*x42 + gg(nu,mu)*x231*x43 - gg(&
                            nu,mu)*x231*x7 + x231*x255*x49
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSSVS
end module lcVSSVS
