!******************************************************************************!
!                                                                              !
!    lcVSVS.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVS.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,  &
    riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVS0)
!       P(1,3)*P(3,1)*c0
!       P(1,1)*P(3,3)*c1
!       c2*(P(1,1)*P(3,1) + P(1,3)*P(3,3))
!       Metric(1,3)*P(-1,1)*P(-1,3)*c3
!       c4*(Metric(1,3)*P(-1,1)**2 + Metric(1,3)*P(-1,3)**2)
        x0 = P1(0)**2
        x2 = P3(0)**2
        x3 = P1(1)**2
        x5 = P3(1)**2
        x6 = P1(2)**2
        x8 = P3(2)**2
        x9 = P1(3)**2
        x11 = P3(3)**2
        x19 = P1(1)*co(2)*w3(1)
        x20 = P1(2)*w3(2)
        x24 = P1(3)*co(2)*w3(3)
        x27 = P1(1)*P3(1)
        x29 = P1(1)*w3(1)
        x31 = P3(2)*co(1)*w3(2)
        x33 = P3(3)*co(1)*w3(3)
        x36 = P3(1)*co(1)*w3(1)
        x39 = P1(2)*P3(2)
        x40 = P1(3)*w3(3)
        x42 = P1(3)*P3(3)
        x44 = P3(1)*co(2)*w3(1)
        x45 = P3(2)*w3(2)
        x47 = P3(1)*w3(1)
        x49 = P3(3)*w3(3)
        x50 = P1(0)*w3(0)
        x52 = P1(0)*P3(0)
        x55 = P3(0)*co(1)*w3(0)
        x58 = P3(0)*co(2)*w3(0)
        x61 = P3(0)*w3(0)
        x62 = cima*w2(0)
        do j = riMaxIn, 0, -1
          x1 = co(2)*w3(0)*wl(0,j)
          x4 = co(2)*w3(1)*wl(1,j)
          x7 = co(2)*w3(2)*wl(2,j)
          x10 = w3(3)*wl(3,j)
          x12 = w3(3)*wl(3,j)*x11
          x13 = co(4)*w3(0)*wl(0,j)
          x14 = co(4)*w3(1)*wl(1,j)
          x15 = co(4)*w3(2)*wl(2,j)
          x16 = co(4)*w3(3)*wl(3,j)
          x17 = P1(0)*P3(0)*w3(0)*wl(0,j)
          x18 = P1(2)*wl(2,j)
          x21 = P1(1)*co(2)*wl(1,j)
          x22 = P1(3)*wl(3,j)
          x23 = P1(1)*wl(1,j)
          x25 = P1(1)*P3(1)*w3(1)*wl(1,j)
          x26 = co(3)*w3(2)*wl(2,j)
          x28 = co(3)*w3(3)*wl(3,j)
          x30 = P3(2)*co(0)*wl(2,j)
          x32 = P3(3)*co(0)*wl(3,j)
          x34 = P1(3)*co(2)*wl(3,j)
          x35 = P3(1)*co(0)*wl(1,j)
          x37 = P1(2)*P3(2)*w3(2)*wl(2,j)
          x38 = co(3)*w3(1)*wl(1,j)
          x41 = P1(3)*P3(3)*w3(3)*wl(3,j)
          x43 = P3(2)*wl(2,j)
          x46 = P3(1)*co(2)*wl(1,j)
          x48 = P3(3)*co(2)*wl(3,j)
          x51 = P1(0)*wl(0,j)
          x53 = P1(0)*co(1)*wl(0,j)
          x54 = P3(0)*co(0)*wl(0,j)
          x56 = co(3)*w3(0)*wl(0,j)
          x57 = P3(1)*wl(1,j)
          x59 = P3(0)*wl(0,j)
          x60 = P3(0)*co(2)*wl(0,j)
          wp(0,j) = -P1(2)*co(2)*w3(2)*x51*x62 - P1(2)*co(2)*wl(2,j)*x50*x62 + &
                    P3(2)*co(2)*wl(2,j)*x49*x62 + co(0)*x17*x62 + co(0)*x25*x62&
                     + co(0)*x37*x62 + co(0)*x41*x62 + co(1)*x17*x62 + co(1)*  &
                    x25*x62 + co(1)*x37*x62 + co(1)*x41*x62 + co(2)*x10*x62*x9 &
                     + co(2)*x12*x62 + co(3)*x17*x62 + co(3)*x25*x62 + co(3)*  &
                    x37*x62 + co(3)*x41*x62 + co(4)*x12*x62 + x0*x1*x62 + x0*  &
                    x13*x62 - x0*x14*x62 - x0*x15*x62 - x0*x16*x62 + x1*x2*x62 &
                     - x11*x13*x62 + x11*x14*x62 + x11*x15*x62 + x13*x2*x62 -  &
                    x13*x3*x62 - x13*x5*x62 - x13*x6*x62 - x13*x62*x8 - x13*x62&
                    *x9 - x14*x2*x62 + x14*x3*x62 + x14*x5*x62 + x14*x6*x62 +  &
                    x14*x62*x8 + x14*x62*x9 - x15*x2*x62 + x15*x3*x62 + x15*x5*&
                    x62 + x15*x6*x62 + x15*x62*x8 + x15*x62*x9 - x16*x2*x62 +  &
                    x16*x3*x62 + x16*x5*x62 + x16*x6*x62 + x16*x62*x8 + x16*x62&
                    *x9 + x18*x19*x62 + x18*x24*x62 + x18*x33*x62 + x18*x36*x62&
                     - x18*x55*x62 + x19*x22*x62 - x19*x51*x62 + x20*x21*x62 + &
                    x20*x32*x62 + x20*x34*x62 + x20*x35*x62 - x20*x54*x62 - x21&
                    *x50*x62 + x22*x31*x62 + x22*x36*x62 - x22*x55*x62 + x23*  &
                    x24*x62 + x23*x31*x62 + x23*x33*x62 - x23*x55*x62 - x24*x51&
                    *x62 + x26*x27*x62 + x26*x42*x62 - x26*x52*x62 + x27*x28*  &
                    x62 - x27*x56*x62 + x28*x39*x62 - x28*x52*x62 + x29*x30*x62&
                     + x29*x32*x62 - x29*x54*x62 + x3*x4*x62 + x30*x40*x62 -   &
                    x30*x50*x62 - x32*x50*x62 - x34*x50*x62 + x35*x40*x62 - x35&
                    *x50*x62 - x36*x51*x62 + x38*x39*x62 + x38*x42*x62 - x38*  &
                    x52*x62 - x39*x56*x62 + x4*x5*x62 - x40*x54*x62 - x42*x56* &
                    x62 + x43*x44*x62 - x43*x58*x62 - x44*x59*x62 + x45*x46*x62&
                     + x45*x48*x62 - x45*x53*x62 - x45*x60*x62 + x46*x49*x62 + &
                    x47*x48*x62 - x48*x61*x62 - x49*x53*x62 - x49*x60*x62 - x57&
                    *x58*x62 + x6*x62*x7 + x62*x7*x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x63 = co(2)*wl(mu,j)
            x64 = co(2)*w3(mu)
            x65 = co(0)*w3(mu)
            x66 = co(1)*wl(mu,j)
            x67 = P3(mu)*co(3)
            x68 = 2*P1(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - P3(3)*wl(3,j)*x62*x65 + w3(0)*wl(0,j)* &
                          x62*x67 - w3(1)*wl(1,j)*x62*x67 - w3(2)*wl(2,j)*x62* &
                          x67 - x10*x62*x67 + x13*x62*x68 - x14*x62*x68 - x15* &
                          x62*x68 - x16*x62*x68 - x18*x62*x64 - x20*x62*x63 -  &
                          x22*x62*x64 - x23*x62*x64 - x29*x62*x63 - x40*x62*x63&
                           - x43*x62*x65 - x45*x62*x66 - x47*x62*x66 - x49*x62*&
                          x66 + x50*x62*x63 + x51*x62*x64 - x57*x62*x65 + x59* &
                          x62*x65 + x61*x62*x66
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) + gg(nu,mu)*x13*x62 - gg(nu,mu)*x14*x62&
                             - gg(nu,mu)*x15*x62 - gg(nu,mu)*x16*x62 + w3(nu)* &
                            x62*x63
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVS
end module lcVSVS
