!******************************************************************************!
!                                                                              !
!    lcVSVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVSVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVSS0)
!       P(1,1)*P(3,3)*c0
!       c1*(P(1,1)*P(3,1) + P(1,3)*P(3,3))
!       P(1,3)*P(3,1)*c2
!       c3*(P(1,1)*P(3,4) + P(1,1)*P(3,5) + P(1,3)*P(3,4) + P(1,3)*P(3,5))
!       c4*(2*P(1,4)*P(3,4) + P(1,4)*P(3,5) + P(1,5)*P(3,4) + 2*P(1,5)*P(3,5))
!       c5*(P(1,4)*P(3,1) + P(1,4)*P(3,3) + P(1,5)*P(3,1) + P(1,5)*P(3,3))
!       Metric(1,3)*P(-1,1)*P(-1,3)*c6
!       c7*(Metric(1,3)*P(-1,4)**2 + Metric(1,3)*P(-1,5)**2)
!       Metric(1,3)*P(-1,4)*P(-1,5)*c8
!       c9*(Metric(1,3)*P(-1,1)*P(-1,4) + Metric(1,3)*P(-1,1)*P(-1,5) + Metric(1,
!       3)*P(-1,3)*P(-1,4) + Metric(1,3)*P(-1,3)*P(-1,5))
!       c10*(Metric(1,3)*P(-1,1)**2 + Metric(1,3)*P(-1,3)**2)
        x0 = P1(0)**2
        x2 = P3(0)**2
        x4 = P1(1)**2
        x6 = P3(1)**2
        x8 = P1(2)**2
        x10 = P3(2)**2
        x12 = P1(3)**2
        x14 = P3(3)**2
        x21 = co(7)*x0
        x22 = P2(0)**2
        x23 = co(7)*x22
        x26 = P2(1)**2
        x27 = P2(2)**2
        x28 = P2(3)**2
        x31 = P4(1)**2
        x33 = P4(2)**2
        x34 = P4(3)**2
        x36 = P4(0)**2
        x54 = 2*co(4)
        x59 = P1(1)*co(3)
        x62 = P1(1)*co(5)
        x64 = P1(2)*co(3)
        x67 = P1(2)*co(5)
        x71 = P1(0)*co(5)*w3(0)
        x73 = P1(0)*P2(0)
        x75 = P1(0)*P2(1)
        x76 = P1(0)*co(5)
        x77 = P2(2)*co(3)
        x81 = P1(0)*w3(0)
        x83 = P3(1)*co(3)
        x86 = P3(2)*co(3)
        x87 = P3(2)*co(5)
        x89 = P3(3)*co(3)
        x91 = P3(3)*co(5)*w3(3)
        x93 = P1(0)*P4(0)
        x95 = P1(1)*P1(2)*co(1)
        x97 = P1(1)*co(1)
        x101 = P1(1)*P2(1)
        x105 = P1(1)*P3(1)*co(6)
        x106 = P1(1)*co(0)
        x109 = P1(1)*co(2)
        x113 = P1(1)*P4(2)*co(4)
        x115 = P1(1)*w3(1)
        x116 = P4(3)*co(4)*w3(3)
        x117 = P1(2)*co(1)
        x122 = P1(2)*co(5)*w3(2)
        x127 = P1(2)*co(0)
        x129 = P3(1)*co(2)
        x131 = P1(2)*co(2)
        x132 = P1(2)*P3(2)*co(6)
        x135 = P4(1)*co(4)
        x137 = P1(2)*P4(2)
        x138 = P1(2)*w3(2)
        x140 = P2(0)*co(3)*w3(0)
        x141 = P1(3)*P2(3)
        x146 = P3(2)*co(0)*w3(2)
        x147 = P3(2)*co(2)
        x149 = P1(3)*P3(3)*co(6)
        x150 = P4(2)*co(4)*w3(2)
        x151 = P4(2)*co(4)
        x152 = P1(3)*P4(3)
        x153 = P2(0)*P3(0)
        x154 = P2(0)*co(3)
        x156 = P3(2)*co(5)*w3(2)
        x157 = P2(0)*P4(0)
        x158 = P2(1)*P3(0)
        x160 = P2(1)*P3(1)
        x163 = P2(1)*w3(1)
        x165 = P2(2)*co(5)
        x168 = P2(2)*P4(2)
        x169 = P2(2)*w3(2)
        x172 = P2(3)*co(3)*w3(3)
        x173 = P3(0)*w3(0)
        x174 = P2(3)*P3(3)
        x179 = P2(3)*P4(3)
        x182 = P3(3)*co(3)*w3(3)
        x184 = P3(0)*P4(0)
        x185 = P3(2)*co(1)
        x187 = P3(1)*co(1)
        x188 = P3(1)*w3(1)
        x190 = P3(2)*w3(2)
        x192 = P3(2)*P4(2)
        x193 = P3(3)*P4(3)
        x196 = P1(0)*P3(0)*co(6)
        x200 = P4(3)*co(4)
        x211 = P4(0)*co(4)*w3(0)
        x216 = P1(3)*co(5)*w3(3)
        x220 = P1(3)*w3(3)
        x222 = P2(0)*w3(0)
        x223 = P4(0)*co(4)
        x225 = P2(3)*w3(3)
        x229 = P3(3)*w3(3)
        x230 = 2*P1(1)*co(4)
        x231 = 2*P1(2)*co(4)
        x232 = 2*P2(1)*co(4)
        x234 = 2*P2(2)*co(4)
        x236 = 2*P2(3)*co(4)
        x238 = P1(0)*P3(0)
        x239 = 2*P1(0)*P3(0)
        x240 = 2*P3(1)*co(4)
        x241 = 2*P3(2)*co(4)
        x242 = 2*P3(2)*co(4)*w3(2)
        x245 = 2*P1(1)*P3(1)
        x246 = P1(1)*P3(1)
        x247 = P1(1)*P4(1)
        x248 = 2*P1(2)*co(4)*w3(2)
        x249 = P1(2)*P2(2)
        x251 = P1(2)*P3(2)
        x252 = 2*P1(2)*P3(2)
        x255 = P1(3)*P3(3)
        x256 = 2*P1(3)*P3(3)
        x257 = 2*P2(0)*co(4)
        x259 = P2(1)*P4(1)
        x260 = P2(2)*P3(2)
        x261 = 2*P2(3)*co(4)*w3(3)
        x262 = P3(1)*P4(1)
        x263 = 2*P4(1)*co(4)
        x264 = P4(0)*w3(0)
        x266 = 2*P4(2)*co(4)*w3(2)
        x267 = P4(3)*w3(3)
        x270 = 2*P4(2)*co(4)
        x272 = 2*P4(1)*P4(2)*co(4)
        x274 = 4*co(4)
        x277 = cima*w2(0)*w4(0)
        do j = riMaxIn, 0, -1
          x1 = w3(0)*wl(0,j)*x0
          x3 = w3(0)*wl(0,j)*x2
          x5 = w3(1)*wl(1,j)*x4
          x7 = w3(1)*wl(1,j)*x6
          x9 = w3(2)*wl(2,j)*x8
          x11 = w3(2)*wl(2,j)*x10
          x13 = w3(3)*wl(3,j)*x12
          x15 = w3(3)*wl(3,j)*x14
          x16 = co(10)*w3(0)*wl(0,j)
          x17 = co(10)*w3(1)*wl(1,j)
          x18 = co(10)*w3(2)*wl(2,j)
          x19 = co(10)*w3(3)*wl(3,j)
          x20 = w3(0)*wl(0,j)
          x24 = co(7)*w3(0)*wl(0,j)
          x25 = co(7)*w3(1)*wl(1,j)
          x29 = co(7)*w3(2)*wl(2,j)
          x30 = co(7)*w3(3)*wl(3,j)
          x32 = co(8)*w3(0)*wl(0,j)
          x35 = w3(1)*wl(1,j)
          x37 = co(8)*x36
          x38 = w3(2)*wl(2,j)
          x39 = w3(3)*wl(3,j)
          x40 = co(9)*w3(0)*wl(0,j)
          x41 = co(9)*x12
          x42 = co(9)*w3(1)*wl(1,j)
          x43 = co(9)*w3(2)*wl(2,j)
          x44 = w3(2)*wl(2,j)*x2
          x45 = co(9)*w3(3)*wl(3,j)
          x46 = co(5)*w3(1)*wl(1,j)
          x47 = co(8)*w3(1)*wl(1,j)
          x48 = co(8)*w3(2)*wl(2,j)
          x49 = co(8)*w3(3)*wl(3,j)
          x50 = 2*co(7)*w3(0)*wl(0,j)
          x51 = 2*co(7)*w3(1)*wl(1,j)
          x52 = 2*co(7)*w3(2)*wl(2,j)
          x53 = 2*co(7)*w3(3)*wl(3,j)
          x55 = 2*co(4)*w3(0)*wl(0,j)
          x56 = 2*co(4)*w3(1)*wl(1,j)
          x57 = 2*co(4)*w3(2)*wl(2,j)
          x58 = 2*co(4)*w3(3)*wl(3,j)
          x60 = P1(0)*w3(0)*wl(1,j)
          x61 = P1(0)*w3(1)*wl(0,j)
          x63 = P1(1)*co(5)*w3(1)*wl(0,j)
          x65 = P1(0)*w3(0)*wl(2,j)
          x66 = P1(0)*w3(2)*wl(0,j)
          x68 = P1(0)*P1(3)*w3(0)*wl(3,j)
          x69 = P1(0)*P1(3)*w3(3)*wl(0,j)
          x70 = P1(3)*wl(3,j)
          x72 = P1(3)*co(5)*w3(3)*wl(0,j)
          x74 = co(3)*w3(1)*wl(0,j)
          x78 = P2(2)*w3(0)*wl(2,j)
          x79 = P1(0)*w3(3)*wl(0,j)
          x80 = P2(3)*co(5)*wl(3,j)
          x82 = P1(0)*P3(0)*w3(0)*wl(0,j)
          x84 = P3(1)*w3(0)*wl(1,j)
          x85 = P3(1)*w3(1)*wl(0,j)
          x88 = P3(3)*co(3)*wl(3,j)
          x90 = P3(3)*wl(3,j)
          x92 = P1(0)*wl(0,j)
          x94 = w3(1)*wl(2,j)
          x96 = w3(2)*wl(1,j)
          x98 = P1(3)*w3(1)*wl(3,j)
          x99 = P1(3)*w3(3)*wl(1,j)
          x100 = P2(0)*w3(0)*wl(1,j)
          x102 = P3(0)*w3(0)*wl(1,j)
          x103 = P3(0)*w3(1)*wl(0,j)
          x104 = P1(1)*P3(1)*w3(1)*wl(1,j)
          x107 = P3(2)*w3(2)*wl(1,j)
          x108 = P3(2)*w3(1)*wl(2,j)
          x110 = P3(3)*w3(3)*wl(1,j)
          x111 = P3(3)*w3(1)*wl(3,j)
          x112 = P4(1)*co(8)*w3(0)*wl(0,j)
          x114 = P4(3)*co(4)*wl(3,j)
          x118 = P1(3)*w3(2)*wl(3,j)
          x119 = P1(3)*w3(3)*wl(2,j)
          x120 = P2(0)*co(3)*w3(0)*wl(2,j)
          x121 = P2(0)*wl(0,j)
          x123 = P2(2)*co(9)*w3(0)*wl(0,j)
          x124 = P3(0)*w3(0)*wl(2,j)
          x125 = P3(0)*w3(2)*wl(0,j)
          x126 = P3(1)*w3(1)*wl(2,j)
          x128 = P1(2)*w3(2)*wl(1,j)
          x130 = P3(2)*w3(2)*wl(2,j)
          x133 = P3(3)*w3(3)*wl(2,j)
          x134 = P3(3)*w3(2)*wl(3,j)
          x136 = P1(2)*w3(1)*wl(2,j)
          x139 = P4(3)*co(4)*w3(3)*wl(2,j)
          x142 = P1(3)*P3(0)*w3(0)*wl(3,j)
          x143 = P1(3)*P3(0)*w3(3)*wl(0,j)
          x144 = P1(3)*P3(1)*w3(1)*wl(3,j)
          x145 = P1(3)*P3(1)*w3(3)*wl(1,j)
          x148 = P1(3)*P3(3)*w3(3)*wl(3,j)
          x155 = P2(0)*P3(1)*w3(1)*wl(0,j)
          x159 = co(5)*w3(0)*wl(1,j)
          x161 = P2(1)*w3(1)*wl(2,j)
          x162 = P2(1)*w3(2)*wl(1,j)
          x164 = P2(1)*wl(1,j)
          x166 = P2(2)*w3(1)*wl(2,j)
          x167 = P2(2)*w3(2)*wl(1,j)
          x170 = P2(2)*wl(2,j)
          x171 = P3(0)*wl(0,j)
          x175 = P2(3)*w3(1)*wl(3,j)
          x176 = P2(3)*w3(3)*wl(1,j)
          x177 = P2(3)*wl(3,j)
          x178 = P2(3)*w3(3)*wl(2,j)
          x180 = P3(0)*P3(1)*w3(0)*wl(1,j)
          x181 = P3(0)*P3(1)*w3(1)*wl(0,j)
          x183 = P3(0)*P3(3)*w3(0)*wl(3,j)
          x186 = P3(1)*w3(2)*wl(1,j)
          x189 = P3(1)*wl(1,j)
          x191 = P3(3)*co(1)*wl(3,j)
          x194 = P2(0)*co(3)*w3(0)*wl(0,j)
          x195 = co(5)*w3(0)*wl(0,j)
          x197 = P1(0)*P3(1)*w3(1)*wl(0,j)
          x198 = P1(0)*P3(3)*w3(3)*wl(0,j)
          x199 = P1(0)*P3(3)*w3(0)*wl(3,j)
          x201 = P2(1)*w3(1)*wl(1,j)
          x202 = P4(0)*co(4)*w3(0)*wl(1,j)
          x203 = P4(0)*co(4)*w3(1)*wl(0,j)
          x204 = P4(1)*co(8)*w3(1)*wl(1,j)
          x205 = P4(1)*co(8)*w3(2)*wl(2,j)
          x206 = P4(1)*co(8)*w3(3)*wl(3,j)
          x207 = P2(2)*w3(2)*wl(2,j)
          x208 = P2(2)*co(9)*w3(1)*wl(1,j)
          x209 = P2(2)*co(9)*w3(2)*wl(2,j)
          x210 = P2(2)*co(9)*w3(3)*wl(3,j)
          x212 = P4(0)*co(4)*wl(0,j)
          x213 = P4(2)*co(8)*w3(1)*wl(1,j)
          x214 = P4(2)*co(8)*w3(2)*wl(2,j)
          x215 = P1(3)*P2(1)*w3(1)*wl(3,j)
          x217 = P1(3)*P2(3)*w3(3)*wl(3,j)
          x218 = P2(3)*co(5)*w3(3)*wl(3,j)
          x219 = P2(3)*co(9)*w3(1)*wl(1,j)
          x221 = P4(1)*co(4)*w3(1)*wl(0,j)
          x224 = P2(3)*w3(3)*wl(3,j)
          x226 = P3(0)*P3(3)*w3(3)*wl(0,j)
          x227 = P3(1)*P3(3)*w3(1)*wl(3,j)
          x228 = P3(2)*wl(2,j)
          x233 = 2*co(4)*w3(1)*wl(0,j)
          x235 = 2*P2(3)*co(4)*wl(3,j)
          x237 = 2*P1(0)*P3(0)*w3(0)*wl(0,j)
          x243 = 2*P2(0)*co(4)*w3(1)*wl(0,j)
          x244 = 2*P3(1)*w3(1)*wl(1,j)
          x250 = 2*P3(2)*w3(2)*wl(2,j)
          x253 = 2*P1(3)*co(4)*wl(3,j)
          x254 = 2*P2(0)*co(4)*wl(0,j)
          x258 = 2*P3(3)*co(4)*wl(3,j)
          x265 = 2*P4(2)*co(4)*wl(2,j)
          x268 = 2*P3(1)*co(7)*w3(3)*wl(3,j)
          x269 = 2*P4(1)*co(7)*w3(2)*wl(2,j)
          x271 = 2*P1(3)*co(4)*w3(3)*wl(2,j)
          x273 = 4*co(4)*w3(0)*wl(0,j)
          x275 = 4*co(4)*w3(1)*wl(1,j)
          x276 = 4*P2(2)*co(4)*w3(2)*wl(2,j)
          wp(0,j) = -2*P1(0)*co(4)*x277*x78 - P1(0)*x194*x277 + P1(0)*x277*x63 &
                     + P1(0)*x277*x72 + P1(1)*w3(1)*wl(1,j)*x263*x277 + P1(1)* &
                    wl(1,j)*x116*x277 + P1(1)*x112*x277 - P1(1)*x202*x277 - P1(&
                    1)*x203*x277 - P1(1)*x204*x277 - P1(1)*x205*x277 - P1(1)*  &
                    x206*x277 - P1(1)*x243*x277 + P1(1)*x268*x277 + P1(1)*x269*&
                    x277 + P1(2)*P3(2)*w3(2)*wl(2,j)*x274*x277 + P1(2)*w3(2)*wl&
                    (2,j)*x270*x277 - P1(2)*wl(2,j)*x211*x277 + P1(2)*x120*x277&
                     + P1(2)*x123*x277 + P1(2)*x139*x277 - P1(2)*x208*x277 - P1&
                    (2)*x209*x277 - P1(2)*x210*x277 - P1(2)*x213*x277 - P1(2)* &
                    x214*x277 + P1(2)*x276*x277 + 2*P1(3)*co(4)*w3(3)*x164*x277&
                     - 2*P1(3)*w3(3)*wl(3,j)*x277*x89 - P1(3)*x218*x277 - P1(3 &
                    )*x219*x277 - 2*P2(0)*co(4)*w3(0)*x228*x277 - P2(0)*w3(0)* &
                    wl(2,j)*x231*x277 - P2(0)*x221*x277 + P2(0)*x277*x63 + P2(0&
                    )*x277*x72 + P2(1)*w3(0)*wl(1,j)*x277*x76 + P2(1)*x112*x277&
                     - P2(1)*x202*x277 - P2(1)*x203*x277 - P2(1)*x204*x277 - P2&
                    (1)*x205*x277 - P2(1)*x206*x277 - P2(1)*x243*x277 + P2(1)* &
                    x269*x277 + 2*P2(2)*co(4)*wl(2,j)*x229*x277 - P2(2)*x213*  &
                    x277 - P2(2)*x214*x277 + P2(2)*x271*x277 + P2(3)*P3(3)*w3(3&
                    )*wl(3,j)*x274*x277 + P2(3)*co(3)*x277*x79 + P3(0)*P3(1)*  &
                    x159*x277 - P3(0)*x194*x277 - P3(0)*x221*x277 + P3(0)*x277*&
                    x63 + P3(0)*x277*x72 + P3(1)*x112*x277 - P3(1)*x204*x277 - &
                    P3(1)*x205*x277 - P3(1)*x206*x277 + P3(1)*x269*x277 + P3(2 &
                    )*x120*x277 + P3(2)*x123*x277 + P3(2)*x139*x277 - P3(2)*   &
                    x208*x277 - P3(2)*x209*x277 - P3(2)*x210*x277 - P3(2)*x213*&
                    x277 - P3(2)*x214*x277 + P3(2)*x271*x277 + P3(2)*x276*x277 &
                     - P3(3)*x218*x277 - P3(3)*x219*x277 - 2*P4(0)*co(4)*wl(0,j&
                    )*x267*x277 - P4(0)*w3(0)*wl(1,j)*x263*x277 - P4(0)*wl(0,j &
                    )*x266*x277 - 2*P4(0)*x221*x277 + 2*P4(1)*co(4)*wl(1,j)*   &
                    x267*x277 + P4(1)*x268*x277 - P4(2)*co(4)*wl(2,j)*x222*x277&
                     - 2*P4(3)*co(4)*wl(3,j)*x264*x277 + 2*P4(3)*co(4)*x224*   &
                    x277 + P4(3)*w3(1)*wl(3,j)*x263*x277 + P4(3)*wl(3,j)*x266* &
                    x277 + co(0)*x104*x277 - co(0)*x142*x277 + co(0)*x144*x277 &
                     + co(0)*x148*x277 - co(0)*x197*x277 - co(0)*x198*x277 + co&
                    (0)*x277*x82 + co(1)*x1*x277 + co(1)*x11*x277 + co(1)*x13* &
                    x277 + co(1)*x15*x277 - co(1)*x180*x277 - co(1)*x181*x277  &
                     - co(1)*x226*x277 + co(1)*x277*x3 + co(1)*x277*x5 - co(1)*&
                    x277*x68 - co(1)*x277*x69 + co(1)*x277*x7 + co(1)*x277*x9  &
                     + co(10)*x1*x277 + co(10)*x13*x277 + co(10)*x277*x5 + co(2&
                    )*x104*x277 - co(2)*x143*x277 + co(2)*x145*x277 + co(2)*   &
                    x148*x277 - co(2)*x199*x277 + co(2)*x277*x82 - co(3)*x1*   &
                    x277 - co(3)*x11*x277 - co(3)*x13*x277 + co(3)*x142*x277 + &
                    co(3)*x143*x277 - co(3)*x15*x277 + co(3)*x180*x277 + co(3)*&
                    x181*x277 - co(3)*x215*x277 - co(3)*x217*x277 - co(3)*x237*&
                    x277 - co(3)*x277*x3 - co(3)*x277*x5 + co(3)*x277*x68 + co(&
                    3)*x277*x69 - co(3)*x277*x7 - co(3)*x277*x9 - 2*co(4)*w3(0 &
                    )*wl(1,j)*x158*x277 - co(5)*x1*x277 - co(5)*x11*x277 - co(5&
                    )*x13*x277 + co(5)*x142*x277 - co(5)*x144*x277 - 2*co(5)*  &
                    x148*x277 - co(5)*x15*x277 + co(5)*x155*x277 + co(5)*x181* &
                    x277 + co(5)*x183*x277 - co(5)*x227*x277 - co(5)*x237*x277 &
                     - co(5)*x277*x3 - co(5)*x277*x9 + co(6)*x104*x277 + co(6)*&
                    x277*x82 - co(7)*x277*x44 - co(9)*x1*x277 + co(9)*x277*x44 &
                     - x0*x17*x277 - x0*x18*x277 - x0*x19*x277 - x0*x277*x30 + &
                    x0*x277*x42 + x0*x277*x43 + x0*x277*x45 + x1*x277*x54 - x10&
                    *x16*x277 + x10*x17*x277 + x10*x18*x277 + x10*x19*x277 -   &
                    x10*x24*x277 + x10*x25*x277 + x10*x277*x29 + x10*x277*x30  &
                     + x10*x277*x40 - x10*x277*x42 - x10*x277*x43 - x10*x277*  &
                    x45 - x100*x135*x277 - x100*x230*x277 - x100*x232*x277 -   &
                    x100*x240*x277 + x100*x277*x59 + x101*x275*x277 + x101*x277&
                    *x40 - x101*x277*x42 - x101*x277*x43 - x101*x277*x45 - x101&
                    *x277*x46 - x101*x277*x50 + x101*x277*x51 + x101*x277*x52  &
                     + x101*x277*x53 - x102*x106*x277 - x102*x135*x277 - x102* &
                    x230*x277 + x102*x277*x59 + x102*x277*x62 - x103*x109*x277 &
                     - x103*x230*x277 + x103*x277*x59 + x104*x274*x277 - x105* &
                    x20*x277 + x105*x277*x38 + x105*x277*x39 + x106*x107*x277  &
                     + x106*x110*x277 + x107*x135*x277 + x107*x230*x277 + x107*&
                    x232*x277 - x107*x277*x59 - x107*x277*x62 + x108*x109*x277 &
                     + x108*x135*x277 + x108*x230*x277 - x108*x277*x59 - x108* &
                    x277*x62 + x109*x111*x277 + x11*x277*x54 + x110*x135*x277  &
                     + x110*x187*x277 + x110*x230*x277 + x110*x232*x277 + x110*&
                    x240*x277 - x110*x277*x59 - x110*x277*x62 + x111*x135*x277 &
                     + x111*x187*x277 + x111*x230*x277 - x111*x277*x59 - x111* &
                    x277*x62 + x113*x277*x94 + x113*x277*x96 + x114*x115*x277  &
                     + x114*x138*x277 + x114*x163*x277 + x114*x169*x277 - x114*&
                    x173*x277 + x114*x188*x277 + x114*x190*x277 - x114*x222*   &
                    x277 - x114*x277*x81 + x115*x235*x277 - x116*x121*x277 +   &
                    x116*x164*x277 + x116*x170*x277 - x116*x171*x277 + x116*   &
                    x189*x277 + x117*x118*x277 + x117*x119*x277 - x117*x277*x65&
                     - x117*x277*x66 + x118*x231*x277 - x118*x277*x64 - x118*  &
                    x277*x77 - x118*x277*x86 + x119*x147*x277 + x119*x151*x277 &
                     - x119*x165*x277 + x119*x231*x277 - x119*x277*x64 - x119* &
                    x277*x67 - x119*x277*x86 - x119*x277*x87 - x12*x16*x277 +  &
                    x12*x17*x277 + x12*x18*x277 - x12*x24*x277 + x12*x25*x277  &
                     + x12*x277*x29 + x12*x277*x30 + x121*x122*x277 - x121*x150&
                    *x277 + x121*x156*x277 - x121*x248*x277 + x121*x277*x91 -  &
                    x122*x277*x70 - x122*x277*x90 - x124*x127*x277 - x124*x151*&
                    x277 + x124*x165*x277 - x124*x185*x277 - x124*x231*x277 -  &
                    x124*x234*x277 - x124*x241*x277 + x124*x277*x64 + x124*x277&
                    *x67 + x124*x277*x86 + x124*x277*x87 - x125*x131*x277 -    &
                    x125*x185*x277 - x125*x231*x277 - x125*x234*x277 - x125*   &
                    x241*x277 + x125*x277*x64 + x125*x277*x67 + x125*x277*x77  &
                     + x125*x277*x86 + x125*x277*x87 + x126*x127*x277 + x126*  &
                    x151*x277 - x126*x165*x277 + x126*x185*x277 + x126*x231*   &
                    x277 + x126*x234*x277 + x126*x241*x277 - x126*x277*x64 -   &
                    x126*x277*x67 - x126*x277*x86 - x126*x277*x87 + x127*x130* &
                    x277 + x127*x133*x277 + x128*x129*x277 + x128*x135*x277 +  &
                    x128*x230*x277 + x128*x232*x277 + x128*x240*x277 - x128*   &
                    x277*x59 - x128*x277*x62 - x129*x277*x60 + x13*x277*x54 +  &
                    x130*x131*x277 + x130*x270*x277 + x131*x134*x277 - x132*x20&
                    *x277 + x132*x277*x35 + x132*x277*x38 + x132*x277*x39 +    &
                    x133*x151*x277 + x133*x185*x277 + x133*x231*x277 + x133*   &
                    x241*x277 - x133*x277*x64 - x133*x277*x67 - x133*x277*x87  &
                     + x134*x231*x277 - x134*x277*x64 + x135*x136*x277 + x135* &
                    x166*x277 + x135*x167*x277 + x135*x175*x277 + x135*x176*   &
                    x277 + x135*x244*x277 - x135*x277*x60 - x135*x277*x61 +    &
                    x135*x277*x98 + x135*x277*x99 + x136*x230*x277 - x136*x277*&
                    x59 - x136*x277*x62 + x137*x277*x32 - x137*x277*x49 - x137*&
                    x277*x50 + x137*x277*x51 + x137*x277*x52 + x137*x277*x53 - &
                    x138*x212*x277 - x138*x277*x80 - x14*x16*x277 + x14*x17*   &
                    x277 + x14*x18*x277 + x14*x19*x277 - x14*x24*x277 + x14*x25&
                    *x277 + x14*x277*x29 + x14*x277*x30 + x14*x277*x40 - x14*  &
                    x277*x42 - x14*x277*x43 - x14*x277*x45 + x140*x277*x70 +   &
                    x140*x277*x90 + x141*x277*x40 - x141*x277*x43 - x141*x277* &
                    x45 - x141*x277*x50 + x141*x277*x51 + x141*x277*x52 + x141*&
                    x277*x53 - x142*x277*x54 - x143*x277*x54 + x144*x277*x54 + &
                    x145*x277*x54 + x146*x277*x70 - x146*x277*x92 - x147*x277* &
                    x65 + x148*x274*x277 - x149*x20*x277 + x149*x277*x35 + x149&
                    *x277*x38 + x149*x277*x39 + x15*x277*x54 - x150*x171*x277  &
                     + x150*x177*x277 + x150*x277*x70 + x150*x277*x90 - x150*  &
                    x277*x92 + x151*x161*x277 + x151*x162*x277 + x151*x178*x277&
                     + x151*x186*x277 - x151*x277*x65 + x152*x277*x32 - x152*  &
                    x277*x47 - x152*x277*x48 - x152*x277*x49 - x152*x277*x50 + &
                    x152*x277*x51 + x152*x277*x52 + x152*x277*x53 + x152*x277* &
                    x58 - x153*x195*x277 + x153*x273*x277 - x153*x277*x40 +    &
                    x153*x277*x42 + x153*x277*x43 + x153*x277*x45 + x153*x277* &
                    x50 - x153*x277*x51 - x153*x277*x52 - x153*x277*x53 + x154*&
                    x277*x84 - x155*x277*x54 - x156*x277*x70 - x156*x277*x90 - &
                    x157*x277*x32 + x157*x277*x47 + x157*x277*x48 + x157*x277* &
                    x49 + x157*x277*x50 - x157*x277*x51 - x157*x277*x52 - x157*&
                    x277*x53 + x157*x277*x55 + x158*x159*x277 - x158*x233*x277 &
                     + x158*x277*x74 + x16*x2*x277 - x16*x277*x4 - x16*x277*x6 &
                     - x16*x277*x8 + x160*x275*x277 + x160*x277*x40 - x160*x277&
                    *x42 - x160*x277*x43 - x160*x277*x45 - x160*x277*x46 - x160&
                    *x277*x50 + x160*x277*x51 + x160*x277*x52 + x160*x277*x53  &
                     + x161*x231*x277 + x161*x234*x277 + x161*x241*x277 - x161*&
                    x277*x64 - x161*x277*x86 + x162*x234*x277 - x162*x277*x67  &
                     - x162*x277*x87 + x163*x235*x277 + x163*x258*x277 - x163* &
                    x277*x88 - x164*x216*x277 + x164*x261*x277 - x164*x277*x91 &
                     + x166*x230*x277 - x166*x277*x62 + x167*x230*x277 - x167* &
                    x277*x59 + x168*x277*x32 - x168*x277*x49 - x168*x277*x50 + &
                    x168*x277*x51 + x168*x277*x52 + x168*x277*x53 - x169*x212* &
                    x277 + x169*x235*x277 + x169*x253*x277 - x169*x254*x277 +  &
                    x169*x258*x277 - x169*x277*x88 - x17*x2*x277 + x17*x277*x6 &
                     + x17*x277*x8 + x170*x261*x277 - x170*x277*x91 + x171*x172&
                    *x277 + x171*x182*x277 - x171*x261*x277 + x171*x277*x91 -  &
                    x172*x189*x277 - x173*x191*x277 - x173*x235*x277 + x173*   &
                    x277*x80 + x173*x277*x88 + x174*x277*x40 - x174*x277*x43 - &
                    x174*x277*x45 - x174*x277*x50 + x174*x277*x51 + x174*x277* &
                    x52 + x174*x277*x53 - x175*x277*x62 + x176*x230*x277 - x176&
                    *x277*x59 - x177*x211*x277 + x177*x242*x277 + x177*x248*   &
                    x277 + x178*x231*x277 + x178*x241*x277 - x178*x277*x64 -   &
                    x178*x277*x86 + x179*x277*x32 - x179*x277*x47 - x179*x277* &
                    x48 - x179*x277*x49 - x179*x277*x50 + x179*x277*x51 + x179*&
                    x277*x52 + x179*x277*x53 - x18*x2*x277 + x18*x277*x4 + x18*&
                    x277*x6 + x18*x277*x8 - x180*x277*x54 - x181*x277*x54 -    &
                    x182*x189*x277 - x182*x228*x277 - x183*x277*x54 - x184*x277&
                    *x32 + x184*x277*x47 + x184*x277*x48 + x184*x277*x49 + x184&
                    *x277*x50 - x184*x277*x51 - x184*x277*x52 - x184*x277*x53  &
                     + x184*x277*x55 + x185*x186*x277 + x186*x234*x277 + x186* &
                    x241*x277 - x186*x277*x64 - x186*x277*x67 - x186*x277*x77  &
                     - x186*x277*x86 - x186*x277*x87 + x188*x235*x277 - x188*  &
                    x277*x80 - x188*x277*x88 - x189*x216*x277 + x189*x261*x277 &
                     - x189*x277*x91 - x19*x2*x277 + x19*x277*x4 + x19*x277*x6 &
                     + x19*x277*x8 + x190*x191*x277 - x190*x212*x277 - x190*   &
                    x254*x277 - x190*x277*x80 - x190*x277*x88 + x192*x277*x32  &
                     - x192*x277*x49 - x192*x277*x50 + x192*x277*x51 + x192*   &
                    x277*x52 + x192*x277*x53 + x193*x277*x32 - x193*x277*x47 - &
                    x193*x277*x48 - x193*x277*x49 - x193*x277*x50 + x193*x277* &
                    x51 + x193*x277*x52 + x193*x277*x53 + x193*x277*x58 - x195*&
                    x277*x73 - x196*x277*x35 - x196*x277*x38 - x196*x277*x39 - &
                    x197*x277*x54 - x198*x277*x54 - x199*x277*x54 + x2*x24*x277&
                     - x2*x25*x277 - x2*x277*x30 - x2*x277*x40 + x2*x277*x42 + &
                    x2*x277*x45 + x20*x21*x277 + x20*x23*x277 - x20*x277*x37 + &
                    x20*x277*x41 - x200*x277*x79 + x201*x263*x277 - x201*x277* &
                    x59 - x201*x277*x83 + x207*x270*x277 - x207*x277*x64 - x207&
                    *x277*x67 - x207*x277*x86 - x207*x277*x87 - x21*x277*x35 - &
                    x21*x277*x38 - x211*x228*x277 - x211*x277*x70 - x211*x277* &
                    x90 - x212*x220*x277 - x212*x225*x277 - x212*x229*x277 +   &
                    x215*x277*x54 + x217*x274*x277 - x22*x277*x30 + x22*x277*  &
                    x55 - x220*x254*x277 - x222*x235*x277 - x222*x253*x277 -   &
                    x222*x258*x277 - x223*x277*x78 - x223*x277*x84 - x223*x277*&
                    x85 - x224*x277*x89 - x225*x254*x277 - x226*x277*x54 + x227&
                    *x277*x54 - x229*x254*x277 - x23*x277*x35 - x23*x277*x38 - &
                    x230*x277*x60 - x230*x277*x61 + x230*x277*x98 + x230*x277* &
                    x99 - x231*x277*x65 - x231*x277*x66 - x232*x277*x60 - x233*&
                    x277*x75 - x234*x277*x66 - x235*x277*x81 - x236*x277*x79 + &
                    x238*x277*x50 - x238*x277*x51 - x238*x277*x52 - x238*x277* &
                    x53 - x239*x277*x40 + x239*x277*x42 + x239*x277*x43 + x239*&
                    x277*x45 - x24*x26*x277 - x24*x27*x277 - x24*x277*x28 - x24&
                    *x277*x4 - x24*x277*x6 - x24*x277*x8 - x240*x277*x60 - x241&
                    *x277*x65 + x242*x277*x70 + x242*x277*x90 - x242*x277*x92  &
                     - x244*x277*x59 + x245*x277*x40 - x245*x277*x42 - x245*   &
                    x277*x43 - x245*x277*x45 - x245*x277*x46 - x246*x277*x50 + &
                    x246*x277*x51 + x246*x277*x52 - x247*x277*x50 + x247*x277* &
                    x51 + x247*x277*x53 - x249*x277*x50 + x249*x277*x51 + x249*&
                    x277*x52 + x249*x277*x53 + x25*x26*x277 + x25*x27*x277 +   &
                    x25*x277*x28 + x25*x277*x4 + x25*x277*x6 + x25*x277*x8 -   &
                    x250*x277*x64 - x250*x277*x67 - x251*x277*x50 + x251*x277* &
                    x51 + x251*x277*x52 + x251*x277*x53 + x252*x277*x40 - x252*&
                    x277*x42 - x252*x277*x43 - x252*x277*x45 - x255*x277*x50 + &
                    x255*x277*x51 + x255*x277*x52 + x255*x277*x53 + x256*x277* &
                    x40 - x256*x277*x42 - x256*x277*x43 - x256*x277*x45 - x257*&
                    x277*x78 - x259*x277*x50 + x259*x277*x51 + x259*x277*x53 + &
                    x26*x277*x29 + x26*x277*x30 + x26*x277*x56 - x260*x277*x50 &
                     + x260*x277*x51 + x260*x277*x52 + x260*x277*x53 - x262*   &
                    x277*x50 + x262*x277*x51 - x264*x265*x277 + x265*x267*x277 &
                     + x27*x277*x29 + x27*x277*x30 + x27*x277*x57 + x272*x277* &
                    x94 + x272*x277*x96 + x273*x277*x73 + x274*x277*x82 + x277*&
                    x28*x29 + x277*x28*x30 + x277*x28*x58 + x277*x29*x4 + x277*&
                    x29*x6 + x277*x29*x8 + x277*x3*x54 + x277*x30*x4 + x277*x30&
                    *x6 + x277*x30*x8 + x277*x31*x32 - x277*x31*x47 - x277*x31*&
                    x48 - x277*x31*x49 - x277*x31*x50 + x277*x31*x51 + x277*x31&
                    *x52 + x277*x31*x53 + x277*x31*x56 + x277*x32*x33 + x277*  &
                    x32*x34 - x277*x32*x93 - x277*x33*x47 - x277*x33*x48 - x277&
                    *x33*x49 - x277*x33*x50 + x277*x33*x51 + x277*x33*x52 +    &
                    x277*x33*x53 + x277*x33*x57 - x277*x34*x47 - x277*x34*x48  &
                     - x277*x34*x49 - x277*x34*x50 + x277*x34*x51 + x277*x34*  &
                    x52 + x277*x34*x53 + x277*x34*x58 + x277*x35*x37 - x277*x35&
                    *x41 + x277*x36*x50 - x277*x36*x51 - x277*x36*x52 - x277*  &
                    x36*x53 + x277*x36*x55 + x277*x37*x38 + x277*x37*x39 - x277&
                    *x38*x41 - x277*x39*x41 + x277*x4*x40 - x277*x4*x42 - x277*&
                    x4*x43 - x277*x4*x45 - x277*x4*x46 + x277*x40*x6 - x277*x40&
                    *x73 + x277*x40*x8 - x277*x42*x6 + x277*x42*x73 - x277*x42*&
                    x8 - x277*x43*x6 + x277*x43*x73 - x277*x43*x8 - x277*x45*x6&
                     + x277*x45*x73 - x277*x45*x8 - x277*x46*x6 + x277*x47*x93 &
                     + x277*x48*x93 + x277*x49*x93 + x277*x5*x54 + x277*x50*x73&
                     + x277*x50*x93 - x277*x51*x73 - x277*x51*x93 - x277*x52*  &
                    x73 - x277*x52*x93 - x277*x53*x73 - x277*x53*x93 - x277*x54&
                    *x68 - x277*x54*x69 + x277*x54*x7 + x277*x54*x9 + x277*x55*&
                    x93 + x277*x59*x60 + x277*x59*x61 - x277*x59*x98 - x277*x59&
                    *x99 + x277*x60*x62 + x277*x60*x83 - x277*x60*x97 + x277*  &
                    x61*x83 - x277*x61*x97 - x277*x62*x98 - x277*x62*x99 + x277&
                    *x64*x65 + x277*x64*x66 + x277*x65*x67 + x277*x65*x86 +    &
                    x277*x65*x87 + x277*x66*x67 + x277*x66*x77 + x277*x66*x86  &
                     + x277*x66*x87 + x277*x70*x71 + x277*x71*x90 + x277*x74*  &
                    x75 + x277*x76*x78 + x277*x76*x84 + x277*x76*x85 + x277*x79&
                    *x89 + x277*x80*x81 + x277*x81*x88 - x277*x83*x98 - x277*  &
                    x83*x99 + x277*x91*x92 + x277*x94*x95 + x277*x95*x96 + x277&
                    *x97*x98 + x277*x97*x99
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x278 = P1(0)*w3(0)*wl(mu,j)
            x279 = P1(0)*w3(mu)*wl(0,j)
            x280 = co(3)*w3(1)*wl(mu,j)
            x281 = w3(mu)*wl(1,j)
            x282 = w3(1)*wl(mu,j)
            x283 = co(5)*w3(mu)*wl(1,j)
            x284 = w3(2)*wl(mu,j)
            x285 = w3(mu)*wl(2,j)
            x286 = co(5)*w3(mu)*wl(2,j)
            x287 = co(3)*w3(3)*wl(mu,j)
            x288 = P1(3)*w3(mu)*wl(3,j)
            x289 = P1(3)*w3(3)*wl(mu,j)
            x290 = P2(2)*w3(2)*wl(mu,j)
            x291 = w3(mu)*wl(3,j)
            x292 = P3(0)*w3(0)*wl(mu,j)
            x293 = P3(0)*w3(mu)*wl(0,j)
            x294 = P3(1)*w3(mu)*wl(1,j)
            x295 = P3(1)*w3(1)*wl(mu,j)
            x296 = P3(2)*w3(2)*wl(mu,j)
            x297 = P3(2)*w3(mu)*wl(2,j)
            x298 = P3(3)*w3(mu)*wl(3,j)
            x299 = P3(3)*w3(3)*wl(mu,j)
            x300 = P3(mu)*co(6)
            x301 = w3(0)*wl(mu,j)
            x302 = w3(mu)*wl(0,j)
            x303 = co(5)*w3(mu)*wl(0,j)
            x304 = w3(3)*wl(mu,j)
            x305 = 2*co(4)*w3(1)*wl(mu,j)
            x306 = 2*co(4)*w3(mu)*wl(1,j)
            x307 = 2*co(4)*w3(mu)*wl(2,j)
            x308 = 2*P1(mu)
            x309 = 2*P3(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - P1(0)*x277*x303 + P1(1)*x277*x280 + P1(&
                          1)*x277*x283 - P1(1)*x277*x305 - P1(1)*x277*x306 + P1&
                          (2)*x277*x286 - P1(2)*x277*x307 + P1(3)*x277*x287 +  &
                          P1(mu)*x277*x50 - P1(mu)*x277*x53 - P2(0)*x277*x303  &
                           + P2(1)*x277*x280 + P2(1)*x277*x283 - P2(1)*x277*   &
                          x305 - P2(1)*x277*x306 + P2(2)*x277*x286 - P2(2)*x277&
                          *x307 + P2(3)*co(5)*x277*x291 + P2(3)*x277*x287 - P2(&
                          mu)*x277*x40 + P2(mu)*x277*x42 + P2(mu)*x277*x43 + P2&
                          (mu)*x277*x45 + P2(mu)*x277*x50 - P2(mu)*x277*x51 -  &
                          P2(mu)*x277*x52 - P2(mu)*x277*x53 - P3(0)*x277*x303  &
                           + P3(1)*x277*x280 + P3(2)*x277*x286 + P3(3)*x277*   &
                          x287 + P3(mu)*x277*x50 - P3(mu)*x277*x51 - P3(mu)*   &
                          x277*x52 - P3(mu)*x277*x53 - P4(mu)*x277*x32 + P4(mu &
                          )*x277*x47 + P4(mu)*x277*x48 + P4(mu)*x277*x49 + P4( &
                          mu)*x277*x50 - P4(mu)*x277*x51 - P4(mu)*x277*x52 - P4&
                          (mu)*x277*x53 + co(0)*x277*x292 - co(0)*x277*x295 -  &
                          co(0)*x277*x296 - co(0)*x277*x299 + co(1)*x277*x278  &
                           + co(1)*x277*x279 - co(1)*x277*x288 - co(1)*x277*   &
                          x289 + co(2)*x277*x293 - co(2)*x277*x294 - co(2)*x277&
                          *x297 - co(2)*x277*x298 - co(3)*x277*x278 - co(3)*   &
                          x277*x279 + co(3)*x277*x288 + co(3)*x277*x290 - co(3 &
                          )*x277*x292 - co(3)*x277*x293 + co(3)*x277*x294 + co(&
                          3)*x277*x296 + co(3)*x277*x297 + co(3)*x277*x298 - co&
                          (5)*x277*x278 + co(5)*x277*x288 + co(5)*x277*x289 -  &
                          co(5)*x277*x292 + co(5)*x277*x294 + co(5)*x277*x295  &
                           + co(5)*x277*x296 + co(5)*x277*x298 + co(5)*x277*   &
                          x299 - x117*x277*x284 - x117*x277*x285 - x135*x277*  &
                          x281 - x135*x277*x282 - x151*x277*x284 - x151*x277*  &
                          x285 - x154*x277*x301 + x16*x277*x308 - x17*x277*x308&
                           - x18*x277*x308 - x19*x277*x308 + x20*x277*x300 -   &
                          x200*x277*x291 - x200*x277*x304 + x223*x277*x301 +   &
                          x223*x277*x302 - x231*x277*x284 - x236*x277*x291 -   &
                          x236*x277*x304 - x25*x277*x308 + x257*x277*x301 +    &
                          x257*x277*x302 + x277*x278*x54 + x277*x279*x54 + x277&
                          *x281*x59 - x277*x281*x97 + x277*x282*x62 - x277*x282&
                          *x97 + x277*x284*x64 + x277*x284*x67 + x277*x285*x64 &
                           - x277*x288*x54 - x277*x289*x54 - x277*x29*x308 -   &
                          x277*x290*x54 + x277*x292*x54 + x277*x293*x54 - x277*&
                          x294*x54 - x277*x295*x54 - x277*x296*x54 - x277*x297*&
                          x54 - x277*x298*x54 - x277*x299*x54 - x277*x300*x35  &
                           - x277*x300*x38 - x277*x300*x39 - x277*x308*x40 +   &
                          x277*x308*x42 + x277*x308*x43 + x277*x308*x45 - x277*&
                          x309*x40 + x277*x309*x42 + x277*x309*x43 + x277*x309*&
                          x45
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              x310 = w3(nu)*wl(mu,j)
              x311 = gg(nu,mu)*w3(0)*wl(0,j)
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) + co(1)*x277*x310 + co(10)*x277*x311 - &
                            co(3)*x277*x310 - co(5)*x277*x310 + co(7)*x277*x311&
                             - co(9)*x277*x311 - gg(nu,mu)*x17*x277 - gg(nu,mu &
                            )*x18*x277 - gg(nu,mu)*x19*x277 - gg(nu,mu)*x25*   &
                            x277 - gg(nu,mu)*x277*x29 - gg(nu,mu)*x277*x30 + gg&
                            (nu,mu)*x277*x42 + gg(nu,mu)*x277*x43 + gg(nu,mu)* &
                            x277*x45 + x277*x310*x54
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVSS
end module lcVSVSS
