!******************************************************************************!
!                                                                              !
!    lcVVS.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVS.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVVS(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,       &
    riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVS0)
!       P(1,2)*P(2,1)*c0
!       c1*(P(1,2)*P(2,3) + P(1,3)*P(2,1))
!       P(1,3)*P(2,3)*c2
!       Metric(1,2)*P(-1,1)*P(-1,2)*c3
        x0 = P1(0)**2
        x2 = P2(0)**2
        x5 = P1(2)**2
        x7 = P2(2)**2
        x13 = P1(0)*co(1)*w2(0)
        x14 = P1(1)*co(1)*w2(1)
        x17 = P1(2)*co(1)*w2(2)
        x21 = P1(1)*co(2)*w2(1)
        x22 = P1(2)*w2(2)
        x24 = P1(3)*w2(3)
        x25 = P1(1)*co(0)
        x26 = P1(1)*P2(1)
        x31 = P1(1)*co(2)
        x32 = P2(2)*co(2)*w2(2)
        x34 = P1(1)*co(0)*w2(1)
        x35 = P2(3)*w2(3)
        x36 = P1(2)*co(2)*w2(2)
        x37 = P1(3)*co(2)*w2(3)
        x39 = P1(2)*co(0)*w2(2)
        x40 = P2(1)*co(2)*w2(1)
        x42 = P1(2)*P2(2)
        x44 = P2(3)*co(2)*w2(3)
        x45 = P1(3)*co(0)*w2(3)
        x46 = P1(3)*P2(3)
        x47 = P2(0)*co(1)*w2(0)
        x49 = P2(1)*co(1)*w2(1)
        x51 = P1(0)*co(2)*w2(0)
        x52 = P1(0)*P2(0)
        x53 = P1(0)*co(0)*w2(0)
        x55 = P2(0)*w2(0)
        x57 = P1(3)*co(1)*w2(3)
        x59 = P2(0)*co(2)*w2(0)
        x60 = P2(1)*co(1)
        x61 = P2(2)*co(1)*w2(2)
        x62 = P2(3)*co(1)*w2(3)
        x63 = 2*P1(0)*P2(0)
        x64 = P1(1)*co(1)
        x66 = 2*P1(1)*co(1)*w2(1)
        x67 = 2*P1(2)*co(1)*w2(2)
        x70 = 2*P1(0)*co(1)*w2(0)
        do j = riMaxIn, 0, -1
          x1 = co(2)*w2(0)*wl(0,j)
          x3 = P1(1)**2*w2(1)*wl(1,j)
          x4 = P2(1)**2*w2(1)*wl(1,j)
          x6 = co(2)*w2(2)*wl(2,j)
          x8 = P1(3)**2*w2(3)*wl(3,j)
          x9 = P2(3)**2*w2(3)*wl(3,j)
          x10 = co(1)*w2(0)*wl(0,j)
          x11 = co(1)*w2(2)*wl(2,j)
          x12 = P1(1)*wl(1,j)
          x15 = P1(0)*wl(0,j)
          x16 = P1(2)*wl(2,j)
          x18 = P1(3)*wl(3,j)
          x19 = P1(0)*P1(3)*w2(3)*wl(0,j)
          x20 = P1(0)*P2(0)*w2(0)*wl(0,j)
          x23 = P1(1)*co(2)*wl(1,j)
          x27 = co(3)*w2(1)*wl(1,j)
          x28 = co(3)*w2(2)*wl(2,j)
          x29 = co(3)*w2(3)*wl(3,j)
          x30 = P2(2)*w2(1)*wl(2,j)
          x33 = P2(3)*wl(3,j)
          x38 = P2(1)*wl(1,j)
          x41 = P2(2)*wl(2,j)
          x43 = P2(3)*co(2)*wl(3,j)
          x48 = P2(0)*wl(0,j)
          x50 = P2(0)*co(1)*wl(0,j)
          x54 = P1(1)*co(1)*wl(1,j)
          x56 = co(3)*w2(0)*wl(0,j)
          x58 = P1(2)*P2(0)*w2(2)*wl(0,j)
          x65 = 2*P2(1)*w2(1)*wl(1,j)
          x68 = 2*P2(2)*wl(2,j)
          x69 = 2*P1(3)*P2(3)*w2(3)*wl(3,j)
          x71 = 2*P2(0)*co(1)*wl(0,j)
          wp(0,j) = P1(3)*P2(3)*cima*co(0)*w2(3)*wl(3,j) + P2(1)*cima*co(2)*x30&
                     + P2(1)*cima*w2(1)*wl(1,j)*x25 + P2(1)*cima*w2(1)*x43 - 2*&
                    P2(1)*cima*wl(1,j)*x57 + P2(2)*cima*co(3)*wl(2,j)*x22 + P2(&
                    2)*cima*w2(2)*x50 + cima*co(0)*x20 - cima*co(0)*x58 + cima*&
                    co(1)*x19 - cima*co(1)*x3 - cima*co(1)*x4 - cima*co(1)*x69 &
                     - cima*co(1)*x8 - cima*co(1)*x9 - cima*co(2)*x19 + cima*co&
                    (2)*x3 + cima*co(2)*x4 - cima*co(2)*x58 + cima*co(2)*x69 + &
                    cima*co(2)*x8 + cima*co(2)*x9 + cima*co(3)*x20 + cima*x0*x1&
                     - cima*x0*x10 + cima*x1*x2 + cima*x1*x63 - cima*x10*x2 -  &
                    cima*x10*x63 - cima*x11*x5 - cima*x11*x7 + cima*x12*x13 +  &
                    cima*x12*x32 - cima*x12*x51 + cima*x13*x16 + cima*x13*x18  &
                     + cima*x13*x68 + cima*x14*x15 - cima*x14*x16 - cima*x14*  &
                    x18 + cima*x15*x17 - cima*x15*x21 - cima*x15*x32 - cima*x15&
                    *x36 - cima*x15*x40 - cima*x15*x44 + cima*x16*x21 + cima*  &
                    x16*x37 + cima*x16*x40 + cima*x16*x44 - cima*x16*x51 - cima&
                    *x16*x57 - cima*x16*x59 - cima*x17*x18 - cima*x17*x68 +    &
                    cima*x18*x21 + cima*x18*x32 + cima*x18*x36 + cima*x18*x40  &
                     - cima*x18*x51 - cima*x18*x59 + cima*x21*x33 - cima*x21*  &
                    x48 + cima*x22*x23 + cima*x22*x43 - cima*x22*x54 + cima*x22&
                    *x71 + cima*x23*x24 + cima*x23*x35 - cima*x23*x55 - cima*  &
                    x24*x54 + cima*x24*x71 + cima*x25*x30 + cima*x26*x27 + cima&
                    *x26*x28 + cima*x26*x29 - cima*x26*x56 + cima*x27*x42 +    &
                    cima*x27*x46 - cima*x27*x52 + cima*x28*x46 - cima*x28*x52  &
                     + cima*x29*x42 + cima*x29*x46 - cima*x29*x52 + cima*x30*  &
                    x31 - cima*x30*x60 + cima*x31*x65 + cima*x32*x33 + cima*x32&
                    *x38 - cima*x32*x48 + cima*x33*x34 + cima*x33*x39 + cima*  &
                    x33*x47 - cima*x33*x49 - cima*x33*x51 - cima*x33*x53 - cima&
                    *x33*x59 - cima*x33*x61 - cima*x33*x66 - cima*x33*x67 +    &
                    cima*x33*x70 - cima*x34*x48 + cima*x35*x50 + cima*x36*x38  &
                     + cima*x36*x68 + cima*x37*x38 + cima*x37*x41 - cima*x37*  &
                    x48 + cima*x38*x39 + cima*x38*x44 + cima*x38*x45 + cima*x38&
                    *x47 - cima*x38*x51 - cima*x38*x53 - cima*x38*x59 - cima*  &
                    x38*x61 - cima*x38*x62 - cima*x38*x67 + cima*x38*x70 + cima&
                    *x39*x41 - cima*x40*x48 + cima*x41*x44 + cima*x41*x45 +    &
                    cima*x41*x47 - cima*x41*x51 - cima*x41*x53 - cima*x41*x59  &
                     - cima*x41*x62 - cima*x41*x66 - cima*x42*x56 - cima*x44*  &
                    x48 - cima*x45*x48 - cima*x46*x56 + cima*x48*x49 + cima*x48&
                    *x66 + cima*x5*x6 - cima*x57*x68 + cima*x6*x7 - cima*x64*  &
                    x65
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x72 = P1(0)*wl(mu,j)
            x73 = co(2)*w2(mu)
            x74 = co(1)*wl(mu,j)
            x75 = co(1)*w2(mu)
            x76 = co(0)*w2(mu)
            x77 = P2(mu)*co(3)
            x78 = co(2)*w2(1)*wl(mu,j)
            x79 = co(2)*w2(mu)*wl(1,j)
            x80 = co(2)*w2(2)*wl(mu,j)
            x81 = co(2)*w2(3)*wl(mu,j)
            x82 = 2*co(1)*w2(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - P1(1)*cima*x78 - P1(1)*cima*x79 - P1(2 &
                          )*cima*x80 - P1(3)*cima*x81 - P2(1)*cima*x78 - P2(1)*&
                          cima*x79 - P2(2)*cima*x80 - P2(3)*cima*x81 - cima*co(&
                          1)*w2(0)*x72 + cima*co(2)*w2(0)*x72 + cima*co(2)*wl( &
                          mu,j)*x55 + cima*w2(0)*wl(0,j)*x77 - cima*w2(1)*wl(1,&
                          j)*x77 - cima*w2(2)*wl(2,j)*x77 - cima*w2(3)*wl(3,j)*&
                          x77 + 2*cima*w2(mu)*wl(1,j)*x60 + cima*w2(mu)*wl(1,j &
                          )*x64 + cima*wl(mu,j)*x14 + cima*x15*x73 - cima*x15* &
                          x75 - cima*x16*x73 + cima*x16*x75 - cima*x18*x73 +   &
                          cima*x18*x75 + cima*x22*x74 + cima*x24*x74 - cima*x33&
                          *x73 - cima*x33*x76 + cima*x33*x82 - cima*x38*x76 -  &
                          cima*x41*x73 - cima*x41*x76 + cima*x41*x82 + cima*x48&
                          *x73 + cima*x48*x76 - cima*x48*x82
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) - cima*co(1)*w2(nu)*wl(mu,j) + cima*co(&
                            2)*w2(nu)*wl(mu,j)
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVS
end module lcVVS
