!******************************************************************************!
!                                                                              !
!    lcVVSSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVSSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVSSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVVSSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVSSS0)
!       P(1,2)*P(2,1)*c0
!       c1*(P(1,1)*P(2,4) + P(1,1)*P(2,5) + P(1,2)*P(2,4) + P(1,2)*P(2,5))
!       c2*(2*P(1,4)*P(2,4) + P(1,4)*P(2,5) + P(1,5)*P(2,4) + 2*P(1,5)*P(2,5))
!       c3*(P(1,4)*P(2,1) + P(1,4)*P(2,2) + P(1,5)*P(2,1) + P(1,5)*P(2,2))
!       P(1,1)*P(2,2)*c4
!       c5*(P(1,1)*P(2,1) + P(1,2)*P(2,2))
!       c6*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,2)**2)
!       Metric(1,2)*P(-1,1)*P(-1,2)*c7
!       c8*(Metric(1,2)*P(-1,4)**2 + Metric(1,2)*P(-1,5)**2)
!       Metric(1,2)*P(-1,4)*P(-1,5)*c9
!       c10*(Metric(1,2)*P(-1,1)*P(-1,4) + Metric(1,2)*P(-1,1)*P(-1,5) + Metric(1
!       ,2)*P(-1,2)*P(-1,4) + Metric(1,2)*P(-1,2)*P(-1,5))
        x0 = P1(1)**2
        x2 = P1(2)**2
        x3 = P1(3)**2
        x4 = P2(1)**2
        x5 = P2(2)**2
        x6 = P2(3)**2
        x7 = P1(0)**2
        x9 = P2(0)**2
        x21 = co(6)*x9
        x27 = P3(0)**2
        x30 = P3(1)**2
        x31 = co(8)*x30
        x32 = P3(2)**2
        x33 = P3(3)**2
        x36 = P4(1)**2
        x38 = P4(2)**2
        x39 = P4(3)**2
        x40 = co(9)*x39
        x41 = P4(0)**2
        x44 = co(9)*x41
        x46 = co(9)*x36
        x47 = co(9)*x38
        x49 = 2*x38
        x50 = 2*x41
        x51 = 2*co(2)
        x57 = 2*x39
        x60 = P1(0)*w2(0)
        x62 = P1(1)*w2(1)
        x67 = P1(2)*w2(2)
        x70 = P1(3)*w2(3)
        x74 = P1(0)*P2(0)
        x77 = P2(1)*co(1)*w2(1)
        x78 = P2(1)*w2(1)
        x84 = P1(0)*P3(0)
        x85 = P3(1)*w2(1)
        x87 = P3(2)*w2(2)
        x89 = P3(3)*w2(3)
        x91 = P1(0)*P4(0)
        x97 = P1(1)*co(5)*w2(1)
        x98 = P2(0)*w2(0)
        x102 = P1(1)*P2(1)
        x105 = P1(1)*co(0)*w2(1)
        x106 = P2(2)*w2(2)
        x109 = P2(3)*w2(3)
        x110 = P3(0)*w2(0)
        x112 = P1(1)*P3(1)
        x116 = P4(2)*co(2)*w2(2)
        x118 = P4(3)*co(2)*w2(3)
        x121 = P2(0)*co(1)*w2(0)
        x123 = P1(2)*co(0)*w2(2)
        x126 = P1(2)*P2(2)
        x127 = P3(0)*co(1)*w2(0)
        x128 = P1(2)*P3(2)
        x129 = P4(1)*co(2)*w2(1)
        x131 = P1(2)*P4(2)
        x132 = P1(3)*co(0)*w2(3)
        x133 = P2(1)*co(4)*w2(1)
        x136 = P1(3)*P2(3)*co(7)
        x137 = P1(3)*P3(3)
        x138 = P1(3)*P4(3)
        x141 = P2(2)*co(1)*w2(2)
        x143 = P2(2)*co(3)*w2(2)
        x144 = P2(3)*co(1)*w2(3)
        x145 = P2(3)*co(3)*w2(3)
        x146 = P2(0)*P3(0)
        x147 = P3(1)*co(1)*w2(1)
        x148 = P3(2)*co(1)*w2(2)
        x149 = P3(3)*co(1)*w2(3)
        x150 = P2(0)*P4(0)
        x154 = P2(1)*P3(1)
        x155 = P2(1)*P4(1)
        x157 = P2(2)*P3(2)
        x158 = P2(2)*P4(2)
        x159 = P2(3)*P3(3)
        x160 = P2(3)*P4(3)
        x161 = P3(0)*P4(0)
        x164 = P3(2)*P4(2)
        x166 = P3(3)*P4(3)
        x167 = P1(0)*co(5)*w2(0)
        x169 = P1(0)*P2(0)*co(7)
        x175 = P4(0)*co(2)*w2(0)
        x184 = P1(3)*P2(3)
        x191 = 2*P1(0)*co(2)*w2(0)
        x192 = 2*P1(1)*co(2)*w2(1)
        x193 = 2*P1(2)*co(2)*w2(2)
        x194 = 2*P1(3)*co(2)*w2(3)
        x195 = 2*co(1)
        x196 = 2*P1(0)*P2(0)
        x197 = 2*co(3)
        x198 = 2*P2(1)*co(2)*w2(1)
        x199 = 2*P1(0)*P3(0)
        x200 = 2*P3(1)*co(2)*w2(1)
        x201 = 2*P3(2)*co(2)*w2(2)
        x203 = 2*P3(3)*co(2)*w2(3)
        x204 = 2*P2(0)*co(2)*w2(0)
        x205 = 2*P1(1)*P2(1)
        x206 = 2*P3(0)*co(2)*w2(0)
        x207 = P1(1)*P4(1)
        x209 = 2*P1(2)*P2(2)
        x210 = 2*P1(3)*P2(3)
        x212 = 2*P2(3)*co(2)*w2(3)
        x213 = 2*P2(0)*P3(0)
        x214 = 2*P2(2)*co(2)*w2(2)
        x215 = 2*P3(0)*P4(0)
        x216 = P3(1)*P4(1)
        x218 = 2*P4(0)*co(2)*w2(0)
        x220 = 2*P4(1)*co(2)*w2(1)
        x222 = 2*P4(2)*co(2)*w2(2)
        x224 = 2*P4(3)*co(2)*w2(3)
        x225 = 2*co(8)
        x227 = P4(3)*w2(3)
        x228 = 4*co(2)
        x231 = cima*w3(0)*w4(0)
        do j = riMaxIn, 0, -1
          x1 = co(10)*w2(0)*wl(0,j)
          x8 = co(10)*w2(1)*wl(1,j)
          x10 = co(10)*w2(2)*wl(2,j)
          x11 = co(10)*w2(3)*wl(3,j)
          x12 = w2(0)*wl(0,j)*x7
          x13 = w2(0)*wl(0,j)*x9
          x14 = w2(1)*wl(1,j)*x0
          x15 = w2(1)*wl(1,j)*x4
          x16 = w2(2)*wl(2,j)*x2
          x17 = w2(2)*wl(2,j)*x5
          x18 = w2(3)*wl(3,j)*x3
          x19 = w2(3)*wl(3,j)*x6
          x20 = co(6)*w2(0)*wl(0,j)
          x22 = w2(0)*wl(0,j)
          x23 = co(6)*w2(1)*wl(1,j)
          x24 = co(6)*w2(2)*wl(2,j)
          x25 = co(6)*w2(3)*wl(3,j)
          x26 = co(8)*w2(0)*wl(0,j)
          x28 = co(8)*w2(1)*wl(1,j)
          x29 = w2(1)*wl(1,j)
          x34 = co(8)*w2(2)*wl(2,j)
          x35 = co(8)*w2(3)*wl(3,j)
          x37 = co(9)*w2(0)*wl(0,j)
          x42 = co(9)*w2(1)*wl(1,j)
          x43 = w2(2)*wl(2,j)
          x45 = w2(3)*wl(3,j)
          x48 = 2*co(8)*w2(0)*wl(0,j)
          x52 = 2*co(2)*w2(0)*wl(0,j)
          x53 = 2*co(2)*w2(1)*wl(1,j)
          x54 = 2*co(2)*w2(2)*wl(2,j)
          x55 = 2*co(2)*w2(3)*wl(3,j)
          x56 = 2*co(8)*w2(1)*wl(1,j)
          x58 = 2*co(8)*w2(2)*wl(2,j)
          x59 = 2*co(8)*w2(3)*wl(3,j)
          x61 = P1(1)*co(1)*wl(1,j)
          x63 = P1(0)*co(1)*wl(0,j)
          x64 = P1(1)*co(3)*wl(1,j)
          x65 = P1(0)*co(3)*wl(0,j)
          x66 = P1(2)*co(1)*wl(2,j)
          x68 = P1(2)*co(3)*wl(2,j)
          x69 = P1(3)*co(1)*wl(3,j)
          x71 = P1(3)*co(3)*wl(3,j)
          x72 = P1(0)*P2(0)*w2(0)*wl(0,j)
          x73 = co(7)*w2(0)*wl(0,j)
          x75 = P1(0)*P2(1)*w2(0)*wl(1,j)
          x76 = P1(0)*wl(0,j)
          x79 = P1(0)*P2(2)*w2(0)*wl(2,j)
          x80 = P1(0)*P2(2)*w2(2)*wl(0,j)
          x81 = P2(3)*co(1)*wl(3,j)
          x82 = P1(0)*P2(3)*w2(3)*wl(0,j)
          x83 = P2(3)*co(3)*wl(3,j)
          x86 = P3(1)*co(3)*wl(1,j)
          x88 = P3(2)*co(3)*wl(2,j)
          x90 = P3(3)*co(3)*wl(3,j)
          x92 = P4(0)*co(9)*w2(2)*wl(2,j)
          x93 = co(9)*w2(3)*wl(3,j)
          x94 = P1(2)*co(5)*wl(2,j)
          x95 = P1(1)*co(5)*wl(1,j)
          x96 = P1(3)*wl(3,j)
          x99 = P2(0)*co(1)*wl(0,j)
          x100 = P2(0)*co(3)*wl(0,j)
          x101 = P1(1)*P2(1)*w2(1)*wl(1,j)
          x103 = co(7)*w2(3)*wl(3,j)
          x104 = P2(2)*wl(2,j)
          x107 = P1(1)*co(4)*wl(1,j)
          x108 = P2(3)*wl(3,j)
          x111 = P3(0)*co(3)*wl(0,j)
          x113 = P4(1)*co(9)*w2(0)*wl(0,j)
          x114 = P4(2)*co(2)*wl(2,j)
          x115 = P1(1)*wl(1,j)
          x117 = P4(3)*co(2)*wl(3,j)
          x119 = P1(2)*P1(3)*w2(2)*wl(3,j)
          x120 = P1(2)*wl(2,j)
          x122 = P2(1)*wl(1,j)
          x124 = P1(2)*co(4)*wl(2,j)
          x125 = P1(2)*P2(2)*w2(2)*wl(2,j)
          x130 = P4(1)*co(2)*wl(1,j)
          x134 = P1(3)*co(4)*wl(3,j)
          x135 = P1(3)*P2(3)*w2(3)*wl(3,j)
          x139 = P2(0)*wl(0,j)
          x140 = P2(1)*co(3)*wl(1,j)
          x142 = P2(2)*co(3)*wl(2,j)
          x151 = P2(2)*co(5)*wl(2,j)
          x152 = P2(1)*co(5)*wl(1,j)
          x153 = P2(3)*co(5)*wl(3,j)
          x156 = P3(0)*wl(0,j)
          x162 = P3(1)*wl(1,j)
          x163 = P3(2)*wl(2,j)
          x165 = P3(3)*wl(3,j)
          x168 = P1(0)*co(5)*wl(0,j)
          x170 = P1(0)*P2(3)*w2(0)*wl(3,j)
          x171 = P1(0)*P3(0)*w2(0)*wl(0,j)
          x172 = P4(0)*co(9)*w2(0)*wl(0,j)
          x173 = P2(2)*co(1)*wl(2,j)
          x174 = P1(1)*P3(1)*w2(1)*wl(1,j)
          x176 = P4(0)*co(2)*wl(0,j)
          x177 = P4(1)*co(9)*w2(1)*wl(1,j)
          x178 = P4(1)*co(9)*w2(2)*wl(2,j)
          x179 = P4(1)*co(9)*w2(3)*wl(3,j)
          x180 = P2(1)*co(1)*wl(1,j)
          x181 = co(1)*w2(2)*wl(2,j)
          x182 = co(3)*w2(2)*wl(2,j)
          x183 = co(9)*w2(2)*wl(2,j)
          x185 = co(1)*w2(3)*wl(3,j)
          x186 = co(3)*w2(3)*wl(3,j)
          x187 = P2(0)*co(5)*wl(0,j)
          x188 = P2(0)*P3(0)*w2(0)*wl(0,j)
          x189 = P2(1)*P3(1)*w2(1)*wl(1,j)
          x190 = P2(1)*P4(1)*w2(1)*wl(1,j)
          x202 = 2*P3(3)*co(2)*wl(3,j)
          x208 = 2*P2(0)*co(2)*wl(0,j)
          x211 = 2*P2(3)*co(2)*wl(3,j)
          x217 = P4(1)*wl(1,j)
          x219 = P4(0)*wl(0,j)
          x221 = 2*P4(2)*co(2)*wl(2,j)
          x223 = P4(3)*wl(3,j)
          x226 = 2*P1(3)*co(2)*wl(3,j)
          x229 = 4*co(2)*w2(2)*wl(2,j)
          x230 = 4*co(2)*w2(3)*wl(3,j)
          wp(0,j) = -P1(0)*x172*x231 + P1(0)*x231*x92 - 2*P1(1)*wl(1,j)*x231*  &
                    x77 + P1(1)*x113*x231 - P1(1)*x177*x231 - P1(1)*x178*x231  &
                     - P1(1)*x179*x231 - P2(0)*x172*x231 + P2(0)*x231*x92 - P3(&
                    0)*x172*x231 + P3(0)*x231*x92 + P3(1)*x113*x231 - P3(1)*   &
                    x177*x231 - P3(1)*x178*x231 - P3(1)*x179*x231 - P4(0)*w2(0 &
                    )*x221*x231 + P4(1)*w2(1)*x221*x231 + co(0)*x101*x231 + co(&
                    0)*x125*x231 + co(0)*x135*x231 - co(0)*x170*x231 + co(0)*  &
                    x231*x72 - co(0)*x231*x75 - co(0)*x231*x79 - co(1)*x12*x231&
                     - co(1)*x13*x231 - co(1)*x14*x231 - co(1)*x15*x231 - co(1 &
                    )*x16*x231 - co(1)*x17*x231 - co(1)*x171*x231 - co(1)*x174*&
                    x231 - co(1)*x18*x231 - co(1)*x188*x231 - co(1)*x19*x231 + &
                    co(1)*x231*x75 + co(1)*x231*x79 + co(1)*x231*x80 + co(1)*  &
                    x231*x82 - 2*co(10)*x101*x231 - co(10)*x13*x231 - co(10)*  &
                    x15*x231 - co(10)*x16*x231 - co(10)*x17*x231 - co(10)*x18* &
                    x231 - co(10)*x189*x231 - co(3)*x12*x231 - co(3)*x13*x231  &
                     - co(3)*x14*x231 - co(3)*x15*x231 - co(3)*x16*x231 - co(3 &
                    )*x17*x231 - co(3)*x171*x231 - co(3)*x174*x231 - co(3)*x18*&
                    x231 - co(3)*x188*x231 - co(3)*x189*x231 - co(3)*x19*x231  &
                     + co(3)*x231*x75 + co(3)*x231*x79 + co(3)*x231*x80 + co(3 &
                    )*x231*x82 + co(4)*x101*x231 + co(4)*x125*x231 + co(4)*x135&
                    *x231 + co(4)*x231*x72 - co(4)*x231*x80 - co(4)*x231*x82 + &
                    co(5)*x119*x231 + co(5)*x12*x231 + co(5)*x13*x231 + co(5)* &
                    x14*x231 + co(5)*x15*x231 + co(5)*x16*x231 + co(5)*x17*x231&
                     + co(5)*x18*x231 + co(5)*x19*x231 + co(6)*x15*x231 + co(6 &
                    )*x16*x231 + co(6)*x17*x231 + co(6)*x18*x231 + co(7)*w2(1)*&
                    wl(1,j)*x126*x231 + co(7)*w2(2)*wl(2,j)*x102*x231 + co(7)* &
                    x101*x231 + co(7)*x125*x231 + co(7)*x135*x231 + co(8)*x13* &
                    x231 + co(8)*x15*x231 + co(8)*x16*x231 + co(8)*x17*x231 -  &
                    co(9)*x190*x231 + x0*x1*x231 - x0*x10*x231 - x0*x11*x231 - &
                    x0*x20*x231 + x0*x23*x231 + x0*x231*x24 + x0*x231*x25 - x0*&
                    x231*x26 + x0*x231*x28 + x0*x231*x34 + x0*x231*x35 - x0*   &
                    x231*x8 + x1*x112*x231 + x1*x128*x231 + x1*x137*x231 - x1* &
                    x146*x231 + x1*x154*x231 + x1*x157*x231 + x1*x159*x231 - x1&
                    *x196*x231 + x1*x2*x231 + x1*x205*x231 + x1*x209*x231 + x1*&
                    x210*x231 + x1*x231*x3 + x1*x231*x4 + x1*x231*x5 + x1*x231*&
                    x6 - x1*x231*x7 - x1*x231*x84 - x10*x112*x231 - x10*x128*  &
                    x231 - x10*x137*x231 + x10*x146*x231 - x10*x154*x231 - x10*&
                    x157*x231 - x10*x159*x231 + x10*x196*x231 - x10*x205*x231  &
                     - x10*x209*x231 - x10*x210*x231 - x10*x231*x3 - x10*x231* &
                    x4 - x10*x231*x6 + x10*x231*x7 + x10*x231*x84 + x10*x231*x9&
                     + x100*x231*x62 + x100*x231*x67 + x100*x231*x70 + x100*   &
                    x231*x78 - x101*x197*x231 + x101*x225*x231 + x101*x228*x231&
                     + x102*x103*x231 - x102*x231*x48 + x102*x231*x58 + x102*  &
                    x231*x59 - x102*x231*x73 + x103*x126*x231 + x104*x105*x231 &
                     + x104*x118*x231 + x104*x121*x231 + x104*x127*x231 + x104*&
                    x129*x231 + x104*x132*x231 - x104*x144*x231 - x104*x147*   &
                    x231 - x104*x149*x231 - x104*x175*x231 + x104*x192*x231 +  &
                    x104*x194*x231 + x104*x198*x231 + x104*x200*x231 + x104*   &
                    x203*x231 - x104*x204*x231 - x104*x206*x231 + x104*x212*   &
                    x231 - x104*x231*x77 + x105*x108*x231 - x105*x139*x231 +   &
                    x106*x107*x231 + x106*x117*x231 + x106*x130*x231 + x106*   &
                    x134*x231 + x106*x152*x231 + x106*x153*x231 - x106*x176*   &
                    x231 - x106*x187*x231 + x106*x202*x231 - x106*x208*x231 +  &
                    x106*x211*x231 + x106*x226*x231 - x106*x231*x61 - x106*x231&
                    *x64 - x106*x231*x69 - x106*x231*x71 - x106*x231*x81 + x107&
                    *x109*x231 - x107*x231*x98 + x108*x116*x231 + x108*x121*   &
                    x231 + x108*x123*x231 + x108*x129*x231 - x108*x143*x231 -  &
                    x108*x147*x231 - x108*x148*x231 - x108*x175*x231 + x108*   &
                    x192*x231 + x108*x201*x231 - x108*x206*x231 - x108*x231*x77&
                     + x109*x114*x231 + x109*x124*x231 + x109*x130*x231 - x109*&
                    x142*x231 + x109*x151*x231 + x109*x152*x231 - x109*x176*   &
                    x231 - x109*x187*x231 - x109*x231*x61 - x109*x231*x64 -    &
                    x109*x231*x68 - x109*x231*x88 - x11*x112*x231 - x11*x128*  &
                    x231 - x11*x137*x231 + x11*x146*x231 - x11*x154*x231 - x11*&
                    x157*x231 - x11*x159*x231 + x11*x196*x231 - x11*x2*x231 -  &
                    x11*x205*x231 - x11*x209*x231 - x11*x210*x231 - x11*x231*x4&
                     - x11*x231*x5 - x11*x231*x6 + x11*x231*x7 + x11*x231*x84  &
                     + x11*x231*x9 - x110*x114*x231 - x110*x117*x231 - x110*   &
                    x130*x231 - x110*x202*x231 + x110*x231*x61 + x110*x231*x69 &
                     + x110*x231*x81 + x111*x231*x62 + x111*x231*x67 + x111*   &
                    x231*x70 + x111*x231*x78 - x112*x231*x48 + x112*x231*x56 + &
                    x112*x231*x58 + x112*x231*x59 - x112*x231*x8 - x114*x231*  &
                    x60 + x114*x231*x62 + x114*x231*x70 + x114*x231*x78 + x114*&
                    x231*x85 + x114*x231*x89 - x114*x231*x98 + x115*x116*x231  &
                     + x115*x118*x231 - x115*x167*x231 - x115*x175*x231 - x115*&
                    x191*x231 + x115*x193*x231 + x115*x194*x231 + x115*x201*   &
                    x231 + x115*x203*x231 - x115*x204*x231 - x115*x206*x231 +  &
                    x115*x212*x231 + x115*x214*x231 + x116*x122*x231 - x116*   &
                    x139*x231 - x116*x156*x231 + x116*x162*x231 + x116*x165*   &
                    x231 - x116*x231*x76 + x116*x231*x96 - x117*x231*x60 + x117&
                    *x231*x62 + x117*x231*x67 + x117*x231*x78 + x117*x231*x85  &
                     + x117*x231*x87 - x117*x231*x98 + x118*x120*x231 + x118*  &
                    x122*x231 - x118*x139*x231 - x118*x156*x231 + x118*x162*   &
                    x231 + x118*x163*x231 - x118*x231*x76 + x119*x231*x51 + x12&
                    *x231*x51 + x120*x121*x231 + x120*x127*x231 + x120*x129*   &
                    x231 - x120*x144*x231 - x120*x147*x231 - x120*x149*x231 -  &
                    x120*x175*x231 - x120*x191*x231 + x120*x192*x231 + x120*   &
                    x194*x231 + x120*x198*x231 + x120*x200*x231 + x120*x203*   &
                    x231 - x120*x204*x231 - x120*x206*x231 + x120*x212*x231 -  &
                    x120*x231*x77 + x121*x122*x231 + x122*x123*x231 + x122*x127&
                    *x231 + x122*x132*x231 - x122*x141*x231 - x122*x143*x231 - &
                    x122*x144*x231 - x122*x145*x231 - x122*x148*x231 - x122*   &
                    x149*x231 - x122*x175*x231 + x122*x193*x231 + x122*x194*   &
                    x231 + x122*x201*x231 + x122*x203*x231 - x122*x204*x231 -  &
                    x122*x206*x231 + x122*x212*x231 + x122*x214*x231 - x123*   &
                    x139*x231 + x124*x231*x78 - x124*x231*x98 - x125*x195*x231 &
                     + x125*x228*x231 - x126*x231*x48 + x126*x231*x56 + x126*  &
                    x231*x58 + x126*x231*x59 - x126*x231*x73 - x128*x181*x231  &
                     - x128*x182*x231 + x128*x229*x231 - x128*x231*x48 + x128* &
                    x231*x56 + x128*x231*x58 + x128*x231*x59 - x128*x231*x8 -  &
                    x129*x139*x231 - x129*x156*x231 + x129*x163*x231 + x129*   &
                    x165*x231 - x129*x231*x76 + x129*x231*x96 + x13*x231*x51 - &
                    x130*x231*x60 + x130*x231*x67 + x130*x231*x70 + x130*x231* &
                    x87 + x130*x231*x89 - x130*x231*x98 - x131*x183*x231 + x131&
                    *x231*x37 - x131*x231*x42 - x131*x231*x48 + x131*x231*x54  &
                     + x131*x231*x56 + x131*x231*x58 + x131*x231*x59 - x131*   &
                    x231*x93 - x132*x139*x231 - x133*x231*x76 + x133*x231*x96  &
                     - x134*x231*x98 - x135*x195*x231 - x135*x197*x231 + x135* &
                    x228*x231 + x136*x231*x29 + x136*x231*x43 - x137*x185*x231 &
                     - x137*x186*x231 + x137*x230*x231 - x137*x231*x48 + x137* &
                    x231*x56 + x137*x231*x58 + x137*x231*x59 - x137*x231*x8 -  &
                    x138*x183*x231 + x138*x231*x37 - x138*x231*x42 - x138*x231*&
                    x48 + x138*x231*x55 + x138*x231*x56 + x138*x231*x58 + x138*&
                    x231*x59 - x138*x231*x93 + x139*x141*x231 + x139*x143*x231 &
                     + x139*x144*x231 + x139*x145*x231 + x139*x147*x231 + x139*&
                    x148*x231 + x139*x149*x231 - x139*x192*x231 - x139*x194*   &
                    x231 - x139*x201*x231 - x139*x203*x231 - x139*x212*x231 +  &
                    x139*x231*x77 + x14*x231*x51 - x140*x231*x67 - x140*x231*  &
                    x70 + x140*x231*x98 - x142*x231*x62 - x142*x231*x70 - x142*&
                    x231*x78 + x142*x231*x98 + x143*x156*x231 - x143*x162*x231 &
                     - x143*x165*x231 + x145*x156*x231 - x145*x162*x231 + x146*&
                    x231*x8 + x15*x231*x51 + x150*x231*x42 + x150*x231*x48 +   &
                    x150*x231*x52 - x150*x231*x56 - x150*x231*x58 - x150*x231* &
                    x59 + x150*x231*x93 + x151*x231*x78 - x151*x231*x98 - x152*&
                    x231*x98 + x153*x231*x78 - x153*x231*x98 - x154*x231*x48 + &
                    x154*x231*x58 + x154*x231*x59 - x155*x183*x231 + x155*x231*&
                    x37 - x155*x231*x48 + x155*x231*x58 + x155*x231*x59 - x155*&
                    x231*x93 - x156*x192*x231 - x156*x193*x231 - x156*x194*x231&
                     - x156*x198*x231 - x156*x200*x231 - x156*x201*x231 - x156*&
                    x203*x231 - x156*x212*x231 - x156*x214*x231 - x157*x181*   &
                    x231 - x157*x182*x231 + x157*x229*x231 - x157*x231*x48 +   &
                    x157*x231*x56 + x157*x231*x58 + x157*x231*x59 - x157*x231* &
                    x8 - x158*x183*x231 + x158*x231*x37 - x158*x231*x42 - x158*&
                    x231*x48 + x158*x231*x54 + x158*x231*x56 + x158*x231*x58 + &
                    x158*x231*x59 - x158*x231*x93 - x159*x185*x231 - x159*x186*&
                    x231 + x159*x230*x231 - x159*x231*x48 + x159*x231*x56 +    &
                    x159*x231*x58 + x159*x231*x59 - x159*x231*x8 + x16*x231*x51&
                     - x160*x183*x231 + x160*x231*x37 - x160*x231*x42 - x160*  &
                    x231*x48 + x160*x231*x55 + x160*x231*x56 + x160*x231*x58 + &
                    x160*x231*x59 - x160*x231*x93 + x161*x231*x42 + x161*x231* &
                    x52 + x161*x231*x93 - x162*x175*x231 - x162*x191*x231 +    &
                    x162*x193*x231 + x162*x194*x231 + x162*x201*x231 + x162*   &
                    x203*x231 - x162*x204*x231 - x162*x206*x231 + x162*x212*   &
                    x231 + x162*x214*x231 - x162*x231*x77 - x163*x175*x231 -   &
                    x163*x191*x231 + x163*x192*x231 + x163*x194*x231 + x163*   &
                    x198*x231 + x163*x200*x231 + x163*x203*x231 - x163*x204*   &
                    x231 - x163*x206*x231 + x163*x212*x231 - x164*x183*x231 +  &
                    x164*x231*x37 - x164*x231*x42 - x164*x231*x48 + x164*x231* &
                    x54 + x164*x231*x56 + x164*x231*x58 + x164*x231*x59 - x164*&
                    x231*x93 - x165*x175*x231 + x165*x192*x231 + x165*x201*x231&
                     - x166*x183*x231 + x166*x231*x37 - x166*x231*x42 - x166*  &
                    x231*x48 + x166*x231*x55 + x166*x231*x56 + x166*x231*x58 + &
                    x166*x231*x59 - x166*x231*x93 - x167*x231*x96 - x168*x231* &
                    x67 - x168*x231*x70 - x169*x231*x29 - x169*x231*x43 - x169*&
                    x231*x45 + x17*x231*x51 - x170*x231*x51 + x171*x228*x231 - &
                    x173*x231*x62 - x173*x231*x70 + x174*x228*x231 - x175*x231*&
                    x96 - x176*x231*x62 - x176*x231*x67 - x176*x231*x70 - x176*&
                    x231*x78 - x176*x231*x85 - x176*x231*x87 - x176*x231*x89 + &
                    x18*x231*x51 - x180*x231*x67 - x180*x231*x70 - x182*x209*  &
                    x231 - x184*x231*x48 + x184*x231*x56 + x184*x231*x58 + x184&
                    *x231*x59 - x184*x231*x73 - x187*x231*x78 + x188*x228*x231 &
                     + x189*x225*x231 + x189*x228*x231 + x19*x231*x51 + x190*  &
                    x225*x231 + x190*x231*x51 - x191*x231*x96 - x192*x231*x76  &
                     + x192*x231*x96 - x193*x231*x76 - x194*x231*x76 - x195*   &
                    x231*x72 + x196*x231*x8 - x197*x231*x72 - x198*x231*x76 +  &
                    x199*x231*x26 - x199*x231*x28 - x199*x231*x34 - x199*x231* &
                    x35 - x2*x20*x231 + x2*x23*x231 + x2*x231*x25 - x2*x231*x26&
                     + x2*x231*x28 + x2*x231*x35 - x2*x231*x8 - x20*x231*x3 -  &
                    x20*x231*x4 - x20*x231*x5 - x20*x231*x6 + x20*x231*x7 -    &
                    x200*x231*x76 - x201*x231*x76 + x201*x231*x96 - x202*x231* &
                    x60 + x202*x231*x67 + x202*x231*x78 + x202*x231*x85 - x202*&
                    x231*x98 - x203*x231*x76 - x204*x231*x96 - x206*x231*x96 - &
                    x207*x231*x48 + x207*x231*x53 + x207*x231*x56 + x207*x231* &
                    x58 + x207*x231*x59 - x208*x231*x67 - x208*x231*x78 - x208*&
                    x231*x85 - x209*x231*x8 + x21*x22*x231 - x21*x231*x29 - x21&
                    *x231*x43 - x21*x231*x45 - x210*x231*x8 + x211*x231*x67 +  &
                    x211*x231*x78 + x211*x231*x85 - x211*x231*x98 + x213*x231* &
                    x26 - x213*x231*x28 - x213*x231*x34 - x213*x231*x35 + x215*&
                    x231*x26 - x215*x231*x28 - x215*x231*x34 - x215*x231*x35 - &
                    x216*x231*x48 + x216*x231*x53 + x216*x231*x56 + x216*x231* &
                    x58 + x216*x231*x59 - x217*x218*x231 + x217*x222*x231 +    &
                    x217*x224*x231 - x218*x223*x231 - x219*x220*x231 - x219*   &
                    x222*x231 - x219*x224*x231 - x22*x231*x31 + x22*x231*x40 + &
                    x220*x223*x231 + x221*x227*x231 + x222*x223*x231 + x226*   &
                    x231*x78 + x226*x231*x85 + x228*x231*x72 + x23*x231*x3 +   &
                    x23*x231*x5 + x23*x231*x6 - x23*x231*x7 + x231*x24*x3 +    &
                    x231*x24*x4 + x231*x24*x6 - x231*x24*x7 + x231*x25*x4 +    &
                    x231*x25*x5 + x231*x25*x6 - x231*x25*x7 + x231*x26*x27 -   &
                    x231*x26*x3 - x231*x26*x32 - x231*x26*x33 - x231*x26*x4 -  &
                    x231*x26*x49 - x231*x26*x5 + x231*x26*x50 - x231*x26*x6 +  &
                    x231*x26*x7 - x231*x27*x28 - x231*x27*x34 - x231*x27*x35 + &
                    x231*x27*x52 + x231*x28*x3 + x231*x28*x32 + x231*x28*x33 + &
                    x231*x28*x49 + x231*x28*x5 - x231*x28*x50 + x231*x28*x57 + &
                    x231*x28*x6 - x231*x28*x7 - x231*x28*x9 + x231*x29*x31 -   &
                    x231*x29*x40 + x231*x3*x34 + x231*x3*x35 - x231*x3*x8 +    &
                    x231*x30*x34 + x231*x30*x35 + x231*x30*x53 + x231*x32*x34  &
                     + x231*x32*x35 + x231*x32*x54 + x231*x33*x34 + x231*x33*  &
                    x35 + x231*x33*x55 + x231*x34*x4 + x231*x34*x49 - x231*x34*&
                    x50 + x231*x34*x6 - x231*x34*x7 - x231*x34*x9 + x231*x35*x4&
                     + x231*x35*x49 + x231*x35*x5 - x231*x35*x50 + x231*x35*x57&
                     + x231*x35*x6 - x231*x35*x7 - x231*x35*x9 + x231*x36*x37  &
                     - x231*x36*x42 - x231*x36*x48 + x231*x36*x53 + x231*x36*  &
                    x56 + x231*x36*x58 + x231*x36*x59 + x231*x37*x38 - x231*x37&
                    *x41 - x231*x38*x42 + x231*x38*x54 - x231*x39*x48 + x231*  &
                    x39*x55 + x231*x39*x58 - x231*x40*x43 - x231*x40*x45 + x231&
                    *x41*x42 + x231*x41*x52 + x231*x42*x91 + x231*x43*x44 -    &
                    x231*x43*x46 - x231*x43*x47 + x231*x44*x45 - x231*x45*x46  &
                     - x231*x45*x47 + x231*x48*x74 + x231*x48*x91 - x231*x5*x8 &
                     - x231*x51*x75 - x231*x51*x79 - x231*x51*x80 - x231*x51*  &
                    x82 + x231*x52*x91 - x231*x56*x74 - x231*x56*x91 - x231*x58&
                    *x74 - x231*x58*x91 - x231*x59*x74 - x231*x59*x91 - x231*x6&
                    *x8 + x231*x60*x61 + x231*x60*x64 + x231*x60*x66 + x231*x60&
                    *x68 + x231*x60*x69 + x231*x60*x71 + x231*x60*x81 + x231*  &
                    x60*x83 + x231*x60*x86 + x231*x60*x88 + x231*x60*x90 - x231&
                    *x60*x94 - x231*x61*x67 - x231*x61*x70 - x231*x61*x87 -    &
                    x231*x61*x89 + x231*x61*x98 + x231*x62*x63 + x231*x62*x65  &
                     - x231*x62*x66 - x231*x62*x68 - x231*x62*x69 - x231*x62*  &
                    x71 - x231*x62*x81 - x231*x62*x83 - x231*x62*x88 - x231*x62&
                    *x90 + x231*x62*x94 + x231*x62*x99 + x231*x63*x67 + x231*  &
                    x63*x70 + x231*x63*x85 + x231*x63*x87 + x231*x63*x89 - x231&
                    *x64*x67 - x231*x64*x70 + x231*x64*x98 + x231*x65*x67 +    &
                    x231*x65*x70 + x231*x65*x78 - x231*x66*x70 - x231*x67*x69  &
                     - x231*x67*x71 - x231*x67*x81 - x231*x67*x83 - x231*x67*  &
                    x86 - x231*x67*x90 + x231*x67*x95 + x231*x67*x99 - x231*x68&
                    *x70 - x231*x68*x78 + x231*x68*x98 - x231*x69*x78 - x231*  &
                    x69*x85 - x231*x69*x87 + x231*x69*x98 + x231*x7*x8 - x231* &
                    x70*x86 - x231*x70*x88 + x231*x70*x94 + x231*x70*x95 + x231&
                    *x70*x99 - x231*x71*x78 + x231*x71*x98 + x231*x73*x74 +    &
                    x231*x76*x77 - x231*x76*x97 - x231*x78*x83 - x231*x78*x88  &
                     - x231*x78*x90 + x231*x8*x84 + x231*x8*x9 + x231*x83*x98  &
                     + x231*x86*x98 + x231*x88*x98 + x231*x90*x98 + x231*x91*  &
                    x93 + x231*x96*x97
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x232 = co(5)*wl(mu,j)
            x233 = co(5)*w2(mu)
            x234 = co(1)*w2(1)*wl(mu,j)
            x235 = co(1)*w2(mu)*wl(1,j)
            x236 = co(3)*wl(mu,j)
            x237 = co(3)*w2(mu)*wl(1,j)
            x238 = co(1)*wl(mu,j)
            x239 = co(1)*w2(mu)
            x240 = co(3)*w2(mu)
            x241 = co(0)*w2(mu)
            x242 = co(4)*wl(mu,j)
            x243 = P2(3)*w2(mu)*wl(3,j)
            x244 = co(3)*w2(mu)*wl(3,j)
            x245 = P2(mu)*co(7)
            x246 = co(2)*w2(0)*wl(mu,j)
            x247 = co(2)*w2(mu)
            x248 = P4(mu)*co(9)
            x249 = co(2)*wl(mu,j)
            x250 = 2*co(2)*w2(1)*wl(mu,j)
            x251 = 2*co(2)*w2(mu)
            x252 = 2*co(2)*wl(mu,j)
            x253 = 2*P1(mu)
            x254 = 2*P2(mu)
            x255 = 2*P4(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + P1(1)*x231*x234 + P1(1)*x231*x235 + P1(&
                          1)*x231*x237 - P1(1)*x231*x250 + P2(1)*x231*x235 + P2&
                          (1)*x231*x237 + P2(3)*x231*x244 + 2*P3(0)*x231*x246  &
                           + P3(1)*x231*x234 + P3(1)*x231*x237 - P3(1)*x231*   &
                          x250 + P3(3)*x231*x244 - P3(mu)*x1*x231 + P3(mu)*x10*&
                          x231 + P3(mu)*x11*x231 + P3(mu)*x231*x48 - P3(mu)*   &
                          x231*x56 - P3(mu)*x231*x58 - P3(mu)*x231*x59 + P3(mu &
                          )*x231*x8 + P4(0)*x231*x246 - P4(1)*co(2)*w2(1)*wl(mu&
                          ,j)*x231 - P4(2)*w2(2)*x231*x249 - P4(2)*wl(2,j)*x231&
                          *x247 - co(0)*x231*x243 + co(1)*x231*x243 - x1*x231* &
                          x253 - x1*x231*x254 + x10*x231*x253 + x10*x231*x254  &
                           + x104*x231*x239 + x104*x231*x240 - x104*x231*x241  &
                           - x104*x231*x251 + x106*x231*x236 + x106*x231*x238  &
                           - x106*x231*x242 - x106*x231*x252 + x109*x231*x236  &
                           + x109*x231*x238 - x109*x231*x242 - x109*x231*x252  &
                           + x11*x231*x253 + x11*x231*x254 - x110*x231*x238 -  &
                          x115*x231*x233 - x115*x231*x251 - x120*x231*x233 +   &
                          x120*x231*x239 + x120*x231*x240 - x120*x231*x251 -   &
                          x122*x231*x241 - x122*x231*x251 - x139*x231*x239 -   &
                          x139*x231*x240 + x139*x231*x241 + x139*x231*x251 -   &
                          x156*x231*x240 + x156*x231*x251 - x162*x231*x251 +   &
                          x163*x231*x240 - x163*x231*x251 - x165*x231*x251 +   &
                          x20*x231*x253 - x217*x231*x247 + x219*x231*x247 + x22&
                          *x231*x245 - x22*x231*x248 - x223*x231*x247 - x227*  &
                          x231*x249 - x23*x231*x253 + x231*x232*x60 - x231*x232&
                          *x62 - x231*x232*x67 - x231*x232*x70 + x231*x233*x76 &
                           - x231*x233*x96 - x231*x236*x60 + x231*x236*x62 +   &
                          x231*x236*x67 + x231*x236*x70 + x231*x236*x78 - x231*&
                          x236*x98 - x231*x238*x60 + x231*x238*x67 + x231*x238*&
                          x70 + x231*x238*x78 + x231*x238*x87 + x231*x238*x89  &
                           - x231*x238*x98 - x231*x239*x76 + x231*x239*x96 -   &
                          x231*x24*x253 - x231*x240*x76 + x231*x240*x96 - x231*&
                          x242*x78 + x231*x242*x98 - x231*x243*x51 - x231*x245*&
                          x29 - x231*x245*x43 - x231*x245*x45 + x231*x248*x29  &
                           + x231*x248*x43 + x231*x248*x45 - x231*x25*x253 +   &
                          x231*x251*x76 - x231*x251*x96 + x231*x252*x60 - x231*&
                          x252*x67 - x231*x252*x70 - x231*x252*x78 - x231*x252*&
                          x87 - x231*x252*x89 + x231*x252*x98 + x231*x253*x26  &
                           - x231*x253*x28 - x231*x253*x34 - x231*x253*x35 +   &
                          x231*x253*x8 + x231*x254*x26 - x231*x254*x28 - x231* &
                          x254*x34 - x231*x254*x35 + x231*x254*x8 + x231*x255* &
                          x26 - x231*x255*x28 - x231*x255*x34 - x231*x255*x35
            if(rankInc .lt. 2) cycle
            do nu = 0, 3
              x256 = w2(nu)*wl(mu,j)
              riOut = incRI(nu, incRI(mu, j))
              wp(0,riOut) = wp(0,riOut) - co(1)*x231*x256 + co(5)*x231*x256 -  &
                            gg(nu,mu)*x1*x231 + gg(nu,mu)*x10*x231 + gg(nu,mu)*&
                            x11*x231 + gg(nu,mu)*x20*x231 - gg(nu,mu)*x23*x231 &
                             - gg(nu,mu)*x231*x24 - gg(nu,mu)*x231*x25 + gg(nu,&
                            mu)*x231*x26 - gg(nu,mu)*x231*x28 - gg(nu,mu)*x231*&
                            x34 - gg(nu,mu)*x231*x35 + gg(nu,mu)*x231*x8 - wl( &
                            nu,j)*x231*x240 + x231*x256*x51
            end do 
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVSSS
end module lcVVSSS
