!******************************************************************************!
!                                                                              !
!    lcVVVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec
  contains
    subroutine loopVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVVSS0)
!       Metric(1,2)*P(3,2)*c0
!       Metric(2,3)*P(1,3)*c1
!       Metric(2,3)*P(1,2)*c2
!       Metric(1,2)*P(3,1)*c3
!       Metric(1,3)*P(2,1)*c4
!       Metric(1,3)*P(2,3)*c5
        x1 = P1(0)*co(3)*w3(0)
        x5 = P1(0)*co(4)*w2(0)
        x9 = P1(1)*co(3)*w3(1)
        x11 = P1(1)*co(4)*w2(1)
        x12 = P1(2)*co(3)*w3(2)
        x13 = P1(2)*co(4)*w2(2)
        x14 = P1(3)*co(3)*w3(3)
        x15 = P1(3)*co(4)*w2(3)
        x16 = P2(0)*w3(0)
        x20 = w2(1)*w3(1)
        x22 = w2(2)*w3(2)
        x23 = w2(3)*w3(3)
        x25 = P2(1)*w3(1)
        x26 = w2(0)*w3(0)
        x28 = P2(2)*w3(2)
        x30 = P2(3)*w3(3)
        x33 = P3(0)*w2(0)
        x38 = P3(1)*w2(1)
        x41 = P3(2)*w2(2)
        x43 = P3(3)*w2(3)
        x46 = P1(3)*co(4)
        x48 = P2(1)*co(0)*w3(1)
        x52 = cima*w4(0)
        do j = riMaxIn, 0, -1
          x0 = w2(1)*wl(1,j)
          x2 = w2(2)*wl(2,j)
          x3 = w2(3)*wl(3,j)
          x4 = w3(1)*wl(1,j)
          x6 = w3(2)*wl(2,j)
          x7 = w3(3)*wl(3,j)
          x8 = w2(0)*wl(0,j)
          x10 = w3(0)*wl(0,j)
          x17 = co(0)*w2(1)*wl(1,j)
          x18 = co(0)*w2(2)*wl(2,j)
          x19 = co(0)*w2(3)*wl(3,j)
          x21 = P2(0)*co(2)*wl(0,j)
          x24 = co(0)*w2(0)*wl(0,j)
          x27 = P2(1)*co(2)*wl(1,j)
          x29 = P2(2)*co(2)*wl(2,j)
          x31 = P2(3)*co(2)*wl(3,j)
          x32 = P3(0)*co(1)*wl(0,j)
          x34 = co(5)*w3(1)*wl(1,j)
          x35 = co(5)*w3(2)*wl(2,j)
          x36 = co(5)*w3(3)*wl(3,j)
          x37 = P3(1)*co(1)*wl(1,j)
          x39 = co(5)*w3(0)*wl(0,j)
          x40 = P3(2)*co(1)*wl(2,j)
          x42 = P3(3)*co(1)*wl(3,j)
          x44 = P1(2)*w2(2)*w3(2)*wl(2,j)
          x45 = w2(3)*w3(3)*wl(3,j)
          x47 = w2(3)*w3(2)*wl(2,j)
          x49 = P2(2)*w2(2)*w3(2)*wl(2,j)
          x50 = P3(0)*w2(0)*w3(0)*wl(0,j)
          x51 = w2(1)*w3(1)*wl(1,j)
          wp(0,j) = -P1(0)*co(4)*w2(0)*w3(0)*wl(0,j)*x52 - P1(1)*co(4)*w2(1)*w3&
                    (1)*wl(1,j)*x52 - P1(3)*co(3)*x45*x52 - P2(3)*co(0)*x45*x52&
                     - P2(3)*co(2)*x45*x52 - P3(1)*co(1)*x51*x52 - P3(1)*co(5)*&
                    x51*x52 - P3(3)*co(1)*x45*x52 - P3(3)*co(5)*x47*x52 - co(0 &
                    )*x49*x52 - co(1)*w3(2)*wl(2,j)*x41*x52 - co(1)*x50*x52 -  &
                    co(2)*w2(0)*wl(0,j)*x16*x52 - co(2)*w2(1)*wl(1,j)*x25*x52  &
                     - co(2)*x49*x52 - co(3)*x44*x52 - co(4)*x44*x52 - co(5)*  &
                    x50*x52 + x0*x1*x52 - x0*x12*x52 - x0*x14*x52 - x0*x48*x52 &
                     - x0*x52*x9 + x1*x2*x52 + x1*x3*x52 - x1*x52*x8 + x10*x11*&
                    x52 + x10*x13*x52 + x10*x15*x52 - x11*x52*x6 - x11*x52*x7  &
                     - x12*x3*x52 + x12*x52*x8 - x13*x4*x52 - x13*x52*x7 - x14*&
                    x2*x52 + x14*x52*x8 - x15*x4*x52 + x16*x17*x52 + x16*x18*  &
                    x52 + x16*x19*x52 - x16*x24*x52 - x17*x28*x52 - x17*x30*x52&
                     - x18*x25*x52 - x18*x30*x52 - x19*x28*x52 - x2*x52*x9 +   &
                    x20*x21*x52 - x20*x29*x52 - x20*x31*x52 + x20*x32*x52 - x20&
                    *x40*x52 - x20*x42*x52 + x21*x22*x52 + x21*x23*x52 - x22*  &
                    x27*x52 - x22*x31*x52 + x22*x32*x52 - x22*x37*x52 - x22*x42&
                    *x52 - x23*x27*x52 - x23*x29*x52 + x23*x32*x52 - x23*x37*  &
                    x52 - x23*x40*x52 + x24*x25*x52 + x24*x28*x52 + x24*x30*x52&
                     + x26*x27*x52 + x26*x29*x52 + x26*x31*x52 + x26*x37*x52 + &
                    x26*x40*x52 + x26*x42*x52 - x3*x48*x52 - x3*x52*x9 + x33*  &
                    x34*x52 + x33*x35*x52 + x33*x36*x52 - x34*x41*x52 - x34*x43&
                    *x52 - x35*x38*x52 - x35*x41*x52 - x36*x38*x52 - x36*x41*  &
                    x52 - x36*x43*x52 + x38*x39*x52 + x39*x41*x52 + x39*x43*x52&
                     + x4*x5*x52 - x45*x46*x52 - x46*x47*x52 + x5*x52*x6 + x5* &
                    x52*x7 + x52*x8*x9
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x53 = co(3)*w3(mu)
            x54 = co(4)*w2(mu)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + x0*x52*x53 - x10*x52*x54 + x2*x52*x53  &
                           + x3*x52*x53 + x4*x52*x54 - x52*x53*x8 + x52*x54*x6 &
                           + x52*x54*x7
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVVSS
end module lcVVVSS
