!******************************************************************************!
!                                                                              !
!    modelintegrals.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   modelintegrals.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module modelintegrals
  use constants_mdl, only: dp
  implicit none
  complex(dp) :: Ten38, Ten47, Ten39, Ten46, Ten14, Ten15, Ten16, Ten17, Ten10 &
                 , Ten11, Ten12, Ten13, Ten36, Ten37, Ten34, Ten35, Ten18,     &
                 Ten19, Ten30, Ten31, Ten58, Ten59, Ten50, Ten32, Ten52, Ten53 &
                 , Ten54, Ten55, Ten56, Ten33, Ten51, Ten45, Ten8, Ten9, Ten6, &
                 Ten7, Ten4, Ten5, Ten2, Ten3, Ten0, Ten1, Ten29, Ten28, Ten21 &
                 , Ten20, Ten23, Ten22, Ten25, Ten24, Ten27, Ten26, Ten49,     &
                 Ten48, Ten57, Ten43, Ten64, Ten41, Ten40, Ten61, Ten60, Ten63 &
                 , Ten44, Ten42, Ten62
  contains
  subroutine set_modelintegrals(reset_collier)
    use input_mdl, only: init_si
    use scalar_functions
    logical, intent(in) :: reset_collier

    if (init_si) call init_scalar_functions(reset_collier)
!   Precomputation of scalar integrals
    Ten42 = DB0(cMD2_reg, cnul, cMD2_reg)
    Ten29 = DB00(cnul, cMS2_reg, cMS2_reg)
    Ten27 = DB00(cnul, cMC2_reg, cMC2_reg)
    Ten41 = B1(cMD2_reg, cnul, cMD2_reg)
    Ten43 = DB1(cMD2_reg, cnul, cMD2_reg)
    Ten31 = HT(cMU2_reg, cMU2_reg)
    Ten30 = DB00(cnul, cMB2_reg, cMB2_reg)
    Ten33 = HT(cMD2_reg, cMD2_reg)
    Ten32 = HT(cMC2_reg, cMC2_reg)
    Ten35 = HT(cMB2_reg, cMB2_reg)
    Ten34 = HT(cMS2_reg, cMS2_reg)
    Ten19 = B00(cnul, cMS2_reg, cMS2_reg)
    Ten36 = B0(cMU2_reg, cnul, cMU2_reg)
    Ten39 = DB1(cMU2_reg, cnul, cMU2_reg)
    Ten38 = DB0(cMU2_reg, cnul, cMU2_reg)
    Ten15 = B0(cnul, cMB2_reg, cMB2_reg)
    Ten14 = B0(cnul, cMS2_reg, cMS2_reg)
    Ten13 = B0(cnul, cMD2_reg, cMD2_reg)
    Ten12 = B0(cnul, cMC2_reg, cMC2_reg)
    Ten11 = B0(cnul, cMU2_reg, cMU2_reg)
    Ten10 = B11(cnul, cMB2_reg, cMB2_reg)
    Ten59 = DB1(rMB2, cnul, cMB2_reg)
    Ten58 = DB0(rMB2, cnul, cMB2_reg)
    Ten53 = B1(cMS2_reg, cnul, cMS2_reg)
    Ten52 = B0(cMS2_reg, cnul, cMS2_reg)
    Ten51 = DB1(cMC2_reg, cnul, cMC2_reg)
    Ten50 = DB0(cMC2_reg, cnul, cMC2_reg)
    Ten57 = B1(rMB2, cnul, cMB2_reg)
    Ten56 = B0(rMB2, cnul, cMB2_reg)
    Ten55 = DB1(cMS2_reg, cnul, cMS2_reg)
    Ten54 = DB0(cMS2_reg, cnul, cMS2_reg)
    Ten44 = B0(rMC2, cnul, cMC2_reg)
    Ten40 = B0(cMD2_reg, cnul, cMD2_reg)
    Ten23 = DB0(cnul, cMD2_reg, cMD2_reg)
    Ten21 = DB0(cnul, cMU2_reg, cMU2_reg)
    Ten20 = B00(cnul, cMB2_reg, cMB2_reg)
    Ten9 = B11(cnul, cMS2_reg, cMS2_reg)
    Ten8 = B11(cnul, cMD2_reg, cMD2_reg)
    Ten3 = B1(cnul, cMD2_reg, cMD2_reg)
    Ten2 = B1(cnul, cMC2_reg, cMC2_reg)
    Ten1 = B1(cnul, cMU2_reg, cMU2_reg)
    Ten0 = B0(cnul, cnul, cnul)
    Ten7 = B11(cnul, cMC2_reg, cMC2_reg)
    Ten6 = B11(cnul, cMU2_reg, cMU2_reg)
    Ten5 = B1(cnul, cMB2_reg, cMB2_reg)
    Ten4 = B1(cnul, cMS2_reg, cMS2_reg)
    Ten22 = DB0(cnul, cMC2_reg, cMC2_reg)
    Ten45 = B1(rMC2, cnul, cMC2_reg)
    Ten46 = DB0(rMC2, cnul, cMC2_reg)
    Ten47 = DB1(rMC2, cnul, cMC2_reg)
    Ten26 = DB00(cnul, cMU2_reg, cMU2_reg)
    Ten37 = B1(cMU2_reg, cnul, cMU2_reg)
    Ten24 = DB0(cnul, cMS2_reg, cMS2_reg)
    Ten25 = DB0(cnul, cMB2_reg, cMB2_reg)
    Ten28 = DB00(cnul, cMD2_reg, cMD2_reg)
    Ten18 = B00(cnul, cMD2_reg, cMD2_reg)
    Ten48 = B0(cMC2_reg, cnul, cMC2_reg)
    Ten49 = B1(cMC2_reg, cnul, cMC2_reg)
    Ten17 = B00(cnul, cMC2_reg, cMC2_reg)
    Ten16 = B00(cnul, cMU2_reg, cMU2_reg)
    Ten64 = B0(cnul, cMB2_reg, cMB2_reg)
    Ten62 = DB0(cMB2_reg, cnul, cMB2_reg)
    Ten63 = DB1(cMB2_reg, cnul, cMB2_reg)
    Ten60 = B0(cMB2_reg, cnul, cMB2_reg)
    Ten61 = B1(cMB2_reg, cnul, cMB2_reg)

  end subroutine set_modelintegrals

end module modelintegrals
