!******************************************************************************!
!                                                                              !
!    tcFSFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFSFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FSFa0)
!       c0*(GammaP(-1,3,1)*P(-1,2)/2 + GammaP(-1,3,1)*P(-1,3))
!       c1*(GammaM(-1,3,1)*P(-1,2)/2 + GammaM(-1,3,1)*P(-1,3))
!       ProjP(3,1)*c2
!       ProjM(3,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(0)*w1(1)
      x1 = pl(3)*w1(0)
      x2 = x0 + x1
      x3 = P1(1)*co(0)
      x4 = pl(0)*w1(0)
      x5 = pl(3)*w1(1)
      x6 = x4 - x5
      x7 = P1(3)*co(0)
      x8 = pl(0)*w1(2)
      x9 = pl(3)*w1(3)
      x10 = P2(1)*co(0)/2
      x11 = P2(3)*co(0)/2
      x12 = x4 + x5
      x13 = P1(0)*co(0)
      x14 = co(2)*m
      x15 = P2(0)*co(0)/2
      x16 = P1(0)*co(1)
      x17 = m*w1(2)
      x18 = P1(1)*co(1)
      x19 = m*w1(3)
      x20 = P1(3)*co(1)
      x21 = P2(0)*co(1)/2
      x22 = P2(1)*co(1)/2
      x23 = P2(3)*co(1)/2
      x24 = x0 - x1
      x25 = P1(2)*cima*co(0)
      x26 = P2(2)*cima*co(0)/2
      x27 = P1(2)*cima*co(1)
      x28 = P2(2)*cima*co(1)/2
      x29 = pl(1)*w1(0)
      x30 = pl(2)*w1(1)
      x31 = x29 + x30
      x32 = pl(1)*w1(3)
      x33 = pl(2)*w1(2)
      x34 = pl(1)*w1(1)
      x35 = pl(2)*w1(0)
      x36 = x34 + x35
      x37 = x34 - x35
      x38 = x29 - x30
      x39 = pl(1)*w1(2)
      x40 = x39 - x9
      x41 = pl(3)*w1(2)
      x42 = x32 - x41
      x43 = x39 + x9
      x44 = co(3)*m
      x45 = m*w1(1)
      x46 = m*w1(0)
      x47 = x32 + x41
      x48 = pl(0)*w1(3)
      x49 = -x33 + x48
      x50 = pl(2)*w1(3)
      x51 = -x50 + x8
      x52 = x33 + x48
      x53 = x50 + x8
      wout(0) = -w2(0)*(co(3)*x8 + co(3)*x9 - w1(0)*x14 + x10*x2 + x11*x6 - x12&
                *x13 - x12*x15 + x16*x17 + x17*x20 + x17*x21 + x17*x23 + x18*  &
                x19 + x19*x22 - x19*x27 - x19*x28 + x2*x3 - x24*x25 - x24*x26  &
                 + x6*x7)
      wout(1) = -w2(0)*(co(3)*x32 + co(3)*x33 - w1(1)*x14 + x10*x31 - x11*x37  &
                 - x13*x36 - x15*x36 + x16*x19 + x17*x18 + x17*x22 + x17*x27 + &
                x17*x28 - x19*x20 + x19*x21 - x19*x23 + x25*x38 + x26*x38 + x3*&
                x31 - x37*x7)
      wout(2) = w2(0)*(-co(2)*x29 + co(2)*x5 + w1(2)*x44 + x10*x45 + x11*x46 - &
                x13*x46 - x15*x46 + x16*x40 + x18*x42 + x20*x43 + x21*x40 + x22&
                *x42 + x23*x43 - x25*x45 - x26*x45 - x27*x47 - x28*x47 + x3*x45&
                 + x46*x7)
      wout(3) = w2(0)*(-co(2)*x0 + co(2)*x35 + w1(3)*x44 + x10*x46 - x11*x45 - &
                x13*x45 - x15*x45 + x16*x49 + x18*x51 - x20*x52 + x21*x49 + x22&
                *x51 - x23*x52 + x25*x46 + x26*x46 + x27*x53 + x28*x53 + x3*x46&
                 - x45*x7)
    else
      x0 = co(1)*w1(2)
      x1 = co(1)*w1(3)
      x2 = P2(0)/2
      x3 = P2(1)/2
      x4 = P2(3)/2
      x5 = P1(2)*cima
      x6 = P2(2)*cima/2
      x7 = co(0)*w1(1)
      x8 = co(0)*w1(0)
      wout(0) = -w2(0)*(P1(0)*x0 + P1(1)*x1 + P1(3)*x0 - co(2)*w1(0) + x0*x2 + &
                x0*x4 + x1*x3 - x1*x5 - x1*x6)
      wout(1) = -w2(0)*(P1(0)*x1 + P1(1)*x0 - P1(3)*x1 - co(2)*w1(1) + x0*x3 + &
                x0*x5 + x0*x6 + x1*x2 - x1*x4)
      wout(2) = w2(0)*(-P1(0)*x8 + P1(1)*x7 + P1(3)*x8 + co(3)*w1(2) - x2*x8 + &
                x3*x7 + x4*x8 - x5*x7 - x6*x7)
      wout(3) = w2(0)*(-P1(0)*x7 + P1(1)*x8 - P1(3)*x7 + co(3)*w1(3) - x2*x7 + &
                x3*x8 - x4*x7 + x5*x8 + x6*x8)
    end if 
      end select 
    end subroutine treeFSFa
end module tcFSFa
