!******************************************************************************!
!                                                                              !
!    tcFaF.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaF.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeFaF(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaF0)
!       GammaP(-1,1,2)*P(-1,2)*c0
!       GammaM(-1,1,2)*P(-1,2)*c1
!       ProjP(1,2)*c2
!       ProjM(1,2)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = co(2)*m
      x1 = pl(1)*w1(2)
      x2 = pl(1)*w1(0)
      x3 = pl(2)*w1(1)
      x4 = P1(0)*co(1)
      x5 = pl(1)*w1(1)
      x6 = pl(2)*w1(0)
      x7 = P1(1)*co(1)
      x8 = P1(3)*co(1)
      x9 = pl(2)*w1(3)
      x10 = P1(1)*co(0)
      x11 = m*w1(3)
      x12 = P1(3)*co(0)
      x13 = m*w1(2)
      x14 = P1(0)*co(0)
      x15 = P1(2)*cima*co(1)
      x16 = P1(2)*cima*co(0)
      x17 = pl(0)*w1(1)
      x18 = pl(3)*w1(0)
      x19 = pl(0)*w1(3)
      x20 = pl(0)*w1(0)
      x21 = pl(3)*w1(1)
      x22 = pl(3)*w1(2)
      x23 = pl(2)*w1(2)
      x24 = pl(0)*w1(2)
      x25 = co(3)*m
      x26 = m*w1(0)
      x27 = m*w1(1)
      x28 = pl(3)*w1(3)
      x29 = pl(1)*w1(3)
      wout(0) = co(3)*x1 - co(3)*x9 + w1(0)*x0 + x10*x11 + x11*x16 + x12*x13 - &
                x13*x14 - x15*(x5 + x6) - x4*(x2 - x3) - x7*(x5 - x6) - x8*(x2 &
                 + x3)
      wout(1) = co(3)*x19 - co(3)*x22 + w1(1)*x0 + x10*x13 - x11*x12 - x11*x14 &
                 - x13*x16 + x15*(x20 + x21) - x4*(x17 - x18) - x7*(x20 - x21  &
                ) + x8*(x17 + x18)
      wout(2) = co(2)*x20 + co(2)*x3 + w1(2)*x25 + x10*(x19 + x23) + x12*(x24  &
                 - x9) - x14*(x24 + x9) - x15*x27 + x16*(x19 - x23) - x26*x4 - &
                x26*x8 - x27*x7
      wout(3) = co(2)*x18 + co(2)*x5 + w1(3)*x25 + x10*(x1 + x28) - x12*(-x22  &
                 + x29) - x14*(x22 + x29) + x15*x26 - x16*(x1 - x28) - x26*x7  &
                 - x27*x4 + x27*x8
    else
      x0 = co(0)*w1(3)
      x1 = co(0)*w1(2)
      x2 = P1(2)*cima
      x3 = co(1)*w1(0)
      x4 = co(1)*w1(1)
      wout(0) = -P1(0)*x1 + P1(1)*x0 + P1(3)*x1 + co(2)*w1(0) + x0*x2
      wout(1) = -P1(0)*x0 + P1(1)*x1 - P1(3)*x0 + co(2)*w1(1) - x1*x2
      wout(2) = -P1(0)*x3 - P1(1)*x4 - P1(3)*x3 + co(3)*w1(2) - x2*x4
      wout(3) = -P1(0)*x4 - P1(1)*x3 + P1(3)*x4 + co(3)*w1(3) + x2*x3
    end if 
      end select 
    end subroutine treeFaF
end module tcFaF
