!******************************************************************************!
!                                                                              !
!    tcSFSFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFSFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFSFa0)
!       c0*(GammaP(-1,4,2)*P(-1,1) + GammaP(-1,4,2)*P(-1,2)/2 + GammaP(-1,4,2)*P 
!       (-1,3))
!       c1*(GammaM(-1,4,2)*P(-1,1) + GammaM(-1,4,2)*P(-1,2)/2 + GammaM(-1,4,2)*P 
!       (-1,3))
!       ProjP(4,2)*c2
!       ProjM(4,2)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(0)*w2(1)
      x1 = pl(3)*w2(0)
      x2 = x0 + x1
      x3 = P1(1)*co(0)
      x4 = pl(0)*w2(0)
      x5 = pl(3)*w2(1)
      x6 = co(0)*(x4 - x5)
      x7 = P3(1)*co(0)
      x8 = co(2)*m
      x9 = P2(1)*co(0)/2
      x10 = P2(3)/2
      x11 = co(0)*(x4 + x5)
      x12 = pl(0)*w2(2)
      x13 = pl(3)*w2(3)
      x14 = P2(0)/2
      x15 = P1(0)*co(1)*m
      x16 = P1(1)*co(1)*m
      x17 = P1(3)*co(1)
      x18 = m*w2(2)
      x19 = P3(0)*co(1)*m
      x20 = P3(1)*co(1)*m
      x21 = P3(3)*co(1)
      x22 = P2(0)*co(1)*m/2
      x23 = P2(1)*co(1)*m/2
      x24 = P2(3)*co(1)/2
      x25 = x0 - x1
      x26 = P1(2)*cima*co(0)
      x27 = P3(2)*cima*co(0)
      x28 = P2(2)*cima*co(0)/2
      x29 = P1(2)*cima*co(1)
      x30 = m*w2(3)
      x31 = P3(2)*cima*co(1)
      x32 = P2(2)*cima*co(1)/2
      x33 = w1(0)*w3(0)
      x34 = pl(1)*w2(0)
      x35 = pl(2)*w2(1)
      x36 = x34 + x35
      x37 = pl(1)*w2(1)
      x38 = pl(2)*w2(0)
      x39 = co(0)*(x37 + x38)
      x40 = co(0)*(x37 - x38)
      x41 = pl(1)*w2(3)
      x42 = pl(2)*w2(2)
      x43 = x34 - x35
      x44 = pl(1)*w2(2)
      x45 = co(1)*(-x13 + x44)
      x46 = pl(3)*w2(2)
      x47 = co(1)*(x41 - x46)
      x48 = x13 + x44
      x49 = P2(1)/2
      x50 = co(3)*m
      x51 = m*w2(1)
      x52 = co(0)*m*w2(0)
      x53 = x41 + x46
      x54 = P3(0)*m
      x55 = cima*co(0)*m*w2(1)
      x56 = pl(0)*w2(3)
      x57 = co(1)*(-x42 + x56)
      x58 = pl(2)*w2(3)
      x59 = co(1)*(x12 - x58)
      x60 = x42 + x56
      x61 = m*w2(0)
      x62 = x12 + x58
      x63 = co(0)*m*w2(1)
      wout(0) = x33*(-P1(0)*x11 + P1(3)*x6 - P3(0)*x11 + P3(3)*x6 - co(3)*x12  &
                 - co(3)*x13 + w2(0)*x8 + w2(2)*x15 + w2(2)*x19 + w2(2)*x22 +  &
                w2(3)*x16 + w2(3)*x20 + w2(3)*x23 + x10*x6 - x11*x14 + x17*x18 &
                 + x18*x21 + x18*x24 + x2*x3 + x2*x7 + x2*x9 - x25*x26 - x25*  &
                x27 - x25*x28 - x29*x30 - x30*x31 - x30*x32)
      wout(1) = x33*(-P1(0)*x39 - P1(3)*x40 - P3(0)*x39 - P3(3)*x40 - co(3)*x41&
                 - co(3)*x42 + w2(1)*x8 + w2(2)*x16 + w2(2)*x20 + w2(2)*x23 +  &
                w2(3)*x15 + w2(3)*x19 + w2(3)*x22 - x10*x40 - x14*x39 - x17*x30&
                 + x18*x29 + x18*x31 + x18*x32 - x21*x30 - x24*x30 + x26*x43 + &
                x27*x43 + x28*x43 + x3*x36 + x36*x7 + x36*x9)
      wout(2) = -x33*(P1(0)*x45 - P1(0)*x52 + P1(1)*x47 - P1(2)*x55 + P1(3)*x52&
                 - P2(2)*x55/2 + P3(0)*x45 + P3(1)*x47 - P3(2)*x55 + P3(3)*x52 &
                 - co(0)*w2(0)*x54 + co(2)*x34 - co(2)*x5 - w2(2)*x50 + x10*x52&
                 + x14*x45 - x14*x52 + x17*x48 + x21*x48 + x24*x48 - x29*x53 + &
                x3*x51 - x31*x53 - x32*x53 + x47*x49 + x51*x7 + x51*x9)
      wout(3) = -x33*(P1(0)*x57 - P1(0)*x63 + P1(1)*x59 - P1(3)*x63 + P3(0)*x57&
                 + P3(1)*x59 - P3(3)*x63 - co(0)*w2(1)*x54 + co(2)*x0 - co(2)* &
                x38 - w2(3)*x50 - x10*x63 + x14*x57 - x14*x63 - x17*x60 - x21* &
                x60 - x24*x60 + x26*x61 + x27*x61 + x28*x61 + x29*x62 + x3*x61 &
                 + x31*x62 + x32*x62 + x49*x59 + x61*x7 + x61*x9)
    else
      x0 = co(1)*w2(2)
      x1 = co(1)*w2(3)
      x2 = P2(0)/2
      x3 = P2(1)/2
      x4 = P2(3)/2
      x5 = P1(2)*cima
      x6 = P3(2)*cima
      x7 = P2(2)*cima/2
      x8 = w1(0)*w3(0)
      x9 = co(0)*w2(0)
      x10 = co(0)*w2(0)/2
      x11 = co(0)*w2(1)
      wout(0) = x8*(P1(0)*x0 + P1(1)*x1 + P1(3)*x0 + P3(0)*x0 + P3(1)*x1 + P3(3&
                )*x0 + co(2)*w2(0) + x0*x2 + x0*x4 + x1*x3 - x1*x5 - x1*x6 - x1&
                *x7)
      wout(1) = x8*(P1(0)*x1 + P1(1)*x0 - P1(3)*x1 + P3(0)*x1 + P3(1)*x0 - P3(3&
                )*x1 + co(2)*w2(1) + x0*x3 + x0*x5 + x0*x6 + x0*x7 + x1*x2 - x1&
                *x4)
      wout(2) = x8*(P1(0)*x9 - P1(1)*x11 - P1(3)*x9 + P2(0)*x10 - P2(3)*x10 +  &
                P3(0)*x9 - P3(1)*x11 - P3(3)*x9 + co(3)*w2(2) - x11*x3 + x11*x5&
                 + x11*x6 + x11*x7)
      wout(3) = x8*(P1(0)*x11 - P1(1)*x9 + P1(3)*x11 - P2(2)*cima*x10 + P3(0)* &
                x11 - P3(1)*x9 + P3(3)*x11 + co(3)*w2(3) + x11*x2 + x11*x4 - x3&
                *x9 - x5*x9 - x6*x9)
    end if 
      end select 
    end subroutine treeSFSFa
end module tcSFSFa
