!******************************************************************************!
!                                                                              !
!    tcSFaSF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFaSF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFaSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSFaSF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFaSF0)
!       c0*(GammaP(-1,2,4)*P(-1,1) + GammaP(-1,2,4)*P(-1,3) + GammaP(-1,2,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,2,4)*P(-1,1) + GammaM(-1,2,4)*P(-1,3) + GammaM(-1,2,4)*P(-1
!       ,4)/2)
!       ProjP(2,4)*c2
!       ProjM(2,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = co(2)*m
      x1 = pl(1)*w2(2)
      x2 = pl(1)*w2(0)
      x3 = pl(2)*w2(1)
      x4 = co(1)*(x2 - x3)/2
      x5 = pl(1)*w2(1)
      x6 = pl(2)*w2(0)
      x7 = co(1)*(x5 - x6)/2
      x8 = x2 + x3
      x9 = co(1)*x8/2
      x10 = P3(3)*co(1)/2
      x11 = pl(2)*w2(3)
      x12 = co(0)*m*w2(2)/2
      x13 = co(1)*(x5 + x6)/2
      x14 = P1(2)*cima
      x15 = co(0)*m*w2(3)/2
      x16 = P3(2)*cima
      x17 = P2(2)*cima
      x18 = w1(0)*w3(0)
      x19 = pl(0)*w2(3)
      x20 = pl(0)*w2(1)
      x21 = pl(3)*w2(0)
      x22 = co(1)*(x20 - x21)/2
      x23 = pl(0)*w2(0)
      x24 = pl(3)*w2(1)
      x25 = co(1)*(x23 - x24)/2
      x26 = x20 + x21
      x27 = co(1)*x26/2
      x28 = pl(3)*w2(2)
      x29 = co(1)*(x23 + x24)/2
      x30 = co(3)*m
      x31 = pl(0)*w2(2)
      x32 = co(0)*(x11 + x31)/2
      x33 = pl(2)*w2(2)
      x34 = co(0)*(x19 + x33)/2
      x35 = co(0)*(-x11 + x31)/2
      x36 = co(1)*m*w2(0)/2
      x37 = co(1)*m*w2(1)/2
      x38 = cima*co(0)*(x19 - x33)/2
      x39 = P3(3)*co(1)*m/2
      x40 = pl(1)*w2(3)
      x41 = co(0)*(x28 + x40)/2
      x42 = co(0)*(-x28 + x40)/2
      x43 = pl(3)*w2(3)
      x44 = co(0)*(x1 + x43)/2
      x45 = co(0)*(x1 - x43)/2
      wout(0) = x18*(P1(0)*x12 + P1(0)*x4 - P1(1)*x15 + P1(1)*x7 - P1(3)*x12 + &
                P1(3)*x9 - P2(0)*x12 - P2(0)*x4 + P2(1)*x15 - P2(1)*x7 + P2(3)*&
                x12 - P2(3)*x9 + P3(0)*x12 + P3(0)*x4 - P3(1)*x15 + P3(1)*x7 - &
                P3(3)*x12 + co(3)*x1 - co(3)*x11 + w2(0)*x0 + x10*x8 + x13*x14 &
                 + x13*x16 - x13*x17 - x14*x15 - x15*x16 + x15*x17)
      wout(1) = x18*(P1(0)*x15 + P1(0)*x22 - P1(1)*x12 + P1(1)*x25 + P1(3)*x15 &
                 - P1(3)*x27 - P2(0)*x15 - P2(0)*x22 + P2(1)*x12 - P2(1)*x25 - &
                P2(3)*x15 + P2(3)*x27 + P3(0)*x15 + P3(0)*x22 - P3(1)*x12 + P3(&
                1)*x25 + P3(3)*x15 + co(3)*x19 - co(3)*x28 + w2(1)*x0 - x10*x26&
                 + x12*x14 + x12*x16 - x12*x17 - x14*x29 - x16*x29 + x17*x29)
      wout(2) = x18*(P1(0)*x32 + P1(0)*x36 - P1(1)*x34 + P1(1)*x37 - P1(2)*x38 &
                 - P1(3)*x35 + P1(3)*x36 - P2(0)*x32 - P2(0)*x36 + P2(1)*x34 - &
                P2(1)*x37 + P2(2)*x38 + P2(3)*x35 - P2(3)*x36 + P3(0)*x32 + P3(&
                0)*x36 - P3(1)*x34 + P3(1)*x37 - P3(2)*x38 - P3(3)*x35 + co(2)*&
                x23 + co(2)*x3 + w2(0)*x39 + w2(2)*x30 + x14*x37 + x16*x37 -   &
                x17*x37)
      wout(3) = x18*(P1(0)*x37 + P1(0)*x41 + P1(1)*x36 - P1(1)*x44 - P1(3)*x37 &
                 + P1(3)*x42 - P2(0)*x37 - P2(0)*x41 - P2(1)*x36 + P2(1)*x44 + &
                P2(3)*x37 - P2(3)*x42 + P3(0)*x37 + P3(0)*x41 + P3(1)*x36 - P3(&
                1)*x44 + P3(3)*x42 + co(2)*x21 + co(2)*x5 - w2(1)*x39 + w2(3)* &
                x30 - x14*x36 + x14*x45 - x16*x36 + x16*x45 + x17*x36 - x17*x45&
                )
    else
      x0 = co(0)*w2(3)/2
      x1 = co(0)*w2(2)/2
      x2 = cima*co(0)*w2(3)/2
      x3 = w1(0)*w3(0)
      x4 = cima*co(0)*w2(2)/2
      x5 = co(1)*w2(0)/2
      x6 = co(1)*w2(1)/2
      x7 = cima*co(1)*w2(1)/2
      x8 = cima*co(1)*w2(0)/2
      wout(0) = -x3*(-P1(0)*x1 + P1(1)*x0 + P1(2)*x2 + P1(3)*x1 + P2(0)*x1 - P2&
                (1)*x0 - P2(2)*x2 - P2(3)*x1 - P3(0)*x1 + P3(1)*x0 + P3(2)*x2  &
                 + P3(3)*x1 - co(2)*w2(0))
      wout(1) = x3*(P1(0)*x0 - P1(1)*x1 + P1(2)*x4 + P1(3)*x0 - P2(0)*x0 + P2(1&
                )*x1 - P2(2)*x4 - P2(3)*x0 + P3(0)*x0 - P3(1)*x1 + P3(2)*x4 +  &
                P3(3)*x0 + co(2)*w2(1))
      wout(2) = x3*(P1(0)*x5 + P1(1)*x6 + P1(2)*x7 + P1(3)*x5 - P2(0)*x5 - P2(1&
                )*x6 - P2(2)*x7 - P2(3)*x5 + P3(0)*x5 + P3(1)*x6 + P3(2)*x7 +  &
                P3(3)*x5 + co(3)*w2(2))
      wout(3) = x3*(P1(0)*x6 + P1(1)*x5 - P1(2)*x8 - P1(3)*x6 - P2(0)*x6 - P2(1&
                )*x5 + P2(2)*x8 + P2(3)*x6 + P3(0)*x6 + P3(1)*x5 - P3(2)*x8 -  &
                P3(3)*x6 + co(3)*w2(3))
    end if 
      end select 
    end subroutine treeSFaSF
end module tcSFaSF
