!******************************************************************************!
!                                                                              !
!    tcSSFaF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFaF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFaF0)
!       c0*(GammaP(-1,3,4)*P(-1,1) + GammaP(-1,3,4)*P(-1,2) + GammaP(-1,3,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,3,4)*P(-1,1) + GammaM(-1,3,4)*P(-1,2) + GammaM(-1,3,4)*P(-1
!       ,4)/2)
!       ProjP(3,4)*c2
!       ProjM(3,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = co(2)*m
      x1 = pl(1)*w3(2)
      x2 = pl(1)*w3(0)
      x3 = pl(2)*w3(1)
      x4 = co(1)*(x2 - x3)/2
      x5 = pl(1)*w3(1)
      x6 = pl(2)*w3(0)
      x7 = x5 - x6
      x8 = P1(1)*co(1)/2
      x9 = x2 + x3
      x10 = P1(3)*co(1)/2
      x11 = P2(1)*co(1)/2
      x12 = co(1)*x9/2
      x13 = pl(2)*w3(3)
      x14 = P3(1)*co(1)/2
      x15 = co(0)*m*w3(2)/2
      x16 = x5 + x6
      x17 = co(1)*x16/2
      x18 = P1(2)*cima
      x19 = P2(2)*cima
      x20 = co(0)*m*w3(3)/2
      x21 = P2(3)*co(0)*m/2
      x22 = P3(2)*cima*co(1)/2
      x23 = P3(2)*cima
      x24 = w1(0)*w2(0)
      x25 = pl(0)*w3(3)
      x26 = pl(0)*w3(1)
      x27 = pl(3)*w3(0)
      x28 = co(1)*(x26 - x27)/2
      x29 = pl(0)*w3(0)
      x30 = pl(3)*w3(1)
      x31 = x29 - x30
      x32 = x26 + x27
      x33 = co(1)*x32/2
      x34 = pl(3)*w3(2)
      x35 = x29 + x30
      x36 = co(1)*x35/2
      x37 = co(3)*m
      x38 = pl(0)*w3(2)
      x39 = co(0)*(x13 + x38)/2
      x40 = pl(2)*w3(2)
      x41 = co(0)*(x25 + x40)/2
      x42 = -x13 + x38
      x43 = co(0)*x42/2
      x44 = P2(3)*co(0)/2
      x45 = co(1)*m*w3(0)/2
      x46 = m*w3(1)
      x47 = m*w3(0)
      x48 = x25 - x40
      x49 = co(0)*x48/2
      x50 = P2(2)*cima*co(0)/2
      x51 = co(1)*m*w3(1)/2
      x52 = pl(1)*w3(3)
      x53 = co(0)*(x34 + x52)/2
      x54 = -x34 + x52
      x55 = co(0)*x54/2
      x56 = pl(3)*w3(3)
      x57 = co(0)*(x1 + x56)/2
      x58 = x1 - x56
      x59 = co(0)*x58/2
      wout(0) = x24*(P1(0)*x15 + P1(0)*x4 - P1(1)*x20 - P1(3)*x15 + P2(0)*x15  &
                 + P2(0)*x4 - P2(1)*x20 + P2(3)*x12 - P3(0)*x15 - P3(0)*x4 + P3&
                (1)*x20 - P3(3)*x12 + P3(3)*x15 + co(3)*x1 - co(3)*x13 + w3(0)*&
                x0 - w3(2)*x21 + x10*x9 + x11*x7 - x14*x7 - x16*x22 + x17*x18  &
                 + x17*x19 - x18*x20 - x19*x20 + x20*x23 + x7*x8)
      wout(1) = x24*(P1(0)*x20 + P1(0)*x28 - P1(1)*x15 + P1(3)*x20 + P2(0)*x20 &
                 + P2(0)*x28 - P2(1)*x15 - P2(3)*x33 - P3(0)*x20 - P3(0)*x28 + &
                P3(1)*x15 - P3(3)*x20 + P3(3)*x33 + co(3)*x25 - co(3)*x34 + w3(&
                1)*x0 + w3(3)*x21 - x10*x32 + x11*x31 - x14*x31 + x15*x18 + x15&
                *x19 - x15*x23 - x18*x36 - x19*x36 + x22*x35 + x31*x8)
      wout(2) = x24*(P1(0)*x39 + P1(0)*x45 - P1(1)*x41 - P1(3)*x43 + P2(0)*x39 &
                 + P2(0)*x45 - P2(1)*x41 + P2(3)*x45 - P3(0)*x39 - P3(0)*x45 + &
                P3(1)*x41 + P3(3)*x43 - P3(3)*x45 + co(2)*x29 + co(2)*x3 + w3(2&
                )*x37 + x10*x47 + x11*x46 - x14*x46 - x18*x49 + x18*x51 + x19* &
                x51 + x23*x49 - x23*x51 - x42*x44 + x46*x8 - x48*x50)
      wout(3) = x24*(P1(0)*x51 + P1(0)*x53 - P1(1)*x57 + P1(3)*x55 + P2(0)*x51 &
                 + P2(0)*x53 - P2(1)*x57 - P2(3)*x51 - P3(0)*x51 - P3(0)*x53 + &
                P3(1)*x57 + P3(3)*x51 - P3(3)*x55 + co(2)*x27 + co(2)*x5 + w3(3&
                )*x37 - x10*x46 + x11*x47 - x14*x47 - x18*x45 + x18*x59 - x19* &
                x45 + x22*x47 - x23*x59 + x44*x54 + x47*x8 + x50*x58)
    else
      x0 = co(0)*w3(3)/2
      x1 = co(0)*w3(2)/2
      x2 = P1(2)*cima
      x3 = cima*co(0)*w3(3)/2
      x4 = w1(0)*w2(0)
      x5 = cima*co(0)*w3(2)/2
      x6 = co(1)*w3(0)/2
      x7 = co(1)*w3(1)/2
      x8 = cima*co(1)*w3(1)/2
      x9 = cima*co(1)*w3(0)/2
      wout(0) = -x4*(-P1(0)*x1 + P1(1)*x0 + P1(3)*x1 - P2(0)*x1 + P2(1)*x0 + P2&
                (2)*x3 + P2(3)*x1 + P3(0)*x1 - P3(1)*x0 - P3(2)*x3 - P3(3)*x1  &
                 - co(2)*w3(0) + x0*x2)
      wout(1) = x4*(P1(0)*x0 - P1(1)*x1 + P1(3)*x0 + P2(0)*x0 - P2(1)*x1 + P2(2&
                )*x5 + P2(3)*x0 - P3(0)*x0 + P3(1)*x1 - P3(2)*x5 - P3(3)*x0 +  &
                co(2)*w3(1) + x1*x2)
      wout(2) = x4*(P1(0)*x6 + P1(1)*x7 + P1(3)*x6 + P2(0)*x6 + P2(1)*x7 + P2(2&
                )*x8 + P2(3)*x6 - P3(0)*x6 - P3(1)*x7 - P3(2)*x8 - P3(3)*x6 +  &
                co(3)*w3(2) + x2*x7)
      wout(3) = x4*(P1(0)*x7 + P1(1)*x6 - P1(3)*x7 + P2(0)*x7 + P2(1)*x6 - P2(2&
                )*x9 - P2(3)*x7 - P3(0)*x7 - P3(1)*x6 + P3(2)*x9 + P3(3)*x7 +  &
                co(3)*w3(3) - x2*x6)
    end if 
      end select 
    end subroutine treeSSFaF
end module tcSSFaF
