!******************************************************************************!
!                                                                              !
!    tcSSSVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSSVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSSSVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSSVV0)
!       P(4,4)*P(5,5)*c0
!       c1*(P(4,4)*P(5,4) + P(4,5)*P(5,5))
!       P(4,5)*P(5,4)*c2
!       c3*(P(4,4)*P(5,2) + P(4,4)*P(5,3) + P(4,5)*P(5,2) + P(4,5)*P(5,3))
!       c4*(P(4,2)*P(5,4) + P(4,2)*P(5,5) + P(4,3)*P(5,4) + P(4,3)*P(5,5))
!       c5*(2*P(4,2)*P(5,2) + P(4,2)*P(5,3) + P(4,3)*P(5,2) + 2*P(4,3)*P(5,3))
!       c6*(Metric(4,5)*P(-1,4)**2 + Metric(4,5)*P(-1,5)**2)
!       Metric(4,5)*P(-1,4)*P(-1,5)*c7
!       Metric(4,5)*P(-1,2)*P(-1,3)*c8
!       c9*(Metric(4,5)*P(-1,2)**2 + Metric(4,5)*P(-1,3)**2)
!       c10*(Metric(4,5)*P(-1,2)*P(-1,4) + Metric(4,5)*P(-1,2)*P(-1,5) + Metric(4
!       ,5)*P(-1,3)*P(-1,4) + Metric(4,5)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x0vec = co(10)*w4(:)
        x1 = P3(0)**2
        x1vec = co(6)*w4(:)
        x2 = P2(1)**2
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P3(1)**2
        x6 = P3(2)**2
        x7 = P3(3)**2
        x8 = P4(0)**2
        x2vec = co(7)*w4(:)
        x3vec = co(9)*w4(:)
        x9 = P4(1)**2
        x10 = P4(2)**2
        x11 = P4(3)**2
        x4vec = 2*co(6)*w4(:)
        x5vec = P1(0)*co(10)*w4(:)
        x6vec = P2(:)*co(3)
        x12 = P1(0)*w4(0)
        x7vec = P3(:)*co(3)
        x8vec = P4(0)*co(7)*w4(:)
        x9vec = P4(:)*co(2)*w4(0)
        x13 = P1(1)*w4(1)
        x10vec = P1(:)*co(1)
        x11vec = P2(:)*co(1)
        x12vec = P3(:)*co(1)
        x13vec = P4(:)*co(1)
        x14 = P1(2)*w4(2)
        x14vec = P3(:)*co(1)*w4(2)
        x15 = P1(3)*w4(3)
        x16 = P2(0)*co(4)*w4(0)
        x17 = P2(1)*w4(1)
        x18 = P2(2)*w4(2)
        x19 = P2(3)*w4(3)
        x20 = P3(0)*co(4)*w4(0)
        x21 = P3(1)*w4(1)
        x22 = P3(2)*w4(2)
        x23 = P3(3)*w4(3)
        x24 = P4(0)*w4(0)
        x15vec = P1(:)*co(0)
        x25 = P4(1)*w4(1)
        x26 = P4(2)*w4(2)
        x27 = P4(3)*w4(3)
        x28 = P2(0)*w4(0)
        x16vec = co(8)*w4(:)
        x29 = P2(1)*P3(1)
        x17vec = P3(:)*co(5)
        x18vec = P4(:)*co(1)*w4(1)
        x19vec = P2(2)*P2(:)*w4(2)
        x30 = P2(2)*P3(2)
        x20vec = P2(2)*P3(:)*w4(2)
        x31 = P2(3)*P3(3)
        x32 = P3(0)*w4(0)
        x21vec = P2(:)*P3(0)*w4(0)
        x22vec = P2(:)*co(5)
        x23vec = P2(:)*P3(3)*w4(3)
        x24vec = P2(:)*co(0)
        x33 = P4(0)*co(0)*w4(0)
        x25vec = P4(:)*co(2)
        x26vec = P2(:)*co(1)*w4(0)
        x27vec = P1(1)*co(10)*w4(:)
        x28vec = P4(1)*co(7)*w4(:)
        x29vec = P1(2)*co(10)*w4(:)
        x30vec = P4(2)*co(7)*w4(:)
        x31vec = P1(3)*co(10)*w4(:)
        x32vec = P4(3)*co(7)*w4(:)
        x34 = P2(1)*co(4)*w4(1)
        x33vec = P1(:)*co(4)
        x35 = P3(1)*co(4)*w4(1)
        x36 = P2(0)*P3(0)
        x34vec = P2(:)*co(4)
        x35vec = P3(:)*co(4)
        x37 = P4(1)*co(0)*w4(1)
        x38 = P4(2)*co(0)*w4(2)
        x39 = P4(3)*co(0)*w4(3)
        x36vec = 2*P1(0)*co(6)*w4(:)
        x40 = 2*co(5)
        x37vec = 2*P4(0)*co(6)*w4(:)
        x38vec = 2*co(10)*w4(:)
        x39vec = 2*P3(:)*co(5)
        x40vec = 2*P4(:)*co(1)
        x41vec = 2*P1(1)*co(6)*w4(:)
        x42vec = 2*P4(1)*co(6)*w4(:)
        x43vec = 2*P1(2)*co(6)*w4(:)
        x44vec = 2*P1(3)*co(6)*w4(:)
        x45vec = 2*P4(3)*co(6)*w4(:)
        x46vec = 2*P2(:)*co(5)
        x47vec = 2*P4(2)*co(6)*w4(:)
        wout = w1(0)*w2(0)*w3(0)*(-P1(0)**2*x1vec - P1(0)*x26vec + P1(0)*x8vec &
                + P1(0)*x9vec + P1(1)**2*x1vec - P1(1)*x28vec + P1(1)*x42vec + &
               P1(2)**2*x1vec + P1(2)*x14vec - P1(2)*x30vec + P1(3)**2*x1vec - &
               P1(3)*x32vec + P1(3)*x45vec + P1(:)*x16 + P1(:)*x20 - P1(:)*x34 &
                - P1(:)*x35 + P2(0)*P2(:)*co(4)*w4(0) - P2(0)*P2(:)*w4(0)*x40  &
                - P2(0)*x26vec - P2(0)*x36vec - P2(0)*x37vec + P2(0)*x5vec + P2&
               (0)*x8vec + P2(0)*x9vec + P2(1)*x18vec - P2(1)*x27vec - P2(1)*  &
               x28vec + P2(1)*x41vec + P2(1)*x42vec + P2(2)*x14vec - P2(2)*    &
               x29vec - P2(2)*x30vec + P2(2)*x43vec + P2(2)*x47vec - P2(3)*    &
               x31vec - P2(3)*x32vec + P2(3)*x44vec + P2(3)*x45vec - P2(:)*x34 &
                - P2(:)*x35 - P3(0)*x26vec - P3(0)*x36vec - P3(0)*x37vec + P3(0&
               )*x5vec + P3(0)*x8vec + P3(0)*x9vec + P3(1)*x18vec - P3(1)*     &
               x27vec - P3(1)*x28vec + P3(1)*x41vec + P3(1)*x42vec + P3(2)*    &
               x14vec - P3(2)*x29vec - P3(2)*x30vec + P3(2)*x43vec + P3(2)*    &
               x47vec - P3(3)*x31vec - P3(3)*x32vec + P3(3)*x44vec + P3(3)*    &
               x45vec + P3(:)*x16 + P3(:)*x20 + P3(:)*x33 - P3(:)*x34 - P3(:)* &
               x35 - P3(:)*x37 - P3(:)*x38 - P3(:)*x39 - P4(0)*x26vec - P4(0)* &
               x36vec + P4(2)*x14vec + P4(2)*x43vec + P4(:)*x33 - P4(:)*x37 -  &
               P4(:)*x38 - P4(:)*x39 + co(1)*x19vec + co(1)*x23vec - co(3)*    &
               x20vec - co(4)*x19vec - co(4)*x20vec + co(4)*x21vec - co(4)*    &
               x23vec + co(5)*x20vec - co(5)*x21vec + co(5)*x23vec + x0*x0vec  &
                - x0*x1vec - x0*x3vec + x0vec*x1 - x0vec*x2 - x0vec*x3 - x0vec*&
               x4 - x0vec*x5 - x0vec*x6 - x0vec*x7 - x1*x1vec - x1*x3vec - x10*&
               x2vec + x10*x4vec - x10vec*x12 + x10vec*x13 + x10vec*x14 +      &
               x10vec*x15 + x10vec*x17 + x10vec*x18 + x10vec*x19 + x10vec*x21  &
                + x10vec*x22 + x10vec*x23 - x10vec*x24 + x10vec*x25 + x10vec*  &
               x26 + x10vec*x27 - x10vec*x28 - x10vec*x32 - x11*x2vec + x11*   &
               x4vec + x11vec*x13 + x11vec*x14 + x11vec*x15 + x11vec*x17 +     &
               x11vec*x19 + x11vec*x21 + x11vec*x22 + x11vec*x25 + x11vec*x26  &
                + x11vec*x27 - x12*x12vec - x12*x13vec + x12*x6vec + x12*x7vec &
                + x12vec*x13 + x12vec*x15 + x12vec*x17 + x12vec*x19 + x12vec*  &
               x21 + x12vec*x23 - x12vec*x24 + x12vec*x25 + x12vec*x27 - x12vec&
               *x28 - x12vec*x32 + x13*x13vec - x13*x25vec - x13*x6vec - x13*  &
               x7vec + x13vec*x14 + x13vec*x15 + x13vec*x18 + x13vec*x19 +     &
               x13vec*x22 + x13vec*x23 - x13vec*x28 - x13vec*x32 - x14*x25vec  &
                - x14*x6vec - x14*x7vec - x15*x25vec - x15*x6vec - x15*x7vec + &
               x15vec*x24 - x15vec*x25 - x15vec*x26 - x15vec*x27 + x16vec*x29  &
                + x16vec*x30 + x16vec*x31 - x16vec*x36 + x17*x17vec - x17*     &
               x25vec + x17*x46vec - x17*x6vec - x17*x7vec + x17vec*x19 -      &
               x17vec*x28 - x18*x25vec - x18*x33vec - x18*x6vec - x19*x25vec - &
               x19*x33vec - x19*x34vec - x19*x35vec + x19*x46vec - x19*x6vec - &
               x19*x7vec + x19vec*x40 + x1vec*x2 + x1vec*x3 + x1vec*x4 + x1vec*&
               x5 + x1vec*x6 + x1vec*x7 + x2*x3vec + x21*x22vec - x21*x25vec + &
               x21*x39vec - x21*x6vec - x21*x7vec + x22*x22vec - x22*x25vec -  &
               x22*x33vec - x22*x34vec - x22*x35vec + x22*x39vec - x22*x6vec - &
               x22*x7vec - x23*x25vec - x23*x33vec - x23*x35vec + x23*x39vec - &
               x23*x6vec - x23*x7vec + x24*x24vec + x24*x25vec - x24*x40vec -  &
               x24vec*x25 - x24vec*x26 - x24vec*x27 - x25*x25vec + x25*x40vec  &
                - x25vec*x26 - x25vec*x27 + x26*x40vec + x27*x40vec + x28*x6vec&
                + x28*x7vec - x29*x38vec + x29*x4vec + x2vec*x8 - x2vec*x9 + x3&
               *x3vec - x30*x38vec + x30*x4vec - x31*x38vec + x31*x4vec - x32* &
               x39vec + x32*x6vec + x32*x7vec + x36*x38vec - x36*x4vec + x3vec*&
               x4 + x3vec*x5 + x3vec*x6 + x3vec*x7 - x4vec*x8 + x4vec*x9)
      end select 
    end subroutine treeSSSVV
end module tcSSSVV
