!******************************************************************************!
!                                                                              !
!    tcSSVSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSVSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSSVSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSVSV0)
!       P(3,3)*P(5,5)*c0
!       c1*(P(3,3)*P(5,3) + P(3,5)*P(5,5))
!       P(3,5)*P(5,3)*c2
!       c3*(P(3,3)*P(5,2) + P(3,3)*P(5,4) + P(3,5)*P(5,2) + P(3,5)*P(5,4))
!       c4*(P(3,2)*P(5,2) + P(3,2)*P(5,4)/2 + P(3,4)*P(5,2)/2 + P(3,4)*P(5,4))
!       c5*(P(3,2)*P(5,3) + P(3,2)*P(5,5) + P(3,4)*P(5,3) + P(3,4)*P(5,5))
!       c6*(Metric(3,5)*P(-1,3)**2 + Metric(3,5)*P(-1,5)**2)
!       Metric(3,5)*P(-1,3)*P(-1,5)*c7
!       c8*(Metric(3,5)*P(-1,2)**2 + Metric(3,5)*P(-1,4)**2)
!       Metric(3,5)*P(-1,2)*P(-1,4)*c9
!       c10*(Metric(3,5)*P(-1,2)*P(-1,3) + Metric(3,5)*P(-1,2)*P(-1,5) + Metric(3
!       ,5)*P(-1,3)*P(-1,4) + Metric(3,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x0vec = co(10)*w3(:)
        x1 = P4(0)**2
        x1vec = co(6)*w3(:)
        x2 = P2(1)**2
        x3 = P2(2)**2
        x2vec = P2(3)**2*w3(:)
        x4 = P4(1)**2
        x5 = P4(2)**2
        x6 = P4(3)**2
        x7 = P3(0)**2
        x3vec = co(7)*w3(:)
        x4vec = co(8)*w3(:)
        x8 = P3(1)**2
        x9 = P3(2)**2
        x10 = P3(3)**2
        x5vec = 2*co(6)*w3(:)
        x6vec = P1(0)*co(10)*w3(:)
        x7vec = P2(:)*co(3)
        x11 = P1(0)*w3(0)
        x8vec = P3(0)*co(7)*w3(:)
        x9vec = P3(:)*co(2)*w3(0)
        x10vec = P4(:)*co(3)
        x11vec = P1(:)*co(1)*w3(1)
        x12vec = P2(:)*co(1)*w3(1)
        x13vec = P3(:)*co(1)
        x12 = P1(1)*w3(1)
        x14vec = P4(:)*co(1)
        x15vec = P1(:)*co(1)*w3(2)
        x16vec = P2(:)*co(1)*w3(2)
        x13 = P1(2)*w3(2)
        x17vec = P4(:)*co(1)*w3(2)
        x14 = P1(3)*w3(3)
        x18vec = P1(:)*co(1)
        x19vec = P2(:)*co(1)
        x15 = P2(0)*co(5)*w3(0)
        x16 = P2(3)*w3(3)
        x17 = P3(0)*w3(0)
        x20vec = P1(:)*co(0)
        x18 = P3(3)*w3(3)
        x19 = P4(0)*w3(0)
        x21vec = P1(:)*co(5)
        x20 = P4(3)*w3(3)
        x21 = P2(0)*w3(0)
        x22vec = P3(:)*co(2)
        x23vec = P2(:)*co(4)
        x22 = P2(1)*w3(1)
        x24vec = co(9)*w3(:)
        x23 = P2(1)*P4(1)
        x25vec = P2(1)*P4(:)*w3(1)
        x24 = P2(2)*w3(2)
        x25 = P2(2)*P4(2)
        x26 = P2(3)*P4(3)
        x26vec = P2(:)*co(0)
        x27vec = P2(:)*co(5)
        x28vec = P3(:)*co(0)
        x29vec = P4(:)*co(0)
        x27 = P3(1)*w3(1)
        x28 = P4(1)*w3(1)
        x29 = P4(2)*w3(2)
        x30vec = P4(0)*P4(:)*w3(0)
        x31vec = P4(1)*P4(:)*w3(1)
        x32vec = P4(:)*co(4)
        x33vec = P4(:)*co(4)/2
        x34vec = P2(:)*co(4)/2
        x35vec = P1(1)*co(10)*w3(:)
        x36vec = P3(1)*co(7)*w3(:)
        x37vec = P1(2)*co(10)*w3(:)
        x38vec = P3(2)*co(7)*w3(:)
        x39vec = P4(:)*co(3)*w3(2)
        x40vec = P1(3)*co(10)*w3(:)
        x41vec = P3(3)*co(7)*w3(:)
        x30 = P2(2)*co(5)*w3(2)
        x31 = P3(1)*co(0)*w3(1)
        x32 = P3(2)*w3(2)
        x33 = P2(0)*P4(0)
        x42vec = P4(:)*co(5)
        x43vec = 2*P1(0)*co(6)*w3(:)
        x44vec = 2*P3(0)*co(6)*w3(:)
        x45vec = 2*co(10)*w3(:)
        x46vec = 2*P3(:)*co(1)
        x47vec = 2*P1(1)*co(6)*w3(:)
        x48vec = 2*P3(1)*co(6)*w3(:)
        x49vec = 2*P2(2)*co(6)*w3(:)
        x50vec = 2*P4(2)*co(6)*w3(:)
        x51vec = 2*P1(3)*co(6)*w3(:)
        x52vec = 2*P4(3)*co(6)*w3(:)
        wout = w1(0)*w2(0)*w4(0)*(-P1(0)**2*x1vec - P1(0)*x44vec + P1(0)*x8vec &
                + P1(0)*x9vec + P1(1)**2*x1vec + P1(1)*x11vec + P1(1)*x12vec - &
               P1(1)*x36vec + P1(1)*x48vec + P1(2)**2*x1vec + P1(2)*P3(2)*x5vec&
                + P1(2)*x15vec + P1(2)*x16vec + P1(2)*x17vec - P1(2)*x38vec -  &
               P1(2)*x39vec + P1(2)*x49vec + P1(2)*x50vec + P1(3)**2*x1vec - P1&
               (3)*x41vec + P1(3)*x52vec + P1(:)*x15 - P1(:)*x30 - P1(:)*x31 - &
               P2(0)*x43vec - P2(0)*x44vec + P2(0)*x6vec + P2(0)*x8vec + P2(1)*&
               x11vec + P2(1)*x12vec - P2(1)*x35vec - P2(1)*x36vec + P2(1)*    &
               x47vec + P2(1)*x48vec + P2(2)*x15vec + P2(2)*x16vec + P2(2)*    &
               x17vec - P2(2)*x37vec - P2(2)*x38vec - P2(2)*x39vec + P2(3)*P3(3&
               )*x5vec - P2(3)*x40vec - P2(3)*x41vec + P2(3)*x51vec + P2(:)*x15&
                - P2(:)*x31 + P3(0)*x9vec + P3(1)*x11vec + P3(1)*x12vec + P3(2 &
               )*x15vec + P3(2)*x16vec + P3(2)*x17vec + P3(2)*x49vec + P3(2)*  &
               x50vec + P3(3)*x51vec + P3(3)*x52vec - P4(0)*x43vec - P4(0)*    &
               x44vec + P4(0)*x6vec + P4(0)*x8vec + P4(0)*x9vec + P4(1)*x11vec &
                + P4(1)*x12vec - P4(1)*x35vec - P4(1)*x36vec + P4(1)*x47vec +  &
               P4(1)*x48vec + P4(2)*x15vec + P4(2)*x16vec + P4(2)*x17vec - P4(2&
               )*x37vec - P4(2)*x38vec - P4(2)*x39vec - P4(3)*x40vec - P4(3)*  &
               x41vec + P4(:)*x15 - P4(:)*x30 - P4(:)*x31 + co(1)*x25vec - co(1&
               )*x30vec - co(10)*x2vec - co(3)*x25vec + co(3)*x30vec - co(3)*  &
               x31vec + co(4)*x25vec/2 - co(4)*x30vec + co(4)*x31vec - co(5)*  &
               x25vec + co(5)*x30vec - co(5)*x31vec + co(6)*x2vec + co(8)*x2vec&
                + x0*x0vec - x0*x1vec - x0*x4vec + x0vec*x1 - x0vec*x2 - x0vec*&
               x3 - x0vec*x4 - x0vec*x5 - x0vec*x6 - x1*x1vec - x1*x4vec - x10*&
               x3vec + x10*x5vec + x10vec*x11 - x10vec*x12 - x10vec*x14 -      &
               x10vec*x16 - x10vec*x20 + x10vec*x21 - x11*x13vec - x11*x14vec  &
                - x11*x18vec - x11*x19vec + x11*x7vec + x12*x13vec + x12*x14vec&
                - x12*x22vec - x12*x7vec + x13*x13vec - x13*x22vec - x13*x7vec &
                + x13vec*x14 + x13vec*x16 - x13vec*x19 + x13vec*x20 - x13vec*  &
               x21 + x13vec*x22 + x13vec*x24 + x13vec*x28 + x13vec*x29 + x14*  &
               x14vec + x14*x18vec + x14*x19vec - x14*x22vec - x14*x7vec +     &
               x14vec*x16 - x14vec*x17 + x14vec*x18 + x14vec*x20 - x14vec*x21  &
                + x14vec*x27 + x14vec*x28 + x16*x18vec + x16*x19vec - x16*     &
               x21vec - x16*x22vec + x16*x23vec - x16*x27vec + x16*x33vec - x16&
               *x42vec - x16*x7vec - x17*x18vec - x17*x19vec + x17*x20vec + x17&
               *x26vec + x17*x28vec + x17*x29vec - x17*x46vec + x18*x18vec +   &
               x18*x19vec - x18*x20vec - x18*x22vec - x18*x26vec - x18*x28vec  &
                - x18*x29vec + x18*x46vec - x18vec*x19 + x18vec*x20 - x18vec*  &
               x21 - x19*x19vec + x19*x21vec + x19*x27vec - x19*x34vec + x19*  &
               x7vec + x19vec*x20 - x19vec*x21 + x1vec*x2 + x1vec*x3 + x1vec*x4&
                + x1vec*x5 + x1vec*x6 + x2*x4vec - x20*x21vec - x20*x22vec -   &
               x20*x27vec + x20*x32vec + x20*x34vec - x20*x42vec - x20*x7vec - &
               x20vec*x32 + x21*x22vec - x21*x23vec - x21*x33vec + x21*x7vec - &
               x21vec*x22 - x21vec*x28 - x21vec*x29 - x22*x22vec + x22*x23vec  &
                - x22*x27vec - x22*x7vec - x22vec*x24 - x22vec*x27 - x22vec*x28&
                - x22vec*x29 - x22vec*x32 + x23*x24vec - x23*x45vec + x23*x5vec&
                + x23vec*x24 - x24*x27vec + x24*x33vec - x24*x7vec + x24vec*x25&
                + x24vec*x26 - x24vec*x33 - x25*x45vec + x25*x5vec - x26*x45vec&
                + x26*x5vec - x26vec*x32 - x27*x28vec + x27*x46vec - x27vec*x28&
                - x27vec*x29 + x28*x34vec - x28*x7vec - x28vec*x32 + x29*x32vec&
                + x29*x34vec - x29*x42vec - x29*x7vec - x29vec*x32 + x3*x4vec  &
                + x32*x46vec + x33*x45vec - x33*x5vec + x3vec*x7 - x3vec*x8 -  &
               x3vec*x9 + x4*x4vec + x4vec*x5 + x4vec*x6 - x5vec*x7 + x5vec*x8 &
                + x5vec*x9)
      end select 
    end subroutine treeSSVSV
end module tcSSVSV
