!******************************************************************************!
!                                                                              !
!    tcSSVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSSVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSVVS0)
!       P(3,4)*P(4,3)*c0
!       c1*(P(3,3)*P(4,2) + P(3,3)*P(4,5) + P(3,4)*P(4,2) + P(3,4)*P(4,5))
!       c2*(2*P(3,2)*P(4,2) + P(3,2)*P(4,5) + P(3,5)*P(4,2) + 2*P(3,5)*P(4,5))
!       c3*(P(3,2)*P(4,3) + P(3,2)*P(4,4) + P(3,5)*P(4,3) + P(3,5)*P(4,4))
!       P(3,3)*P(4,4)*c4
!       c5*(P(3,3)*P(4,3) + P(3,4)*P(4,4))
!       c6*(Metric(3,4)*P(-1,3)**2 + Metric(3,4)*P(-1,4)**2)
!       Metric(3,4)*P(-1,3)*P(-1,4)*c7
!       c8*(Metric(3,4)*P(-1,2)**2 + Metric(3,4)*P(-1,5)**2)
!       Metric(3,4)*P(-1,2)*P(-1,5)*c9
!       c10*(Metric(3,4)*P(-1,2)*P(-1,3) + Metric(3,4)*P(-1,2)*P(-1,4) + Metric(3
!       ,4)*P(-1,3)*P(-1,5) + Metric(3,4)*P(-1,4)*P(-1,5))
        x0 = P3(1)**2
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x2 = co(10)*x1
        x3 = P3(2)**2
        x4 = P3(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P3(0)**2
        x9 = co(6)*x1
        x10 = P4(0)**2*x1
        x11 = co(8)*x1
        x12 = P2(1)**2
        x13 = co(9)*x1
        x14 = P2(2)**2
        x15 = P2(3)**2
        x16 = P2(0)**2
        x17 = 2*co(8)*x1
        x18 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x19 = co(2)*x18
        x20 = P1(0)*w3(0)
        x21 = P2(1)*co(9)*x1
        x22 = P1(1)*co(10)*x1
        x23 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x24 = co(3)*x23
        x25 = P1(1)*w3(1)
        x26 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x27 = P1(1)*w3(1)*x26
        x28 = P2(2)*co(9)*x1
        x29 = P1(2)*co(10)*x1
        x30 = P1(2)*w3(2)
        x31 = co(3)*x26
        x32 = P2(3)*co(9)*x1
        x33 = P1(3)*co(10)*x1
        x34 = P1(3)*w3(3)
        x35 = co(3)*w3(3)*x26
        x36 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x37 = co(2)*x36
        x38 = P2(0)*w3(0)
        x39 = P2(0)*co(2)*w3(0)
        x40 = co(7)*x1
        x41 = P3(0)*P4(0)
        x42 = P3(0)*w3(0)
        x43 = co(4)*x26
        x44 = co(5)*x23
        x45 = P3(1)*w3(1)
        x46 = co(1)*x36
        x47 = co(1)*x23
        x48 = co(1)*x26
        x49 = P3(2)*w3(2)
        x50 = P3(3)*w3(3)
        x51 = P3(3)*w3(3)*x26
        x52 = P4(0)*w3(0)*x23
        x53 = P4(0)*w3(0)
        x54 = P4(0)*w3(0)*x26
        x55 = P4(1)*w3(1)
        x56 = P4(2)*w3(2)
        x57 = P4(3)*co(1)*w3(3)
        x58 = P4(3)*w3(3)
        x59 = P2(0)*co(9)*x1
        x60 = P1(0)*co(10)*x1
        x61 = co(3)*w3(0)*x26
        x62 = co(2)*w3(2)*x18
        x63 = P2(1)*w3(1)
        x64 = co(2)*x23
        x65 = P2(2)*w3(2)
        x66 = co(2)*x26
        x67 = P2(3)*w3(3)
        x68 = P3(1)*P4(1)
        x69 = P3(2)*P4(2)
        x70 = P3(3)*P4(3)
        x71 = co(0)*x23
        x72 = co(5)*x26
        x73 = P4(3)*w3(3)*x26
        x74 = 2*P2(1)*co(8)*x1
        x75 = 2*P1(1)*co(8)*x1
        x76 = 2*co(2)*x36
        x77 = 2*co(2)*x23
        x78 = 2*co(2)
        x79 = 2*P1(2)*co(8)*x1
        x80 = 2*co(2)*x26
        x81 = 2*P1(3)*co(8)*x1
        x82 = 2*co(2)*w3(3)*x26
        x83 = 2*co(2)*x18
        x84 = 2*P2(2)*co(8)*x1
        x85 = 2*P2(3)*co(8)*x1
        x86 = 2*co(10)*x1
        x87 = 2*P4(1)*w3(1)
        x88 = 2*P1(0)*co(8)*x1
        x89 = 2*P2(0)*co(8)*x1
        wout(0) = -w1(0)*w2(0)*(P1(0)**2*x11 - P1(0)*x59 - P1(0)*x61 - P1(1)**2&
                  *x11 + P1(1)*x21 - P1(1)*x74 - P1(2)**2*x11 + P1(2)*x28 - P1(&
                  2)*x62 - P1(3)**2*x11 + P1(3)*x32 + P1(3)*x35 - P1(3)*x82 +  &
                  P2(0)*x88 - P2(1)*co(2)*w3(1)*x26 - 2*P2(2)*x62 - P2(2)*x79  &
                   - P2(3)*co(2)*w3(3)*x26 - P2(3)*x81 - P3(0)*x59 - P3(0)*x60 &
                   - P3(0)*x61 + P3(0)*x88 + P3(0)*x89 + P3(1)*x21 + P3(1)*x22 &
                   - P3(1)*x74 - P3(1)*x75 + P3(2)*x28 + P3(2)*x29 - P3(2)*x62 &
                   - P3(2)*x79 - P3(2)*x84 + P3(3)*x32 + P3(3)*x33 + P3(3)*x35 &
                   - P3(3)*x81 - P3(3)*x82 - P3(3)*x85 - P4(0)*x59 - P4(0)*x60 &
                   + P4(0)*x88 + P4(0)*x89 + P4(1)*x21 + P4(1)*x22 - P4(1)*x74 &
                   - P4(1)*x75 + P4(2)*x28 + P4(2)*x29 - P4(2)*x79 - P4(2)*x84 &
                   + P4(3)*co(1)*w3(3)*x26 + P4(3)*x32 + P4(3)*x33 + P4(3)*x35 &
                   - P4(3)*x81 - P4(3)*x85 + co(0)*x52 + co(1)*x51 - co(1)*x52 &
                   - co(10)*x10 + co(3)*x27 - co(3)*x52 - co(3)*x54 - co(4)*x51&
                   + co(5)*x54 - co(5)*x73 + co(6)*x10 + co(8)*x10 - x0*x11 +  &
                  x0*x2 - x0*x9 - x11*x3 - x11*x4 - x11*x5 - x11*x6 - x11*x7 + &
                  x11*x8 + x12*x13 - x12*x17 + x13*x14 + x13*x15 - x13*x16 -   &
                  x14*x17 - x15*x17 + x16*x17 + x17*x41 - x17*x68 - x17*x69 -  &
                  x17*x70 + x19*x20 - x19*x25 - x19*x34 + x19*x42 - x19*x45 -  &
                  x19*x50 + x19*x53 - x19*x55 - x19*x56 - x19*x58 + x2*x3 + x2*&
                  x4 + x2*x5 + x2*x6 + x2*x7 - x2*x8 - x20*x24 + x20*x76 + x20*&
                  x77 + x20*x80 + x23*x39 + x23*x57 + x24*x25 + x24*x30 + x24* &
                  x34 - x24*x42 + x24*x45 + x24*x49 + x24*x50 + x24*x55 + x24* &
                  x56 + x24*x58 - x25*x76 - x25*x77 + x26*x39 - x27*x78 - x3*x9&
                   + x30*x31 - x30*x76 - x30*x77 - x30*x80 + x31*x45 + x31*x49 &
                   + x31*x55 + x31*x56 - x34*x76 - x34*x77 + x36*x57 + x37*x38 &
                   - x37*x63 - x37*x65 - x37*x67 - x37*x87 + x38*x83 - x4*x9 + &
                  x40*x41 - x40*x68 - x40*x69 - x40*x70 - x41*x86 + x42*x43 +  &
                  x42*x44 - x42*x46 - x42*x47 - x42*x48 + x42*x76 + x42*x77 +  &
                  x42*x80 - x43*x45 - x43*x49 - x44*x45 - x44*x49 - x44*x50 +  &
                  x45*x46 + x45*x47 + x45*x48 - x45*x76 - x45*x77 - x45*x80 +  &
                  x46*x49 + x46*x50 - x46*x53 + x46*x55 + x46*x56 + x47*x49 +  &
                  x47*x50 + x47*x55 + x47*x56 + x48*x49 - x48*x53 + x48*x55 +  &
                  x48*x56 - x49*x76 - x49*x77 - x49*x80 - x5*x9 - x50*x76 - x50&
                  *x77 + x52*x78 + x53*x76 + x54*x78 - x55*x71 - x55*x72 - x56*&
                  x71 - x56*x72 - x56*x76 - x56*x77 - x56*x80 - x58*x71 - x58* &
                  x76 - x58*x77 - x6*x9 - x63*x64 - x63*x83 - x64*x65 - x64*x67&
                   - x64*x87 - x65*x66 - x66*x87 - x67*x83 + x68*x86 + x69*x86 &
                   - x7*x9 + x70*x86 - x73*x78 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSSVVS
end module tcSSVVS
