!******************************************************************************!
!                                                                              !
!    tcSVSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSVSSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVSSV0)
!       P(2,5)*P(5,2)*c0
!       c1*(P(2,2)*P(5,3) + P(2,2)*P(5,4) + P(2,5)*P(5,3) + P(2,5)*P(5,4))
!       c2*(2*P(2,3)*P(5,3) + P(2,3)*P(5,4) + P(2,4)*P(5,3) + 2*P(2,4)*P(5,4))
!       c3*(P(2,3)*P(5,2) + P(2,3)*P(5,5) + P(2,4)*P(5,2) + P(2,4)*P(5,5))
!       P(2,2)*P(5,5)*c4
!       c5*(P(2,2)*P(5,2) + P(2,5)*P(5,5))
!       Metric(2,5)*P(-1,2)*P(-1,5)*c6
!       c7*(Metric(2,5)*P(-1,3)**2 + Metric(2,5)*P(-1,4)**2)
!       Metric(2,5)*P(-1,3)*P(-1,4)*c8
!       c9*(Metric(2,5)*P(-1,2)*P(-1,3) + Metric(2,5)*P(-1,2)*P(-1,4) + Metric(2,
!       5)*P(-1,3)*P(-1,5) + Metric(2,5)*P(-1,4)*P(-1,5))
!       c10*(Metric(2,5)*P(-1,2)**2 + Metric(2,5)*P(-1,5)**2)
        if (last) VB_last = .true.
        x0vec = co(10)*w2(:)
        x0 = P3(1)**2
        x1 = P3(2)**2
        x2 = P3(3)**2
        x3 = P4(1)**2
        x4 = P4(2)**2
        x5 = P4(3)**2
        x6 = P2(0)**2
        x1vec = co(6)*w2(:)
        x2vec = co(7)*w2(:)
        x7 = P3(0)**2
        x3vec = co(9)*w2(:)
        x8 = P4(0)**2
        x9 = P2(1)**2
        x10 = P2(2)**2
        x11 = P2(3)**2
        x4vec = 2*co(10)*w2(:)
        x5vec = P2(0)*co(6)*w2(:)
        x12 = P1(0)*w2(0)
        x6vec = P2(:)*co(0)
        x7vec = P1(0)*co(9)*w2(:)
        x8vec = P3(:)*co(1)
        x9vec = P4(:)*co(1)
        x10vec = P1(:)*co(5)
        x13 = P1(1)*w2(1)
        x11vec = P2(:)*co(5)*w2(1)
        x12vec = P3(:)*co(5)*w2(1)
        x13vec = P4(:)*co(5)
        x14 = P1(2)*w2(2)
        x14vec = P2(:)*co(5)
        x15vec = P3(:)*co(5)
        x15 = P1(3)*w2(3)
        x16vec = P3(:)*co(5)*w2(3)
        x16 = P2(0)*w2(0)
        x17vec = P1(:)*co(4)
        x17 = P2(1)*w2(1)
        x18 = P2(2)*w2(2)
        x19 = P2(3)*w2(3)
        x18vec = P1(:)*co(3)
        x20 = P3(0)*w2(0)
        x21 = P3(1)*w2(1)
        x22 = P3(2)*w2(2)
        x23 = P3(3)*w2(3)
        x24 = P4(0)*w2(0)
        x25 = P4(1)*w2(1)
        x26 = P4(2)*w2(2)
        x27 = P4(3)*w2(3)
        x28 = P2(0)*co(4)*w2(0)
        x19vec = P3(:)*co(4)
        x20vec = P3(:)*co(3)
        x21vec = P4(:)*co(3)
        x22vec = co(8)*w2(:)
        x29 = P3(1)*P4(1)
        x23vec = P4(:)*co(2)
        x30 = P3(2)*P4(2)
        x31 = P3(3)*P4(3)
        x24vec = P3(:)*P4(0)*w2(0)
        x25vec = P3(:)*P4(1)*w2(1)
        x26vec = P3(:)*P4(3)*w2(3)
        x27vec = P2(1)*co(6)*w2(:)
        x28vec = P1(1)*co(9)*w2(:)
        x29vec = P3(:)*co(1)*w2(1)
        x30vec = P2(2)*co(6)*w2(:)
        x31vec = P2(:)*co(0)*w2(2)
        x32vec = P1(2)*co(9)*w2(:)
        x33vec = P2(3)*co(6)*w2(:)
        x34vec = P2(:)*co(0)*w2(3)
        x35vec = P1(3)*co(9)*w2(:)
        x36vec = P3(:)*w2(3)
        x32 = P2(1)*co(4)*w2(1)
        x33 = P2(3)*co(4)*w2(3)
        x34 = P2(2)*co(4)*w2(2)
        x35 = P3(0)*P4(0)
        x37vec = P3(1)*P3(:)*w2(1)
        x38vec = 2*P2(0)*co(10)*w2(:)
        x39vec = 2*P1(0)*co(10)*w2(:)
        x40vec = 2*P2(:)*co(5)
        x41vec = 2*P3(:)*co(2)
        x42vec = 2*co(9)*w2(:)
        x43vec = 2*P4(:)*co(2)
        x44vec = 2*P2(1)*co(10)*w2(:)
        x45vec = 2*P4(1)*co(10)*w2(:)
        x46vec = 2*P2(2)*co(10)*w2(:)
        x47vec = 2*P1(2)*co(10)*w2(:)
        x48vec = 2*P1(3)*co(10)*w2(:)
        x49vec = 2*P4(3)*co(10)*w2(:)
        wout = w1(0)*w3(0)*w4(0)*(-P1(0)**2*x0vec - P1(0)*x38vec + P1(0)*x5vec &
                + P1(1)**2*x0vec + P1(1)*P3(1)*x4vec + P1(1)*x11vec + P1(1)*   &
               x12vec - P1(1)*x27vec - P1(1)*x29vec + P1(1)*x44vec + P1(1)*    &
               x45vec + P1(2)**2*x0vec - P1(2)*x30vec - P1(2)*x31vec + P1(2)*  &
               x46vec + P1(3)**2*x0vec - P1(3)*co(1)*x36vec + P1(3)*x16vec - P1&
               (3)*x33vec - P1(3)*x34vec + P1(3)*x49vec - P1(:)*x32 - P1(:)*x33&
                - P2(1)*P3(:)*co(4)*w2(1) + 2*P2(1)*x11vec + P2(1)*x12vec + P2(&
               1)*x45vec - P2(2)*x31vec + P2(3)*P3(3)*x4vec - P2(3)*co(4)*     &
               x36vec + P2(3)*x16vec - P2(3)*x34vec + P2(3)*x48vec + P2(3)*    &
               x49vec + P2(:)*x28 - P2(:)*x32 - P2(:)*x33 - P2(:)*x34 - P3(0)* &
               x38vec - P3(0)*x39vec + P3(0)*x5vec + P3(0)*x7vec + P3(1)*x11vec&
                + P3(1)*x12vec - P3(1)*x27vec - P3(1)*x28vec - P3(1)*x29vec +  &
               P3(1)*x44vec - P3(2)*x30vec - P3(2)*x32vec + P3(2)*x46vec + P3(2&
               )*x47vec - P3(3)*x33vec - P3(3)*x35vec + P3(3)*x48vec + P3(:)*co&
               (2)*x26 - P4(0)*x38vec - P4(0)*x39vec + P4(0)*x5vec + P4(0)*    &
               x7vec + P4(1)*x11vec - P4(1)*x27vec - P4(1)*x28vec - P4(1)*     &
               x29vec - P4(2)*x30vec - P4(2)*x32vec + P4(2)*x46vec + P4(2)*    &
               x47vec + P4(3)*x16vec - P4(3)*x33vec - P4(3)*x34vec - P4(3)*    &
               x35vec + P4(:)*x28 - P4(:)*x32 - P4(:)*x33 - P4(:)*x34 + co(1)* &
               x24vec - co(1)*x26vec - co(2)*x24vec + co(2)*x25vec + co(2)*    &
               x26vec + 2*co(2)*x37vec - co(3)*x25vec - co(3)*x37vec - co(5)*  &
               x24vec + co(5)*x25vec + x0*x0vec + x0*x2vec - x0*x3vec + x0vec* &
               x1 + x0vec*x2 + x0vec*x3 + x0vec*x4 + x0vec*x5 - x0vec*x7 -     &
               x0vec*x8 + x1*x2vec - x1*x3vec - x10*x1vec + x10*x4vec - x10vec*&
               x12 + x10vec*x13 + x10vec*x14 + x10vec*x15 - x10vec*x16 + x10vec&
               *x17 + x10vec*x18 + x10vec*x19 - x10vec*x20 + x10vec*x21 +      &
               x10vec*x22 + x10vec*x23 - x10vec*x24 + x10vec*x25 + x10vec*x26  &
                + x10vec*x27 - x11*x1vec + x11*x4vec - x12*x13vec - x12*x14vec &
                - x12*x15vec + x12*x6vec + x12*x8vec + x12*x9vec + x13*x13vec  &
                - x13*x6vec - x13*x9vec + x13vec*x14 + x13vec*x15 - x13vec*x16 &
                + x13vec*x17 + x13vec*x18 + x13vec*x19 - x13vec*x20 + x13vec*  &
               x21 + x13vec*x22 + x13vec*x23 - x13vec*x24 + x13vec*x25 + x13vec&
               *x26 + x13vec*x27 + x14*x14vec + x14*x15vec - x14*x8vec - x14*  &
               x9vec + x14vec*x15 - x14vec*x20 + x14vec*x22 + x14vec*x23 -     &
               x14vec*x24 + x14vec*x26 + x14vec*x27 - x15*x9vec - x15vec*x16 + &
               x15vec*x18 - x15vec*x20 + x15vec*x22 + x15vec*x23 + x15vec*x26  &
                + x16*x17vec + x16*x19vec - x16*x40vec + x16*x6vec - x17*x6vec &
                - x17vec*x18 - x18*x19vec + x18*x40vec + x18vec*x20 - x18vec*  &
               x21 - x18vec*x22 - x18vec*x23 + x18vec*x24 - x18vec*x25 - x18vec&
               *x26 - x18vec*x27 + x19*x40vec + x1vec*x6 - x1vec*x9 + x2*x2vec &
                - x2*x3vec + x20*x20vec + x20*x21vec - x20*x23vec - x20*x41vec &
                + x20*x6vec + x20*x8vec + x20*x9vec - x20vec*x22 - x20vec*x23  &
                + x20vec*x24 - x20vec*x26 - x20vec*x27 - x21*x21vec + x21*     &
               x23vec - x21*x6vec - x21*x9vec - x21vec*x22 - x21vec*x23 +      &
               x21vec*x24 - x21vec*x25 - x21vec*x26 - x21vec*x27 + x22*x23vec  &
                + x22*x41vec - x22*x6vec - x22*x8vec - x22*x9vec + x22vec*x29  &
                + x22vec*x30 + x22vec*x31 - x22vec*x35 + x23*x23vec + x23*     &
               x41vec - x23*x6vec - x23*x8vec - x23*x9vec - x24*x43vec + x24*  &
               x6vec + x24*x9vec + x25*x43vec - x25*x6vec - x25*x9vec + x26*   &
               x43vec - x26*x6vec - x26*x8vec - x26*x9vec + x27*x43vec - x27*  &
               x9vec - x29*x42vec + x29*x4vec + x2vec*x3 + x2vec*x4 + x2vec*x5 &
                - x2vec*x7 - x2vec*x8 - x3*x3vec - x30*x42vec + x30*x4vec - x31&
               *x42vec + x31*x4vec + x35*x42vec - x35*x4vec - x3vec*x4 - x3vec*&
               x5 + x3vec*x7 + x3vec*x8 - x4vec*x6 + x4vec*x9)
      end select 
    end subroutine treeSVSSV
end module tcSVSSV
