!******************************************************************************!
!                                                                              !
!    tcSVSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSVSVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVSVS0)
!       P(2,2)*P(4,4)*c0
!       c1*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,4)*P(4,2)*c2
!       c3*(P(2,2)*P(4,3) + P(2,2)*P(4,5) + P(2,4)*P(4,3) + P(2,4)*P(4,5))
!       c4*(2*P(2,3)*P(4,3) + P(2,3)*P(4,5) + P(2,5)*P(4,3) + 2*P(2,5)*P(4,5))
!       c5*(P(2,3)*P(4,2) + P(2,3)*P(4,4) + P(2,5)*P(4,2) + P(2,5)*P(4,4))
!       c6*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
!       Metric(2,4)*P(-1,2)*P(-1,4)*c7
!       c8*(Metric(2,4)*P(-1,3)**2 + Metric(2,4)*P(-1,5)**2)
!       Metric(2,4)*P(-1,3)*P(-1,5)*c9
!       c10*(Metric(2,4)*P(-1,2)*P(-1,3) + Metric(2,4)*P(-1,2)*P(-1,5) + Metric(2
!       ,4)*P(-1,3)*P(-1,4) + Metric(2,4)*P(-1,4)*P(-1,5))
        x0 = P2(1)**2
        x1 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x2 = co(10)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P2(0)**2
        x9 = co(6)*x1
        x10 = P4(0)**2
        x11 = co(8)*x1
        x12 = P3(1)**2
        x13 = co(9)*x1
        x14 = P3(2)**2
        x15 = P3(3)**2
        x16 = P3(0)**2
        x17 = 2*co(8)*x1
        x18 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x19 = co(4)*x18
        x20 = P1(0)*w2(0)
        x21 = P1(1)*co(10)*x1
        x22 = P3(1)*co(9)*x1
        x23 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x24 = co(5)*x23
        x25 = P1(1)*w2(1)
        x26 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x27 = co(5)*x26
        x28 = P1(2)*co(10)*x1
        x29 = P3(2)*co(9)*x1
        x30 = P1(2)*w2(2)
        x31 = P1(3)*co(10)*x1
        x32 = P3(3)*co(9)*x1
        x33 = P1(3)*w2(3)
        x34 = co(7)*x1
        x35 = P2(0)*P4(0)
        x36 = P2(0)*w2(0)
        x37 = co(0)*x26
        x38 = co(1)*x23
        x39 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x40 = co(3)*x39
        x41 = P2(1)*w2(1)
        x42 = co(3)*x23
        x43 = co(3)*x26
        x44 = P2(1)*co(5)*w2(1)
        x45 = P2(2)*w2(2)
        x46 = co(3)*w2(3)*x39
        x47 = P2(3)*w2(3)
        x48 = P2(3)*w2(3)*x26
        x49 = P3(0)*co(4)*w2(0)
        x50 = co(1)*x26
        x51 = P4(0)*w2(0)
        x52 = P4(0)*w2(0)*x23
        x53 = P4(1)*w2(1)
        x54 = P4(2)*w2(2)
        x55 = P4(3)*w2(3)
        x56 = P1(0)*co(10)*x1
        x57 = P3(0)*co(9)*x1
        x58 = P1(0)*w2(0)*x23
        x59 = co(4)*w2(2)*x18
        x60 = P2(1)*P4(1)
        x61 = P2(2)*P4(2)
        x62 = P2(3)*P4(3)
        x63 = P3(1)*co(4)*w2(1)
        x64 = P3(2)*co(4)*w2(2)
        x65 = P3(3)*co(4)*w2(3)
        x66 = co(2)*x23
        x67 = 2*P1(1)*co(8)*x1
        x68 = 2*co(4)*x39
        x69 = 2*co(4)*x23
        x70 = 2*co(4)*x26
        x71 = 2*P1(2)*co(8)*x1
        x72 = 2*P1(3)*co(8)*x1
        x73 = 2*P3(3)*co(8)*x1
        x74 = 2*co(4)*w2(3)*x39
        x75 = 2*co(10)*x1
        x76 = 2*P3(1)*co(8)*x1
        x77 = 2*P3(2)*co(8)*x1
        x78 = 2*co(4)
        x79 = 2*co(4)*x18
        x80 = 2*P1(0)*co(8)*x1
        x81 = 2*P3(0)*co(8)*x1
        wout(0) = -w1(0)*w3(0)*(P1(0)**2*x11 - P1(0)*x57 + P1(0)*x81 - P1(1)**2&
                  *x11 + P1(1)*x22 - P1(2)**2*x11 + P1(2)*x29 - P1(2)*x59 - P1(&
                  3)**2*x11 + P1(3)*x32 - P1(3)*x73 - P1(3)*x74 - P2(0)*x56 -  &
                  P2(0)*x57 + P2(0)*x80 + P2(0)*x81 + P2(1)*x21 + P2(1)*x22 -  &
                  P2(1)*x67 - P2(1)*x76 + P2(2)*x28 + P2(2)*x29 - P2(2)*x59 -  &
                  P2(2)*x71 - P2(2)*x77 + P2(3)*x31 + P2(3)*x32 + P2(3)*x46 -  &
                  P2(3)*x72 - P2(3)*x73 - P2(3)*x74 + P3(0)*co(4)*w2(0)*x23 +  &
                  P3(0)*w2(0)*x79 - P3(1)*w2(1)*x79 - P3(1)*x67 - 2*P3(2)*x59  &
                   - P3(2)*x71 - P3(3)*co(4)*w2(3)*x39 - P3(3)*w2(3)*x79 - P4(0&
                  )*x56 - P4(0)*x57 + P4(0)*x80 + P4(0)*x81 + P4(1)*x21 + P4(1 &
                  )*x22 - P4(1)*x67 - P4(1)*x76 + P4(2)*x28 + P4(2)*x29 - P4(2 &
                  )*x59 - P4(2)*x71 - P4(2)*x77 + P4(3)*x31 + P4(3)*x32 + P4(3 &
                  )*x46 - P4(3)*x72 - P4(3)*x73 - P4(3)*x74 - co(0)*x48 + co(2 &
                  )*x52 + co(3)*x48 - co(5)*x52 - co(5)*x58 - x0*x11 + x0*x2 - &
                  x0*x9 + x10*x11 - x10*x2 + x10*x9 - x11*x3 - x11*x4 - x11*x5 &
                   - x11*x6 - x11*x7 + x11*x8 + x12*x13 - x12*x17 + x13*x14 +  &
                  x13*x15 - x13*x16 - x14*x17 - x15*x17 + x16*x17 + x17*x35 -  &
                  x17*x60 - x17*x61 - x17*x62 + x19*x20 - x19*x25 - x19*x33 +  &
                  x19*x36 - x19*x41 - x19*x47 + x19*x51 - x19*x53 - x19*x55 +  &
                  x2*x3 + x2*x4 + x2*x5 + x2*x6 + x2*x7 - x2*x8 - x20*x27 + x20&
                  *x68 + x20*x70 + x23*x44 - x23*x63 - x23*x64 - x23*x65 + x24*&
                  x25 + x24*x30 + x24*x33 - x24*x36 + x24*x45 + x24*x47 + x24* &
                  x53 + x24*x54 + x24*x55 + x25*x27 - x25*x68 - x25*x69 - x25* &
                  x70 + x26*x44 + x26*x49 - x26*x63 - x26*x64 - x26*x65 + x27* &
                  x30 + x27*x33 - x27*x36 + x27*x45 + x27*x47 - x27*x51 + x27* &
                  x53 + x27*x54 + x27*x55 - x3*x9 - x30*x68 - x30*x69 - x30*x70&
                   - x33*x69 - x33*x70 + x34*x35 - x34*x60 - x34*x61 - x34*x62 &
                   - x35*x75 + x36*x37 + x36*x38 - x36*x40 - x36*x42 - x36*x43 &
                   + x36*x68 + x36*x69 + x36*x70 - x37*x41 - x37*x45 - x38*x41 &
                   - x38*x45 - x38*x47 + x39*x49 - x39*x63 - x39*x64 - x4*x9 + &
                  x40*x41 + x40*x45 - x40*x51 + x40*x53 + x40*x54 + x41*x42 +  &
                  x41*x43 - x41*x68 - x41*x69 - x41*x70 + x42*x45 + x42*x47 -  &
                  x42*x51 + x42*x53 + x42*x54 + x42*x55 + x43*x45 - x43*x51 +  &
                  x43*x53 + x43*x54 + x43*x55 - x45*x68 - x45*x69 - x45*x70 -  &
                  x47*x69 - x48*x78 - x5*x9 + x50*x51 - x50*x53 - x50*x54 - x50&
                  *x55 + x51*x68 + x51*x70 + x52*x78 - x53*x66 - x53*x68 - x53*&
                  x69 - x53*x70 - x54*x66 - x54*x68 - x54*x69 - x54*x70 - x55* &
                  x66 - x55*x69 - x55*x70 + x58*x78 - x6*x9 + x60*x75 + x61*x75&
                   + x62*x75 - x7*x9 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVSVS
end module tcSVSVS
