!******************************************************************************!
!                                                                              !
!    tcSVVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSVVSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVSS0)
!       P(2,3)*P(3,2)*c0
!       c1*(P(2,2)*P(3,4) + P(2,2)*P(3,5) + P(2,3)*P(3,4) + P(2,3)*P(3,5))
!       c2*(P(2,4)*P(3,4) + P(2,4)*P(3,5)/2 + P(2,5)*P(3,4)/2 + P(2,5)*P(3,5))
!       c3*(P(2,4)*P(3,2) + P(2,4)*P(3,3) + P(2,5)*P(3,2) + P(2,5)*P(3,3))
!       P(2,2)*P(3,3)*c4
!       c5*(P(2,2)*P(3,2) + P(2,3)*P(3,3))
!       c6*(Metric(2,3)*P(-1,2)**2 + Metric(2,3)*P(-1,3)**2)
!       Metric(2,3)*P(-1,2)*P(-1,3)*c7
!       c8*(Metric(2,3)*P(-1,4)**2 + Metric(2,3)*P(-1,5)**2)
!       Metric(2,3)*P(-1,4)*P(-1,5)*c9
!       c10*(Metric(2,3)*P(-1,2)*P(-1,4) + Metric(2,3)*P(-1,2)*P(-1,5) + Metric(2
!       ,3)*P(-1,3)*P(-1,4) + Metric(2,3)*P(-1,3)*P(-1,5))
        x0 = P2(1)**2
        x1 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x2 = co(10)*x1
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P3(1)**2
        x6 = P3(2)**2
        x7 = P3(3)**2
        x8 = P2(0)**2
        x9 = co(6)*x1
        x10 = P3(0)**2
        x11 = co(8)*x1
        x12 = P4(1)**2
        x13 = co(9)*x1
        x14 = P4(2)**2
        x15 = P4(3)**2
        x16 = P4(0)**2
        x17 = 2*co(8)*x1
        x18 = -P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3)
        x19 = co(2)*w2(0)*x18
        x20 = -P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)
        x21 = co(2)*x20
        x22 = P1(0)*w2(0)
        x23 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x24 = co(2)*w2(0)*x23
        x25 = P1(1)*co(10)*x1
        x26 = P4(1)*co(9)*x1
        x27 = co(3)*w2(1)*x20
        x28 = P1(1)*w2(1)
        x29 = co(3)*x23
        x30 = P1(2)*co(10)*x1
        x31 = P4(2)*co(9)*x1
        x32 = co(3)*x20
        x33 = P1(2)*w2(2)
        x34 = P1(3)*co(10)*x1
        x35 = P4(3)*co(9)*x1
        x36 = P1(3)*w2(3)
        x37 = co(7)*x1
        x38 = P2(0)*P3(0)
        x39 = P2(0)*w2(0)
        x40 = P2(0)*w2(0)*x23
        x41 = co(5)*x20
        x42 = co(1)*x18
        x43 = P2(1)*w2(1)
        x44 = co(1)*x20
        x45 = P2(1)*w2(1)*x23
        x46 = P2(2)*w2(2)
        x47 = P2(2)*w2(2)*x23
        x48 = P2(3)*w2(3)
        x49 = co(1)*x23
        x50 = P3(0)*w2(0)
        x51 = co(0)*x20
        x52 = co(2)*x18
        x53 = P3(0)*w2(0)*x23
        x54 = P3(1)*w2(1)
        x55 = P3(1)*w2(1)*x23
        x56 = P3(1)*w2(1)*x20
        x57 = P3(2)*w2(2)
        x58 = P3(3)*co(1)*w2(3)
        x59 = P3(3)*w2(3)
        x60 = P3(3)*w2(3)*x23
        x61 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x62 = co(2)*x61
        x63 = P4(0)*w2(0)
        x64 = co(2)*x61/2
        x65 = P4(0)/2
        x66 = co(2)*x20/2
        x67 = P1(0)*co(10)*x1
        x68 = P4(0)*co(9)*x1
        x69 = co(3)*w2(0)*x23
        x70 = co(2)*w2(1)*x20
        x71 = co(2)*x23
        x72 = P1(2)*co(2)*w2(2)
        x73 = co(2)*w2(2)*x20
        x74 = P2(1)*P3(1)
        x75 = P2(2)*P3(2)
        x76 = P2(2)*co(2)*w2(2)
        x77 = P2(3)*P3(3)
        x78 = P3(2)*co(2)*w2(2)
        x79 = P4(1)*w2(1)
        x80 = P4(3)*w2(3)
        x81 = 2*P1(1)*co(8)*x1
        x82 = 2*P4(1)*co(8)*x1
        x83 = 2*P1(2)*co(8)*x1
        x84 = 2*P1(3)*co(8)*x1
        x85 = 2*P4(3)*co(8)*x1
        x86 = 2*co(10)*x1
        x87 = 2*P4(2)*co(8)*x1
        x88 = 2*P1(0)*co(8)*x1
        x89 = 2*P4(0)*co(8)*x1
        x90 = -P4(0)*w3(0)/2 + P4(1)*w3(1)/2 + P4(2)*w3(2)/2 + P4(3)*w3(3)/2
        x91 = co(2)*x18/2
        x92 = co(2)*x23/2
        x93 = P4(2)*co(2)*w2(2)/2
        wout(0) = -w1(0)*w4(0)*(P1(0)**2*x11 + P1(0)*x19 + P1(0)*x24 - P1(0)*  &
                  x68 - P1(0)*x69 + P1(0)*x89 - P1(1)**2*x11 + P1(1)*x26 + P1(1&
                  )*x27 - P1(1)*x70 - P1(1)*x82 - P1(2)**2*x11 + P1(2)*x31 - P1&
                  (2)*x73 - P1(3)**2*x11 + P1(3)*x35 - P1(3)*x85 + P2(0)*x19 + &
                  P2(0)*x24 - P2(0)*x67 - P2(0)*x68 - P2(0)*x69 + P2(0)*x88 +  &
                  P2(0)*x89 - P2(1)*co(5)*w2(1)*x20 + P2(1)*x25 + P2(1)*x26 +  &
                  P2(1)*x27 - P2(1)*x70 - P2(1)*x81 - P2(1)*x82 + P2(2)*x30 +  &
                  P2(2)*x31 - P2(2)*x73 - P2(2)*x83 - P2(2)*x87 + P2(3)*x34 +  &
                  P2(3)*x35 - P2(3)*x84 - P2(3)*x85 + P3(0)*x24 - P3(0)*x67 -  &
                  P3(0)*x68 - P3(0)*x69 + P3(0)*x88 + P3(0)*x89 + P3(1)*x25 +  &
                  P3(1)*x26 - P3(1)*x70 - P3(1)*x81 - P3(1)*x82 + P3(2)*x30 +  &
                  P3(2)*x31 - P3(2)*x73 - P3(2)*x83 - P3(2)*x87 + P3(3)*x34 +  &
                  P3(3)*x35 - P3(3)*x84 - P3(3)*x85 - P4(1)*x70/2 - P4(2)*co(2 &
                  )*w2(2)*x61 - P4(2)*x73/2 - P4(2)*x83 - co(0)*x56 - co(1)*x40&
                   + co(1)*x45 + co(1)*x47 - co(1)*x53 + co(1)*x55 - co(2)*x45 &
                   - co(2)*x55 + co(3)*x45 + co(3)*x47 + co(3)*x55 + co(3)*x56 &
                   + co(3)*x60 - co(4)*x23*x48 + co(4)*x40 - co(4)*x45 - co(4)*&
                  x47 - co(5)*x23*x57 + co(5)*x53 - co(5)*x55 - co(5)*x60 - x0*&
                  x11 + x0*x2 - x0*x9 + x10*x11 - x10*x2 + x10*x9 - x11*x3 -   &
                  x11*x4 - x11*x5 - x11*x6 - x11*x7 + x11*x8 + x12*x13 - x12*  &
                  x17 + x13*x14 + x13*x15 - x13*x16 - x14*x17 - x15*x17 + x16* &
                  x17 + x17*x38 - x17*x74 - x17*x75 - x17*x77 + x18*x58 - x18* &
                  x72 - x18*x76 - x18*x78 - x18*x93 + x19*x65 + x2*x3 + x2*x4  &
                   + x2*x5 + x2*x6 + x2*x7 - x2*x8 + x21*x22 - x21*x36 + x21*  &
                  x39 - x21*x48 + x21*x50 - x21*x59 - x22*x32 + x22*x64 + x23* &
                  x58 - x23*x72 - x23*x76 - x23*x78 - x23*x93 + x24*x65 + x28* &
                  x29 - x28*x52 - x28*x64 - x28*x71 + x29*x33 + x29*x36 + x29* &
                  x48 + x29*x57 - x3*x9 + x32*x33 + x32*x36 - x32*x39 + x32*x46&
                   + x32*x48 - x32*x50 + x32*x57 + x32*x59 - x36*x52 - x36*x64 &
                   - x36*x71 + x37*x38 - x37*x74 - x37*x75 - x37*x77 - x38*x86 &
                   + x39*x41 - x39*x42 - x39*x44 + x39*x64 - x4*x9 - x41*x46 - &
                  x41*x48 + x42*x43 + x42*x46 + x42*x48 - x42*x50 + x42*x54 +  &
                  x42*x57 + x43*x44 - x43*x52 - x43*x64 + x44*x46 + x44*x48 -  &
                  x44*x50 + x44*x54 + x44*x57 + x44*x59 + x48*x49 - x48*x52 -  &
                  x48*x64 - x48*x71 + x49*x57 - x5*x9 + x50*x51 + x50*x52 + x50&
                  *x64 - x51*x57 - x51*x59 - x52*x54 - x52*x59 - x54*x64 - x59*&
                  x64 - x59*x71 - x6*x9 + x62*x63 - x62*x79 - x62*x80 + x63*x66&
                   - x66*x80 - x7*x9 - x72*x90 + x74*x86 + x75*x86 - x76*x90 + &
                  x77*x86 - x78*x90 - x79*x91 - x79*x92 + x8*x9 - x80*x91 - x80&
                  *x92)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVVSS
end module tcSVVSS
