!******************************************************************************!
!                                                                              !
!    tcSVVVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeSVVVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVVV0)
!       Metric(2,3)*Metric(4,5)*c0
!       Metric(2,4)*Metric(3,5)*c1
!       Metric(2,5)*Metric(3,4)*c2
        if (last) VB_last = .true.
        x0vec = co(0)*w4(:)
        x1vec = co(1)*w3(:)
        wout = w1(0)*(co(2)*w2(:)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) +  &
               w3(3)*w4(3)) - w2(0)*w3(0)*x0vec - w2(0)*w4(0)*x1vec + w2(1)*w3(&
               1)*x0vec + w2(1)*w4(1)*x1vec + w2(2)*w3(2)*x0vec + w2(2)*w4(2)* &
               x1vec + w2(3)*w3(3)*x0vec + w2(3)*w4(3)*x1vec)
      case(SVVVV1)
!       c0*(-Metric(2,4)*P(3,2)*P(5,3) + Metric(2,4)*P(3,4)*P(5,3) + Metric(2,4)*
!       P(3,5)*P(5,2) - Metric(2,4)*P(3,5)*P(5,4) - Metric(3,5)*P(2,3)*P(4,2) +  
!       Metric(3,5)*P(2,4)*P(4,3) - Metric(3,5)*P(2,4)*P(4,5) + Metric(3,5)*P(2,5
!       )*P(4,2))
!       c1*(-Metric(2,3)*P(4,2)*P(5,3) + Metric(2,5)*P(3,5)*P(4,2) + Metric(3,4)*
!       P(2,4)*P(5,3) - Metric(4,5)*P(2,4)*P(3,5))
!       c2*(-Metric(2,4)*P(3,2)*P(5,4) + Metric(2,5)*P(3,2)*P(4,5) + Metric(3,4)*
!       P(2,3)*P(5,4) - Metric(3,5)*P(2,3)*P(4,5))
!       c3*(Metric(2,3)*P(4,2)*P(5,4) - Metric(2,3)*P(4,3)*P(5,4) - Metric(2,3)*P
!       (4,5)*P(5,2) + Metric(2,3)*P(4,5)*P(5,3) - Metric(4,5)*P(2,3)*P(3,4) +   
!       Metric(4,5)*P(2,3)*P(3,5) + Metric(4,5)*P(2,4)*P(3,2) - Metric(4,5)*P(2,5
!       )*P(3,2))
!       c4*(Metric(2,3)*P(4,3)*P(5,2) - Metric(2,4)*P(3,4)*P(5,2) - Metric(3,5)*P
!       (2,5)*P(4,3) + Metric(4,5)*P(2,5)*P(3,4))
!       c5*(-Metric(2,5)*P(3,2)*P(4,3) + Metric(2,5)*P(3,4)*P(4,2) - Metric(2,5)*
!       P(3,4)*P(4,5) + Metric(2,5)*P(3,5)*P(4,3) - Metric(3,4)*P(2,3)*P(5,2) +  
!       Metric(3,4)*P(2,4)*P(5,2) + Metric(3,4)*P(2,5)*P(5,3) - Metric(3,4)*P(2,5
!       )*P(5,4))
!       c6*(-Metric(2,5)*Metric(3,4)*P(-1,2)*P(-1,3) + Metric(2,5)*Metric(3,4)*P 
!       (-1,2)*P(-1,4) + Metric(2,5)*Metric(3,4)*P(-1,3)*P(-1,5) - Metric(2,5)*  
!       Metric(3,4)*P(-1,4)*P(-1,5))
!       c7*(-Metric(2,3)*Metric(4,5)*P(-1,2)*P(-1,4) + Metric(2,3)*Metric(4,5)*P 
!       (-1,2)*P(-1,5) + Metric(2,3)*Metric(4,5)*P(-1,3)*P(-1,4) - Metric(2,3)*  
!       Metric(4,5)*P(-1,3)*P(-1,5))
!       c8*(-Metric(2,4)*Metric(3,5)*P(-1,2)*P(-1,3) + Metric(2,4)*Metric(3,5)*P 
!       (-1,2)*P(-1,5) + Metric(2,4)*Metric(3,5)*P(-1,3)*P(-1,4) - Metric(2,4)*  
!       Metric(3,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P3(0)**2
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x0vec = co(6)*w2(:)*x1
        x2 = P4(1)**2
        x3 = P4(2)**2
        x4 = P4(3)**2
        x5 = P2(0)**2
        x6 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x1vec = co(7)*w4(:)*x6
        x7 = P3(1)**2
        x8 = P3(2)**2
        x9 = P3(3)**2
        x10 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x2vec = co(8)*w3(:)*x10
        x11 = P4(0)**2
        x12 = P2(1)**2
        x13 = P2(2)**2
        x14 = P2(3)**2
        x15 = P1(0)*P2(0)
        x16 = P1(0)*w3(0)
        x3vec = P2(:)*co(0)*x10
        x17 = P1(0)*P3(0)
        x18 = P1(0)*w4(0)
        x4vec = P3(:)*co(3)*x6
        x5vec = P3(:)*co(5)*x1
        x19 = P1(0)*w2(0)
        x20 = P2(1)*w4(1)
        x21 = P2(2)*w4(2)
        x22 = P2(3)*w4(3)
        x23 = P2(0)*w4(0)
        x24 = x20 + x21 + x22 - x23
        x6vec = co(0)*w3(:)*x24
        x7vec = co(1)*w2(:)*x24
        x25 = P4(1)*w3(1)
        x26 = P4(2)*w3(2)
        x27 = P4(3)*w3(3)
        x28 = P4(0)*w3(0)
        x29 = x25 + x26 + x27 - x28
        x8vec = co(4)*w4(:)*x29
        x30 = P3(1)*w4(1)
        x31 = P3(2)*w4(2)
        x32 = P3(3)*w4(3)
        x33 = P3(0)*w4(0)
        x34 = x30 + x31 + x32 - x33
        x9vec = co(5)*w2(:)*x34
        x35 = P1(1)*w4(1)
        x10vec = P2(:)*co(3)*x6
        x36 = P1(1)*P3(1)
        x37 = P1(1)*P4(1)
        x38 = P1(1)*w3(1)
        x11vec = P4(:)*co(0)*x10
        x12vec = P4(:)*co(5)*x1
        x39 = P1(1)*w2(1)
        x40 = P2(1)*w3(1)
        x41 = P2(2)*w3(2)
        x42 = P2(3)*w3(3)
        x43 = P2(0)*w3(0)
        x44 = x40 + x41 + x42 - x43
        x13vec = co(3)*w4(:)*x44
        x14vec = co(4)*w3(:)*x34
        x45 = P1(2)*w4(2)
        x46 = P1(2)*P3(2)
        x47 = P1(2)*P4(2)
        x48 = P1(2)*w3(2)
        x49 = P1(2)*w2(2)
        x50 = P1(3)*w4(3)
        x51 = P1(3)*P3(3)
        x15vec = P4(3)*co(6)*w2(:)*x1
        x16vec = P1(3)*co(8)*w3(:)*x10
        x52 = P1(3)*w3(3)
        x17vec = P4(:)*x1
        x53 = P1(3)*w2(3)
        x18vec = P3(:)*co(0)*x10
        x19vec = P3(:)*co(1)*x6
        x54 = P2(0)*w2(0)
        x55 = P2(0)*co(2)*w3(0)
        x20vec = P4(:)*x10
        x56 = -x18 + x35 + x45 + x50
        x21vec = w2(:)*x56
        x22vec = w2(:)*x24
        x23vec = w2(:)*x34
        x57 = P4(1)*w4(1)
        x58 = P4(2)*w4(2)
        x59 = P4(3)*w4(3)
        x60 = P4(0)*w4(0)
        x61 = x57 + x58 + x59 - x60
        x24vec = co(2)*w2(:)*x61
        x25vec = P4(:)*co(3)*x6
        x62 = P2(1)*w2(1)
        x63 = P2(2)*w2(2)
        x64 = P2(3)*w2(3)
        x65 = P3(0)*w3(0)
        x66 = P3(0)*w2(0)
        x26vec = P2(:)*co(5)*x1
        x27vec = P2(:)*co(4)*x6
        x28vec = P2(:)*co(4)*x10
        x67 = P4(1)*w2(1)
        x68 = P4(2)*w2(2)
        x69 = P4(3)*w2(3)
        x70 = -x16 + x38 + x48 + x52
        x29vec = co(3)*w4(:)*x70
        x71 = P3(1)*w3(1)
        x72 = P3(2)*w3(2)
        x73 = P3(3)*w3(3)
        x74 = -x65 + x71 + x72 + x73
        x30vec = co(3)*w4(:)*x74
        x75 = P3(1)*w2(1)
        x31vec = P4(:)*co(2)*x1
        x32vec = P3(1)*co(2)*w2(1)*w3(:)
        x76 = P3(2)*w2(2)
        x33vec = P3(2)*co(2)*w2(2)*w3(:)
        x77 = P3(3)*w2(3)
        x34vec = P3(3)*co(2)*w2(3)*w3(:)
        x78 = P4(0)*w2(0)
        x35vec = P3(:)*x1
        x79 = P4(1)*co(1)*w2(1)
        x80 = P4(2)*co(1)*w2(2)
        x36vec = P3(:)*P4(3)*w2(3)*x1
        x37vec = P4(1)*co(0)*w2(1)*w3(:)
        x38vec = co(1)*w4(:)*x70
        x39vec = w4(:)*x44
        x40vec = co(1)*w4(:)*x74
        x41vec = w4(:)*x29
        x42vec = co(5)*w2(:)*x56
        x43vec = co(5)*w2(:)*x61
        x44vec = co(0)*w3(:)*x56
        x45vec = co(0)*w3(:)*x61
        x81 = P4(3)*co(1)*w2(3)
        x82 = P1(0)*P4(0)
        x83 = P1(1)*P2(1)
        x46vec = co(0)*w2(1)*w3(:)*x24
        x84 = P1(2)*P2(2)
        x47vec = P2(3)*co(7)*w4(:)*x6
        x85 = P2(1)*co(2)*w3(1)
        x86 = P2(2)*co(2)*w3(2)
        x48vec = P3(:)*co(5)*w2(3)*x1
        x87 = P2(3)*co(2)*w3(3)
        x49vec = P3(0)*co(2)*w2(0)*w3(:)
        x88 = P4(0)*co(1)*w2(0)
        x50vec = P4(0)*co(1)*w2(0)*w4(:)
        x89 = P4(0)*co(5)*w3(0)
        x51vec = 2*P2(0)*co(6)*w2(:)*x1
        x52vec = 2*co(6)*w2(:)*x1
        x90 = P2(1)*P3(1)
        x53vec = 2*co(8)*w3(:)*x10
        x54vec = 2*co(7)*w4(:)*x6
        x91 = P2(1)*P4(1)
        x55vec = 2*co(5)*w2(:)*x34
        x56vec = 2*P2(2)*co(6)*w2(:)*x1
        x57vec = 2*P3(2)*co(8)*w3(:)*x10
        x58vec = 2*P4(2)*co(7)*w4(:)*x6
        x92 = P2(3)*P3(3)
        x59vec = 2*P4(0)*co(7)*w4(:)*x6
        x60vec = 2*P3(0)*co(8)*w3(:)*x10
        x93 = 2*P3(1)*w2(1)
        x61vec = 2*co(0)*w3(:)*x24
        x62vec = 2*co(3)*w4(:)*x29
        x94 = -2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3)
        x63vec = co(0)*w3(:)*x94
        x64vec = 2*co(3)*w4(:)*x44
        x95 = P3(1)*P4(1)
        x96 = P3(3)*P4(3)
        x65vec = 2*co(5)*w2(:)*x24
        wout = -w1(0)*(-P1(1)*x46vec - P1(3)*P3(:)*co(5)*w2(3)*x1 + P1(3)*co(5 &
               )*w2(3)*x17vec + P1(3)*x15vec - P1(3)*x47vec + P2(0)*x59vec + P2&
               (0)*x60vec - P2(1)*x46vec - P2(2)*x57vec - P2(2)*x58vec + 2*P2(3&
               )*x15vec - P2(3)*x16vec - P2(3)*x48vec + P3(0)*x51vec - P3(0)*  &
               x59vec + P3(2)*co(2)*w2(2)*x17vec - P3(2)*x56vec + P3(2)*x58vec &
                - P3(3)*x48vec - 2*P4(0)*co(5)*w3(0)*x22vec - P4(0)*x51vec - P4&
               (0)*x60vec + P4(2)*x56vec + P4(2)*x57vec + P4(3)*x16vec - 2*P4(3&
               )*x47vec + co(1)*x36vec - co(3)*w4(:)*x29*x93 - co(5)*x36vec -  &
               w2(:)*x61*x89 + w4(:)*x74*x80 + x0*x0vec - x0*x1vec - x0vec*x11 &
                + x0vec*x17 + x0vec*x2 + x0vec*x3 - x0vec*x36 + x0vec*x37 +    &
               x0vec*x4 - x0vec*x46 + x0vec*x47 - x0vec*x51 - x0vec*x7 - x0vec*&
               x8 - x0vec*x82 - x0vec*x9 - x10vec*x18 + x10vec*x20 + x10vec*x21&
                + x10vec*x22 - x10vec*x23 + x10vec*x30 + x10vec*x31 + x10vec*  &
               x32 - x10vec*x33 + x10vec*x35 + x10vec*x45 + x10vec*x50 + x10vec&
               *x57 + x10vec*x58 + x10vec*x59 - x10vec*x60 - x11*x2vec - x11vec&
               *x16 + x11vec*x25 + x11vec*x26 + x11vec*x27 - x11vec*x28 +      &
               x11vec*x38 + x11vec*x40 + x11vec*x41 + x11vec*x42 - x11vec*x43  &
                + x11vec*x48 + x11vec*x52 - x11vec*x65 + x11vec*x71 + x11vec*  &
               x72 + x11vec*x73 - x12*x1vec - x12*x2vec - x12vec*x19 + x12vec* &
               x39 + x12vec*x49 - x12vec*x54 + x12vec*x62 + x12vec*x63 + x12vec&
               *x64 - x12vec*x66 + x12vec*x67 + x12vec*x68 + x12vec*x69 +      &
               x12vec*x75 + x12vec*x76 + x12vec*x77 - x12vec*x78 - x13*x1vec - &
               x13*x2vec - x13vec*x19 + x13vec*x39 + x13vec*x49 + x13vec*x53 - &
               x13vec*x54 + x13vec*x62 + x13vec*x63 + x13vec*x64 - x14*x1vec - &
               x14*x2vec - x14vec*x19 + x14vec*x39 + x14vec*x49 + x14vec*x53 - &
               x14vec*x54 + x14vec*x62 + x14vec*x63 + x14vec*x64 - x14vec*x66  &
                + x14vec*x67 + x14vec*x68 + x14vec*x69 + x14vec*x75 + x14vec*  &
               x76 + x14vec*x77 - x14vec*x78 + x15*x1vec + x15*x2vec + x16*    &
               x3vec + x16*x7vec + x16*x9vec - x17*x1vec + x18*x4vec + x18vec* &
               x25 + x18vec*x26 + x18vec*x27 - x18vec*x28 - x18vec*x40 - x18vec&
               *x41 - x18vec*x42 + x18vec*x43 + x19*x5vec + x19*x6vec + x19*   &
               x8vec - x19vec*x20 - x19vec*x21 - x19vec*x22 + x19vec*x23 +     &
               x1vec*x36 + x1vec*x46 + x1vec*x5 + x1vec*x51 + x1vec*x7 + x1vec*&
               x8 - x1vec*x83 - x1vec*x84 + x1vec*x9 + x2*x2vec + x20*x25vec - &
               x20*x4vec + x20vec*x55 - x20vec*x85 - x20vec*x86 - x20vec*x87 + &
               x21*x25vec - x21*x4vec + x21vec*x55 - x21vec*x85 - x21vec*x86 - &
               x21vec*x87 - x21vec*x89 + x22*x25vec - x22*x4vec + x22vec*x55 - &
               x22vec*x85 - x22vec*x86 - x22vec*x87 - x23*x25vec + x23*x4vec + &
               x23vec*x55 - x23vec*x85 - x23vec*x86 - x23vec*x87 + x24*x32vec  &
                + x24*x33vec + x24*x34vec - x24*x49vec - x24vec*x40 - x24vec*  &
               x41 - x24vec*x42 + x24vec*x43 - x25*x28vec - x25*x3vec + x25*   &
               x42vec + x25*x43vec + x25*x65vec - x25*x7vec - x25vec*x30 -     &
               x25vec*x31 - x25vec*x32 + x25vec*x33 - x26*x28vec - x26*x3vec + &
               x26*x42vec + x26*x43vec + x26*x65vec - x26*x7vec + x26vec*x66 + &
               x26vec*x67 + x26vec*x68 + x26vec*x69 - x26vec*x75 - x26vec*x76  &
                - x26vec*x77 - x26vec*x78 - x27*x28vec - x27*x3vec + x27*x42vec&
                + x27*x43vec + x27*x65vec - x27*x7vec + x27vec*x30 + x27vec*x31&
                + x27vec*x32 - x27vec*x33 + x28*x28vec + x28*x3vec + x28*x7vec &
                + x29vec*x66 - x29vec*x75 - x29vec*x76 - x29vec*x77 + x2vec*x3 &
                + x2vec*x37 + x2vec*x4 + x2vec*x47 + x2vec*x5 - x2vec*x82 -    &
               x2vec*x83 - x2vec*x84 - x30*x4vec + x30vec*x66 - x30vec*x75 -   &
               x30vec*x76 - x30vec*x77 - x31*x4vec - x31vec*x66 + x31vec*x75 + &
               x31vec*x77 - x32*x4vec + x32vec*x34 + x32vec*x56 + x32vec*x61 + &
               x33*x4vec + x33vec*x34 + x33vec*x56 + x33vec*x61 + x34*x34vec - &
               x34*x49vec + x34vec*x56 + x34vec*x61 - x35*x4vec + x35vec*x79 + &
               x35vec*x80 - x35vec*x88 + x37vec*x56 + x37vec*x61 + x37vec*x94  &
                - x38*x3vec - x38*x7vec - x38*x9vec + x38vec*x67 + x38vec*x68  &
                + x38vec*x69 - x39*x5vec - x39*x8vec + x39vec*x79 + x39vec*x80 &
                + x39vec*x81 - x39vec*x88 - x3vec*x40 - x3vec*x41 - x3vec*x42  &
                + x3vec*x43 - x3vec*x48 - x3vec*x52 + x3vec*x65 - x3vec*x71 -  &
               x3vec*x72 - x3vec*x73 - x40*x55vec - x40*x7vec + x40vec*x67 +   &
               x40vec*x69 - x41*x55vec - x41*x7vec + x41vec*x79 + x41vec*x80 + &
               x41vec*x81 - x41vec*x88 - x42*x55vec - x42*x7vec + x43*x55vec + &
               x43*x7vec + x44vec*x68 + x44vec*x69 - x44vec*x78 - x45*x4vec +  &
               x45vec*x68 + x45vec*x69 - x45vec*x78 - x48*x7vec - x48*x9vec -  &
               x49*x5vec - x49*x6vec - x49*x8vec - x49vec*x56 - x49vec*x61 -   &
               x4vec*x50 - x4vec*x57 - x4vec*x58 - x4vec*x59 + x4vec*x60 -     &
               x50vec*x70 - x50vec*x74 - x52*x7vec - x52*x9vec - x52vec*x90 +  &
               x52vec*x91 - x52vec*x92 - x53*x6vec - x53*x8vec - x53vec*x90 -  &
               x53vec*x92 + x53vec*x95 + x53vec*x96 + x54*x5vec + x54*x6vec +  &
               x54*x8vec - x54vec*x91 + x54vec*x95 + x54vec*x96 - x5vec*x62 -  &
               x5vec*x63 + x5vec*x66 - x5vec*x67 - x5vec*x68 - x5vec*x75 -     &
               x5vec*x76 + x5vec*x78 + x61vec*x66 - x61vec*x76 - x61vec*x77 -  &
               x62*x8vec + x62vec*x66 - x62vec*x76 - x62vec*x77 - x63*x6vec -  &
               x63*x8vec + x63vec*x68 + x63vec*x69 - x63vec*x78 - x64*x6vec -  &
               x64*x8vec + x64vec*x67 + x64vec*x68 + x64vec*x69 - x64vec*x78 + &
               x65*x7vec + x65*x9vec + x66*x8vec - x67*x8vec - x68*x8vec - x69*&
               x8vec - x6vec*x93 - x71*x7vec - x71*x9vec - x72*x7vec - x72*    &
               x9vec - x73*x7vec - x73*x9vec - x75*x8vec - x76*x8vec - x77*    &
               x8vec + x78*x8vec)
      end select 
    end subroutine treeSVVVV
end module tcSVVVV
