!******************************************************************************!
!                                                                              !
!    tcVSSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVSSSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSSV0)
!       P(1,1)*P(5,5)*c0
!       c1*(P(1,1)*P(5,1) + P(1,5)*P(5,5))
!       P(1,5)*P(5,1)*c2
!       c3*(P(1,1)*P(5,3) + P(1,1)*P(5,4) + P(1,5)*P(5,3) + P(1,5)*P(5,4))
!       c4*(2*P(1,3)*P(5,3) + P(1,3)*P(5,4) + P(1,4)*P(5,3) + 2*P(1,4)*P(5,4))
!       c5*(P(1,3)*P(5,1) + P(1,3)*P(5,5) + P(1,4)*P(5,1) + P(1,4)*P(5,5))
!       c6*(Metric(1,5)*P(-1,1)**2 + Metric(1,5)*P(-1,5)**2)
!       Metric(1,5)*P(-1,1)*P(-1,5)*c7
!       c8*(Metric(1,5)*P(-1,3)**2 + Metric(1,5)*P(-1,4)**2)
!       Metric(1,5)*P(-1,3)*P(-1,4)*c9
!       c10*(Metric(1,5)*P(-1,1)*P(-1,3) + Metric(1,5)*P(-1,1)*P(-1,4) + Metric(1
!       ,5)*P(-1,3)*P(-1,5) + Metric(1,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P3(0)**2
        x0vec = co(10)*w1(:)
        x1 = P4(0)**2
        x1vec = co(6)*w1(:)
        x2 = P3(1)**2
        x3 = P3(2)**2
        x4 = P3(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P1(0)**2
        x2vec = co(7)*w1(:)
        x3vec = co(8)*w1(:)
        x9 = P1(1)**2
        x10 = P1(2)**2
        x11 = P1(3)**2
        x4vec = 2*co(6)*w1(:)
        x12 = P1(0)*co(0)*w1(0)
        x13 = P1(0)*w1(0)
        x5vec = P1(:)*co(2)
        x6vec = P1(0)*co(7)*w1(:)
        x7vec = P1(0)*P2(:)*w1(0)
        x14 = P1(1)*w1(1)
        x8vec = P2(:)*co(1)
        x9vec = P3(:)*co(1)
        x10vec = P4(:)*co(1)
        x15 = P1(2)*co(1)*w1(2)
        x16 = P1(2)*w1(2)
        x17 = P1(3)*w1(3)
        x11vec = P4(:)*co(1)*w1(3)
        x18 = P2(0)*w1(0)
        x12vec = P1(:)*co(1)
        x19 = P2(1)*w1(1)
        x20 = P2(2)*co(1)*w1(2)
        x21 = P2(3)*w1(3)
        x22 = P3(0)*w1(0)
        x23 = P3(1)*w1(1)
        x24 = P3(2)*w1(2)
        x25 = P3(3)*w1(3)
        x26 = P4(0)*w1(0)
        x27 = P4(1)*w1(1)
        x28 = P4(2)*co(1)*w1(2)
        x29 = P4(3)*w1(3)
        x13vec = P2(0)*co(10)*w1(:)
        x14vec = P3(:)*co(3)
        x15vec = P4(:)*co(3)
        x16vec = P2(1)*P3(:)*w1(1)
        x30 = P2(2)*w1(2)
        x17vec = P2(:)*P3(0)*w1(0)
        x18vec = P2(:)*co(5)
        x19vec = P3(:)*co(5)
        x20vec = P4(:)*co(5)
        x21vec = co(9)*w1(:)
        x31 = P3(1)*P4(1)
        x22vec = P4(:)*co(4)
        x32 = P3(2)*P4(2)
        x33 = P3(3)*P4(3)
        x23vec = P3(:)*co(4)
        x34 = P4(2)*w1(2)
        x35 = P1(1)*co(0)*w1(1)
        x24vec = P1(1)*co(7)*w1(:)
        x36 = P1(2)*co(0)*w1(2)
        x25vec = P1(2)*co(7)*w1(:)
        x37 = P1(3)*co(0)*w1(3)
        x26vec = P1(3)*co(7)*w1(:)
        x27vec = P2(1)*co(10)*w1(:)
        x28vec = P2(2)*co(10)*w1(:)
        x29vec = P2(3)*co(10)*w1(:)
        x38 = P3(0)*P4(0)
        x30vec = 2*P1(:)*co(1)
        x31vec = 2*P2(0)*co(6)*w1(:)
        x32vec = 2*P1(0)*co(6)*w1(:)
        x33vec = 2*P3(:)*co(4)
        x34vec = 2*co(10)*w1(:)
        x35vec = 2*P4(:)*co(4)
        x36vec = 2*P2(1)*co(6)*w1(:)
        x37vec = 2*P1(1)*co(6)*w1(:)
        x38vec = 2*P1(2)*co(6)*w1(:)
        x39vec = 2*P1(3)*co(6)*w1(:)
        x40vec = 2*P2(2)*co(6)*w1(:)
        x41vec = 2*P2(3)*co(6)*w1(:)
        wout = w2(0)*w3(0)*w4(0)*(-P1(0)*x31vec + P1(1)*x36vec + P1(3)*x11vec  &
                + P1(:)*x12 + 2*P1(:)*x15 + P1(:)*x20 + P1(:)*x28 - P1(:)*x35  &
                - P1(:)*x36 - P1(:)*x37 - P2(0)**2*x1vec + P2(0)*x6vec + P2(1  &
               )**2*x1vec - P2(1)*x24vec + P2(2)**2*x1vec - P2(2)*x25vec + P2(2&
               )*x38vec + P2(3)**2*x1vec + P2(3)*x11vec - P2(3)*x26vec + P2(3)*&
               x39vec + P2(:)*x15 + P2(:)*x20 + P2(:)*x28 - P2(:)*x35 - P2(:)* &
               x36 - P2(:)*x37 + P3(0)*x13vec - P3(0)*x31vec - P3(0)*x32vec +  &
               P3(0)*x6vec - P3(1)*x24vec - P3(1)*x27vec + P3(1)*x36vec + P3(1 &
               )*x37vec - P3(2)*x25vec - P3(2)*x28vec + P3(2)*x38vec + P3(2)*  &
               x40vec + P3(3)*x11vec - P3(3)*x26vec - P3(3)*x29vec + P3(3)*    &
               x39vec + P3(3)*x41vec + P3(:)*x12 + P3(:)*x15 + P3(:)*x20 + P3  &
               (:)*x28 - P3(:)*x35 - P3(:)*x36 - P3(:)*x37 + P4(0)*x13vec - P4(&
               0)*x31vec - P4(0)*x32vec + P4(0)*x6vec - P4(1)*x24vec - P4(1)*  &
               x27vec + P4(1)*x36vec + P4(1)*x37vec - P4(2)*x25vec - P4(2)*    &
               x28vec + P4(2)*x38vec + P4(2)*x40vec + P4(3)*x11vec - P4(3)*    &
               x26vec - P4(3)*x29vec + P4(3)*x39vec + P4(3)*x41vec + P4(:)*x12 &
                - P4(:)*x35 - P4(:)*x36 - P4(:)*x37 + co(0)*x7vec + co(1)*     &
               x16vec - co(1)*x17vec - co(1)*x7vec - co(3)*x16vec + co(5)*     &
               x17vec + x0*x0vec - x0*x1vec - x0*x3vec + x0vec*x1 - x0vec*x2 - &
               x0vec*x3 - x0vec*x4 - x0vec*x5 - x0vec*x6 - x0vec*x7 - x1*x1vec &
                - x1*x3vec - x10*x2vec + x10*x4vec - x10vec*x13 + x10vec*x14 + &
               x10vec*x16 - x10vec*x18 + x10vec*x19 - x10vec*x22 + x10vec*x23  &
                + x10vec*x24 - x10vec*x26 + x10vec*x27 + x10vec*x30 + x10vec*  &
               x34 - x11*x2vec + x11*x4vec - x12vec*x18 + x12vec*x19 + x12vec* &
               x21 - x12vec*x22 + x12vec*x23 + x12vec*x24 + x12vec*x25 - x12vec&
               *x26 + x12vec*x27 + x12vec*x29 - x13*x30vec + x13*x5vec - x13*  &
               x9vec + x14*x30vec - x14*x5vec + x14*x8vec + x14*x9vec + x14vec*&
               x18 - x14vec*x21 + x14vec*x22 - x14vec*x23 - x14vec*x24 - x14vec&
               *x25 + x14vec*x26 - x14vec*x27 - x14vec*x29 - x14vec*x30 -      &
               x14vec*x34 + x15vec*x18 - x15vec*x19 - x15vec*x21 + x15vec*x22  &
                - x15vec*x23 - x15vec*x24 - x15vec*x25 + x15vec*x26 - x15vec*  &
               x27 - x15vec*x29 - x15vec*x30 - x15vec*x34 - x16*x5vec + x17*   &
               x30vec - x17*x5vec + x17*x8vec + x17*x9vec + x18*x5vec - x18*   &
               x8vec - x18*x9vec - x18vec*x23 - x18vec*x24 - x18vec*x25 +      &
               x18vec*x26 - x18vec*x27 - x18vec*x29 - x18vec*x34 - x19*x5vec + &
               x19*x8vec + x19vec*x22 - x19vec*x23 - x19vec*x24 - x19vec*x25 + &
               x19vec*x26 - x19vec*x27 - x19vec*x29 - x19vec*x34 + x1vec*x2 +  &
               x1vec*x3 + x1vec*x4 + x1vec*x5 + x1vec*x6 + x1vec*x7 + x2*x3vec &
                + x20vec*x22 - x20vec*x23 - x20vec*x24 - x20vec*x25 + x20vec*  &
               x26 - x20vec*x27 - x20vec*x29 - x20vec*x34 - x21*x5vec + x21*   &
               x8vec + x21*x9vec + x21vec*x31 + x21vec*x32 + x21vec*x33 -      &
               x21vec*x38 - x22*x22vec - x22*x33vec + x22*x5vec - x22*x9vec +  &
               x22vec*x23 + x22vec*x24 + x22vec*x25 + x23*x33vec - x23*x5vec + &
               x23*x8vec + x23*x9vec - x23vec*x26 + x23vec*x27 + x23vec*x29 +  &
               x23vec*x34 + x24*x33vec - x24*x5vec + x24*x8vec + x24*x9vec +   &
               x25*x33vec - x25*x5vec + x25*x8vec + x25*x9vec - x26*x35vec +   &
               x26*x5vec - x26*x8vec - x26*x9vec + x27*x35vec - x27*x5vec + x27&
               *x8vec + x27*x9vec + x29*x35vec - x29*x5vec + x29*x8vec + x29*  &
               x9vec + x2vec*x8 - x2vec*x9 + x3*x3vec - x30*x5vec - x31*x34vec &
                + x31*x4vec - x32*x34vec + x32*x4vec - x33*x34vec + x33*x4vec  &
                + x34*x35vec - x34*x5vec + x34vec*x38 - x38*x4vec + x3vec*x4 + &
               x3vec*x5 + x3vec*x6 + x3vec*x7 - x4vec*x8 + x4vec*x9)
      end select 
    end subroutine treeVSSSV
end module tcVSSSV
