!******************************************************************************!
!                                                                              !
!    tcVSSV.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSV.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVSSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m, &
    wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSV0)
!       P(1,4)*P(4,1)*c0
!       P(1,1)*P(4,4)*c1
!       c2*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       Metric(1,4)*P(-1,1)*P(-1,4)*c3
!       c4*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x0vec = co(3)*w1(:)
        x1vec = co(4)*w1(:)
        x1 = P1(1)**2
        x2 = P1(2)**2
        x3 = P1(3)**2
        x2vec = 2*co(4)*w1(:)
        x3vec = P1(:)*co(0)
        x4 = P1(0)*w1(0)
        x4vec = P1(:)*co(1)
        x5vec = P1(0)*co(3)*w1(:)
        x6vec = P2(:)*co(1)
        x7vec = P3(:)*co(1)
        x8vec = P2(:)*co(2)
        x5 = P1(1)*w1(1)
        x9vec = P3(:)*co(2)
        x6 = P1(2)*w1(2)
        x10vec = P2(:)*co(2)*w1(3)
        x7 = P1(3)*w1(3)
        x8 = P2(0)*w1(0)
        x11vec = P1(:)*co(2)
        x9 = P2(1)*w1(1)
        x10 = P2(2)*w1(2)
        x11 = P2(3)*w1(3)
        x12 = P3(0)*w1(0)
        x13 = P3(1)*w1(1)
        x14 = P3(2)*w1(2)
        x15 = P3(3)*w1(3)
        x12vec = P1(1)*co(3)*w1(:)
        x13vec = P1(2)*co(3)*w1(:)
        x14vec = P1(3)*co(3)*w1(:)
        x15vec = 2*P1(:)*co(2)
        x16vec = 2*P2(0)*co(4)*w1(:)
        x17vec = 2*P2(1)*co(4)*w1(:)
        x18vec = 2*P1(2)*co(4)*w1(:)
        x19vec = 2*P3(3)*co(4)*w1(:)
        wout = w2(0)*w3(0)*(-P1(0)*P3(0)*x2vec - P1(0)*x16vec + P1(1)*P3(1)*   &
               x2vec + P1(1)*x17vec + P1(3)*P2(3)*x2vec + P1(3)*x10vec + P1(3)*&
               x19vec - P2(0)**2*x1vec + P2(0)*x5vec + P2(1)**2*x1vec - P2(1)* &
               x12vec + P2(2)**2*x1vec + P2(2)*P3(2)*x2vec - P2(2)*x13vec + P2(&
               2)*x18vec + P2(3)**2*x1vec + P2(3)*x10vec - P2(3)*x14vec + P2(3 &
               )*x19vec - P3(0)**2*x1vec - P3(0)*x16vec + P3(0)*x5vec + P3(1)**&
               2*x1vec - P3(1)*x12vec + P3(1)*x17vec + P3(2)**2*x1vec - P3(2)* &
               x13vec + P3(2)*x18vec + P3(3)**2*x1vec - P3(3)*x14vec + x0*x0vec&
                - x0*x2vec - x0vec*x1 - x0vec*x2 - x0vec*x3 + x1*x2vec + x10*  &
               x11vec - x10*x3vec + x10*x8vec + x10*x9vec + x11*x11vec - x11*  &
               x3vec + x11*x9vec - x11vec*x12 + x11vec*x13 + x11vec*x14 +      &
               x11vec*x15 - x11vec*x8 + x11vec*x9 + x12*x3vec - x12*x8vec - x12&
               *x9vec - x13*x3vec + x13*x8vec + x13*x9vec - x14*x3vec + x14*   &
               x8vec + x14*x9vec - x15*x3vec + x15*x8vec + x15*x9vec - x15vec* &
               x4 + x15vec*x5 + x15vec*x6 + x15vec*x7 + x2*x2vec + x2vec*x3 +  &
               x3vec*x4 - x3vec*x5 - x3vec*x6 - x3vec*x7 + x3vec*x8 - x3vec*x9 &
                + x4*x4vec + x4*x6vec + x4*x7vec - x4*x8vec - x4*x9vec - x4vec*&
               x5 - x4vec*x6 - x4vec*x7 - x5*x6vec - x5*x7vec + x5*x8vec + x5* &
               x9vec - x6*x6vec - x6*x7vec + x6*x8vec + x6*x9vec - x6vec*x7 -  &
               x7*x7vec + x7*x9vec - x8*x8vec - x8*x9vec + x8vec*x9 + x9*x9vec)
      end select 
    end subroutine treeVSSV
end module tcVSSV
