!******************************************************************************!
!                                                                              !
!    tcVSSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVSSVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSVS0)
!       P(1,4)*P(4,1)*c0
!       c1*(P(1,1)*P(4,3) + P(1,1)*P(4,5) + P(1,4)*P(4,3) + P(1,4)*P(4,5))
!       c2*(2*P(1,3)*P(4,3) + P(1,3)*P(4,5) + P(1,5)*P(4,3) + 2*P(1,5)*P(4,5))
!       c3*(P(1,3)*P(4,1) + P(1,3)*P(4,4) + P(1,5)*P(4,1) + P(1,5)*P(4,4))
!       P(1,1)*P(4,4)*c4
!       c5*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       Metric(1,4)*P(-1,1)*P(-1,4)*c6
!       c7*(Metric(1,4)*P(-1,3)**2 + Metric(1,4)*P(-1,5)**2)
!       Metric(1,4)*P(-1,3)*P(-1,5)*c8
!       c9*(Metric(1,4)*P(-1,1)*P(-1,3) + Metric(1,4)*P(-1,1)*P(-1,5) + Metric(1,
!       4)*P(-1,3)*P(-1,4) + Metric(1,4)*P(-1,4)*P(-1,5))
!       c10*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
        x0 = P1(0)**2
        x1 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x2 = co(10)*x1
        x3 = P4(0)**2
        x4 = co(7)*x1
        x5 = P3(1)**2
        x6 = co(8)*x1
        x7 = P3(2)**2
        x8 = P3(3)**2
        x9 = P1(1)**2
        x10 = co(9)*x1
        x11 = P1(2)**2
        x12 = P1(3)**2
        x13 = P4(1)**2
        x14 = P4(2)**2
        x15 = P4(3)**2
        x16 = P3(0)**2
        x17 = 2*co(7)*x1
        x18 = co(6)*x1
        x19 = P1(0)*P4(0)
        x20 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x21 = co(2)*x20
        x22 = P1(0)*w1(0)
        x23 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x24 = co(4)*x23
        x25 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x26 = P1(0)*w1(0)*x25
        x27 = P2(1)*co(9)*x1
        x28 = P3(1)*co(8)*x1
        x29 = co(1)*x25
        x30 = P1(1)*w1(1)
        x31 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x32 = co(1)*x31
        x33 = co(1)*x23
        x34 = co(3)*x25
        x35 = co(3)*x23
        x36 = P2(2)*co(9)*x1
        x37 = P3(2)*co(8)*x1
        x38 = P1(2)*w1(2)
        x39 = co(3)*w1(2)*x25
        x40 = P2(3)*co(9)*x1
        x41 = P3(3)*co(8)*x1
        x42 = P1(3)*w1(3)
        x43 = P1(3)*w1(3)*x23
        x44 = P2(0)*w1(0)
        x45 = P2(1)*w1(1)
        x46 = P2(2)*w1(2)
        x47 = w1(3)*x25
        x48 = P2(3)*co(3)
        x49 = w1(3)*x23
        x50 = co(2)*x25
        x51 = P3(0)*w1(0)
        x52 = co(2)*x31
        x53 = co(2)*x23
        x54 = P4(0)*w1(0)*x25
        x55 = P4(0)*w1(0)
        x56 = co(5)*x23
        x57 = P4(1)*w1(1)
        x58 = P4(1)*co(3)*w1(1)
        x59 = P4(2)*w1(2)
        x60 = P4(3)*w1(3)
        x61 = P4(3)*w1(3)*x23
        x62 = P4(3)*w1(3)*x25
        x63 = P2(0)*co(9)*x1
        x64 = P3(0)*co(8)*x1
        x65 = P1(1)*P4(1)
        x66 = co(5)*x25
        x67 = P1(2)*P4(2)
        x68 = P1(3)*P4(3)
        x69 = co(2)*w1(3)*x20
        x70 = P3(1)*w1(1)
        x71 = P3(2)*w1(2)
        x72 = P3(3)*co(2)
        x73 = co(0)*x25
        x74 = 2*co(9)*x1
        x75 = 2*P2(1)*co(7)*x1
        x76 = 2*P3(1)*co(7)*x1
        x77 = 2*co(2)*x25
        x78 = 2*co(2)*x31
        x79 = 2*co(2)*x23
        x80 = 2*P2(2)*co(7)*x1
        x81 = 2*P3(2)*co(7)*x1
        x82 = 2*P2(3)*co(7)*x1
        x83 = 2*P3(3)*co(7)*x1
        x84 = 2*co(2)
        x85 = 2*P2(3)*co(2)
        x86 = 2*co(2)*x20
        x87 = 2*P2(0)*co(7)*x1
        x88 = 2*P3(0)*co(7)*x1
        wout(0) = -w2(0)*w3(0)*(-P1(0)*x63 - P1(0)*x64 + P1(0)*x87 + P1(0)*x88 &
                   + P1(1)*x27 + P1(1)*x28 - P1(1)*x75 - P1(1)*x76 + P1(2)*x36 &
                   + P1(2)*x37 + P1(2)*x39 - P1(2)*x80 - P1(2)*x81 + P1(3)*x40 &
                   + P1(3)*x41 - P1(3)*x82 - P1(3)*x83 + P2(0)**2*x4 - P2(0)*  &
                  x64 - P2(1)**2*x4 + P2(1)*x28 - P2(1)*x76 - P2(2)**2*x4 + P2(&
                  2)*x37 + P2(2)*x39 - P2(2)*x81 - P2(3)**2*x4 - P2(3)*w1(3)*  &
                  x78 + P2(3)*x41 - P2(3)*x69 - P2(3)*x83 + P3(0)*x87 - 2*P3(3 &
                  )*x69 - P4(0)*x63 - P4(0)*x64 + P4(0)*x87 + P4(0)*x88 + P4(1 &
                  )*x27 + P4(1)*x28 - P4(1)*x75 - P4(1)*x76 + P4(2)*x36 + P4(2 &
                  )*x37 + P4(2)*x39 - P4(2)*x80 - P4(2)*x81 + P4(3)*x40 + P4(3 &
                  )*x41 - P4(3)*x82 - P4(3)*x83 + co(0)*x54 - co(0)*x62 - co(1 &
                  )*x26 + co(1)*x43 + co(1)*x61 - co(3)*x26 + co(3)*x43 - co(3 &
                  )*x54 + co(3)*x61 + co(3)*x62 - co(4)*x43 + co(5)*x26 - co(5 &
                  )*x61 - w1(3)*x31*x72 - x0*x10 + x0*x2 + x0*x4 + x10*x11 +   &
                  x10*x12 + x10*x13 + x10*x14 + x10*x15 - x10*x3 + x10*x9 - x11&
                  *x2 - x11*x4 - x12*x2 - x12*x4 - x13*x2 - x13*x4 - x14*x2 -  &
                  x14*x4 - x15*x2 - x15*x4 + x16*x17 - x16*x6 + x17*x19 - x17* &
                  x5 - x17*x65 - x17*x67 - x17*x68 - x17*x7 - x17*x8 + x18*x19 &
                   - x18*x65 - x18*x67 - x18*x68 - x19*x74 + x2*x3 - x2*x9 +   &
                  x21*x22 - x21*x30 - x21*x38 - x21*x42 + x21*x44 - x21*x45 -  &
                  x21*x46 + x21*x55 - x21*x57 - x21*x59 - x21*x60 + x22*x24 -  &
                  x22*x32 - x22*x33 - x22*x35 + x22*x78 + x22*x79 + x23*x58 -  &
                  x24*x30 - x24*x38 + x25*x58 + x26*x84 + x29*x30 + x29*x38 +  &
                  x29*x42 - x29*x55 + x29*x57 + x29*x59 + x29*x60 + x3*x4 + x30&
                  *x32 + x30*x33 + x30*x34 + x30*x35 - x30*x66 - x30*x77 - x30*&
                  x78 - x30*x79 + x32*x38 + x32*x42 - x32*x55 + x32*x57 + x32* &
                  x59 + x32*x60 + x33*x38 - x33*x55 + x33*x57 + x33*x59 + x34* &
                  x42 - x34*x44 + x34*x45 + x35*x38 - x35*x44 + x35*x45 + x35* &
                  x46 - x35*x55 + x35*x59 - x38*x66 - x38*x77 - x38*x78 - x38* &
                  x79 - x4*x9 - x42*x66 - x42*x77 - x42*x78 - x43*x84 + x44*x77&
                   + x44*x78 + x44*x79 - x45*x77 - x45*x78 - x45*x79 - x46*x77 &
                   - x46*x78 - x46*x79 + x47*x48 - x47*x72 - x47*x85 + x48*x49 &
                   - x49*x72 - x49*x85 + x5*x6 + x50*x51 - x50*x70 - x50*x71 + &
                  x51*x52 + x51*x53 + x51*x86 - x52*x70 - x52*x71 - x53*x70 -  &
                  x53*x71 + x54*x84 + x55*x56 + x55*x78 + x55*x79 - x56*x57 -  &
                  x56*x59 - x57*x73 - x57*x77 - x57*x78 - x57*x79 - x59*x73 -  &
                  x59*x77 - x59*x78 - x59*x79 + x6*x7 + x6*x8 - x60*x78 - x61* &
                  x84 - x62*x84 + x65*x74 + x67*x74 + x68*x74 - x70*x86 - x71* &
                  x86)
        wout(1:3) = cnul
      end select 
    end subroutine treeVSSVS
end module tcVSSVS
