!******************************************************************************!
!                                                                              !
!    tcVSVVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSVVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVSVVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSVVV0)
!       Metric(1,3)*Metric(4,5)*c0
!       Metric(1,4)*Metric(3,5)*c1
!       Metric(1,5)*Metric(3,4)*c2
        if (last) VB_last = .true.
        x0vec = co(0)*w4(:)
        x1vec = co(1)*w3(:)
        wout = w2(0)*(co(2)*w1(:)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) +  &
               w3(3)*w4(3)) - w1(0)*w3(0)*x0vec - w1(0)*w4(0)*x1vec + w1(1)*w3(&
               1)*x0vec + w1(1)*w4(1)*x1vec + w1(2)*w3(2)*x0vec + w1(2)*w4(2)* &
               x1vec + w1(3)*w3(3)*x0vec + w1(3)*w4(3)*x1vec)
      case(VSVVV1)
!       c0*(-Metric(1,3)*P(4,3)*P(5,1) + Metric(1,4)*P(3,4)*P(5,1) + Metric(3,5)*
!       P(1,5)*P(4,3) - Metric(4,5)*P(1,5)*P(3,4))
!       c1*(-Metric(1,3)*P(4,1)*P(5,4) + Metric(1,3)*P(4,3)*P(5,4) + Metric(1,3)*
!       P(4,5)*P(5,1) - Metric(1,3)*P(4,5)*P(5,3) + Metric(4,5)*P(1,3)*P(3,4) -  
!       Metric(4,5)*P(1,3)*P(3,5) - Metric(4,5)*P(1,4)*P(3,1) + Metric(4,5)*P(1,5
!       )*P(3,1))
!       c2*(-Metric(1,4)*P(3,1)*P(5,4) + Metric(1,5)*P(3,1)*P(4,5) + Metric(3,4)*
!       P(1,3)*P(5,4) - Metric(3,5)*P(1,3)*P(4,5))
!       c3*(-Metric(1,5)*P(3,1)*P(4,3) + Metric(1,5)*P(3,4)*P(4,1) - Metric(1,5)*
!       P(3,4)*P(4,5) + Metric(1,5)*P(3,5)*P(4,3) - Metric(3,4)*P(1,3)*P(5,1) +  
!       Metric(3,4)*P(1,4)*P(5,1) + Metric(3,4)*P(1,5)*P(5,3) - Metric(3,4)*P(1,5
!       )*P(5,4))
!       c4*(-Metric(1,3)*P(4,1)*P(5,3) + Metric(1,5)*P(3,5)*P(4,1) + Metric(3,4)*
!       P(1,4)*P(5,3) - Metric(4,5)*P(1,4)*P(3,5))
!       c5*(-Metric(1,4)*P(3,1)*P(5,3) + Metric(1,4)*P(3,4)*P(5,3) + Metric(1,4)*
!       P(3,5)*P(5,1) - Metric(1,4)*P(3,5)*P(5,4) - Metric(3,5)*P(1,3)*P(4,1) +  
!       Metric(3,5)*P(1,4)*P(4,3) - Metric(3,5)*P(1,4)*P(4,5) + Metric(3,5)*P(1,5
!       )*P(4,1))
!       c6*(-Metric(1,3)*Metric(4,5)*P(-1,1)*P(-1,4) + Metric(1,3)*Metric(4,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,3)*Metric(4,5)*P(-1,3)*P(-1,4) - Metric(1,3)*  
!       Metric(4,5)*P(-1,3)*P(-1,5))
!       c7*(-Metric(1,5)*Metric(3,4)*P(-1,1)*P(-1,3) + Metric(1,5)*Metric(3,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,5)*Metric(3,4)*P(-1,3)*P(-1,5) - Metric(1,5)*  
!       Metric(3,4)*P(-1,4)*P(-1,5))
!       c8*(-Metric(1,4)*Metric(3,5)*P(-1,1)*P(-1,3) + Metric(1,4)*Metric(3,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,4)*Metric(3,5)*P(-1,3)*P(-1,4) - Metric(1,4)*  
!       Metric(3,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x1 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x0vec = co(6)*w4(:)*x1
        x2 = P3(1)**2
        x3 = P3(2)**2
        x4 = P3(3)**2
        x5 = P3(0)**2
        x6 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x1vec = co(7)*w1(:)*x6
        x7 = P4(1)**2
        x8 = P4(2)**2
        x9 = P4(3)**2
        x10 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x2vec = co(8)*w3(:)*x10
        x11 = P1(1)**2
        x12 = P1(2)**2
        x13 = P1(3)**2
        x14 = P4(0)**2
        x15 = P1(0)*w4(0)
        x3vec = P1(:)*co(1)*x1
        x16 = P1(0)*w3(0)
        x4vec = P1(:)*co(5)*x10
        x17 = P1(0)*P2(0)
        x5vec = P3(:)*co(3)*w1(0)*x6
        x6vec = P3(:)*co(4)*x1
        x7vec = P3(:)*co(5)*x10
        x8vec = P4(:)*co(1)*x1
        x9vec = P4(:)*co(2)*x10
        x18 = P3(1)*w4(1)
        x19 = P3(2)*w4(2)
        x20 = P3(3)*w4(3)
        x21 = P3(0)*w4(0)
        x22 = x18 + x19 + x20 - x21
        x10vec = co(0)*w1(0)*w3(:)*x22
        x23 = P1(1)*w3(1)
        x24 = P1(2)*w3(2)
        x25 = P1(3)*w3(3)
        x26 = -x16 + x23 + x24 + x25
        x11vec = co(1)*w1(0)*w4(:)*x26
        x27 = P1(1)*w4(1)
        x28 = P1(2)*w4(2)
        x29 = P1(3)*w4(3)
        x30 = -x15 + x27 + x28 + x29
        x12vec = P1(0)*co(2)*w1(:)*w3(0)
        x31 = P2(1)*w4(1)
        x32 = P2(2)*w4(2)
        x33 = P2(3)*w4(3)
        x34 = P2(0)*w4(0)
        x35 = x31 + x32 + x33 - x34
        x13vec = co(2)*w1(:)*x35
        x36 = P4(1)*w4(1)
        x37 = P4(2)*w4(2)
        x38 = P4(3)*w4(3)
        x39 = P4(0)*w4(0)
        x40 = x36 + x37 + x38 - x39
        x14vec = co(4)*w1(:)*x30
        x15vec = co(5)*w1(0)*w3(:)*x30
        x16vec = P3(:)*co(1)*x1
        x41 = P1(1)*w1(1)
        x17vec = P4(:)*co(3)*x6
        x18vec = P4(:)*co(5)*x10
        x42 = P4(1)*w3(1)
        x43 = P4(2)*w3(2)
        x44 = P4(3)*w3(3)
        x45 = P4(0)*w3(0)
        x46 = x42 + x43 + x44 - x45
        x19vec = co(0)*w1(1)*w4(:)*x46
        x20vec = P4(:)*co(3)*w1(2)*x6
        x47 = co(0)*x46
        x21vec = P1(2)*w1(2)*w4(:)
        x48 = P1(3)*w1(3)
        x22vec = co(0)*w4(:)*x46
        x49 = P2(0)*w3(0)
        x23vec = P1(:)*co(0)*x1
        x50 = P3(0)*w1(0)
        x24vec = P1(:)*co(3)*x6
        x51 = P3(0)*w3(0)
        x25vec = P1(:)*co(0)*x10
        x52 = P4(1)*w1(1)
        x53 = P4(2)*w1(2)*x6
        x54 = P4(3)*w1(3)
        x26vec = P2(0)*co(7)*w1(:)*x6
        x27vec = co(3)*w1(:)*x22
        x28vec = P2(1)*co(6)*w4(:)*x1
        x55 = P2(1)*P4(1)
        x56 = P2(1)*w1(1)
        x57 = P2(1)*w3(1)
        x29vec = P2(1)*w1(1)*w4(:)
        x30vec = P2(2)*co(6)*w4(:)*x1
        x31vec = P2(2)*co(7)*w1(:)*x6
        x32vec = P2(2)*co(8)*w3(:)*x10
        x58 = P2(2)*w3(2)
        x33vec = P2(2)*w1(2)*w4(:)
        x34vec = P2(3)*co(6)*w4(:)*x1
        x35vec = P2(3)*co(7)*w1(:)*x6
        x36vec = P2(3)*co(8)*w3(:)*x10
        x59 = P2(3)*w1(3)
        x60 = P2(3)*w3(3)
        x61 = P3(1)*w1(1)
        x37vec = P4(:)*co(2)*x6
        x62 = P3(1)*w3(1)
        x38vec = P3(1)*w1(1)*w4(:)
        x63 = -x49 + x57 + x58 + x60
        x64 = co(1)*x63
        x65 = P3(2)*w3(2)
        x66 = P3(3)*w3(3)
        x67 = -x51 + x62 + x65 + x66
        x68 = co(1)*x67
        x39vec = P3(1)*co(2)*w1(1)*w3(:)
        x40vec = co(2)*w3(:)*x22
        x69 = P3(2)*co(3)*w1(2)*x6
        x41vec = P3(2)*w1(2)*w4(:)
        x42vec = P3(2)*co(2)*w1(2)*w3(:)
        x70 = P3(2)*w1(2)
        x71 = P3(3)*w1(3)
        x43vec = P3(3)*w1(3)*w4(:)
        x44vec = P3(3)*co(2)*w1(3)*w3(:)
        x45vec = P3(:)*co(4)*x6
        x46vec = co(3)*w1(:)*x35
        x47vec = co(3)*w1(:)*x40
        x48vec = P4(1)*co(4)*w1(1)*w4(:)
        x49vec = co(5)*w3(:)*x35
        x50vec = co(5)*w3(:)*x40
        x51vec = P4(2)*w1(2)*w4(:)
        x52vec = P4(2)*co(4)*w1(2)*w4(:)
        x72 = co(4)*x46
        x73 = P4(2)*w1(2)
        x53vec = P4(3)*co(4)*w1(3)*w4(:)
        x54vec = P4(3)*w1(3)*w4(:)
        x55vec = P4(:)*co(3)*w1(0)*x6
        x56vec = co(0)*w1(0)*w4(:)*x46
        x57vec = P1(1)*co(8)*w3(:)*x10
        x58vec = P3(:)*co(3)*x6
        x59vec = co(0)*w3(:)*x22
        x60vec = co(1)*w1(1)*w4(:)*x26
        x61vec = P1(1)*co(2)*w1(:)*w3(1)
        x62vec = co(5)*w3(:)*x30
        x63vec = P3(:)*co(3)*w1(2)*x6
        x64vec = co(0)*w1(2)*w3(:)*x22
        x74 = co(1)*x26
        x65vec = P1(2)*co(2)*w1(:)*w3(2)
        x66vec = co(5)*w1(2)*w3(:)*x30
        x67vec = co(1)*w4(:)*x26
        x68vec = P1(3)*co(2)*w1(:)*w3(3)
        x75 = P4(0)*w1(0)
        x69vec = P3(0)*co(6)*w4(:)*x1
        x70vec = P4(0)*co(8)*w3(:)*x10
        x71vec = P3(1)*co(7)*w1(:)*x6
        x72vec = P3(0)*w1(0)*w4(:)
        x73vec = P3(0)*co(2)*w1(0)*w3(:)
        x74vec = P4(0)*co(4)*w1(0)*w4(:)
        x75vec = P4(0)*co(5)*w1(0)*w3(:)
        x76vec = 2*P1(0)*co(7)*w1(:)*x6
        x77vec = 2*co(6)*w4(:)*x1
        x76 = P1(1)*P4(1)
        x78vec = 2*co(3)*w1(:)*x22
        x79vec = 2*P1(2)*co(7)*w1(:)*x6
        x80vec = 2*P3(2)*co(8)*w3(:)*x10
        x81vec = 2*P4(2)*co(6)*w4(:)*x1
        x82vec = 2*P1(3)*co(7)*w1(:)*x6
        x83vec = 2*P3(3)*co(8)*w3(:)*x10
        x84vec = 2*P4(3)*co(6)*w4(:)*x1
        x77 = 2*P4(0)
        x78 = 2*P3(0)
        x79 = 2*co(1)*x46
        x85vec = 2*co(5)*w3(:)*x30
        x86vec = 2*co(3)*w1(:)*x30
        x80 = 2*co(1)*x26
        x81 = P3(1)*P4(1)
        x87vec = 2*co(5)*w3(:)*x22
        wout = -w2(0)*(P1(0)*P4(0)*x77vec + P1(0)*co(8)*w3(:)*x10*x78 + P1(0)* &
               x10vec + P1(0)*x11vec + P1(0)*x15vec - P1(0)*x55vec - P1(0)*    &
               x56vec + P1(0)*x5vec + P1(1)*x19vec - P1(1)*x28vec - P1(1)*     &
               x60vec - 2*P1(1)*x71vec + P1(2)*x20vec - P1(2)*x30vec - P1(2)*  &
               x32vec - P1(2)*x63vec - P1(2)*x64vec - P1(2)*x66vec - P1(2)*    &
               x80vec - P1(2)*x81vec - P1(3)*x34vec - P1(3)*x36vec - P1(3)*    &
               x83vec - P1(3)*x84vec + P1(:)*co(3)*x53 - P1(:)*x69 + P2(0)*    &
               x10vec + P2(0)*x11vec + P2(0)*x15vec - P2(0)*x55vec - P2(0)*    &
               x56vec + P2(0)*x5vec - P2(0)*x69vec - P2(0)*x70vec - P2(1)*     &
               x57vec - P2(1)*x71vec + P2(2)*x20vec - P2(2)*x63vec - P2(2)*    &
               x64vec - P2(2)*x66vec + P3(0)*x10vec + P3(0)*x26vec - P3(0)*    &
               x56vec + P3(0)*x5vec + P3(0)*x76vec + P3(1)*x28vec - 2*P3(1)*   &
               x57vec + P3(2)*P4(:)*co(2)*w1(2)*x6 + P3(2)*x30vec - P3(2)*     &
               x31vec - P3(2)*x63vec - P3(2)*x79vec + P3(2)*x81vec + P3(3)*    &
               x34vec - P3(3)*x35vec - P3(3)*x82vec + P3(3)*x84vec + P3(:)*co(4&
               )*x53 + P4(0)*x10vec - P4(0)*x26vec - P4(0)*x56vec + P4(0)*x5vec&
                - P4(0)*x76vec + P4(1)*x19vec - 2*P4(1)*x60vec + P4(2)*x20vec  &
                + P4(2)*x31vec + P4(2)*x32vec - P4(2)*x63vec - P4(2)*x64vec +  &
               P4(2)*x79vec + P4(2)*x80vec + P4(3)*x35vec + P4(3)*x36vec + P4(3&
               )*x82vec + P4(3)*x83vec + P4(:)*x69 + 2*co(7)*w1(:)*x6*x76 + 2* &
               co(8)*w3(:)*x10*x81 + x0*x0vec + x0*x2vec - x0vec*x11 - x0vec*  &
               x12 - x0vec*x13 + x0vec*x17 + x0vec*x2 + x0vec*x3 + x0vec*x4 -  &
               x0vec*x5 - x11*x2vec + x11vec*x77 - x12*x2vec + x12vec*x22 +    &
               x12vec*x30 + x12vec*x40 - x13*x2vec + x13vec*x16 - x13vec*x23 - &
               x13vec*x24 - x13vec*x25 - x14*x1vec - x14*x2vec + x14vec*x16 -  &
               x14vec*x23 - x14vec*x24 - x14vec*x25 - x14vec*x42 - x14vec*x43  &
                - x14vec*x44 + x14vec*x45 + x14vec*x49 + x14vec*x51 - x14vec*  &
               x57 - x14vec*x58 - x14vec*x60 - x14vec*x62 - x14vec*x65 - x14vec&
               *x66 - x15*x16vec + x15*x3vec + x15*x6vec + x15*x8vec + x15vec* &
               x78 - x16*x18vec + x16*x4vec + x16*x78vec + x16*x7vec + x16*    &
               x9vec + x16vec*x18 + x16vec*x19 + x16vec*x20 - x16vec*x21 +     &
               x16vec*x27 + x16vec*x28 + x16vec*x29 + x16vec*x31 + x16vec*x32  &
                + x16vec*x33 - x16vec*x34 + x16vec*x36 + x16vec*x37 + x16vec*  &
               x38 - x16vec*x39 + x17*x2vec + x17vec*x41 + x17vec*x48 - x17vec*&
               x50 + x17vec*x52 + x17vec*x54 + x17vec*x56 + x17vec*x59 + x17vec&
               *x61 + x17vec*x71 - x17vec*x75 - x18*x23vec - x18*x3vec + x18*  &
               x8vec + x18vec*x23 + x18vec*x24 + x18vec*x25 + x18vec*x42 +     &
               x18vec*x43 + x18vec*x44 - x18vec*x45 - x18vec*x49 - x18vec*x51  &
                + x18vec*x57 + x18vec*x58 + x18vec*x60 + x18vec*x62 + x18vec*  &
               x65 + x18vec*x66 - x19*x23vec - x19*x3vec + x19*x8vec - x1vec*x2&
                - x1vec*x3 - x1vec*x4 + x1vec*x5 + x1vec*x55 + x1vec*x7 + x1vec&
               *x8 + x1vec*x9 - x20*x23vec - x20*x3vec + x20*x8vec + x21*x23vec&
                + x21*x3vec - x21*x8vec + x21vec*x47 - x21vec*x74 + x22*x44vec &
                - x22*x61vec - x22*x65vec - x22*x68vec + x22vec*x48 + x22vec*  &
               x54 + x22vec*x59 + x22vec*x71 - x23*x4vec - x23*x78vec - x23*   &
               x7vec - x23*x9vec - x24*x4vec - x24*x78vec - x24*x7vec - x24*   &
               x9vec + x24vec*x50 + x24vec*x52 + x24vec*x54 - x24vec*x61 -     &
               x24vec*x71 - x24vec*x75 - x25*x4vec - x25*x78vec - x25*x7vec -  &
               x25*x9vec + x25vec*x42 + x25vec*x43 + x25vec*x44 - x25vec*x45 + &
               x26*x48vec + x26*x52vec + x26*x53vec - x26*x74vec - x27*x3vec - &
               x27*x6vec - x27*x8vec + x27vec*x49 + x27vec*x51 - x27vec*x57 -  &
               x27vec*x58 - x27vec*x60 - x27vec*x62 - x27vec*x65 - x27vec*x66  &
                - x28*x3vec - x28*x6vec - x28*x8vec - x29*x3vec - x29*x6vec -  &
               x29*x8vec + x29vec*x47 - x29vec*x74 + x2vec*x55 + x2vec*x7 +    &
               x2vec*x8 + x2vec*x9 + x30*x39vec + x30*x42vec + x30*x44vec - x30&
               *x61vec - x30*x65vec - x30*x68vec - x30*x73vec - x31*x3vec - x32&
               *x3vec - x33*x3vec + x33vec*x47 - x33vec*x74 + x34*x3vec + x35* &
               x39vec + x35*x42vec + x35*x44vec - x35*x73vec - x35*x75vec - x36&
               *x3vec - x37*x3vec - x37vec*x50 + x37vec*x61 + x37vec*x71 - x38*&
               x3vec + x38vec*x47 + x38vec*x64 + x38vec*x68 + x38vec*x79 + x39*&
               x3vec + x39vec*x40 + x40*x42vec + x40*x44vec - x40*x61vec - x40*&
               x65vec - x40*x68vec - x40*x73vec - x40*x75vec - x40vec*x50 +    &
               x40vec*x61 + x40vec*x70 - x41*x58vec - x41*x59vec - x41*x62vec  &
                + x41vec*x47 + x41vec*x64 + x41vec*x68 + x41vec*x79 + x42*     &
               x46vec + x42*x47vec - x42*x4vec + x42*x7vec + x42*x86vec + x43* &
               x46vec + x43*x47vec - x43*x4vec + x43*x7vec + x43*x86vec +      &
               x43vec*x64 + x43vec*x68 + x43vec*x79 + x44*x46vec + x44*x47vec  &
                - x44*x4vec + x44*x7vec + x44*x86vec - x45*x46vec - x45*x47vec &
                + x45*x4vec - x45*x7vec - x45*x86vec + x45vec*x52 + x45vec*x54 &
                - x45vec*x75 + x46*x48vec - x46*x74vec + x47*x51vec - x48*     &
               x58vec - x48*x59vec - x48*x62vec - x48*x67vec + x48vec*x63 +    &
               x48vec*x67 + x49*x4vec + x49vec*x52 + x49vec*x54 + x49vec*x73 + &
               x4vec*x51 - x4vec*x57 - x4vec*x58 - x4vec*x60 - x4vec*x62 -     &
               x4vec*x65 - x4vec*x66 + x50vec*x52 + x50vec*x54 + x50vec*x73 +  &
               x51vec*x72 - x51vec*x80 - x52*x58vec - x52*x59vec + x52*x87vec  &
                + x52vec*x63 + x52vec*x67 + x53vec*x63 + x53vec*x67 - x54*     &
               x58vec - x54*x59vec + x54*x87vec + x54vec*x72 - x54vec*x80 - x56&
               *x58vec - x56*x59vec - x56*x62vec - x58vec*x59 - x58vec*x61 -   &
               x58vec*x71 - x59*x59vec - x59*x62vec - x59*x67vec - x59vec*x61  &
                - x59vec*x70 - x59vec*x71 - x61*x85vec - x63*x74vec - x64*     &
               x72vec - x67*x74vec - x68*x72vec - x69vec*x77 - x70*x85vec -    &
               x70vec*x78 - x71*x85vec - x72vec*x79 + x73*x87vec - x75vec*(-2* &
               P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3)) -  &
               x76*x77vec + x77vec*x81)
      end select 
    end subroutine treeVSVVV
end module tcVSVVV
