!******************************************************************************!
!                                                                              !
!    tcVVSSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVSSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVSSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVVSSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVSSS0)
!       P(1,2)*P(2,1)*c0
!       c1*(P(1,1)*P(2,4) + P(1,1)*P(2,5) + P(1,2)*P(2,4) + P(1,2)*P(2,5))
!       c2*(2*P(1,4)*P(2,4) + P(1,4)*P(2,5) + P(1,5)*P(2,4) + 2*P(1,5)*P(2,5))
!       c3*(P(1,4)*P(2,1) + P(1,4)*P(2,2) + P(1,5)*P(2,1) + P(1,5)*P(2,2))
!       P(1,1)*P(2,2)*c4
!       c5*(P(1,1)*P(2,1) + P(1,2)*P(2,2))
!       c6*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,2)**2)
!       Metric(1,2)*P(-1,1)*P(-1,2)*c7
!       c8*(Metric(1,2)*P(-1,4)**2 + Metric(1,2)*P(-1,5)**2)
!       Metric(1,2)*P(-1,4)*P(-1,5)*c9
!       c10*(Metric(1,2)*P(-1,1)*P(-1,4) + Metric(1,2)*P(-1,1)*P(-1,5) + Metric(1
!       ,2)*P(-1,2)*P(-1,4) + Metric(1,2)*P(-1,2)*P(-1,5))
        x0 = P1(1)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = co(10)*x1
        x3 = P1(2)**2
        x4 = P1(3)**2
        x5 = P2(1)**2
        x6 = P2(2)**2
        x7 = P2(3)**2
        x8 = P1(0)**2
        x9 = co(6)*x1
        x10 = P2(0)**2
        x11 = co(8)*x1
        x12 = P4(1)**2
        x13 = co(9)*x1
        x14 = P4(2)**2
        x15 = P4(3)**2
        x16 = P4(0)**2
        x17 = 2*co(8)*x1
        x18 = co(7)*x1
        x19 = P1(0)*P2(0)
        x20 = P1(0)*w1(0)
        x21 = -P4(0)*w2(0) + P4(1)*w2(1) + P4(2)*w2(2) + P4(3)*w2(3)
        x22 = co(2)*x21
        x23 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x24 = co(4)*x23
        x25 = P1(1)*w2(1)
        x26 = P1(2)*w2(2)
        x27 = P1(3)*w2(3)
        x28 = P1(0)*w2(0)
        x29 = x25 + x26 + x27 - x28
        x30 = co(5)*x29
        x31 = P3(1)*co(10)*x1
        x32 = P4(1)*co(9)*x1
        x33 = P1(1)*w1(1)
        x34 = co(1)*x29
        x35 = co(1)*x23
        x36 = -P3(0)*w2(0) + P3(1)*w2(1) + P3(2)*w2(2) + P3(3)*w2(3)
        x37 = co(1)*x36
        x38 = co(3)*x23
        x39 = P1(2)*w1(2)
        x40 = P1(3)*w1(3)
        x41 = co(3)*(-x20 + x33 + x39 + x40)
        x42 = P2(1)*w1(1)
        x43 = P2(2)*w1(2)
        x44 = P2(3)*w1(3)
        x45 = P2(0)*w1(0)
        x46 = co(3)*(x42 + x43 + x44 - x45)
        x47 = P3(1)*w1(1)
        x48 = P3(2)*w1(2)
        x49 = P3(3)*w1(3)
        x50 = P3(0)*w1(0)
        x51 = co(3)*(x47 + x48 + x49 - x50)
        x52 = P4(1)*w1(1)
        x53 = P4(2)*w1(2)
        x54 = P4(3)*w1(3)
        x55 = P4(0)*w1(0)
        x56 = co(3)*(x52 + x53 + x54 - x55)
        x57 = P3(2)*co(10)*x1
        x58 = P4(2)*co(9)*x1
        x59 = P3(3)*co(10)*x1
        x60 = P4(3)*co(9)*x1
        x61 = P1(3)*co(1)*w1(3)
        x62 = co(0)*x29
        x63 = co(5)*x23
        x64 = co(2)*x29
        x65 = co(2)*x23
        x66 = co(2)*x36
        x67 = co(3)*x29
        x68 = P3(0)*co(10)*x1
        x69 = P4(0)*co(9)*x1
        x70 = P1(1)*P2(1)
        x71 = P1(2)*P2(2)
        x72 = P1(3)*P2(3)
        x73 = P4(2)*co(2)*w1(2)
        x74 = 2*co(10)*x1
        x75 = 2*P3(1)*co(8)*x1
        x76 = 2*P4(1)*co(8)*x1
        x77 = 2*co(2)*x29
        x78 = 2*co(2)*x23
        x79 = 2*co(2)*x36
        x80 = 2*P1(2)*co(8)*x1
        x81 = 2*P3(3)*co(8)*x1
        x82 = 2*P4(3)*co(8)*x1
        x83 = 2*P2(2)*co(8)*x1
        x84 = 2*co(2)*x21
        x85 = 2*P1(0)*co(8)*x1
        x86 = 2*P2(0)*co(8)*x1
        x87 = 2*P3(0)*w1(0)
        wout(0) = -w3(0)*w4(0)*(-P1(0)*x68 - P1(0)*x69 + P1(1)*x31 + P1(1)*x32 &
                   - P1(1)*x75 - P1(1)*x76 + P1(2)*x57 + P1(2)*x58 + P1(3)*x59 &
                   + P1(3)*x60 - P1(3)*x81 - P1(3)*x82 - P2(0)*x68 - P2(0)*x69 &
                   + P2(1)*x31 + P2(1)*x32 - P2(1)*x75 - P2(1)*x76 + P2(2)*x57 &
                   + P2(2)*x58 + P2(3)*x59 + P2(3)*x60 - P2(3)*x81 - P2(3)*x82 &
                   + P3(0)**2*x11 + P3(0)*P4(0)*x17 - P3(0)*x69 + P3(0)*x85 +  &
                  P3(0)*x86 - P3(1)**2*x11 + P3(1)*x32 - P3(2)**2*x11 - P3(2)* &
                  P4(2)*x17 + P3(2)*x58 - P3(2)*x80 - P3(2)*x83 - P3(3)**2*x11 &
                   + P3(3)*x60 + P4(0)*x85 + P4(0)*x86 - P4(1)*x75 - P4(2)*x80 &
                   - P4(2)*x83 - P4(3)*x81 - x0*x11 + x0*x2 - x0*x9 + x10*x11  &
                   - x10*x2 + x10*x9 - x11*x3 - x11*x4 - x11*x5 - x11*x6 - x11*&
                  x7 + x11*x8 + x12*x13 - x12*x17 + x13*x14 + x13*x15 - x13*x16&
                   - x14*x17 - x15*x17 + x16*x17 + x17*x19 - x17*x70 - x17*x71 &
                   - x17*x72 + x18*x19 - x18*x70 - x18*x71 - x18*x72 - x19*x74 &
                   + x2*x3 + x2*x4 + x2*x5 + x2*x6 + x2*x7 - x2*x8 + x20*x22 + &
                  x20*x24 + x20*x30 - x20*x34 - x20*x35 - x20*x37 - x20*x38 +  &
                  x20*x77 + x20*x78 + x20*x79 - x22*x33 - x22*x39 - x22*x40 -  &
                  x22*x42 - x22*x43 - x22*x44 + x22*x45 - x22*x47 - x22*x48 -  &
                  x22*x49 + x22*x50 + x23*x61 - x23*x73 - x24*x33 - x24*x39 -  &
                  x24*x40 + x25*x41 + x25*x46 + x25*x51 + x25*x56 + x26*x41 +  &
                  x26*x46 + x26*x51 + x26*x56 + x27*x41 + x27*x46 + x27*x51 +  &
                  x27*x56 - x28*x41 - x28*x46 - x28*x51 - x28*x56 - x29*x73 -  &
                  x3*x9 - x30*x33 - x30*x39 - x30*x40 + x33*x34 + x33*x35 + x33&
                  *x37 + x33*x38 - x33*x77 - x33*x78 - x33*x79 + x34*x39 + x34*&
                  x40 + x34*x42 + x34*x43 + x34*x44 - x34*x45 + x35*x39 + x35* &
                  x42 + x35*x43 + x35*x44 - x35*x45 + x36*x61 - x36*x73 + x37* &
                  x39 + x37*x42 + x37*x43 + x37*x44 - x37*x45 + x38*x39 + x38* &
                  x40 + x38*x42 + x38*x43 + x38*x44 - x38*x45 + x38*x47 + x38* &
                  x48 + x38*x49 - x38*x50 - x39*x77 - x39*x78 - x39*x79 - x4*x9&
                   - x40*x77 - x40*x78 - x40*x79 - x42*x62 - x42*x63 - x42*x77 &
                   - x42*x78 - x42*x79 - x43*x62 - x43*x63 - x43*x77 - x43*x78 &
                   - x43*x79 - x44*x62 - x44*x63 - x44*x77 - x44*x78 - x44*x79 &
                   + x45*x62 + x45*x63 + x45*x77 + x45*x78 + x45*x79 - x47*x77 &
                   - x47*x78 - x47*x79 - x48*x77 - x48*x78 - x48*x79 - x49*x77 &
                   - x49*x78 - x49*x79 - x5*x9 + x50*x79 - x52*x64 - x52*x65 - &
                  x52*x66 - x52*x67 - x52*x84 - x53*x67 - x53*x84 - x54*x64 -  &
                  x54*x65 - x54*x66 - x54*x67 - x54*x84 + x55*x64 + x55*x65 +  &
                  x55*x66 + x55*x67 + x55*x84 - x6*x9 + x64*x87 + x65*x87 - x7*&
                  x9 + x70*x74 + x71*x74 + x72*x74 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeVVSSS
end module tcVVSSS
