!******************************************************************************!
!                                                                              !
!    tcVVSVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVSVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVVSVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVSVV0)
!       Metric(1,2)*Metric(4,5)*c0
!       Metric(1,4)*Metric(2,5)*c1
!       Metric(1,5)*Metric(2,4)*c2
        if (last) VB_last = .true.
        x0vec = co(0)*w4(:)
        x1vec = co(1)*w2(:)
        wout = w3(0)*(co(2)*w1(:)*(-w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) +  &
               w2(3)*w4(3)) - w1(0)*w2(0)*x0vec - w1(0)*w4(0)*x1vec + w1(1)*w2(&
               1)*x0vec + w1(1)*w4(1)*x1vec + w1(2)*w2(2)*x0vec + w1(2)*w4(2)* &
               x1vec + w1(3)*w2(3)*x0vec + w1(3)*w4(3)*x1vec)
      case(VVSVV1)
!       c0*(-Metric(1,2)*P(4,2)*P(5,1) + Metric(1,4)*P(2,4)*P(5,1) + Metric(2,5)*
!       P(1,5)*P(4,2) - Metric(4,5)*P(1,5)*P(2,4))
!       c1*(-Metric(1,2)*P(4,1)*P(5,4) + Metric(1,2)*P(4,2)*P(5,4) + Metric(1,2)*
!       P(4,5)*P(5,1) - Metric(1,2)*P(4,5)*P(5,2) + Metric(4,5)*P(1,2)*P(2,4) -  
!       Metric(4,5)*P(1,2)*P(2,5) - Metric(4,5)*P(1,4)*P(2,1) + Metric(4,5)*P(1,5
!       )*P(2,1))
!       c2*(-Metric(1,4)*P(2,1)*P(5,4) + Metric(1,5)*P(2,1)*P(4,5) + Metric(2,4)*
!       P(1,2)*P(5,4) - Metric(2,5)*P(1,2)*P(4,5))
!       c3*(-Metric(1,5)*P(2,1)*P(4,2) + Metric(1,5)*P(2,4)*P(4,1) - Metric(1,5)*
!       P(2,4)*P(4,5) + Metric(1,5)*P(2,5)*P(4,2) - Metric(2,4)*P(1,2)*P(5,1) +  
!       Metric(2,4)*P(1,4)*P(5,1) + Metric(2,4)*P(1,5)*P(5,2) - Metric(2,4)*P(1,5
!       )*P(5,4))
!       c4*(-Metric(1,2)*P(4,1)*P(5,2) + Metric(1,5)*P(2,5)*P(4,1) + Metric(2,4)*
!       P(1,4)*P(5,2) - Metric(4,5)*P(1,4)*P(2,5))
!       c5*(-Metric(1,4)*P(2,1)*P(5,2) + Metric(1,4)*P(2,4)*P(5,2) + Metric(1,4)*
!       P(2,5)*P(5,1) - Metric(1,4)*P(2,5)*P(5,4) - Metric(2,5)*P(1,2)*P(4,1) +  
!       Metric(2,5)*P(1,4)*P(4,2) - Metric(2,5)*P(1,4)*P(4,5) + Metric(2,5)*P(1,5
!       )*P(4,1))
!       c6*(-Metric(1,2)*Metric(4,5)*P(-1,1)*P(-1,4) + Metric(1,2)*Metric(4,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,2)*Metric(4,5)*P(-1,2)*P(-1,4) - Metric(1,2)*  
!       Metric(4,5)*P(-1,2)*P(-1,5))
!       c7*(-Metric(1,5)*Metric(2,4)*P(-1,1)*P(-1,2) + Metric(1,5)*Metric(2,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,5)*Metric(2,4)*P(-1,2)*P(-1,5) - Metric(1,5)*  
!       Metric(2,4)*P(-1,4)*P(-1,5))
!       c8*(-Metric(1,4)*Metric(2,5)*P(-1,1)*P(-1,2) + Metric(1,4)*Metric(2,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,4)*Metric(2,5)*P(-1,2)*P(-1,4) - Metric(1,4)*  
!       Metric(2,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x0vec = co(6)*w4(:)*x1
        x2 = P2(1)**2
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P2(0)**2
        x6 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x1vec = co(7)*w1(:)*x6
        x7 = P4(1)**2
        x8 = P4(2)**2
        x9 = P4(3)**2
        x10 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x2vec = co(8)*w2(:)*x10
        x11 = P1(1)**2
        x12 = P1(2)**2
        x13 = P1(3)**2
        x14 = P4(0)**2
        x15 = P1(0)*w4(0)
        x3vec = P1(:)*co(1)*x1
        x16 = P1(0)*w2(0)
        x4vec = P1(:)*co(5)*x10
        x5vec = P2(:)*co(3)*x6
        x17 = P1(0)*w1(0)
        x6vec = P2(:)*co(4)*x1
        x7vec = P2(:)*co(5)*x10
        x8vec = P3(0)*co(6)*w4(:)*x1
        x9vec = P3(0)*co(8)*w2(:)*x10
        x10vec = P4(:)*co(1)*x1
        x18 = P2(1)*w4(1)
        x19 = P2(2)*w4(2)
        x20 = P2(3)*w4(3)
        x21 = P2(0)*w4(0)
        x22 = x18 + x19 + x20 - x21
        x11vec = co(0)*w2(:)*x22
        x23 = P1(1)*w2(1)
        x24 = P1(2)*w2(2)
        x25 = P1(3)*w2(3)
        x26 = -x16 + x23 + x24 + x25
        x12vec = co(1)*w1(0)*w4(:)*x26
        x27 = P1(1)*w4(1)
        x28 = P1(2)*w4(2)
        x29 = P1(3)*w4(3)
        x30 = -x15 + x27 + x28 + x29
        x13vec = P1(0)*co(2)*w1(:)*w2(0)
        x31 = P3(1)*w4(1)
        x32 = P3(2)*w4(2)
        x33 = P3(3)*w4(3)
        x34 = P3(0)*w4(0)
        x35 = x31 + x32 + x33 - x34
        x14vec = co(2)*w1(:)*x35
        x36 = P4(1)*w4(1)
        x37 = P4(2)*w4(2)
        x38 = P4(3)*w4(3)
        x39 = P4(0)*w4(0)
        x40 = x36 + x37 + x38 - x39
        x15vec = co(2)*w1(:)*x40
        x16vec = co(4)*w1(:)*x30
        x17vec = co(5)*w2(:)*x30
        x18vec = P2(:)*co(1)*x1
        x19vec = P4(:)*co(3)*x6
        x41 = P1(1)*w1(1)
        x20vec = P4(:)*co(5)*x10
        x42 = P4(1)*w2(1)
        x43 = P4(2)*w2(2)
        x44 = P4(3)*w2(3)
        x45 = P4(0)*w2(0)
        x46 = x42 + x43 + x44 - x45
        x21vec = co(0)*w4(:)*x46
        x47 = P1(2)*w1(2)
        x22vec = co(0)*w1(2)*w4(:)*x46
        x48 = P1(3)*w1(3)
        x23vec = P1(:)*co(0)*x1
        x49 = P2(0)*w1(0)
        x24vec = P1(:)*co(3)*x6
        x50 = P2(0)*w2(0)
        x51 = P3(0)*w2(0)
        x25vec = P1(:)*co(0)*x10
        x52 = P4(1)*w1(1)
        x53 = P4(2)*w1(2)
        x54 = P4(3)*w1(3)
        x26vec = P3(0)*co(7)*w1(:)*x6
        x27vec = co(3)*w1(:)*x22
        x55 = P2(1)*P3(1)
        x28vec = P4(:)*co(2)*x6
        x56 = P2(1)*w1(1)
        x57 = P2(1)*w2(1)
        x58 = P2(2)*w2(2)
        x59 = P2(3)*w2(3)
        x60 = -x50 + x57 + x58 + x59
        x29vec = co(1)*w4(:)*x60
        x61 = P3(1)*w2(1)
        x62 = P3(2)*w2(2)
        x63 = P3(3)*w2(3)
        x64 = -x51 + x61 + x62 + x63
        x30vec = co(1)*w4(:)*x64
        x65 = P2(1)*co(2)*w1(1)
        x31vec = w2(:)*x30
        x32vec = w2(:)*x22
        x66 = P2(2)*P3(2)
        x67 = P2(2)*w1(2)
        x33vec = P2(2)*co(2)*w1(2)*w2(:)
        x34vec = P2(2)*w1(2)*w2(:)
        x35vec = P3(3)*co(6)*w4(:)*x1
        x68 = P2(3)*w1(3)
        x69 = P2(3)*co(2)*w1(3)
        x36vec = co(2)*w2(:)*x35
        x37vec = co(2)*w2(:)*x40
        x70 = P3(0)*w1(0)
        x71 = P4(0)*w1(0)
        x38vec = P2(:)*co(4)*x6
        x72 = P3(1)*P4(1)
        x73 = P3(1)*w1(1)
        x74 = P3(2)*P4(2)
        x75 = P3(2)*w1(2)
        x39vec = P3(3)*co(7)*w1(:)*x6
        x40vec = P3(3)*co(8)*w2(:)*x10
        x76 = P3(3)*w1(3)
        x41vec = co(3)*w1(:)*x35
        x42vec = co(3)*w1(:)*x40
        x43vec = co(4)*w4(:)*x26
        x44vec = co(4)*w4(:)*x60
        x45vec = co(4)*w4(:)*x64
        x46vec = co(4)*w4(:)*x46
        x47vec = co(5)*w2(:)*x35
        x48vec = co(5)*w2(:)*x40
        x49vec = P4(2)*co(5)*w1(2)*w2(:)
        x50vec = P2(:)*co(3)*w1(1)*x6
        x77 = P1(1)*P3(1)
        x51vec = P4(:)*co(2)*x10
        x52vec = co(0)*w1(1)*w2(:)*x22
        x53vec = co(1)*w4(:)*x26
        x54vec = co(2)*w1(:)*x30
        x55vec = co(2)*w1(:)*x22
        x78 = P1(2)*P3(2)
        x79 = co(0)*x22
        x56vec = P1(2)*w1(2)*w2(:)
        x80 = co(5)*x30
        x81 = P2(2)*co(3)*w1(2)*x6
        x57vec = P2(0)*co(1)*w1(0)*w4(:)
        x82 = P2(0)*co(2)*w1(0)
        x58vec = P3(2)*w1(2)*w2(:)
        x59vec = 2*co(7)*w1(:)*x6
        x83 = P1(0)*P4(0)
        x84 = P1(1)*P2(1)
        x60vec = 2*co(8)*w2(:)*x10
        x61vec = 2*co(6)*w4(:)*x1
        x85 = P1(1)*P4(1)
        x62vec = 2*co(3)*w1(:)*x22
        x63vec = 2*P2(2)*co(8)*w2(:)*x10
        x86 = P1(2)*P4(2)
        x87 = P1(3)*P2(3)
        x88 = P1(3)*P4(3)
        x64vec = 2*P2(0)*co(8)*w2(:)*x10
        x89 = -2*P4(0)*w2(0) + 2*P4(1)*w2(1) + 2*P4(2)*w2(2) + 2*P4(3)*w2(3)
        x65vec = 2*co(5)*w2(:)*x30
        x66vec = 2*co(3)*w1(:)*x30
        x67vec = 2*co(5)*w2(:)*x22
        x90 = 2*P4(1)*w1(1)
        x68vec = 2*co(1)*w4(:)*x26
        x91 = P2(1)*P4(1)
        x69vec = co(1)*w4(:)*x89
        x92 = P2(3)*P4(3)
        wout = -w3(0)*(P1(0)*P2(0)*x59vec + P1(0)*P4(:)*co(2)*w2(0)*x10 + P1(0 &
               )*x12vec + P1(0)*x64vec + P1(0)*x8vec + P1(0)*x9vec - P1(1)*    &
               x50vec - P1(1)*x52vec - P1(2)*P2(2)*x59vec + P1(2)*x22vec - P1(2&
               )*x63vec - P1(3)*x35vec - P1(3)*x40vec - P1(:)*x81 - P2(0)*P4(0 &
               )*x61vec + P2(0)*x26vec - P2(0)*x8vec - P2(1)*x50vec - P2(1)*   &
               x52vec + P2(2)*P4(2)*x61vec - 2*P2(2)*w1(2)*w2(:)*x80 + P2(3)*  &
               x35vec - P2(3)*x39vec - P2(:)*x81 + P3(0)*x12vec - P3(1)*x50vec &
                - P3(1)*x52vec + P3(2)*x22vec + 2*P4(0)*x12vec - P4(0)*x26vec  &
                - P4(0)*x64vec - P4(0)*x9vec - P4(1)*x52vec - P4(2)*w1(2)*w2   &
               (:)*x79 + P4(2)*x22vec + P4(2)*x63vec + P4(3)*x39vec + P4(3)*   &
               x40vec + co(2)*x34vec*x40 + co(5)*w2(:)*x22*x90 + w2(:)*x35*x65 &
                + w2(:)*x40*x65 + x0*x0vec + x0*x2vec - x0vec*x11 - x0vec*x12  &
                - x0vec*x13 + x0vec*x2 + x0vec*x3 + x0vec*x4 - x0vec*x5 + x0vec&
               *x55 + x0vec*x66 - x0vec*x77 - x0vec*x78 + x10vec*x15 + x10vec* &
               x18 + x10vec*x19 + x10vec*x20 - x10vec*x21 - x10vec*x27 - x10vec&
               *x28 - x10vec*x29 - x11*x2vec + x11vec*x17 - x11vec*x48 + x11vec&
               *x49 - x11vec*x54 - x11vec*x68 + x11vec*x70 + x11vec*x71 -      &
               x11vec*x76 - x12*x2vec - x13*x2vec + x13vec*x22 + x13vec*x30 -  &
               x14*x1vec - x14*x2vec + x14vec*x16 - x14vec*x23 - x14vec*x24 -  &
               x14vec*x25 - x15*x18vec + x15*x3vec + x15*x6vec + x15vec*x16 -  &
               x15vec*x23 - x15vec*x24 - x15vec*x25 + x16*x16vec - x16*x20vec  &
                + x16*x4vec + x16*x62vec + x16*x7vec - x16vec*x23 - x16vec*x24 &
                - x16vec*x25 - x16vec*x42 - x16vec*x43 - x16vec*x44 + x16vec*  &
               x45 + x16vec*x50 + x16vec*x51 - x16vec*x57 - x16vec*x58 - x16vec&
               *x59 - x16vec*x61 - x16vec*x62 - x16vec*x63 + x17*x17vec - x17* &
               x19vec - x17*x21vec + x17*x5vec - x17vec*x41 - x17vec*x48 +     &
               x17vec*x70 - x17vec*x73 - x17vec*x76 + x18*x18vec - x18*x23vec  &
                - x18*x3vec + x18vec*x19 + x18vec*x20 - x18vec*x21 + x18vec*x27&
                + x18vec*x28 + x18vec*x29 + x18vec*x31 + x18vec*x32 + x18vec*  &
               x33 - x18vec*x34 + x18vec*x36 + x18vec*x37 + x18vec*x38 - x18vec&
               *x39 - x19*x23vec - x19*x3vec + x19vec*x41 + x19vec*x47 + x19vec&
               *x48 - x19vec*x49 + x19vec*x52 + x19vec*x53 + x19vec*x54 +      &
               x19vec*x56 + x19vec*x67 + x19vec*x68 - x19vec*x70 - x19vec*x71  &
                + x19vec*x73 + x19vec*x75 + x19vec*x76 - x1vec*x2 - x1vec*x3 - &
               x1vec*x4 + x1vec*x5 - x1vec*x55 - x1vec*x66 + x1vec*x7 + x1vec* &
               x72 + x1vec*x74 + x1vec*x8 + x1vec*x9 - x20*x23vec - x20*x3vec  &
                + x20vec*x23 + x20vec*x24 + x20vec*x25 + x20vec*x42 + x20vec*  &
               x43 + x20vec*x44 - x20vec*x45 - x20vec*x50 - x20vec*x51 + x20vec&
               *x57 + x20vec*x58 + x20vec*x59 + x20vec*x61 + x20vec*x62 +      &
               x20vec*x63 + x21*x23vec + x21*x3vec + x21vec*x41 + x21vec*x48 - &
               x21vec*x49 + x21vec*x52 + x21vec*x54 + x21vec*x56 + x21vec*x67  &
                + x21vec*x68 - x21vec*x70 - x21vec*x71 + x21vec*x73 + x21vec*  &
               x76 + x22*x33vec - x23*x4vec - x23*x51vec - x23*x54vec - x23*   &
               x55vec - x23*x62vec - x23*x7vec - x24*x4vec - x24*x51vec - x24* &
               x54vec - x24*x55vec - x24*x62vec - x24*x7vec + x24vec*x49 +     &
               x24vec*x52 + x24vec*x53 + x24vec*x54 - x24vec*x56 - x24vec*x68  &
                - x24vec*x71 - x25*x4vec - x25*x51vec - x25*x54vec - x25*x55vec&
                - x25*x62vec - x25*x7vec + x25vec*x42 + x25vec*x43 + x25vec*x44&
                - x25vec*x45 - x27*x3vec - x27*x6vec + x27vec*x50 + x27vec*x51 &
                - x27vec*x57 - x27vec*x58 - x27vec*x59 - x27vec*x61 - x27vec*  &
               x62 - x27vec*x63 - x28*x3vec - x28*x6vec - x28vec*x49 + x28vec* &
               x56 + x28vec*x67 + x28vec*x68 - x29*x3vec - x29*x6vec + x29vec* &
               x56 + x29vec*x67 + x29vec*x68 + x2vec*x7 + x2vec*x72 + x2vec*x74&
                - x2vec*x77 - x2vec*x78 + x2vec*x8 + x2vec*x9 + x30*x33vec +   &
               x30vec*x56 + x30vec*x67 + x30vec*x68 - x31*x3vec + x31vec*x65 + &
               x31vec*x69 - x31vec*x82 - x32*x3vec + x32vec*x65 + x32vec*x69 - &
               x32vec*x82 - x33*x3vec + x33vec*x35 + x34*x3vec - x34vec*x79 +  &
               x35*x49vec - x36*x3vec - x36vec*x49 + x36vec*x68 - x37*x3vec -  &
               x37vec*x49 + x37vec*x68 - x38*x3vec + x38vec*x52 + x38vec*x53 + &
               x38vec*x54 - x38vec*x71 + x39*x3vec + x40*x49vec - x41*x53vec + &
               x41vec*x42 + x41vec*x43 + x41vec*x44 - x41vec*x45 + x42*x42vec  &
                - x42*x4vec + x42*x66vec + x42*x7vec + x42vec*x43 + x42vec*x44 &
                - x42vec*x45 - x43*x4vec + x43*x66vec + x43*x7vec + x43vec*x52 &
                + x43vec*x53 + x43vec*x54 - x43vec*x71 - x44*x4vec + x44*x66vec&
                + x44*x7vec + x44vec*x52 + x44vec*x53 + x44vec*x54 - x44vec*x71&
                + x45*x4vec - x45*x66vec - x45*x7vec + x45vec*x52 + x45vec*x53 &
                + x45vec*x54 - x45vec*x71 + x46vec*x52 + x46vec*x53 + x46vec*  &
               x54 - x46vec*x71 - x47*x53vec - x47*x5vec + x47vec*x52 + x47vec*&
               x54 - x47vec*x71 - x48*x53vec - x48*x5vec + x48vec*x52 + x48vec*&
               x54 - x48vec*x71 + x49*x5vec + x49*x65vec + x49vec*(-2*P2(0)*w4(&
               0) + 2*P2(1)*w4(1) + 2*P2(2)*w4(2) + 2*P2(3)*w4(3)) + x4vec*x50 &
                + x4vec*x51 - x4vec*x57 - x4vec*x58 - x4vec*x59 - x4vec*x61 -  &
               x4vec*x62 - x4vec*x63 - x52*x5vec - x53*x5vec - x53*x68vec -    &
               x53vec*x73 - x53vec*x75 - x53vec*x76 - x53vec*x90 - x54*x5vec + &
               x54*x67vec - x54*x68vec - x56*x65vec + x56*x69vec - x56vec*x79  &
                - x56vec*x80 - x57vec*x60 - x57vec*x64 - x57vec*x89 - x58vec*  &
               x79 - x58vec*x80 - x59vec*x83 - x59vec*x84 + x59vec*x85 + x59vec&
               *x86 - x59vec*x87 + x59vec*x88 - x5vec*x68 + x5vec*x70 + x5vec* &
               x71 - x5vec*x75 - x5vec*x76 - x60vec*x84 - x60vec*x87 + x60vec* &
               x91 + x60vec*x92 + x61vec*x83 - x61vec*x85 - x61vec*x86 - x61vec&
               *x88 + x61vec*x91 + x61vec*x92 - x65vec*x68 + x67*x69vec -      &
               x67vec*x71 + x68*x69vec)
      end select 
    end subroutine treeVVSVV
end module tcVVSVV
