!******************************************************************************!
!                                                                              !
!    tcVVVSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVVVSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVSV0)
!       Metric(1,2)*Metric(3,5)*c0
!       Metric(1,3)*Metric(2,5)*c1
!       Metric(1,5)*Metric(2,3)*c2
        if (last) VB_last = .true.
        x0vec = co(0)*w3(:)
        x1vec = co(1)*w2(:)
        wout = w4(0)*(co(2)*w1(:)*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) +  &
               w2(3)*w3(3)) - w1(0)*w2(0)*x0vec - w1(0)*w3(0)*x1vec + w1(1)*w2(&
               1)*x0vec + w1(1)*w3(1)*x1vec + w1(2)*w2(2)*x0vec + w1(2)*w3(2)* &
               x1vec + w1(3)*w2(3)*x0vec + w1(3)*w3(3)*x1vec)
      case(VVVSV1)
!       c0*(Metric(1,2)*P(3,1)*P(5,3) - Metric(1,2)*P(3,2)*P(5,3) - Metric(1,2)*P
!       (3,5)*P(5,1) + Metric(1,2)*P(3,5)*P(5,2) - Metric(3,5)*P(1,2)*P(2,3) +   
!       Metric(3,5)*P(1,2)*P(2,5) + Metric(3,5)*P(1,3)*P(2,1) - Metric(3,5)*P(1,5
!       )*P(2,1))
!       c1*(-Metric(1,3)*P(2,1)*P(5,3) + Metric(1,5)*P(2,1)*P(3,5) + Metric(2,3)*
!       P(1,2)*P(5,3) - Metric(2,5)*P(1,2)*P(3,5))
!       c2*(-Metric(1,2)*P(3,1)*P(5,2) + Metric(1,5)*P(2,5)*P(3,1) + Metric(2,3)*
!       P(1,3)*P(5,2) - Metric(3,5)*P(1,3)*P(2,5))
!       c3*(-Metric(1,3)*P(2,1)*P(5,2) + Metric(1,3)*P(2,3)*P(5,2) + Metric(1,3)*
!       P(2,5)*P(5,1) - Metric(1,3)*P(2,5)*P(5,3) - Metric(2,5)*P(1,2)*P(3,1) +  
!       Metric(2,5)*P(1,3)*P(3,2) - Metric(2,5)*P(1,3)*P(3,5) + Metric(2,5)*P(1,5
!       )*P(3,1))
!       c4*(Metric(1,2)*P(3,2)*P(5,1) - Metric(1,3)*P(2,3)*P(5,1) - Metric(2,5)*P
!       (1,5)*P(3,2) + Metric(3,5)*P(1,5)*P(2,3))
!       c5*(-Metric(1,5)*P(2,1)*P(3,2) + Metric(1,5)*P(2,3)*P(3,1) - Metric(1,5)*
!       P(2,3)*P(3,5) + Metric(1,5)*P(2,5)*P(3,2) - Metric(2,3)*P(1,2)*P(5,1) +  
!       Metric(2,3)*P(1,3)*P(5,1) + Metric(2,3)*P(1,5)*P(5,2) - Metric(2,3)*P(1,5
!       )*P(5,3))
!       c6*(-Metric(1,3)*Metric(2,5)*P(-1,1)*P(-1,2) + Metric(1,3)*Metric(2,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,3)*Metric(2,5)*P(-1,2)*P(-1,3) - Metric(1,3)*  
!       Metric(2,5)*P(-1,3)*P(-1,5))
!       c7*(Metric(1,2)*Metric(3,5)*P(-1,1)*P(-1,3) - Metric(1,2)*Metric(3,5)*P(-
!       1,1)*P(-1,5) - Metric(1,2)*Metric(3,5)*P(-1,2)*P(-1,3) + Metric(1,2)*    
!       Metric(3,5)*P(-1,2)*P(-1,5))
!       c8*(-Metric(1,5)*Metric(2,3)*P(-1,1)*P(-1,2) + Metric(1,5)*Metric(2,3)*P 
!       (-1,1)*P(-1,3) + Metric(1,5)*Metric(2,3)*P(-1,2)*P(-1,5) - Metric(1,5)*  
!       Metric(2,3)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x1 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x0vec = co(6)*w2(:)*x1
        x2 = P3(1)**2
        x3 = P3(2)**2
        x4 = P3(3)**2
        x5 = P1(1)**2
        x6 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1vec = co(7)*w3(:)*x6
        x7 = P1(2)**2
        x8 = P1(3)**2
        x9 = P2(0)**2
        x10 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x2vec = co(8)*w1(:)*x10
        x11 = P3(0)**2
        x12 = P2(1)**2
        x13 = P2(2)**2
        x14 = P2(3)**2
        x15 = P1(0)*w2(0)
        x3vec = P1(:)*co(3)*x1
        x16 = P1(0)*co(0)*w3(0)*x6
        x17 = P1(0)*w3(0)*x6
        x4vec = P2(:)*co(3)*x1
        x5vec = P2(:)*co(5)*x10
        x18 = P1(0)*w1(0)
        x6vec = P3(:)*co(1)*x1
        x7vec = P4(0)*co(6)*w2(:)*x1
        x19 = P1(1)*w3(1)
        x20 = P1(2)*w3(2)
        x21 = P1(3)*w3(3)
        x22 = -P1(0)*w3(0) + x19 + x20 + x21
        x8vec = co(1)*w1(:)*x22
        x23 = P2(1)*w3(1)
        x24 = P2(2)*w3(2)
        x25 = P2(3)*w3(3)
        x26 = P2(0)*w3(0)
        x27 = x23 + x24 + x25 - x26
        x9vec = co(1)*w1(:)*x27
        x28 = P3(1)*w3(1)
        x29 = P3(2)*w3(2)
        x30 = P3(3)*w3(3)
        x31 = P3(0)*w3(0)
        x32 = x28 + x29 + x30 - x31
        x10vec = co(1)*w1(:)*x32
        x33 = P4(1)*w3(1)
        x34 = P4(2)*w3(2)
        x35 = P4(3)*w3(3)
        x36 = P4(0)*w3(0)
        x37 = x33 + x34 + x35 - x36
        x11vec = co(1)*w1(:)*x37
        x12vec = co(2)*w1(:)*x22
        x13vec = co(3)*w2(:)*x22
        x38 = P3(1)*w2(1)
        x39 = P3(2)*w2(2)
        x40 = P3(3)*w2(3)
        x41 = P3(0)*w2(0)
        x42 = x38 + x39 + x40 - x41
        x14vec = co(4)*w3(:)*x42
        x15vec = P1(:)*co(0)*x6
        x16vec = P3(:)*co(0)*x6
        x43 = P1(1)*w2(1)
        x17vec = P3(:)*co(3)*x1
        x18vec = P3(:)*co(5)*w1(1)*x10
        x19vec = P4(1)*co(7)*w3(:)*x6
        x44 = P1(1)*w1(1)
        x45 = P1(2)*w2(2)
        x46 = P1(3)*w2(3)
        x47 = -x15 + x43 + x45 + x46
        x20vec = co(0)*w3(:)*x47
        x21vec = co(4)*w2(:)*x27
        x22vec = P3(:)*co(5)*x10
        x48 = P1(2)*w1(2)
        x49 = P1(2)*P4(2)
        x50 = P1(3)*w1(3)
        x23vec = P1(3)*co(7)*w3(:)*x6
        x51 = P2(0)*w2(0)
        x24vec = P1(:)*co(5)*x10
        x52 = P2(0)*w1(0)
        x25vec = P1(:)*co(4)*x6
        x26vec = P1(:)*co(4)*x1
        x53 = P3(1)*w1(1)
        x54 = P3(2)*w1(2)
        x55 = P3(3)*w1(3)
        x56 = P4(0)*w2(0)
        x27vec = P2(:)*co(0)*x6
        x57 = P2(0)*P4(0)
        x58 = P2(1)*w2(1)
        x59 = P2(2)*w2(2)
        x60 = P2(3)*w2(3)
        x61 = -x51 + x58 + x59 + x60
        x28vec = co(0)*w3(:)*x61
        x62 = P4(1)*w2(1)
        x63 = P4(2)*w2(2)
        x64 = P4(3)*w2(3)
        x65 = -x56 + x62 + x63 + x64
        x29vec = co(0)*w3(:)*x65
        x30vec = co(5)*w1(:)*x27
        x66 = P2(1)*w1(1)
        x31vec = P3(:)*co(1)*x10
        x32vec = co(1)*w2(:)*x22
        x33vec = co(1)*w2(:)*x27
        x34vec = co(1)*w2(:)*x32
        x35vec = co(1)*w2(:)*x37
        x67 = P2(2)*w1(2)
        x68 = P2(3)*w1(3)
        x69 = P3(0)*w1(0)
        x36vec = P2(:)*co(2)*x10
        x70 = P4(0)*w1(0)
        x37vec = P4(1)*co(6)*w2(:)*x1
        x38vec = P4(1)*co(8)*w1(:)*x10
        x71 = P3(1)*co(2)*w1(1)
        x39vec = w3(:)*x47
        x40vec = w3(:)*x61
        x41vec = co(3)*w2(:)*x32
        x42vec = co(3)*w2(:)*x37
        x43vec = co(5)*w1(:)*x32
        x44vec = co(5)*w1(:)*x37
        x72 = P3(2)*P4(2)
        x45vec = co(2)*w3(:)*x47
        x46vec = co(2)*w3(:)*x61
        x47vec = co(2)*w3(:)*x42
        x48vec = co(2)*w3(:)*x65
        x49vec = P4(3)*co(6)*w2(:)*x1
        x50vec = P3(3)*co(8)*w1(:)*x10
        x73 = P3(3)*co(2)*w1(3)
        x74 = P4(2)*w1(2)
        x75 = P4(3)*w1(3)
        x76 = P4(1)*w1(1)
        x51vec = P1(0)*co(7)*w3(:)*x6
        x52vec = co(4)*w1(0)*w2(:)*x27
        x53vec = P2(:)*co(2)*x6
        x54vec = P1(1)*w1(:)*w2(1)
        x55vec = co(3)*w1(1)*w2(:)*x22
        x77 = P2(2)*P4(2)
        x78 = P2(3)*P4(3)
        x56vec = P3(0)*co(8)*w1(:)*x10
        x57vec = 2*P2(1)*co(6)*w2(:)*x1
        x58vec = 2*co(8)*w1(:)*x10
        x79 = -2*P2(0)*w3(0) + 2*P2(1)*w3(1) + 2*P2(2)*w3(2) + 2*P2(3)*w3(3)
        x59vec = 2*co(6)*w2(:)*x1
        x80 = P1(2)*P2(2)
        x60vec = 2*co(5)*w1(:)*x27
        x81 = P1(3)*P2(3)
        x61vec = 2*P2(0)*co(6)*w2(:)*x1
        x62vec = 2*co(7)*w3(:)*x6
        x63vec = 2*co(0)*w3(:)*x42
        x82 = P2(2)*P3(2)
        x64vec = 2*co(3)*w2(:)*x22
        x83 = P2(3)*P3(3)
        x65vec = 2*co(0)*w3(:)*x47
        x66vec = co(3)*w2(:)*x79
        x67vec = 2*co(5)*w1(:)*x22
        x84 = P1(1)*P3(1)
        x85 = P1(2)*P3(2)
        x86 = 2*P2(0)*w1(0)
        wout = -w4(0)*(P1(0)*P2(0)*x58vec - P1(0)*x52vec - 2*P1(0)*x56vec + P1(&
               0)*x61vec + P1(0)*x7vec - P1(1)*P2(1)*x58vec - P1(1)*co(5)*w1   &
               (:)*w2(1)*x79 + P1(1)*x18vec + P1(1)*x19vec - P1(1)*x37vec - P1(&
               1)*x55vec - P1(1)*x57vec - P1(3)*x49vec + 2*P1(3)*x50vec - P1   &
               (:)*x16 + P2(0)*P3(0)*x62vec - P2(0)*x52vec - P2(1)*P3(1)*x62vec&
                + P2(1)*x18vec - P2(1)*x19vec - P2(1)*x38vec - 2*P2(1)*x55vec  &
                + P2(:)*co(2)*x17 + P2(:)*x16 - 2*P3(0)*x51vec - P3(0)*x52vec  &
                - P3(0)*x61vec - P3(0)*x7vec + P3(1)*x18vec + P3(1)*x37vec + P3&
               (1)*x38vec + P3(1)*x57vec + 2*P3(3)*x23vec + P3(3)*x49vec - P3  &
               (:)*co(0)*x17 - P4(0)*x51vec - P4(0)*x52vec - P4(0)*x56vec + P4(&
               1)*x18vec - P4(1)*x55vec + P4(3)*x23vec + P4(3)*x50vec + co(0)* &
               w3(:)*x42*x86 - co(1)*x22*x54vec - co(1)*x27*x54vec - co(1)*x32*&
               x54vec - co(1)*x37*x54vec + w3(:)*x42*x71 + w3(:)*x65*x71 + x0* &
               x0vec - x0*x1vec - x0vec*x11 + x0vec*x2 + x0vec*x3 + x0vec*x4 - &
               x0vec*x49 - x0vec*x5 - x0vec*x7 + x0vec*x72 - x0vec*x8 + x10vec*&
               x15 - x10vec*x45 - x10vec*x46 - x11*x2vec + x11vec*x15 - x11vec*&
               x45 - x11vec*x46 - x12*x1vec - x12*x2vec + x12vec*x15 - x12vec* &
               x38 - x12vec*x39 - x12vec*x40 + x12vec*x41 - x12vec*x43 - x12vec&
               *x45 - x12vec*x46 + x12vec*x51 + x12vec*x56 - x12vec*x58 -      &
               x12vec*x59 - x12vec*x60 - x12vec*x62 - x12vec*x63 - x12vec*x64  &
                - x13*x1vec - x13*x2vec + x13vec*x18 - x13vec*x48 - x13vec*x50 &
                + x13vec*x70 - x13vec*x74 - x13vec*x75 + x13vec*x86 - x14*x1vec&
                - x14*x2vec + x14vec*x18 - x14vec*x44 - x14vec*x48 - x14vec*x50&
                + x14vec*x52 - x14vec*x53 - x14vec*x54 - x14vec*x55 - x14vec*  &
               x66 - x14vec*x67 - x14vec*x68 + x14vec*x69 + x14vec*x70 - x14vec&
               *x74 - x14vec*x75 - x14vec*x76 - x15*x17vec + x15*x3vec + x15*  &
               x4vec + x15*x60vec + x15*x6vec + x15*x8vec + x15*x9vec + x15vec*&
               x19 + x15vec*x20 + x15vec*x21 + x15vec*x23 + x15vec*x24 + x15vec&
               *x25 - x15vec*x26 + x15vec*x28 + x15vec*x29 + x15vec*x30 -      &
               x15vec*x31 + x15vec*x33 + x15vec*x34 + x15vec*x35 - x15vec*x36  &
                + x16vec*x19 + x16vec*x20 + x16vec*x21 - x16vec*x23 - x16vec*  &
               x24 - x16vec*x25 + x16vec*x26 + x17vec*x38 + x17vec*x39 + x17vec&
               *x40 - x17vec*x41 + x17vec*x43 + x17vec*x45 + x17vec*x46 -      &
               x17vec*x51 - x17vec*x56 + x17vec*x58 + x17vec*x59 + x17vec*x60  &
                + x17vec*x62 + x17vec*x63 + x17vec*x64 - x18*x20vec - x18*     &
               x22vec + x18*x5vec - x19*x27vec - x19*x53vec + x1vec*x49 + x1vec&
               *x5 + x1vec*x57 + x1vec*x7 - x1vec*x77 - x1vec*x78 + x1vec*x8 + &
               x1vec*x9 + x2*x2vec - x20*x27vec - x20*x53vec + x20vec*x44 +    &
               x20vec*x48 + x20vec*x50 - x20vec*x70 + x20vec*x74 + x20vec*x75  &
                + x20vec*x76 - x21*x27vec - x21*x53vec + x21vec*x44 + x21vec*  &
               x48 + x21vec*x50 + x21vec*x53 + x21vec*x54 + x21vec*x55 + x21vec&
               *x66 + x21vec*x67 + x21vec*x68 + x21vec*x74 + x21vec*x75 +      &
               x21vec*x76 + x22vec*x48 + x22vec*x50 - x22vec*x52 + x22vec*x54  &
                + x22vec*x55 + x22vec*x67 + x22vec*x68 - x22vec*x69 - x22vec*  &
               x70 + x22vec*x74 + x22vec*x75 + x23*x25vec - x23*x27vec + x24*  &
               x25vec - x24*x27vec + x24vec*x52 + x24vec*x53 + x24vec*x54 +    &
               x24vec*x55 - x24vec*x66 - x24vec*x67 - x24vec*x68 - x24vec*x69  &
                + x25*x25vec - x25*x27vec - x25vec*x26 + x26*x27vec - x26vec*  &
               x38 - x26vec*x39 - x26vec*x40 + x26vec*x41 - x27vec*x28 - x27vec&
               *x29 - x27vec*x30 + x27vec*x31 - x27vec*x33 - x27vec*x34 -      &
               x27vec*x35 + x27vec*x36 + x28vec*x52 - x28vec*x66 - x28vec*x67  &
                - x28vec*x68 + x29vec*x52 - x29vec*x66 - x29vec*x67 - x29vec*  &
               x68 + x2vec*x3 + x2vec*x4 + x2vec*x57 + x2vec*x72 - x2vec*x77 - &
               x2vec*x78 + x2vec*x9 + x30vec*x51 + x30vec*x56 - x30vec*x58 -   &
               x30vec*x59 - x30vec*x60 - x30vec*x62 - x30vec*x63 - x30vec*x64  &
                - x31vec*x52 + x31vec*x66 + x31vec*x67 + x31vec*x68 - x32vec*  &
               x52 + x32vec*x66 + x32vec*x67 + x32vec*x68 - x33vec*x52 + x33vec&
               *x66 + x33vec*x67 + x33vec*x68 - x34vec*x52 + x34vec*x66 +      &
               x34vec*x67 + x34vec*x68 - x35vec*x52 + x35vec*x66 + x35vec*x67  &
                + x35vec*x68 + x36vec*x53 + x36vec*x54 + x36vec*x55 - x36vec*  &
               x69 - x38*x3vec + x38*x43vec + x38*x44vec + x38*x4vec + x38*    &
               x67vec - x39*x3vec + x39*x43vec + x39*x44vec + x39*x4vec + x39* &
               x67vec + x39vec*x71 + x39vec*x73 - x3vec*x40 + x3vec*x41 - x3vec&
               *x43 - x3vec*x45 - x3vec*x46 + x3vec*x51 + x3vec*x56 - x3vec*x58&
                - x3vec*x59 - x3vec*x60 - x3vec*x62 - x3vec*x63 - x3vec*x64 +  &
               x40*x43vec + x40*x44vec + x40*x4vec + x40*x67vec + x40vec*x71 + &
               x40vec*x73 - x41*x43vec - x41*x44vec - x41*x4vec - x41*x67vec + &
               x41vec*x53 + x41vec*x54 + x41vec*x55 - x41vec*x69 + x42vec*x53  &
                + x42vec*x54 + x42vec*x55 - x42vec*x69 - x43*x4vec - x43*x6vec &
                - x44*x5vec - x45*x4vec - x45*x60vec - x45*x6vec - x45*x8vec - &
               x45*x9vec + x45vec*x54 - x45vec*x69 - x46*x4vec - x46*x60vec -  &
               x46*x6vec - x46*x8vec - x46*x9vec + x46vec*x54 - x46vec*x69 +   &
               x47vec*x54 + x47vec*x55 - x47vec*x69 - x48*x5vec + x48vec*x54 + &
               x48vec*x55 - x48vec*x69 - x50*x5vec + x52*x5vec - x53*x5vec +   &
               x53*x65vec + x53*x66vec - x54*x5vec + x54*x65vec + x54*x66vec - &
               x55*x5vec + x55*x65vec + x55*x66vec - x58vec*x80 - x58vec*x81 + &
               x58vec*x84 + x58vec*x85 - x59vec*x80 - x59vec*x81 + x59vec*x82  &
                + x59vec*x83 - x5vec*x66 - x5vec*x67 - x5vec*x68 + x5vec*x69 + &
               x5vec*x70 - x5vec*x74 - x5vec*x75 - x5vec*x76 - x62vec*x82 -    &
               x62vec*x83 + x62vec*x84 + x62vec*x85 - x63vec*x66 - x63vec*x67  &
                - x63vec*x68 - x64vec*x67 - x64vec*x68 - x65vec*x69 - x66vec*  &
               x69)
      end select 
    end subroutine treeVVVSV
end module tcVVVSV
