!******************************************************************************!
!                                                                              !
!    tcVVVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-14 13:42             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec, x63vec, x64vec, x65vec, x66vec,      &
                                  x67vec, x68vec, x69vec, x70vec, x71vec,      &
                                  x72vec, x73vec, x74vec, x75vec, x76vec,      &
                                  x77vec, x78vec, x79vec, x80vec, x81vec,      &
                                  x82vec, x83vec, x84vec, x85vec, x86vec,      &
                                  x87vec
  contains
    subroutine treeVVVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVVS0)
!       Metric(1,2)*Metric(3,4)*c0
!       Metric(1,3)*Metric(2,4)*c1
!       Metric(1,4)*Metric(2,3)*c2
        x0 = co(0)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3))
        x1 = co(1)*(-w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3))
        x2 = co(2)*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3))
        wout(0) = -w1(0)*w2(0)*x0 - w1(0)*w3(0)*x1 - w1(0)*w4(0)*x2 + w1(1)*w2(&
                  1)*x0 + w1(1)*w3(1)*x1 + w1(1)*w4(1)*x2 + w1(2)*w2(2)*x0 + w1&
                  (2)*w3(2)*x1 + w1(2)*w4(2)*x2 + w1(3)*w2(3)*x0 + w1(3)*w3(3)*&
                  x1 + w1(3)*w4(3)*x2
        wout(1:3) = cnul
      case(VVVVS1)
!       c0*(Metric(1,2)*P(3,1)*P(4,3) - Metric(1,2)*P(3,2)*P(4,3) - Metric(1,2)*P
!       (3,4)*P(4,1) + Metric(1,2)*P(3,4)*P(4,2) - Metric(3,4)*P(1,2)*P(2,3) +   
!       Metric(3,4)*P(1,2)*P(2,4) + Metric(3,4)*P(1,3)*P(2,1) - Metric(3,4)*P(1,4
!       )*P(2,1))
!       c1*(-Metric(1,3)*P(2,1)*P(4,3) + Metric(1,4)*P(2,1)*P(3,4) + Metric(2,3)*
!       P(1,2)*P(4,3) - Metric(2,4)*P(1,2)*P(3,4))
!       c2*(-Metric(1,2)*P(3,1)*P(4,2) + Metric(1,4)*P(2,4)*P(3,1) + Metric(2,3)*
!       P(1,3)*P(4,2) - Metric(3,4)*P(1,3)*P(2,4))
!       c3*(-Metric(1,3)*P(2,1)*P(4,2) + Metric(1,3)*P(2,3)*P(4,2) + Metric(1,3)*
!       P(2,4)*P(4,1) - Metric(1,3)*P(2,4)*P(4,3) - Metric(2,4)*P(1,2)*P(3,1) +  
!       Metric(2,4)*P(1,3)*P(3,2) - Metric(2,4)*P(1,3)*P(3,4) + Metric(2,4)*P(1,4
!       )*P(3,1))
!       c4*(-Metric(1,2)*P(3,2)*P(4,1) + Metric(1,3)*P(2,3)*P(4,1) + Metric(2,4)*
!       P(1,4)*P(3,2) - Metric(3,4)*P(1,4)*P(2,3))
!       c5*(-Metric(1,4)*P(2,1)*P(3,2) + Metric(1,4)*P(2,3)*P(3,1) - Metric(1,4)*
!       P(2,3)*P(3,4) + Metric(1,4)*P(2,4)*P(3,2) - Metric(2,3)*P(1,2)*P(4,1) +  
!       Metric(2,3)*P(1,3)*P(4,1) + Metric(2,3)*P(1,4)*P(4,2) - Metric(2,3)*P(1,4
!       )*P(4,3))
!       c6*(-Metric(1,3)*Metric(2,4)*P(-1,1)*P(-1,2) + Metric(1,3)*Metric(2,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,3)*Metric(2,4)*P(-1,2)*P(-1,3) - Metric(1,3)*  
!       Metric(2,4)*P(-1,3)*P(-1,4))
!       c7*(-Metric(1,4)*Metric(2,3)*P(-1,1)*P(-1,2) + Metric(1,4)*Metric(2,3)*P 
!       (-1,1)*P(-1,3) + Metric(1,4)*Metric(2,3)*P(-1,2)*P(-1,4) - Metric(1,4)*  
!       Metric(2,3)*P(-1,3)*P(-1,4))
!       c8*(-Metric(1,2)*Metric(3,4)*P(-1,1)*P(-1,3) + Metric(1,2)*Metric(3,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,2)*Metric(3,4)*P(-1,2)*P(-1,3) - Metric(1,2)*  
!       Metric(3,4)*P(-1,2)*P(-1,4))
        x0 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x2 = P3(0)*co(7)*x0*x1
        x3 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x4 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x5 = P4(0)*co(6)*x3*x4
        x6 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x7 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x8 = P1(0)*co(8)*x6*x7
        x9 = P1(0)*w3(0)
        x10 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x11 = co(0)*x10*x6
        x12 = P1(0)*co(1)*w2(0)
        x13 = P4(1)*w3(1)
        x14 = P4(2)*w3(2)
        x15 = P4(3)*w3(3)
        x16 = P4(0)*w3(0)
        x17 = x13 + x14 + x15 - x16
        x18 = co(6)*x3*x4
        x19 = P1(1)*P2(1)
        x20 = co(7)*x0*x1
        x21 = P3(1)*co(8)*x6*x7
        x22 = P1(1)*w2(1)
        x23 = co(1)*x10*x3
        x24 = P1(1)*w3(1)
        x25 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x26 = co(2)*x25*x6
        x27 = co(3)*x25*x3
        x28 = P2(1)*w3(1)
        x29 = P2(2)*w3(2)
        x30 = P2(3)*w3(3)
        x31 = P2(0)*w3(0)
        x32 = x28 + x29 + x30 - x31
        x33 = co(5)*x0*x32
        x34 = P1(2)*P2(2)
        x35 = P3(2)*co(8)*x6*x7
        x36 = P1(2)*w2(2)
        x37 = P1(2)*w3(2)
        x38 = P2(3)*co(6)*x3*x4
        x39 = P1(3)*co(7)*x0*x1
        x40 = P1(3)*co(8)*x6*x7
        x41 = P1(3)*w2(3)
        x42 = P1(3)*w3(3)
        x43 = P2(0)*P3(0)
        x44 = co(8)*x6*x7
        x45 = P2(0)*P4(0)
        x46 = P2(0)*w1(0)
        x47 = P4(1)*w2(1)
        x48 = P4(2)*w2(2)
        x49 = P4(3)*w2(3)
        x50 = P4(0)*w2(0)
        x51 = x47 + x48 + x49 - x50
        x52 = co(0)*x51*x7
        x53 = co(1)*x1*x10
        x54 = P2(1)*P4(1)
        x55 = P2(1)*w1(1)
        x56 = P3(1)*w2(1)
        x57 = P3(2)*w2(2)
        x58 = P3(3)*w2(3)
        x59 = P3(0)*w2(0)
        x60 = x56 + x57 + x58 - x59
        x61 = co(0)*x60*x7
        x62 = co(1)*x17*x4
        x63 = x24 + x37 + x42 - x9
        x64 = co(3)*x4*x63
        x65 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x66 = co(4)*x6*x65
        x67 = co(5)*x1*x65
        x68 = P2(2)*P4(2)
        x69 = P2(2)*co(0)*w1(2)*x7
        x70 = P2(2)*w1(2)
        x71 = co(3)*w1(2)*x4*x63
        x72 = co(5)*w1(2)*x1*x65
        x73 = P2(3)*co(8)*x6*x7
        x74 = P2(3)*w1(3)
        x75 = P1(0)*w2(0)
        x76 = x22 + x36 + x41 - x75
        x77 = co(0)*x7*x76
        x78 = P3(0)*w1(0)
        x79 = co(2)*x1*x25
        x80 = co(3)*x32*x4
        x81 = co(4)*x3*x65
        x82 = co(5)*x0*x63
        x83 = P3(1)*co(6)*x3*x4
        x84 = P3(1)*co(7)*x0*x1
        x85 = P3(1)*w1(1)
        x86 = co(2)*x51*x7
        x87 = co(3)*x17*x4
        x88 = co(5)*x0*x17
        x89 = P4(2)*co(6)*x3*x4
        x90 = P3(2)*co(7)*x0*x1
        x91 = P3(2)*w1(2)
        x92 = P3(2)*co(3)*w1(2)*x4
        x93 = P3(3)*P4(3)
        x94 = P3(3)*w1(3)
        x95 = P3(3)*co(3)*w1(3)
        x96 = co(0)*x25*x6
        x97 = co(2)*x0*x63
        x98 = P4(0)*w1(0)
        x99 = co(3)*x3*x65
        x100 = co(4)*x32*x4
        x101 = co(5)*x1*x25
        x102 = P4(1)*w1(1)
        x103 = co(0)*x6*x65
        x104 = co(3)*x10*x3
        x105 = co(4)*x60*x7
        x106 = co(5)*x1*x10
        x107 = co(0)*w1(2)*x7*x76
        x108 = P4(2)*w1(2)
        x109 = P4(3)*w1(3)
        x110 = P1(0)*P2(0)
        x111 = P1(1)*P4(1)
        x112 = co(1)*x0*x17
        x113 = P4(3)*w2(3)*x0
        wout(0) = P1(0)*x2 + P1(0)*x5 + P1(1)*x21 - P1(1)*x84 - P1(2)*P4(2)*x44&
                   + P1(2)*x35 - P1(2)*x89 - P1(2)*x90 - P1(3)*P4(3)*x18 + P1(3&
                  )*x38 - P2(1)*x21 - P2(1)*x83 - P2(2)*P3(2)*x18 - P2(2)*x35  &
                   + P2(2)*x71 + P2(2)*x72 - P2(3)*P4(3)*x20 + P2(3)*x39 - P3(0&
                  )*x5 - P3(0)*x8 - P3(2)*x107 - P3(2)*x72 + P3(2)*x89 - P3(3)*&
                  x38 - P3(3)*x39 + P3(3)*x40 - P3(3)*x73 - P4(0)*x2 + P4(0)*x8&
                   + P4(1)*x83 + P4(1)*x84 + P4(2)*x107 - P4(2)*x71 + P4(2)*x90&
                   - P4(3)*x40 + P4(3)*x73 - co(2)*x113*x63 - co(5)*x113*x32 + &
                  x0*x12*x17 - x10*x12*x3 - x100*x102 - x100*x108 - x100*x109  &
                   + x100*x98 - x101*x102 - x101*x108 - x101*x109 + x101*x98 + &
                  x102*x105 + x102*x106 - x102*x64 + x102*x77 + x103*x13 + x103&
                  *x14 + x103*x15 - x103*x16 + x104*x47 + x104*x48 + x104*x49  &
                   - x104*x50 + x105*x108 + x105*x109 - x105*x98 + x106*x108 + &
                  x106*x109 - x106*x98 - x109*x64 + x109*x77 - x11*x24 + x11*  &
                  x28 + x11*x29 + x11*x30 - x11*x31 - x11*x37 - x11*x42 + x11* &
                  x9 - x110*x18 - x110*x20 - x111*x18 - x111*x44 - x112*x22 -  &
                  x112*x36 - x112*x41 - x13*x96 - x14*x96 - x15*x96 + x16*x96  &
                   + x17*x4*x95 + x17*x92 + x18*x19 + x18*x34 + x18*x43 + x18* &
                  x93 + x19*x20 + x20*x34 + x20*x45 - x20*x54 - x20*x68 + x20* &
                  x93 + x22*x23 + x22*x27 + x22*x33 + x23*x36 + x23*x41 + x24* &
                  x26 + x26*x37 + x26*x42 - x26*x9 + x27*x36 + x27*x41 - x27*  &
                  x56 - x27*x57 - x27*x58 + x27*x59 - x27*x75 + x28*x66 + x29* &
                  x66 + x30*x66 - x31*x66 - x32*x4*x95 - x32*x92 + x33*x36 +   &
                  x33*x41 - x33*x47 - x33*x48 + x33*x50 - x33*x75 + x43*x44 -  &
                  x44*x45 + x44*x54 + x44*x68 + x46*x52 + x46*x53 - x46*x61 -  &
                  x46*x62 - x46*x64 - x46*x67 - x47*x97 - x47*x99 - x48*x97 -  &
                  x48*x99 - x49*x99 + x50*x97 + x50*x99 - x51*x69 - x52*x55 -  &
                  x52*x74 - x53*x55 - x53*x70 - x53*x74 + x55*x61 + x55*x62 +  &
                  x55*x64 + x55*x67 - x56*x81 - x56*x82 + x56*x88 - x57*x81 -  &
                  x57*x82 + x57*x88 - x58*x81 - x58*x82 + x58*x88 + x59*x81 +  &
                  x59*x82 - x59*x88 + x60*x69 + x61*x74 + x62*x70 + x62*x74 +  &
                  x64*x74 + x64*x98 + x67*x74 + x67*x78 - x67*x85 - x67*x94 +  &
                  x77*x78 - x77*x85 - x77*x94 - x77*x98 + x78*x79 + x78*x80 -  &
                  x78*x86 - x78*x87 - x79*x85 - x79*x91 - x79*x94 - x80*x85 +  &
                  x85*x86 + x85*x87 + x86*x91 + x86*x94
        wout(1:3) = cnul
      end select 
    end subroutine treeVVVVS
end module tcVVVVS
